/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 * Portions Copyright (c) 2010-2012 Postgres-XC Development Group
 *
 * This source code file contains modifications made by THL A29 Limited ("Tencent Modifications").
 * All Tencent Modifications are Copyright (C) 2023 THL A29 Limited.
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_am.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "miscadmin.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "nodes/nodes.h"
#include "pgxc/poolmgr.h"
#include "parser/parser.h"
#include "parser/parse_expr.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"
#include "storage/nodelock.h"

#ifdef _PG_ORCL_
#include "utils/guc.h"
#include "port.h"
#endif

#ifdef __AUDIT__
#include "audit/audit.h"
#endif
#ifdef _MLS_
#include "utils/mls.h"
#endif
/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 281 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    FCONST = 259,
    SCONST = 260,
    BCONST = 261,
    XCONST = 262,
    Op = 263,
    ICONST = 264,
    PARAM = 265,
    TYPECAST = 266,
    DOT_DOT = 267,
    COLON_EQUALS = 268,
    EQUALS_GREATER = 269,
    LESS_EQUALS = 270,
    GREATER_EQUALS = 271,
    NOT_EQUALS = 272,
    ABORT_P = 273,
    ABSOLUTE_P = 274,
    ACCESS = 275,
    ACTION = 276,
    ADD_P = 277,
    ADMIN = 278,
    AFTER = 279,
    AGGREGATE = 280,
    ALL = 281,
    ALSO = 282,
    ALTER = 283,
    ALWAYS = 284,
    ANALYSE = 285,
    ANALYZE = 286,
    AND = 287,
    ANY = 288,
    ARRAY = 289,
    AS = 290,
    ASC = 291,
    ASSERTION = 292,
    ASSIGNMENT = 293,
    ASYMMETRIC = 294,
    AT = 295,
    ATTACH = 296,
    ATTRIBUTE = 297,
    AUDIT = 298,
    AUTHORIZATION = 299,
    BACKWARD = 300,
    BARRIER = 301,
    BEFORE = 302,
    BEGIN_P = 303,
    BEGIN_SUBTXN = 304,
    BETWEEN = 305,
    BIGINT = 306,
    BINARY = 307,
    BINARY_FLOAT = 308,
    BINARY_DOUBLE = 309,
    BIT = 310,
    BOOLEAN_P = 311,
    BOTH = 312,
    BY = 313,
    CACHE = 314,
    CALLED = 315,
    CASCADE = 316,
    CASCADED = 317,
    CASE = 318,
    CAST = 319,
    CATALOG_P = 320,
    CHAIN = 321,
    CHAR_P = 322,
    CHARACTER = 323,
    CHARACTERISTICS = 324,
    CHECK = 325,
    CHECKPOINT = 326,
    CLASS = 327,
    CLEAN = 328,
    CLOSE = 329,
    CLUSTER = 330,
    COALESCE = 331,
    COLLATE = 332,
    COLLATION = 333,
    COLUMN = 334,
    COLUMNS = 335,
    COMMENT = 336,
    COMMENTS = 337,
    COMMIT = 338,
    COMMIT_SUBTXN = 339,
    COMMITTED = 340,
    CONCURRENTLY = 341,
    CONFIGURATION = 342,
    CONFLICT = 343,
    CONNECTION = 344,
    CONSTRAINT = 345,
    CONSTRAINTS = 346,
    CONTENT_P = 347,
    CONTINUE_P = 348,
    CONVERSION_P = 349,
    COORDINATOR = 350,
    COPY = 351,
    COST = 352,
    CREATE = 353,
    CROSS = 354,
    CSV = 355,
    CUBE = 356,
    CURRENT_P = 357,
    CURRENT_CATALOG = 358,
    CURRENT_DATE = 359,
    CURRENT_ROLE = 360,
    CURRENT_SCHEMA = 361,
    CURRENT_TIME = 362,
    CURRENT_TIMESTAMP = 363,
    CURRENT_USER = 364,
    CURSOR = 365,
    CYCLE = 366,
    DATA_P = 367,
    DATABASE = 368,
    DAY_P = 369,
    DBTIMEZONE = 370,
    DEALLOCATE = 371,
    DEC = 372,
    DECIMAL_P = 373,
    DECLARE = 374,
    DEFAULT = 375,
    DEFAULTS = 376,
    DEFERRABLE = 377,
    DEFERRED = 378,
    DEFINER = 379,
    DELETE_P = 380,
    DELIMITER = 381,
    DELIMITERS = 382,
    DEPENDS = 383,
    DESC = 384,
    DETACH = 385,
    DICTIONARY = 386,
    DIRECT = 387,
    DISABLE_P = 388,
    DISCARD = 389,
    DISTINCT = 390,
    DISTKEY = 391,
    DISTRIBUTE = 392,
    DISTRIBUTED = 393,
    DISTSTYLE = 394,
    DO = 395,
    DOCUMENT_P = 396,
    DOMAIN_P = 397,
    DOUBLE_P = 398,
    DROP = 399,
    EACH = 400,
    ELSE = 401,
    ENABLE_P = 402,
    ENCODING = 403,
    ENCRYPTED = 404,
    END_P = 405,
    ENUM_P = 406,
    ESCAPE = 407,
    EVENT = 408,
    EXCEPT = 409,
    EXCHANGE = 410,
    EXCLUDE = 411,
    EXCLUDING = 412,
    EXCLUSIVE = 413,
    EXECUTE = 414,
    EXISTS = 415,
    EXPLAIN = 416,
    EXTENSION = 417,
    EXTENT = 418,
    EXTERNAL = 419,
    EXTRACT = 420,
    FALSE_P = 421,
    FAMILY = 422,
    FETCH = 423,
    FILTER = 424,
    FIRST_P = 425,
    FLOAT_P = 426,
    FOLLOWING = 427,
    FOR = 428,
    FORCE = 429,
    FOREIGN = 430,
    FORWARD = 431,
    FREEZE = 432,
    FROM = 433,
    FULL = 434,
    FUNCTION = 435,
    FUNCTIONS = 436,
    GENERATED = 437,
    GLOBAL = 438,
    GRANT = 439,
    GRANTED = 440,
    GREATEST = 441,
    GROUP_P = 442,
    GROUPING = 443,
    GTM = 444,
    HANDLER = 445,
    HAVING = 446,
    HEADER_P = 447,
    HOLD = 448,
    HOUR_P = 449,
    IDENTITY_P = 450,
    IF_P = 451,
    ILIKE = 452,
    IMMEDIATE = 453,
    IMMUTABLE = 454,
    IMPLICIT_P = 455,
    IMPORT_P = 456,
    IN_P = 457,
    INCLUDING = 458,
    INCREMENT = 459,
    INDEX = 460,
    INDEXES = 461,
    INHERIT = 462,
    INHERITS = 463,
    INITIALLY = 464,
    INLINE_P = 465,
    INNER_P = 466,
    INOUT = 467,
    INPUT_P = 468,
    INSENSITIVE = 469,
    INSERT = 470,
    INSTEAD = 471,
    INT_P = 472,
    INTEGER = 473,
    INTERSECT = 474,
    INTERVAL = 475,
    INTO = 476,
    INVOKER = 477,
    IS = 478,
    ISNULL = 479,
    ISOLATION = 480,
    JOIN = 481,
    KEY = 482,
    LABEL = 483,
    LANGUAGE = 484,
    LARGE_P = 485,
    LAST_P = 486,
    LATERAL_P = 487,
    LEADING = 488,
    LEAKPROOF = 489,
    LEAST = 490,
    LEFT = 491,
    LEVEL = 492,
    LIKE = 493,
    LIMIT = 494,
    LISTEN = 495,
    LOAD = 496,
    LOCAL = 497,
    LOCALTIME = 498,
    LOCALTIMESTAMP = 499,
    LOCATION = 500,
    LOCK_P = 501,
    LOCKED = 502,
    LOGGED = 503,
    MAPPING = 504,
    MATCH = 505,
    MATERIALIZED = 506,
    MAXVALUE = 507,
    METHOD = 508,
    MINUTE_P = 509,
    MINVALUE = 510,
    MODE = 511,
    MONTH_P = 512,
    MOVE = 513,
    NAME_P = 514,
    NAMES = 515,
    NATIONAL = 516,
    NATURAL = 517,
    NCHAR = 518,
    NEW = 519,
    NEXT = 520,
    NO = 521,
    NOAUDIT = 522,
    NODE = 523,
    NONE = 524,
    NOT = 525,
    NOTHING = 526,
    NOTIFY = 527,
    NOTNULL = 528,
    NOWAIT = 529,
    NULL_P = 530,
    NULLIF = 531,
    NULLS_P = 532,
    NUMBER = 533,
    NUMERIC = 534,
    OBJECT_P = 535,
    OF = 536,
    OFF = 537,
    OFFSET = 538,
    OID_P = 539,
    OIDS = 540,
    OLD = 541,
    ON = 542,
    ONLY = 543,
    OPENTENBASE_P = 544,
    OPERATOR = 545,
    OPTION = 546,
    OPTIONS = 547,
    OR = 548,
    ORDER = 549,
    ORDINALITY = 550,
    OUT_P = 551,
    OUTER_P = 552,
    OVER = 553,
    OVERLAPS = 554,
    OVERLAY = 555,
    OVERRIDING = 556,
    OWNED = 557,
    OWNER = 558,
    PARALLEL = 559,
    PARSER = 560,
    PARTIAL = 561,
    PARTITION = 562,
    PARTITIONS = 563,
    PASSING = 564,
    PASSWORD = 565,
    PAUSE = 566,
    PLACING = 567,
    PLANS = 568,
    POLICY = 569,
    POSITION = 570,
    PRECEDING = 571,
    PRECISION = 572,
    PREFERRED = 573,
    PRESERVE = 574,
    PREPARE = 575,
    PREPARED = 576,
    PRIMARY = 577,
    PRIOR = 578,
    PRIVILEGES = 579,
    PROCEDURAL = 580,
    PROCEDURE = 581,
    PROGRAM = 582,
    PUBLICATION = 583,
    PUSHDOWN = 584,
    QUOTE = 585,
    RANDOMLY = 586,
    RANGE = 587,
    READ = 588,
    REAL = 589,
    REASSIGN = 590,
    REBUILD = 591,
    RECHECK = 592,
    RECURSIVE = 593,
    REF = 594,
    REFERENCES = 595,
    REFERENCING = 596,
    REFRESH = 597,
    REINDEX = 598,
    RELATIVE_P = 599,
    RELEASE = 600,
    RENAME = 601,
    REPEATABLE = 602,
    REPLACE = 603,
    REPLICA = 604,
    RESET = 605,
    RESTART = 606,
    RESTRICT = 607,
    RETURNING = 608,
    RETURNS = 609,
    REVOKE = 610,
    RIGHT = 611,
    ROLE = 612,
    ROLLBACK = 613,
    ROLLBACK_SUBTXN = 614,
    ROLLUP = 615,
    ROW = 616,
    ROWS = 617,
    RULE = 618,
    SAMPLE = 619,
    SAVEPOINT = 620,
    SCHEMA = 621,
    SCHEMAS = 622,
    SCROLL = 623,
    SEARCH = 624,
    SECOND_P = 625,
    SECURITY = 626,
    SELECT = 627,
    SEQUENCE = 628,
    SEQUENCES = 629,
    SERIALIZABLE = 630,
    SERVER = 631,
    SESSION = 632,
    SESSION_USER = 633,
    SESSIONTIMEZONE = 634,
    SET = 635,
    SETS = 636,
    SETOF = 637,
    SHARDING = 638,
    SHARE = 639,
    SHOW = 640,
    SIMILAR = 641,
    SIMPLE = 642,
    SKIP = 643,
    SLOT = 644,
    SMALLINT = 645,
    SNAPSHOT = 646,
    SOME = 647,
    SQL_P = 648,
    STABLE = 649,
    STANDALONE_P = 650,
    START = 651,
    STATEMENT = 652,
    STATISTICS = 653,
    STDIN = 654,
    STDOUT = 655,
    STEP = 656,
    STORAGE = 657,
    STRICT_P = 658,
    STRIP_P = 659,
    SUBSCRIPTION = 660,
    SUBSTRING = 661,
    SUCCESSFUL = 662,
    SYMMETRIC = 663,
    SYNC = 664,
    SYSDATE = 665,
    SYSID = 666,
    SYSTEM_P = 667,
    SYSTIMESTAMP = 668,
    TABLE = 669,
    TABLES = 670,
    TABLESAMPLE = 671,
    TABLESPACE = 672,
    TEMP = 673,
    TEMPLATE = 674,
    TEMPORARY = 675,
    TEXT_P = 676,
    THEN = 677,
    TIME = 678,
    TIMESTAMP = 679,
    TO = 680,
    TRAILING = 681,
    TRANSACTION = 682,
    TRANSFORM = 683,
    TREAT = 684,
    TRIGGER = 685,
    TRIM = 686,
    TRUE_P = 687,
    TRUNCATE = 688,
    TRUSTED = 689,
    TYPE_P = 690,
    TYPES_P = 691,
    UNBOUNDED = 692,
    UNCOMMITTED = 693,
    UNENCRYPTED = 694,
    UNION = 695,
    UNIQUE = 696,
    UNKNOWN = 697,
    UNLISTEN = 698,
    UNLOCK_P = 699,
    UNLOGGED = 700,
    UNPAUSE = 701,
    UNTIL = 702,
    UPDATE = 703,
    USER = 704,
    USING = 705,
    VACUUM = 706,
    VALID = 707,
    VALIDATE = 708,
    VALIDATOR = 709,
    VALUE_P = 710,
    VALUES = 711,
    VARCHAR = 712,
    VARIADIC = 713,
    VARYING = 714,
    VERBOSE = 715,
    VERSION_P = 716,
    VIEW = 717,
    VIEWS = 718,
    VOLATILE = 719,
    WHEN = 720,
    WHENEVER = 721,
    WHERE = 722,
    WHITESPACE_P = 723,
    WINDOW = 724,
    WITH = 725,
    WITHIN = 726,
    WITHOUT = 727,
    WORK = 728,
    WRAPPER = 729,
    WRITE = 730,
    XML_P = 731,
    XMLATTRIBUTES = 732,
    XMLCONCAT = 733,
    XMLELEMENT = 734,
    XMLEXISTS = 735,
    XMLFOREST = 736,
    XMLNAMESPACES = 737,
    XMLPARSE = 738,
    XMLPI = 739,
    XMLROOT = 740,
    XMLSERIALIZE = 741,
    XMLTABLE = 742,
    YEAR_P = 743,
    YES_P = 744,
    ZONE = 745,
    NOT_LA = 746,
    NULLS_LA = 747,
    WITH_LA = 748,
    POSTFIXOP = 749,
    UMINUS = 750
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 219 "gram.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs		*objwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	InferClause			*infer;
	OnConflictClause	*onconflict;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	struct ImportQual	*importqual;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;
/* PGXC_BEGIN */
	DistributeBy		*distby;
	PGXCSubCluster		*subclus;
/* PGXC_END */
	A_Const				*a_const;
	PartitionElem		*partelem;
	PartitionSpec		*partspec;
	PartitionBoundSpec	*partboundspec;
	RoleSpec			*rolespec;
	PartitionForExpr	*partfor;
	PartitionBy         *partby; 
	StatSyncOpt      *analyze_sync_opt;

#line 869 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 899 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  882
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   114456

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  513
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  719
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3010
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5970

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   750

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   502,     2,     2,
     507,   508,   500,   498,   511,   499,   509,   501,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   512,   510,
     494,   496,   495,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   505,     2,   506,   503,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   497,
     504
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   840,   840,   856,   868,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   913,
     915,   916,   917,   919,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1026,  1036,
    1047,  1048,  1049,  1058,  1059,  1063,  1064,  1068,  1073,  1077,
    1087,  1095,  1099,  1103,  1108,  1112,  1160,  1162,  1166,  1170,
    1174,  1178,  1192,  1210,  1221,  1235,  1236,  1240,  1251,  1262,
    1273,  1297,  1307,  1317,  1327,  1337,  1347,  1367,  1385,  1399,
    1400,  1411,  1421,  1431,  1446,  1464,  1465,  1469,  1476,  1484,
    1485,  1486,  1487,  1488,  1489,  1503,  1509,  1515,  1524,  1532,
    1540,  1544,  1552,  1560,  1567,  1576,  1577,  1585,  1596,  1604,
    1612,  1623,  1631,  1639,  1646,  1655,  1665,  1666,  1670,  1671,
    1674,  1676,  1680,  1681,  1682,  1683,  1687,  1688,  1689,  1695,
    1707,  1711,  1715,  1730,  1737,  1738,  1739,  1743,  1744,  1745,
    1749,  1750,  1754,  1758,  1759,  1766,  1773,  1783,  1790,  1800,
    1801,  1806,  1807,  1812,  1818,  1824,  1830,  1836,  1846,  1856,
    1857,  1861,  1862,  1870,  1885,  1891,  1897,  1903,  1909,  1928,
    1937,  1946,  1955,  1964,  1975,  1986,  1995,  2004,  2013,  2024,
    2035,  2044,  2053,  2062,  2071,  2080,  2089,  2100,  2114,  2115,
    2119,  2120,  2126,  2139,  2155,  2165,  2181,  2190,  2199,  2208,
    2217,  2226,  2234,  2242,  2251,  2260,  2269,  2278,  2295,  2304,
    2313,  2322,  2332,  2345,  2360,  2369,  2378,  2387,  2397,  2407,
    2422,  2430,  2440,  2450,  2457,  2464,  2472,  2480,  2487,  2494,
    2502,  2510,  2518,  2525,  2532,  2540,  2547,  2554,  2562,  2570,
    2578,  2586,  2594,  2602,  2612,  2619,  2627,  2635,  2643,  2651,
    2659,  2666,  2673,  2680,  2686,  2695,  2703,  2711,  2719,  2728,
    2738,  2739,  2743,  2744,  2745,  2749,  2757,  2761,  2762,  2766,
    2773,  2780,  2787,  2797,  2798,  2801,  2804,  2805,  2809,  2810,
    2815,  2819,  2823,  2828,  2835,  2837,  2842,  2846,  2850,  2861,
    2869,  2922,  2935,  2949,  2961,  2968,  2972,  2979,  2980,  2981,
    2982,  2983,  2987,  2988,  2993,  2994,  2999,  3009,  3019,  3039,
    3052,  3053,  3058,  3067,  3077,  3087,  3113,  3119,  3152,  3184,
    3208,  3209,  3213,  3214,  3218,  3219,  3229,  3230,  3231,  3234,
    3235,  3240,  3241,  3245,  3249,  3253,  3257,  3261,  3265,  3269,
    3273,  3277,  3281,  3285,  3289,  3293,  3297,  3301,  3310,  3314,
    3318,  3322,  3326,  3330,  3334,  3335,  3340,  3344,  3351,  3358,
    3359,  3360,  3361,  3362,  3366,  3370,  3378,  3396,  3426,  3462,
    3499,  3536,  3555,  3587,  3588,  3589,  3590,  3591,  3598,  3605,
    3606,  3610,  3611,  3615,  3616,  3620,  3624,  3631,  3635,  3642,
    3643,  3644,  3648,  3649,  3652,  3674,  3693,  3715,  3716,  3720,
    3727,  3728,  3729,  3760,  3767,  3774,  3785,  3796,  3808,  3817,
    3826,  3844,  3845,  3864,  3871,  3878,  3885,  3896,  3906,  3907,
    3908,  3912,  3913,  3914,  3915,  3916,  3917,  3918,  3927,  3934,
    3938,  3951,  3966,  3980,  3995,  4009,  4027,  4048,  4049,  4053,
    4054,  4058,  4059,  4062,  4068,  4072,  4080,  4085,  4091,  4092,
    4096,  4101,  4108,  4109,  4119,  4121,  4123,  4125,  4128,  4131,
    4134,  4138,  4139,  4140,  4141,  4142,  4145,  4146,  4150,  4151,
    4154,  4168,  4183,  4186,  4187,  4190,  4191,  4194,  4205,  4216,
    4230,  4231,  4232,  4233,  4236,  4237,  4238,  4239,  4242,  4243,
    4247,  4248,  4256,  4259,  4260,  4261,  4271,  4272,  4275,  4293,
    4307,  4314,  4321,  4351,  4352,  4356,  4363,  4370,  4381,  4383,
    4385,  4388,  4406,  4417,  4441,  4460,  4476,  4497,  4498,  4499,
    4511,  4524,  4540,  4553,  4554,  4566,  4586,  4599,  4615,  4626,
    4637,  4638,  4641,  4642,  4645,  4646,  4649,  4653,  4657,  4661,
    4665,  4669,  4673,  4677,  4681,  4685,  4689,  4694,  4698,  4702,
    4708,  4709,  4713,  4714,  4715,  4720,  4723,  4724,  4736,  4748,
    4763,  4764,  4772,  4773,  4777,  4778,  4782,  4783,  4787,  4788,
    4792,  4802,  4815,  4816,  4826,  4837,  4838,  4851,  4858,  4875,
    4884,  4893,  4902,  4911,  4920,  4932,  4935,  4939,  4943,  4947,
    4951,  4963,  4973,  4976,  4980,  4993,  5002,  5011,  5020,  5029,
    5038,  5047,  5056,  5065,  5074,  5083,  5092,  5101,  5110,  5119,
    5128,  5137,  5146,  5155,  5164,  5173,  5182,  5191,  5200,  5209,
    5218,  5236,  5247,  5248,  5249,  5250,  5254,  5255,  5259,  5260,
    5270,  5278,  5290,  5291,  5295,  5299,  5307,  5311,  5315,  5322,
    5326,  5331,  5336,  5343,  5350,  5355,  5365,  5377,  5392,  5393,
    5398,  5399,  5403,  5404,  5414,  5423,  5431,  5448,  5468,  5488,
    5509,  5540,  5549,  5570,  5585,  5586,  5590,  5598,  5613,  5622,
    5634,  5635,  5647,  5655,  5672,  5696,  5713,  5727,  5728,  5732,
    5733,  5737,  5738,  5742,  5743,  5747,  5761,  5765,  5766,  5770,
    5771,  5772,  5773,  5774,  5784,  5802,  5823,  5849,  5850,  5851,
    5855,  5857,  5879,  5881,  5883,  5885,  5887,  5892,  5893,  5897,
    5898,  5902,  5913,  5914,  5918,  5927,  5931,  5935,  5940,  5950,
    5951,  5955,  5956,  5960,  5961,  5965,  5966,  5967,  5971,  5975,
    5976,  5977,  5981,  5982,  5987,  5988,  6015,  6016,  6017,  6018,
    6019,  6020,  6033,  6043,  6057,  6059,  6064,  6069,  6071,  6076,
    6086,  6087,  6088,  6089,  6101,  6121,  6143,  6153,  6164,  6174,
    6184,  6195,  6204,  6211,  6218,  6227,  6236,  6245,  6254,  6263,
    6273,  6282,  6294,  6297,  6298,  6301,  6305,  6312,  6313,  6314,
    6315,  6316,  6317,  6320,  6323,  6324,  6332,  6339,  6340,  6343,
    6345,  6356,  6367,  6378,  6389,  6402,  6403,  6419,  6434,  6435,
    6439,  6451,  6461,  6469,  6478,  6487,  6488,  6491,  6492,  6495,
    6496,  6497,  6500,  6514,  6519,  6529,  6538,  6550,  6551,  6555,
    6563,  6575,  6585,  6598,  6608,  6630,  6640,  6658,  6668,  6678,
    6688,  6698,  6708,  6718,  6728,  6738,  6748,  6758,  6768,  6782,
    6783,  6784,  6785,  6786,  6787,  6788,  6789,  6790,  6791,  6792,
    6793,  6794,  6799,  6800,  6801,  6802,  6803,  6804,  6805,  6810,
    6811,  6812,  6816,  6817,  6820,  6821,  6824,  6826,  6831,  6832,
    6842,  6853,  6854,  6855,  6889,  6897,  6905,  6913,  6921,  6929,
    6937,  6945,  6953,  6966,  6974,  6982,  6990,  6998,  7006,  7014,
    7022,  7034,  7035,  7036,  7037,  7038,  7039,  7040,  7041,  7042,
    7043,  7044,  7045,  7046,  7047,  7052,  7053,  7054,  7055,  7056,
    7057,  7058,  7059,  7060,  7061,  7062,  7063,  7064,  7068,  7069,
    7083,  7093,  7103,  7113,  7123,  7133,  7143,  7155,  7156,  7161,
    7162,  7163,  7164,  7165,  7166,  7171,  7172,  7173,  7174,  7175,
    7176,  7177,  7178,  7179,  7182,  7183,  7193,  7199,  7207,  7215,
    7223,  7231,  7239,  7247,  7255,  7263,  7271,  7279,  7287,  7295,
    7303,  7311,  7319,  7327,  7337,  7338,  7341,  7342,  7352,  7368,
    7382,  7408,  7410,  7412,  7414,  7421,  7430,  7431,  7434,  7441,
    7448,  7455,  7469,  7477,  7485,  7493,  7501,  7509,  7517,  7525,
    7533,  7541,  7549,  7557,  7565,  7573,  7581,  7589,  7601,  7602,
    7606,  7607,  7612,  7613,  7623,  7636,  7646,  7658,  7659,  7662,
    7663,  7673,  7683,  7684,  7688,  7692,  7696,  7707,  7720,  7734,
    7751,  7752,  7753,  7754,  7755,  7767,  7795,  7826,  7827,  7831,
    7832,  7836,  7837,  7841,  7842,  7845,  7846,  7854,  7865,  7876,
    7889,  7890,  7893,  7894,  7897,  7898,  7899,  7902,  7903,  7904,
    7920,  7932,  7945,  7960,  7961,  7964,  7965,  7969,  7970,  7974,
    7975,  7980,  7992,  7999,  8006,  8021,  8022,  8026,  8027,  8042,
    8051,  8060,  8069,  8078,  8090,  8091,  8092,  8093,  8094,  8100,
    8104,  8119,  8120,  8126,  8136,  8140,  8145,  8153,  8194,  8198,
    8202,  8206,  8214,  8215,  8219,  8229,  8230,  8236,  8237,  8244,
    8248,  8252,  8256,  8260,  8264,  8268,  8272,  8276,  8280,  8284,
    8288,  8292,  8296,  8300,  8304,  8308,  8313,  8320,  8324,  8328,
    8332,  8336,  8342,  8343,  8350,  8351,  8355,  8356,  8359,  8371,
    8375,  8390,  8401,  8402,  8407,  8408,  8423,  8433,  8446,  8456,
    8469,  8479,  8492,  8500,  8502,  8504,  8509,  8511,  8516,  8517,
    8522,  8540,  8549,  8550,  8554,  8558,  8570,  8581,  8592,  8605,
    8606,  8607,  8611,  8623,  8624,  8634,  8646,  8650,  8654,  8658,
    8665,  8685,  8694,  8703,  8712,  8723,  8724,  8727,  8728,  8729,
    8732,  8733,  8736,  8746,  8755,  8772,  8781,  8790,  8799,  8808,
    8817,  8826,  8835,  8844,  8856,  8865,  8874,  8883,  8893,  8903,
    8912,  8921,  8930,  8939,  8948,  8958,  8968,  8978,  8988,  8998,
    9008,  9018,  9028,  9038,  9048,  9058,  9068,  9079,  9090,  9101,
    9112,  9122,  9132,  9143,  9154,  9164,  9174,  9182,  9194,  9206,
    9215,  9224,  9233,  9242,  9251,  9260,  9269,  9283,  9284,  9287,
    9288,  9298,  9306,  9315,  9323,  9340,  9349,  9358,  9367,  9376,
    9385,  9394,  9403,  9412,  9421,  9430,  9439,  9448,  9457,  9466,
    9475,  9484,  9493,  9502,  9511,  9520,  9529,  9538,  9547,  9556,
    9574,  9583,  9584,  9587,  9589,  9595,  9596,  9597,  9598,  9599,
    9608,  9616,  9624,  9632,  9640,  9648,  9656,  9664,  9672,  9680,
    9688,  9696,  9704,  9712,  9720,  9728,  9736,  9744,  9752,  9760,
    9768,  9776,  9794,  9816,  9817,  9821,  9825,  9832,  9833,  9836,
    9857,  9864,  9872,  9880,  9897,  9911,  9928,  9932,  9939,  9948,
    9959,  9970,  9981,  9992, 10003, 10014, 10026, 10038, 10050, 10062,
   10074, 10094, 10104, 10114, 10124, 10142, 10159, 10160, 10161, 10166,
   10172, 10181, 10182, 10183, 10184, 10185, 10189, 10190, 10193, 10194,
   10195, 10196, 10200, 10201, 10202, 10214, 10224, 10225, 10228, 10237,
   10243, 10262, 10269, 10276, 10283, 10290, 10297, 10304, 10311, 10318,
   10325, 10333, 10341, 10349, 10357, 10365, 10372, 10379, 10386, 10393,
   10402, 10403, 10404, 10408, 10411, 10414, 10417, 10420, 10427, 10429,
   10431, 10436, 10438, 10450, 10463, 10476, 10494, 10515, 10516, 10517,
   10518, 10528, 10544, 10554, 10555, 10559, 10560, 10564, 10568, 10572,
   10590, 10591, 10592, 10593, 10594, 10595, 10596, 10603, 10604, 10615,
   10622, 10629, 10640, 10657, 10665, 10673, 10681, 10698, 10715, 10721,
   10737, 10750, 10759, 10767, 10775, 10784, 10795, 10806, 10816, 10817,
   10828, 10838, 10849, 10860, 10871, 10882, 10891, 10903, 10904, 10918,
   10941, 10949, 10958, 10969, 10970, 10982, 10997, 11012, 11024, 11033,
   11045, 11058, 11059, 11063, 11064, 11065, 11066, 11067, 11080, 11091,
   11102, 11111, 11123, 11124, 11128, 11135, 11142, 11150, 11159, 11160,
   11163, 11164, 11167, 11168, 11173, 11174, 11178, 11179, 11183, 11184,
   11190, 11204, 11218, 11242, 11259, 11260, 11264, 11265, 11269, 11270,
   11274, 11275, 11279, 11280, 11288, 11290, 11291, 11292, 11293, 11295,
   11296, 11297, 11298, 11300, 11301, 11302, 11303, 11305, 11306, 11307,
   11308, 11309, 11311, 11312, 11313, 11314, 11316, 11317, 11318, 11319,
   11321, 11322, 11323, 11324, 11326, 11327, 11329, 11330, 11331, 11332,
   11333, 11335, 11336, 11337, 11338, 11340, 11341, 11342, 11344, 11345,
   11346, 11347, 11349, 11350, 11351, 11352, 11354, 11355, 11356, 11357,
   11358, 11359, 11361, 11362, 11363, 11364, 11366, 11367, 11368, 11369,
   11371, 11372, 11373, 11374, 11383, 11384, 11385, 11386, 11387, 11388,
   11389, 11390, 11391, 11392, 11393, 11394, 11395, 11396, 11397, 11406,
   11407, 11408, 11409, 11410, 11413, 11414, 11415, 11416, 11417, 11424,
   11425, 11429, 11430, 11431, 11432, 11435, 11436, 11440, 11444, 11448,
   11452, 11456, 11463, 11474, 11485, 11496, 11507, 11518, 11539, 11555,
   11573, 11587, 11593, 11601, 11610, 11615, 11641, 11649, 11660, 11663,
   11666, 11670, 11671, 11691, 11701, 11711, 11721, 11740, 11748, 11764,
   11772, 11788, 11806, 11823, 11840, 11857, 11874, 11894, 11895, 11899,
   11903, 11917, 11927, 11937, 11947, 11966, 11980, 11986, 12003, 12018,
   12036, 12040, 12055, 12062, 12081, 12088, 12098, 12105, 12115, 12116,
   12117, 12118, 12119, 12120, 12121, 12122, 12123, 12127, 12131, 12138,
   12145, 12146, 12150, 12151, 12152, 12162, 12177, 12190, 12200, 12210,
   12222, 12223, 12224, 12227, 12228, 12229, 12232, 12233, 12245, 12255,
   12256, 12260, 12261, 12262, 12263, 12273, 12280, 12303, 12304, 12314,
   12320, 12326, 12332, 12348, 12366, 12370, 12378, 12384, 12391, 12397,
   12404, 12413, 12414, 12418, 12420, 12425, 12436, 12446, 12456, 12462,
   12471, 12480, 12486, 12487, 12498, 12512, 12513, 12524, 12535, 12536,
   12539, 12540, 12541, 12542, 12543, 12544, 12545, 12546, 12549, 12550,
   12554, 12555, 12556, 12565, 12572, 12580, 12582, 12585, 12587, 12598,
   12616, 12617, 12621, 12626, 12650, 12661, 12662, 12672, 12683, 12686,
   12687, 12688, 12689, 12690, 12693, 12694, 12695, 12743, 12744, 12748,
   12749, 12764, 12765, 12772, 12780, 12788, 12796, 12804, 12812, 12823,
   12824, 12851, 12865, 12880, 12881, 12900, 12904, 12908, 12925, 12932,
   12939, 12949, 12950, 12953, 12966, 12967, 12968, 12972, 12973, 12977,
   12989, 12997, 13002, 13007, 13012, 13017, 13025, 13033, 13038, 13043,
   13050, 13051, 13055, 13056, 13057, 13064, 13065, 13069, 13070, 13074,
   13075, 13079, 13083, 13084, 13087, 13096, 13109, 13110, 13111, 13112,
   13116, 13117, 13121, 13123, 13133, 13138, 13141, 13146, 13147, 13155,
   13165, 13166, 13167, 13175, 13179, 13180, 13183, 13184, 13209, 13210,
   13214, 13215, 13219, 13220, 13221, 13222, 13223, 13227, 13240, 13247,
   13254, 13261, 13262, 13266, 13267, 13271, 13272, 13276, 13277, 13281,
   13292, 13293, 13294, 13295, 13299, 13300, 13310, 13316, 13334, 13335,
   13339, 13340, 13346, 13351, 13359, 13366, 13374, 13380, 13387, 13432,
   13467, 13471, 13497, 13501, 13513, 13526, 13540, 13551, 13566, 13572,
   13577, 13583, 13590, 13591, 13599, 13603, 13607, 13613, 13620, 13625,
   13626, 13627, 13628, 13632, 13633, 13645, 13646, 13651, 13664, 13674,
   13687, 13704, 13705, 13708, 13716, 13728, 13729, 13742, 13746, 13753,
   13766, 13779, 13780, 13795, 13805, 13817, 13822, 13823, 13826, 13827,
   13830, 13831, 13836, 13837, 13842, 13843, 13851, 13856, 13857, 13861,
   13865, 13871, 13896, 13906, 13919, 13920, 13924, 13938, 13995, 14009,
   14011, 14016, 14018, 14020, 14022, 14027, 14029, 14034, 14042, 14062,
   14067, 14074, 14079, 14085, 14090, 14099, 14101, 14104, 14108, 14109,
   14110, 14111, 14112, 14113, 14118, 14138, 14139, 14140, 14141, 14152,
   14158, 14166, 14167, 14173, 14178, 14183, 14188, 14193, 14199, 14205,
   14210, 14216, 14222, 14228, 14234, 14241, 14248, 14255, 14277, 14286,
   14290, 14298, 14302, 14310, 14322, 14343, 14347, 14353, 14357, 14370,
   14378, 14388, 14390, 14392, 14394, 14396, 14398, 14403, 14404, 14411,
   14420, 14428, 14437, 14448, 14456, 14457, 14458, 14462, 14464, 14466,
   14468, 14470, 14472, 14474, 14479, 14484, 14490, 14498, 14503, 14510,
   14517, 14521, 14525, 14561, 14562, 14564, 14572, 14587, 14589, 14591,
   14593, 14595, 14597, 14599, 14601, 14603, 14605, 14607, 14609, 14611,
   14613, 14616, 14618, 14620, 14623, 14625, 14627, 14629, 14632, 14637,
   14645, 14650, 14658, 14663, 14671, 14676, 14685, 14693, 14701, 14709,
   14727, 14735, 14743, 14751, 14759, 14775, 14783, 14791, 14799, 14807,
   14815, 14823, 14827, 14831, 14835, 14839, 14847, 14855, 14863, 14871,
   14891, 14913, 14924, 14931, 14947, 14952, 14958, 14983, 14985, 14987,
   14989, 14991, 14993, 14995, 14997, 14999, 15001, 15003, 15005, 15007,
   15009, 15011, 15013, 15015, 15017, 15019, 15021, 15025, 15029, 15033,
   15037, 15042, 15058, 15059, 15060, 15075, 15109, 15111, 15113, 15124,
   15148, 15159, 15170, 15177, 15187, 15197, 15206, 15210, 15216, 15223,
   15230, 15240, 15247, 15275, 15310, 15321, 15322, 15329, 15335, 15348,
   15352, 15356, 15360, 15364, 15368, 15372, 15376, 15381, 15385, 15390,
   15394, 15398, 15403, 15407, 15412, 15416, 15420, 15424, 15426, 15430,
   15439, 15444, 15451, 15466, 15473, 15477, 15481, 15485, 15489, 15496,
   15504, 15512, 15516, 15520, 15524, 15528, 15532, 15538, 15542, 15551,
   15555, 15559, 15564, 15578, 15580, 15584, 15586, 15588, 15591, 15594,
   15597, 15598, 15601, 15609, 15619, 15620, 15623, 15624, 15625, 15630,
   15634, 15638, 15642, 15653, 15654, 15658, 15659, 15667, 15668, 15672,
   15673, 15678, 15686, 15688, 15702, 15705, 15732, 15733, 15736, 15737,
   15748, 15766, 15773, 15782, 15799, 15844, 15852, 15860, 15868, 15876,
   15897, 15898, 15899, 15902, 15903, 15906, 15909, 15910, 15911, 15914,
   15915, 15918, 15919, 15920, 15921, 15922, 15923, 15924, 15925, 15926,
   15927, 15928, 15929, 15932, 15934, 15939, 15941, 15946, 15948, 15950,
   15952, 15954, 15956, 15968, 15972, 15979, 15983, 15989, 15993, 16002,
   16013, 16014, 16017, 16021, 16025, 16031, 16032, 16037, 16041, 16048,
   16049, 16050, 16051, 16052, 16053, 16054, 16055, 16065, 16069, 16076,
   16083, 16084, 16100, 16104, 16109, 16113, 16128, 16133, 16137, 16140,
   16143, 16144, 16145, 16148, 16155, 16165, 16179, 16180, 16184, 16195,
   16196, 16199, 16200, 16203, 16207, 16214, 16218, 16222, 16230, 16241,
   16242, 16246, 16247, 16251, 16252, 16255, 16256, 16266, 16267, 16271,
   16272, 16275, 16291, 16299, 16307, 16329, 16330, 16341, 16345, 16372,
   16374, 16379, 16382, 16385, 16387, 16389, 16391, 16401, 16403, 16414,
   16418, 16422, 16426, 16430, 16439, 16446, 16478, 16482, 16488, 16495,
   16499, 16503, 16509, 16510, 16512, 16513, 16514, 16518, 16548, 16575,
   16579, 16585, 16587, 16604, 16605, 16606, 16611, 16612, 16613, 16618,
   16619, 16620, 16621, 16627, 16628, 16629, 16630, 16631, 16652, 16653,
   16654, 16655, 16656, 16657, 16658, 16659, 16660, 16661, 16662, 16663,
   16664, 16665, 16666, 16667, 16668, 16670, 16672, 16673, 16674, 16675,
   16676, 16677, 16678, 16679, 16680, 16681, 16682, 16683, 16684, 16685,
   16686, 16687, 16688, 16689, 16690, 16691, 16692, 16693, 16694, 16695,
   16696, 16697, 16698, 16699, 16700, 16701, 16702, 16703, 16704, 16705,
   16706, 16707, 16708, 16709, 16710, 16711, 16712, 16713, 16714, 16715,
   16716, 16717, 16718, 16719, 16720, 16721, 16722, 16723, 16724, 16725,
   16727, 16728, 16729, 16730, 16732, 16733, 16734, 16735, 16736, 16737,
   16738, 16739, 16740, 16741, 16742, 16743, 16744, 16745, 16746, 16747,
   16748, 16749, 16751, 16753, 16754, 16755, 16756, 16757, 16758, 16759,
   16760, 16761, 16762, 16763, 16764, 16765, 16766, 16767, 16768, 16769,
   16770, 16771, 16772, 16773, 16774, 16775, 16776, 16777, 16778, 16779,
   16780, 16781, 16782, 16783, 16784, 16785, 16786, 16787, 16788, 16789,
   16790, 16791, 16792, 16793, 16794, 16795, 16796, 16797, 16798, 16799,
   16800, 16801, 16802, 16803, 16804, 16805, 16806, 16807, 16808, 16809,
   16810, 16811, 16812, 16813, 16814, 16815, 16816, 16817, 16818, 16819,
   16820, 16821, 16822, 16823, 16824, 16825, 16827, 16829, 16830, 16832,
   16834, 16835, 16836, 16837, 16838, 16839, 16840, 16841, 16842, 16843,
   16844, 16847, 16849, 16850, 16852, 16854, 16855, 16856, 16858, 16860,
   16861, 16862, 16863, 16864, 16865, 16866, 16867, 16868, 16869, 16870,
   16872, 16874, 16875, 16876, 16878, 16880, 16881, 16882, 16883, 16884,
   16885, 16886, 16887, 16888, 16889, 16890, 16891, 16892, 16893, 16894,
   16895, 16896, 16897, 16898, 16899, 16900, 16901, 16902, 16903, 16904,
   16905, 16906, 16907, 16908, 16909, 16910, 16911, 16912, 16913, 16914,
   16915, 16916, 16917, 16919, 16921, 16922, 16923, 16924, 16925, 16926,
   16927, 16928, 16929, 16930, 16931, 16932, 16933, 16934, 16936, 16938,
   16939, 16940, 16941, 16942, 16943, 16944, 16945, 16946, 16947, 16948,
   16949, 16950, 16951, 16952, 16953, 16954, 16955, 16956, 16957, 16958,
   16959, 16960, 16961, 16962, 16963, 16964, 16966, 16968, 16969, 16970,
   16971, 16972, 16973, 16974, 16975, 16976, 16977, 16978, 16979, 16980,
   16981, 16982, 16983, 16984, 16985, 16986, 16987, 16988, 16989, 17003,
   17004, 17006, 17007, 17009, 17010, 17011, 17012, 17013, 17014, 17015,
   17016, 17017, 17018, 17019, 17020, 17021, 17022, 17023, 17024, 17025,
   17026, 17027, 17028, 17029, 17031, 17033, 17034, 17035, 17036, 17037,
   17038, 17039, 17040, 17041, 17042, 17043, 17044, 17045, 17046, 17047,
   17048, 17049, 17050, 17051, 17052, 17053, 17054, 17055, 17056, 17057,
   17058, 17059, 17073, 17074, 17075, 17076, 17077, 17078, 17079, 17080,
   17081, 17082, 17083, 17084, 17085, 17086, 17087, 17088, 17089, 17090,
   17091, 17092, 17093, 17094, 17095, 17105, 17106, 17107, 17108, 17109,
   17110, 17111, 17112, 17113, 17115, 17117, 17118, 17119, 17120, 17121,
   17122, 17123, 17124, 17125, 17126, 17127, 17128, 17129, 17130, 17132,
   17134, 17135, 17136, 17137, 17138, 17139, 17140, 17141, 17142, 17143,
   17144, 17145, 17146, 17147, 17148, 17149, 17150, 17151, 17152, 17153,
   17154, 17155, 17156, 17157, 17158, 17160, 17162, 17163, 17164, 17165,
   17166, 17167, 17168, 17170, 17172, 17173, 17174, 17175, 17176, 17178,
   17180, 17181, 17183, 17185, 17187, 17188, 17190, 17191, 17192, 17193,
   17194, 17195, 17196, 17197, 17198, 17199, 17200, 17202, 17204, 17205,
   17206
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "EQUALS_GREATER", "LESS_EQUALS", "GREATER_EQUALS", "NOT_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTACH", "ATTRIBUTE", "AUDIT", "AUTHORIZATION",
  "BACKWARD", "BARRIER", "BEFORE", "BEGIN_P", "BEGIN_SUBTXN", "BETWEEN",
  "BIGINT", "BINARY", "BINARY_FLOAT", "BINARY_DOUBLE", "BIT", "BOOLEAN_P",
  "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLEAN", "CLOSE", "CLUSTER", "COALESCE",
  "COLLATE", "COLLATION", "COLUMN", "COLUMNS", "COMMENT", "COMMENTS",
  "COMMIT", "COMMIT_SUBTXN", "COMMITTED", "CONCURRENTLY", "CONFIGURATION",
  "CONFLICT", "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P",
  "CONTINUE_P", "CONVERSION_P", "COORDINATOR", "COPY", "COST", "CREATE",
  "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DBTIMEZONE", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT",
  "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DEPENDS", "DESC", "DETACH", "DICTIONARY", "DIRECT",
  "DISABLE_P", "DISCARD", "DISTINCT", "DISTKEY", "DISTRIBUTE",
  "DISTRIBUTED", "DISTSTYLE", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCHANGE", "EXCLUDE",
  "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXTENSION",
  "EXTENT", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER",
  "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD",
  "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GENERATED", "GLOBAL",
  "GRANT", "GRANTED", "GREATEST", "GROUP_P", "GROUPING", "GTM", "HANDLER",
  "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE",
  "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDING",
  "INCREMENT", "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY",
  "INLINE_P", "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT",
  "INSTEAD", "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO",
  "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL",
  "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF",
  "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL",
  "LOCALTIME", "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED",
  "MAPPING", "MATCH", "MATERIALIZED", "MAXVALUE", "METHOD", "MINUTE_P",
  "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL",
  "NATURAL", "NCHAR", "NEW", "NEXT", "NO", "NOAUDIT", "NODE", "NONE",
  "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF",
  "NULLS_P", "NUMBER", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OID_P", "OIDS", "OLD", "ON", "ONLY", "OPENTENBASE_P", "OPERATOR",
  "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY", "OUT_P", "OUTER_P",
  "OVER", "OVERLAPS", "OVERLAY", "OVERRIDING", "OWNED", "OWNER",
  "PARALLEL", "PARSER", "PARTIAL", "PARTITION", "PARTITIONS", "PASSING",
  "PASSWORD", "PAUSE", "PLACING", "PLANS", "POLICY", "POSITION",
  "PRECEDING", "PRECISION", "PREFERRED", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROGRAM",
  "PUBLICATION", "PUSHDOWN", "QUOTE", "RANDOMLY", "RANGE", "READ", "REAL",
  "REASSIGN", "REBUILD", "RECHECK", "RECURSIVE", "REF", "REFERENCES",
  "REFERENCING", "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME",
  "REPEATABLE", "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK",
  "ROLLBACK_SUBTXN", "ROLLUP", "ROW", "ROWS", "RULE", "SAMPLE",
  "SAVEPOINT", "SCHEMA", "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P",
  "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER",
  "SESSION", "SESSION_USER", "SESSIONTIMEZONE", "SET", "SETS", "SETOF",
  "SHARDING", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP", "SLOT",
  "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STEP", "STORAGE",
  "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING", "SUCCESSFUL",
  "SYMMETRIC", "SYNC", "SYSDATE", "SYSID", "SYSTEM_P", "SYSTIMESTAMP",
  "TABLE", "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE",
  "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOCK_P",
  "UNLOGGED", "UNPAUSE", "UNTIL", "UPDATE", "USER", "USING", "VACUUM",
  "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR",
  "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW", "VIEWS",
  "VOLATILE", "WHEN", "WHENEVER", "WHERE", "WHITESPACE_P", "WINDOW",
  "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA",
  "'<'", "'>'", "'='", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'",
  "$accept", "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "CreateSchemaStmt", "OptSchemaName",
  "OptSchemaEltList", "schema_stmt", "VariableSetStmt", "set_rest",
  "generic_set", "set_rest_more", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "reset_rest",
  "generic_reset", "SetResetClause", "FunctionSetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "alter_group_cmds",
  "partition_cmd", "alter_group_cmd", "index_partition_cmd",
  "alter_table_cmd", "alter_column_default", "opt_drop_behavior",
  "opt_collate_clause", "alter_using", "replica_identity",
  "Identified_cluster", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "partbound_datum",
  "partbound_datum_list", "range_datum_list", "PartitionRangeDatum",
  "AlterCompositeTypeStmt", "alter_type_cmds", "alter_type_cmd",
  "ClosePortalStmt", "CopyStmt", "copy_from", "opt_program",
  "opt_shard_list", "copy_file_name", "copy_options", "copy_opt_list",
  "copy_opt_item", "opt_binary", "opt_oids", "copy_delimiter", "opt_using",
  "copy_generic_opt_list", "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "generated_when",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem", "opt_no_inherit",
  "opt_column_list", "columnList", "columnElem", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem",
  "ExclusionWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "interval_expr", "part_strategy", "part_params", "part_elem", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptDistributeBy",
  "OptDistributeType", "DistributeStyle", "OptDistKey",
  "OptDistributeByInternal", "OptSubCluster", "OptSubClusterInternal",
  "OptConsTableSpace", "ExistingIndex", "CreateStatsStmt", "CreateAsStmt",
  "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "AlterForeignTableStmt",
  "ImportForeignSchemaStmt", "import_qualification_type",
  "import_qualification", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreatePolicyStmt",
  "AlterPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultPermissive",
  "RowSecurityDefaultForCmd", "row_security_cmd", "CreateAmStmt",
  "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerReferencing", "TriggerTransitions",
  "TriggerTransition", "TransitionOldOrNew", "TransitionRowOrTable",
  "TransitionRelName", "TriggerForSpec", "TriggerForOptEach",
  "TriggerForType", "TriggerWhen", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertStmt", "DropAssertStmt", "DefineStmt", "definition",
  "def_list", "def_elem", "def_arg", "old_aggr_definition",
  "old_aggr_list", "old_aggr_elem", "opt_enum_val_list", "enum_val_list",
  "AlterEnumStmt", "opt_if_not_exists", "CreateOpClassStmt",
  "opclass_item_list", "opclass_item", "opt_default", "opt_opfamily",
  "opclass_purpose", "opt_recheck", "CreateOpFamilyStmt",
  "AlterOpFamilyStmt", "opclass_drop_list", "opclass_drop",
  "DropOpClassStmt", "DropOpFamilyStmt", "DropOwnedStmt",
  "ReassignOwnedStmt", "DropStmt", "drop_type_any_name", "drop_type_name",
  "drop_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_type_any_name", "comment_type_name", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type_any_name",
  "security_label_type_name", "security_label", "FetchStmt", "fetch_args",
  "from_in", "opt_from_in", "GrantStmt", "RevokeStmt", "privileges",
  "privilege_list", "privilege", "privilege_target", "grantee_list",
  "grantee", "opt_grant_grant_option", "GrantRoleStmt", "RevokeRoleStmt",
  "opt_grant_admin_option", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique", "opt_concurrently",
  "opt_index_name", "access_method_clause", "index_params", "index_elem",
  "opt_collate", "opt_class", "opt_asc_desc", "opt_nulls_order",
  "CreateFunctionStmt", "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "operator_with_argtypes_list",
  "operator_with_argtypes", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "CreateTransformStmt", "transform_element_list", "DropTransformStmt",
  "ReindexStmt", "reindex_target_type", "reindex_target_multitable",
  "reindex_option_list", "reindex_option_elem", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "AlterObjectSchemaStmt", "AlterOperatorStmt", "operator_def_list",
  "operator_def_elem", "operator_def_arg", "AlterOwnerStmt",
  "CreatePublicationStmt", "opt_publication_for_tables",
  "publication_for_tables", "opt_publication_for_shards",
  "publication_for_shards", "AlterPublicationStmt",
  "CreateSubscriptionStmt", "publication_name_list",
  "publication_name_item", "AlterSubscriptionStmt", "DropSubscriptionStmt",
  "RuleStmt", "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "opt_transaction", "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "AlterCollationStmt", "AlterSystemStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "any_with", "CreateConversionStmt",
  "ClusterStmt", "cluster_index_specification", "VacuumStmt",
  "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "analyze_sync_option", "opt_verbose", "opt_full",
  "opt_freeze", "analyze_option_list", "analyze_option_elem",
  "opt_name_list", "AuditStmt", "audit_or_noaudit",
  "opt_when_success_or_not", "success_or_not", "audit_stmt_list",
  "audit_stmts", "audit_stmt", "audit_user_list", "audit_obj_type",
  "audit_obj", "CleanAuditStmt", "SampleStmt", "PauseStmt", "BarrierStmt",
  "opt_barrier_id", "CreateNodeStmt", "pgxcnode_name", "pgxcgroup_name",
  "pgxcnodes", "pgxcnode_list", "AlterNodeStmt", "DropNodeStmt",
  "CreateNodeGroupStmt", "AlterNodeGroupStmt", "DropNodeGroupStmt",
  "MoveDataStmt", "data_node", "shard_list", "CreateShardStmt",
  "DropShardStmt", "CleanShardingStmt", "CreateKeyValuesStmt",
  "qual_table_list", "CheckOverLapStmt", "ExplainStmt", "ExplainableStmt",
  "explain_option_list", "explain_option_elem", "explain_option_name",
  "explain_option_arg", "ExecDirectStmt", "DirectStmt", "CleanConnStmt",
  "CleanConnDbName", "CleanConnUserName", "opt_force", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_target",
  "insert_rest", "override_kind", "insert_column_list",
  "insert_column_item", "opt_on_conflict", "opt_conf_expr",
  "returning_clause", "DeleteStmt", "using_clause", "LockStmt", "opt_lock",
  "lock_type", "opt_nowait", "opt_nowait_or_skip", "LockNodeStmt",
  "lock_param_list", "lock_param", "UpdateStmt", "set_clause_list",
  "set_clause", "set_target", "set_target_list", "DeclareCursorStmt",
  "cursor_name", "cursor_options", "opt_hold", "SelectStmt",
  "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_with_clause", "into_clause", "OptTempTableName",
  "opt_table", "all_or_distinct", "distinct_clause", "opt_all_clause",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "opt_partition_for", "partition_for",
  "relation_expr_list", "relation_expr_opt_alias", "tablesample_clause",
  "opt_repeatable_clause", "func_table", "rowsfrom_item", "rowsfrom_list",
  "opt_col_def_list", "opt_ordinality", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "xmltable",
  "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "explicit_row", "implicit_row", "sub_type",
  "all_Op", "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "func_arg_list", "func_arg_expr", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "opt_slice_bound", "indirection", "opt_indirection", "opt_asymmetric",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "ColId", "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,    60,    62,    61,   749,    43,    45,
      42,    47,    37,    94,   750,    91,    93,    40,    41,    46,
      59,    44,    58
};
# endif

#define YYPACT_NINF -5107

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5107)))

#define YYTABLE_NINF -2908

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2908)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    9637,  1256, 18981, -5107, -5107, -5107,  1256, -5107,  1031, -5107,
     968, 74592,   975,  1248,  1301, -5107,   195, 14132, 75080, 85328,
     793,  1038, 14496,  1256, 75568,  2534, 56048, 70688,  1419, 85328,
     477,  1172, 55560, -5107,   828, 85328,  1784, 76056,  1389,  1527,
     814, 85816, 76544, 69224,  1353, -5107, 85328, 85328,  1722,  1493,
   86304, 77032,  1563, 77520,  1172, 51684,  1943,   185,  1531, 86792,
   85328,  2090,  2115,  1550, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,    11, -5107,
   14912, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
    1848, -5107,  1236,  2009,  1651,   885,  1670, -5107, -5107, -5107,
   66296,  1275, 85328, 85328, 85328,  1847, 85328,  1769, 85328,   527,
   66296, 61904,  1952, 78008,  1965,  1795, 78496,  1900, 47774, 87280,
   -5107, 85328, 59464, 85328, 85328, 87768, 85328, 85328, 85328, 85328,
     699, 72152, 85328,  1895, 85328, 85328, 59952, 88256,  2125,  1529,
   85328,  2318,  1941,  2355,  2219,  2369,  2386,  2398, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   85328, 13364,   477, -5107, -5107,  2090, 85328,  2199, 66296, 85328,
     477,  1938, 88744,  2023, 85328,  2190, 85328,  2034, 89232,   537,
    1855, 61904,  2197,  2038,  1915, 78984,  2097, 48263,  2166, 85328,
   85328, 61904, 89720, 90208,  2334, 90696, 85328, 85328, -5107, -5107,
    2179, 85328, 85328, -5107,  2301, 62392,  1542,  2311,  2446,  2372,
    1124, -5107, 79472, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, 65320,  1038, -5107, -5107,  2348, 66784, 85328,  2378, -5107,
   -5107, 91184,111122,  2204, -5107,   819, 67272, 62880,  2359,  2554,
    2184, 79960,  2236, 48752,  2598, -5107, -5107, 63368, -5107, -5107,
   -5107, -5107,  2465, -5107, 91672, -5107, 92160,  2297,  2378, -5107,
  111596, 63856, -5107,  2442, 92648, 93136, 93624, -5107,  2516,  2397,
    2178,  1648, 85328,  1625, 43349, -5107, -5107, -5107,   975, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107,   364,   305,   261,
     224,   346, -5107, -5107,   234,   236,   239,   364,  2681,  2681,
   -5107, 85328, -5107, -5107,   305,   779,  2194,  2194,  2194,  2437,
      22, -5107,  2194,  2360, -5107, -5107, -5107, -5107, 77520,  2523,
   85328, -5107,  2261,  2275,  2224, -5107,  2578,   477,  2235,  2689,
    2290, -5107, -5107, -5107, -5107, -5107,  2294, 85328, 85328, 85328,
   -5107, -5107,  2712,  2281,  2559,  2298, -5107, -5107, -5107,  2515,
    2525,  2530,   147,   477,  2396,  2332,  1772, -5107,  2655, -5107,
    2553, 30879, 30879,   477, 80448, 94112,   241, 65320,   477, 80936,
    2354,  1359,  2543, -5107, -5107, -5107,   144, -5107,  2825,  2381,
    2652,  2298,  1529, 44821, -5107,   136, 77520, -5107, -5107, -5107,
   -5107,   394,  2707, 32899, 85328,  2383, -5107,  2382,  2383,  2402,
    2406,  1651, -5107,  9637,   217, 94600,  2596, -5107,  4355, -5107,
    2511,  4939, -5107,  2518,  2503,  5946,  2517, -5107, -5107,  1502,
   -5107, -5107,  2540,  2544,  2476, -5107, -5107, -5107, -5107, -5107,
    1522, -5107,  2603,   986, -5107, -5107, -5107,  2552, -5107,  2570,
   -5107, -5107,   252,  2451, -5107,  1524,  1524,  2927,  1524,  1615,
    1905, -5107,  2241, -5107,  2808,  2779, 77520,  2494,   240, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107,  1814,  2504,  1772, -5107,   250, -5107,  2747, 85328,
    1631,  2512,  1838,  1134, -5107, -5107,   881, 85328,   257,  2562,
   81424,  4781,  2519,  1772,  2531, -5107, -5107, -5107,  2703,   426,
   -5107, -5107, -5107, -5107, 85328,  2835,  2890,  8271,   354, 81912,
   85328,  2849, -5107, 85328, -5107, -5107, -5107, -5107, 85328, 85328,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,  2560,
    1414, -5107, -5107,  2546,  2908,  2785,  1108,  2876,  2738,  1447,
    2798,  1543,  2929, 17281,  1286,  2741,  1870,   271, 82400, 85328,
    2888,  2931,  9226,  1628,  1057,  2805,  1014,  2876,  2921,  2749,
    1447,  2936, 11445, 85328, -5107,  2860,  2977,   103, -5107,   332,
   -5107,  1006, -5107, -5107,   342,  2813, 85328, -5107, -5107,  3044,
    2656,  2820,    98,  2857, 66296,  2609, -5107, -5107, 85328, -5107,
   -5107,112070,  2687, -5107,   867, 66296, -5107,  2831,  2657, 49241,
   85328, -5107, -5107, 85328, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107,  2752,  2949, 85328,112070, -5107,  2894, 85328, 85328,
    2951,  2617, -5107, -5107, -5107, -5107,  2194, 85328,  2619,  3057,
   -5107, -5107,112070,  2859,   419, 85328,  1616,  2944,  3097, 85328,
    2865,  2955,  1616,  2669, 95088, -5107, -5107,  1616, -5107, 85328,
    3143, -5107, -5107, 85328,  1581, 85328, 85328, 85328,  2642,  2066,
    2863,  2978,  1616,  2882,  3109,  3120,  2895,  2735,   248,  2906,
    2382,  3079,  2875,  1075,   356,   209,  1999,  1616,  2721, 95576,
   96064, 85328,  2725, 85328,  3106, 66296, 85328,  3022, -5107,  2872,
   -5107, -5107,  1061, -5107, -5107, -5107, -5107, -5107,  3040, -5107,
     180,   286,  3041,  2695,  3047, 96552, -5107, -5107, -5107, -5107,
   -5107,  2745, -5107,  2745,  2745,  2701,  2701,  2892,  2705,  3060,
   -5107, -5107, -5107,  2144,  2745,  2701,  2701, -5107,113018, -5107,
    1633,  1703, -5107,   198, -5107,  3188, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107,  2718, -5107,  1003,  1808, -5107, -5107,
    2753, -5107,  3068,   210, -5107,  3070, -5107,  2720, 85328, 97040,
   -5107, 85328,  2849, 97528, 98016, 98504,  3072,   228, -5107, 61904,
    3074,  2720,  3052,  3081,   286,  3085, -5107,  1076,  3075,  3090,
     198,  3092,  2001,  2720, 65808,  3094,   348, -5107,  3095,   361,
    3098,  2970, 98992,  2754, 32899, -5107,  2845, -5107,  1531, -5107,
    1464, -5107, 54584, -5107,  1625,   305, -5107, 85328,   305, 85328,
     305, 85328,   305, 85328,   305, 85328, 85328, 85328,   305, -5107,
   -5107, -5107, 85328,  2755, 85328, 85328, -5107, -5107, -5107, 71176,
   61904, 71664, -5107, 85328, -5107,   134, 85328,  3151, -5107,  2759,
    2760,   477, -5107, 99480, -5107,112070,  3233, 61904,  3106, -5107,
    1782, -5107, -5107, -5107, -5107, -5107, -5107,  3034, 85328,  3100,
    3104, 71176, 61904,  3105, 99968,  2681, 32899, 51196, -5107,  1772,
   65320,  2992,  2773, -5107, -5107, -5107, -5107, -5107,  1885,  3278,
    3279,  3281,   251,  3290, 32899,  2789,   251,   251,  2795,  3131,
   -5107, -5107, -5107,   301,  2799,  2800, -5107, -5107,   270,   270,
   -5107,  2802,  2803, -5107,   273,  2804,  2806,  3300,  3309,   287,
    2809,  2810,  2811,  2144,   251, 32899, -5107,  2812,   270,   270,
    2815,  2821,  2822,  3315,  2823, -5107, -5107,  3322,  2826, -5107,
   -5107,   316,   374,  2830,  2838, -5107,  2802, -5107,   300,  2840,
    2844,  2846,  2847,  2848,  2850,  2851,  2854, 32899, 32899, 32899,
   -5107, 29364,  1772,   477, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107,   303,  4412, -5107,  2861, -5107, -5107,  3039, -5107,
   -5107, 32899, -5107, -5107,   117, -5107,   311, -5107, -5107, -5107,
    1772,  3121,  2855, -5107, -5107,  1456,  2858, -5107,   435, -5107,
   -5107, -5107, -5107, -5107, -5107, 64344,  3327, -5107,   448,   477,
     332,   382,  3262, 53608, 54096, -5107, -5107,  3134, -5107, 85328,
    3065,  3201, -5107, -5107, -5107,   159, -5107, -5107, -5107, -5107,
    1859, -5107, -5107, -5107,   975, 13272,  1867,  2383, 85328, 85328,
    3340, -5107, -5107, -5107, -5107, -5107,  1869, -5107,   281, -5107,
    2382, -5107, -5107, -5107, -5107, -5107,  2914, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107,  2915,  3191, -5107, -5107, -5107,  3192, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107,  2919,  3197, -5107, -5107, -5107,  3183, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, 85328, 72640,
    3119, -5107, 15572, -5107, -5107,  1651,  1651, 32899,  1651,   856,
     142, 31384, 32899,  3218,  3110,   282,  1203,  3221, -5107,  3117,
    1615,  1905, 77520, 85328,100456,  3026, 32899,  2982,  2983,  3045,
   52660, -5107,  1772, 85328,  2849,  2987,  2952,  2990,  3050, 57024,
    2909,  2995,  2998,  3051, -5107,  3185, -5107, -5107,  3000,  3001,
  100944, -5107, -5107,   959, -5107, -5107, -5107,   959, -5107,  2932,
    1727,   260,   285,  3002,   219,   868,  3339, -5107,  1435, -5107,
   -5107,  3064, -5107,  5329, 85328,  3271, 12336,  3146,   354,  3148,
    3067, -5107, -5107,   196,  3011, 85328, -5107,  3015,  3170,   354,
     325,101432, -5107, -5107, -5107, -5107, -5107, -5107,  5554, 28415,
   -5107,  1970,  3027,  3004,  1581,  3037, 85328, 68248,  1787,  3154,
    3187,  3204,  3190,  1479,  3417,   890,  1379,  2010,   245,  3273,
    3118, 85328,  1690,  3199, 85328,  2975,  3059,  3323,  3062,  3293,
    2984,  1706,  1238,  3395,  2979, -5107, -5107, -5107, -5107, -5107,
   -5107,  2228,  2234,  3189, -5107,  3291,  3334,  8407,  3125, 85328,
    1581,  1415,  3049,  3056,109700, -5107,  3076,   780, 49730, 85328,
   85328,  3083,  3086,  3087,  3088,    31,  3397,  1711,  3089, -5107,
   -5107, -5107,  1711, 85328,  3091,  3096, 85328,113018,   354, -5107,
    3450,   354,   354,  2113,  3453,  3099,   451,  3258,  1919,  1616,
    2979,  1951, -5107,  3101,  3103,   336, -5107,  3228,  3107,  3108,
    3115,  3156,   477, -5107, -5107,  3116,  3195,  3124,   694, -5107,
   -5107,  1295,  3112, 77520,  3224,  3227,   264,  2163,  2979, -5107,
    3126,  3127,  2984,  2984, 85328, 85328, 85328, 85328, 85328,   249,
    3500,  3501,  3130,   446,  3178,  3035, -5107,  1711, 60440,  3133,
   -5107,  1711, 85328,  3135,  2260,  2979,  1652,  1752, -5107, -5107,
   -5107,  1529, -5107, 85328, 85328,  3376,  2754,  2754, 72640,  3381,
   85328, 85328, -5107, 85328, -5107,  3338,112070,  3275,  3342, -5107,
    3093, -5107,  3343,   354, -5107, 85328, 85328,  3345,  3276,  3282,
    1107,112070,  3285,  3350, -5107,  3352,  3353,  3510,  3158,  3111,
    3149, 53134, -5107,  2642,  3078,  3551,  3427, 85328, 57024, -5107,
    3564,   959, 85328, -5107,112070,  3302,  3431,   256, -5107, 85328,
    3324,   657, -5107,  1581, -5107,   172,  3122,    68,  3308, -5107,
    3507,  3479,  3152, -5107, -5107,   926, 85328,   262,  3543, -5107,
   -5107,  3443, 61904,  1478,  3444,   477,  3153,  3420,  3407,  3452,
    3326,   477, 61904,  3365, 85328, 85328, 85328, 85328, -5107, -5107,
    3335,   895,   315, -5107, 60440,  3348, -5107, 85328,  3354,  1951,
    3364,  3580,    76,  2194,101920,  3449, -5107,102408,  3128,  3601,
  112070,  3408, -5107,  2004, -5107,  3270, -5107, 66296, -5107, -5107,
   66296, -5107, -5107, -5107,112070, 85328,  3480, -5107, -5107,  3132,
   -5107, -5107, 32899, -5107, -5107, -5107,  2681, -5107,112070,  2745,
    2745, -5107, -5107, -5107,  3607,  3219,  3220,  2681, -5107,  2681,
   -5107,112070, -5107,  3139,  3140,  2681,  3222,  3223,  3225, -5107,
    3144,  3229,  2681, -5107, -5107,  2000, -5107, -5107, 66296, 66296,
   -5107, 61904, 61904, -5107,  3486,   348, -5107,  1581,  3492,   286,
    3493,  3205,  3496,  3207, 49730, 49730, -5107,   368, 61904, 85328,
   85328, -5107, 85328, -5107, -5107, -5107, -5107,112070,112070, -5107,
   61904, 60440,  3498,  3499,   286, 85328, 85328, -5107, 85328, -5107,
   85328, 85328,  3390,  1616, 85328,   477,  1871,102896,  1625, 64832,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, 85328, -5107,
   85328, -5107, 85328, -5107, 85328, -5107, 85328, -5107, -5107, -5107,
   85328, -5107, 85328,  1897, -5107, -5107,  1910,   942, 85328, 85328,
     255, 66296, 85328,  3382, 85328, 85328, 85328, 85328, 85328,  3236,
    2858,  1483, -5107,  1402,   848, 77520,  3389,  3552,  3488,  2277,
    2277, -5107,  3398,  1616, -5107,  1911,  2090,  1168, 85328,  1358,
    2294, -5107, -5107, 71664, 70688,  3489,   143,  3595, 85328, -5107,
    3163, 10828,  3161, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,  7569,
   32899,  1772, 30374, -5107, -5107, 13272,  3209, 32899, 32899,  3168,
    2681,  2681, -5107,  1239, 32899, 32899, 32899,  2681,  2681,  3487,
   32899, 49730, 32899, 37444, 26421, 32899, 32899, 29869, -5107, 32899,
    3418, 38448, 32899,   382,  3419, 32899,   382,  3487,  3665,  3665,
    1682,  3333,  3169,  1772, -5107,  2681,  1069, -5107,   323,112070,
   32899, 32899, 32899, 32899, 57024,  3256,   263, 85328, 32899,  3174,
    1515, -5107, 32899, -5107,  3175, 32899,  3263,  1244, 32899, 32899,
   32899, 32899, 32899, 32899, 32899, 32899, 32899, -5107, 39918,   469,
    3503,  3514,    46,   553, 82888, 30879,  3513, 25409, -5107,   293,
    3513, -5107, -5107, -5107, 85328,  3327, -5107, -5107,  3265, -5107,
   -5107, -5107, -5107, -5107,   314, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107,  3182, -5107, -5107, -5107, -5107,  3182, -5107,  3186,
   -5107,   165,  3502,  3504,   286, 94600,   394, 73128, -5107, 32899,
   -5107,  1923,   229, 94600,   217, -5107, 85328, 85328,  3286, -5107,
   -5107, -5107, -5107, -5107, -5107,  3509,  1349, -5107, -5107,   266,
    3238,   276, -5107,   295,   304, 83376,  3232,  3196, -5107,  3297,
   -5107,  3490, -5107,  3202, -5107, 11003,  3490, -5107, -5107,   231,
    3330,  3481,  3428, -5107, -5107, -5107,  3206, 13272, -5107,  1664,
   13272,  1948, -5107, -5107, -5107, -5107, -5107, -5107,   755, -5107,
   85328,   753,  3218,  1203,  3257,  1127,  3671, 85328, -5107, 45311,
    1939, 61904, 85328, 85328,  3422, -5107,  3657, -5107,113018, -5107,
    3212, -5107,112544,108752, -5107, -5107,   841, -5107,   911,  1581,
    1581, 61904, -5107, 85328, 85328, -5107, 57024, 61904, 85328, 85328,
   -5107, 61904, 85328, 85328, -5107, -5107, -5107, -5107, -5107, 55072,
    1052, 70688,  3355, 69712, -5107, -5107,  3215, 85328,  3277,  3505,
    3512,  1454, -5107, -5107,103384, -5107,  3448, 61904, 85328, 85328,
   32899,  3454, 85328, 85328, -5107,   294,  3305,  3306, -5107, 85328,
    3316,  3491, 66296,  3241, 85328, 85328,112070,  3310,   869, 66296,
    3280, 50219, 85328, 85328, 85328, 85328,  3374,  3572,112070, 85328,
    3520,  1182, 77520,   344,  2340,  2979,  3476, -5107,  3590,   345,
   -5107, -5107, 61904, -5107, 85328,  3470, -5107, -5107, -5107, 83864,
    3714,  3371, -5107, -5107,103872, -5107, -5107, -5107,  1958, -5107,
   61904, 61904, -5107, 85328, 15101,104360,  1472,  3494,  2754,  2681,
   -5107, -5107,112070, -5107, 85328, 85328, 85328, 85328,  2754,  3603,
    3526, 85328, 73616,  3763,  3261, -5107, -5107, -5107, -5107,  3633,
  104848,105336,   674,  1103,  3535, 85328, 74104, 85328,  3536, -5107,
    3421, 85328, -5107, -5107, 57512, 61904, -5107, 85328,   947, 57024,
   -5107, -5107,  3730, 85328, -5107,  3506,   307, -5107, 85328,  2754,
   85328, 13937, -5107, -5107,  3356,  3367, 85328,  3511,   386,  2420,
    2979,  3360,  3283, -5107, -5107, -5107,   477, -5107, -5107,  3458,
     722, 85328, 85328,  3288,  1981, 61904, 85328, 57024, -5107,  3517,
    1338, 77520, 77520, 61904, 85328, 77520, -5107, 85328, 94112, -5107,
   61904,   235, -5107,  3441, 61904, 85328, 17638, -5107, -5107, -5107,
     354, -5107, -5107, -5107, -5107, -5107, 85328, 85328,   354, 85328,
   85328,   354,  1287, -5107, 61904, 85328, -5107, -5107, -5107, 85328,
   61904, 85328, 85328, -5107, 61904,  3318, 85328, 57024, -5107, 85328,
   10746, 85328, 85328, 85328, 85328, 85328, 85328, 61904, 85328, -5107,
   -5107,  1393,   658,   131,   731,   871, 85328,  3594, 85328,105824,
   61904, 85328, 85328,   477, 85328,  1721, -5107, -5107,  3416, -5107,
   61904,   235, -5107, 15480, 85328, 85328,  3372,  3375,   218,  3463,
   -5107, -5107, -5107,  3294, -5107, -5107,  3628,  3628,  3628, 83376,
   -5107, 85328,  3296, -5107, -5107, -5107,   337,  3773,106312,   337,
   -5107,   337,  3586,  3361,  3362,   337, 85328, 85328, -5107, -5107,
   -5107, -5107,  3581, 85328,   337,   337,   337,  3525,  3495,  3529,
    3432,  3612,  3325,  1987, -5107, -5107, 32899,112070, 85328, -5107,
    1995, -5107,  3329,   895, -5107,  3349, -5107, 57024, 85328,  3631,
    3618,   232,   932,  3663,  3545, 68736,  1873, -5107,  3423,  3825,
    2754, -5107, -5107, -5107,   477, -5107,  3667, 85328,  3383, 85328,
    3808,  3433, 77520,  3464,  3318, -5107,  1873, 85328, -5107,  2026,
   70688, -5107, -5107, -5107, -5107, -5107, -5107, -5107, 85328, -5107,
   -5107,  3674, 85328,  2681, 85328, 32899,  3518, -5107,   477,  2642,
    2642,  2642,  2642, -5107, -5107, -5107, -5107,  3570,   197, -5107,
    3346,  2642, 85328,  3478,  3692,  1873,  3357,  3695, -5107,  1951,
    3700,  1917, 85328,  3582, 68736,  1581,  3399,  3597,  3836,  2194,
     477,  3602,  3587, -5107, 28889,  7192,  3588,  3647, 65320,  3687,
    3688,  3709, -5107,   180, -5107,  3848, -5107, 85328, 32899,  2007,
    3377,   198, -5107, -5107,  3379,  3140,  3396,  3400,  3380,  3384,
   -5107,  2681,   220,  3385,  1251,  1109,  3519,  2681,  3630,  3386,
   -5107,   210, -5107,  2720, -5107, 85328, -5107, -5107, 85328, -5107,
   85328, 85328, 85328, 85328,   228, -5107, -5107,  2720, -5107,   286,
   -5107,  3662,   198,  2720,  3523,  3722, 65320, -5107,   348, -5107,
     361,  3613,   286,  3741, -5107, -5107,  2019, -5107, -5107, -5107,
    3632,  2194, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
    2030, -5107, 85328, -5107,  3702,  3703,  3705,  3294,  3402,  3434,
   85328,  3403,  3294,   354,  3294,  2858,  2858,  3294,  3402, 60928,
    3886,  3725, -5107,  3497,  3404,  3737,   193, -5107,   835,    83,
    3660, -5107, -5107, -5107,  3740,106800,  2031, -5107, -5107, -5107,
    2048,  3757, -5107, -5107,112070, -5107, 61904,  3451, 85328, 85328,
   -5107,   362,  3640,  3409, 60928,  3861,   286,  3641, -5107, -5107,
   -5107, 32899, 66296, -5107, -5107,112070,  3508,  3528, 66296,  3654,
    3475, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,112070,
   -5107,  3710, 85328, 85328,  2050, -5107, -5107,  1765, -5107,  1768,
   32899,   183, -5107, 11516,  2055, 32899,  3435,  3436, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107,  3438,  3762, -5107,  2060,  2061,
    2062,  3439,  3442,  4990,  3446, 11946,  3447,  3445, 37444, 37444,
   29364,  1144, -5107, 37444,  3456,  3650,  2068, 11114,  3440,  3457,
   12038, 31889, 32899, 31889, 31889, 12082,  3440,  3459,  2076, 57024,
    3648, 12616,  2078, -5107, 32899, 57024,  5310, 32899, -5107, 32899,
    3460, -5107, -5107,  2901,  2901,  2901,  3487, -5107,  3468, -5107,
   37444, 37444, -5107,  2791, 29364, -5107, -5107,  3781, -5107, -5107,
    1773, -5107,  3462, -5107, -5107,  3129, 49730,  7952, 32899,   272,
   32899,  3174, 32899,  3541,  2901,  2901,  2901,   457,   457,   222,
     222,   222,   453,   553, -5107, -5107, -5107,  3466,  3467,  3469,
    3672,  3473, 32899, -5107,  2070,  2102, 85328,  2229,  2604,  3069,
   -5107, -5107, -5107, 40899,  3527, 32899, 32899, 32899,  3484, -5107,
    2327, 13272,   704, -5107,   328,  3527, -5107,  1529,  2681,  1069,
   54584,  3065, -5107, 32899, -5107, -5107, -5107, -5107,  2382, -5107,
   -5107, -5107,  1626, 13272, -5107, -5107,  3720,  3477, -5107,  2382,
   -5107, -5107,  3482,   281, -5107, -5107, 85328, -5107, -5107,  3232,
   -5107, 85328, -5107, 32899, -5107, -5107,  1760,  3483, 32899,  1664,
   -5107, -5107,  3547, -5107, 32899, -5107, -5107, -5107,  2858, -5107,
    3713, -5107, -5107, -5107, 40899,  3530,  3540,   635, 44330,  3711,
   -5107, 85328, -5107, 85328,   371, -5107,  3465, -5107, -5107, -5107,
   -5107, -5107, -5107,108752,  1808, -5107,112544, -5107,112544, -5107,
    1808,  3941, -5107,108752,   -11, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   61904, 61904,  3716, 85328,  3719,  3717, 32899,   958, 85328,  3515,
    3516,  1513,  3796, 85328, -5107,  3845,   286, -5107, -5107,  3589,
   -5107, 13272, -5107, -5107, -5107, -5107, -5107, 61904, 85328, -5107,
   65320, -5107, 85328, -5107,112070, -5107, -5107, -5107, 85328,  3539,
   85328, -5107, 85328, 85328, 85328, -5107, -5107, -5107, -5107, -5107,
    1125,112070, -5107, -5107, 85328, 85328,   188,  3591,  3592, 85328,
   -5107,   930,  3228, 15551, 85328, 85328, 85328,  3802, 85328, -5107,
   -5107, -5107, -5107,  3743, -5107, -5107,108752, -5107,  2720,  1387,
    3600,  2979,  3749, -5107,  3860, -5107, -5107,  3734, -5107,   981,
   -5107, -5107, -5107, 85328,  3659, -5107, -5107, -5107, -5107, -5107,
    3524, 85328,  3533, -5107,  3872,   286,  3873,   286, 85328, 85328,
   85328, 85328,  3673, -5107, -5107, -5107, -5107,  3573,  3675,  3797,
   -5107, 57024, 57024, 57024,  2094, -5107, -5107,   477, -5107, -5107,
   -5107, -5107, -5107, -5107,  3837, -5107,  2095, -5107,  1660,  3548,
   -5107, -5107, -5107, -5107, 85328, -5107, -5107, -5107, 61904, 85328,
   15835,  3888, 85328, 85328, 85328,  3932,  3125, -5107,  3318, 57024,
   -5107,  1890, -5107,  1589,112070, -5107,110174, -5107, -5107,  2099,
   -5107,  3558, 85328,  3634, 61904,  3606,  3546,  3546, -5107, -5107,
    3546, -5107, -5107, -5107,  3819,  3751, -5107,   360,  3754, 61904,
    3620, -5107,  3643, -5107, -5107,  3644,  2691,  2979,  1951, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107,  2642, -5107, -5107,  1517, -5107, -5107,  1440,
     302,  2827,  2979, -5107,   347, -5107,  3646, -5107,  3649, -5107,
   -5107, -5107,  3816,  3826,  3832,  3658,  3661,  3718,  3666,  3670,
    3721, -5107,  3678,  3724,  3679,  3732,  3795,  3682,   286,112070,
    3818,   477,  3728,  3939,   286, -5107,  3684, -5107,  3686, -5107,
    4071, -5107, 85328, -5107,  3689,  2853,  2979, -5107, -5107, 61904,
   85328, -5107, -5107, -5107,107288,  3693,  3693,  3693, -5107,  3694,
   -5107, -5107, -5107,112070, 85328,  3897, -5107, -5107,   337, 85328,
   85328, -5107,  3898,  3899, 85328,  3901, -5107, -5107, -5107, -5107,
   -5107,   476, -5107,  3619,   174,  3937, 46784, -5107,  4125,  5994,
    3621,   423, -5107, 57024, 46784,  1914,  2754,  2674,   176,  1616,
   85328,  2681, -5107, 65320, 85328, 65320, -5107,   932,  3734, 85328,
   85328, 85328,  3623,  3624, -5107, -5107, -5107, -5107, 61904,  1113,
   61904,  2681, -5107, -5107, 85328, -5107, -5107,  3804,  3699, -5107,
   85328,  2194,  4134,  3965, -5107,  3546,  3637, -5107,  4101,  3120,
    1478,  3799,  1568,  2735,  4036, -5107, -5107,  2382,   376, 57024,
    3399, -5107, -5107, -5107, -5107, 85328, 85328,   895,   477, -5107,
    3642,  3638, -5107, 85328,  3978, 85328, 85328, 85328, 85328,  3451,
    3645, 85328,  3651,112070,  3867,  2984,  4120,  3997,  2090,  3399,
    3735,  4001, 77520, -5107,  2101,   163, -5107,   477, 65320,109226,
    3989, -5107,  3976, -5107, -5107,   817, 85328,  3973, -5107, -5107,
    2090, -5107,112070, -5107,  2105, -5107, -5107, -5107,  2681, -5107,
   -5107,  1636,  1636,  3664, -5107,  3676, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107,  3668, -5107, -5107, -5107,   348,   286,  3715,
     286,  3723,   286, -5107, -5107, 85328, -5107, 85328, 60440,   286,
   -5107, -5107, 85328, -5107, 85328,   232, -5107, 85328,  4009, -5107,
   -5107,  3805,  3806,  3811, 85328,  3294, -5107,  3677, 61904,  1559,
   -5107, -5107,  3887, -5107, -5107, 77520,  3803, -5107, -5107, -5107,
   -5107,  4023,  4025, -5107,106800,  3680, -5107,  3761, -5107,  2277,
   -5107, 85328,   232, -5107, -5107,   884, -5107, -5107, -5107, 61904,
   71176,   379, 61904, -5107, -5107, 13272,  3683,  3961,  3967, -5107,
   -5107,  3969,   354, -5107,  3971, -5107,  3972,  3974, -5107, -5107,
   -5107,  3691, 12751, 32899, -5107,  4048,112070, -5107,  6034, -5107,
   -5107, -5107, 32899, -5107, -5107, -5107, -5107, -5107, 32899, -5107,
   32899,  4021, -5107, 26927,  4190,  4190,  3696,112070, 37444, 37444,
   37444, 37444,  1777,  2815, 37444, 37444, 37444, 37444, 37444, 37444,
   37444, 37444, 37444, 37949,   838, -5107,  3903, 32899, 32899,  4030,
    4021, -5107,112070,  3698,  3440,  3701,  3706, 32899, -5107, -5107,
    2106, 38938,  3708, 57024, -5107, 32899, 11383,  2107,  3750, 13128,
    1772,  6315,   477, 32899,  1170,  2948, 32899,  2114, 32899,  4026,
   -5107, -5107, -5107,  3729, -5107, -5107,112070, 32899,  3736,  3235,
   37444, 37444,  3895, -5107,  5146, 32899, 29364, -5107,  3919,  3756,
   45801, -5107, 27433,  3707,  1172,  1172,  1172,  1172, -5107, 85328,
   85328, 85328, 41389,  4043,  3738, 40408, 84352,  3745,  2087, -5107,
   84352, 84840, 84352, -5107,  3733, -5107,  3742,  1772, 32899,  4040,
     724,   724,  3919, -5107, 32899, 32899, 32394,  3744, -5107,  4040,
     332,  3758, -5107, -5107, -5107,  6398,  3286,  3760, -5107, -5107,
    2090,  3286, -5107, -5107,  3755, -5107,  3764, -5107,  3483,   903,
   -5107,  6547,  3940, -5107, -5107, -5107,  3745, 33404,  3876, -5107,
   -5107, -5107,  3776,  2120, -5107, -5107,  4144,  3876, -5107, -5107,
    2128, 45311,  3530, 32899,  1772,  2137,  1657, -5107, -5107,108752,
   -5107,  3813,  2720,  2720,   189,  3294,  4070,   189,  6830, -5107,
   -5107, 41879, 85328, 85328, -5107, 85328,  2153,  1729, 85328, -5107,
   85328, -5107, -5107, -5107, -5107,  4215, -5107, 85328, -5107, -5107,
    3801,  3820, 85328, 85328, 85328, 85328,  4039, -5107, -5107,  2512,
   -5107, -5107, 61904, 85328, -5107, -5107, -5107,   422,  2898,  2979,
   -5107,  3840, -5107, -5107, -5107,  4056, -5107,  4214,  3856, 85328,
    4114, 85328,  3768, -5107,  1729,  4094,   291,  2984,   451,  6584,
   -5107,   125, -5107, -5107,  3842, -5107, -5107, 85328,  2165, 85328,
   85328, -5107, 85328, -5107, -5107, -5107, -5107, -5107, -5107, 85328,
   -5107,  3907, -5107, -5107, -5107, -5107, 57512, -5107, -5107, 85328,
   -5107, 57024, 46784, 57024, 58488, -5107, -5107,  1449,   479,  2969,
    2979, 85328, -5107,  3854, -5107, -5107, -5107, -5107,  1517,  3857,
    3858,  3920,  1118,   247,  3863,  3864,  3924,  3783,  3784,  3785,
   -5107, 57024, 47285,  3948, 85328,  2720,  3788,  3828,   364,   477,
   -5107, -5107,   477,  2720,   477, 85328, 85328, 85328, -5107, 57024,
   -5107,  4241,  3883, 85328, 85328, 85328, 85328, -5107,  3846, -5107,
   85328, 85328,  4128,   829,  2025, 61904, 85328, 85328, 61904, 85328,
   85328, 85328, 85328, 85328, 85328,  4141, 85328, -5107,  4227,  4146,
    2100,  4195,  3874, 85328, -5107, 85328,   477,  3228, 85328, 85328,
   -5107, -5107, 85328, -5107, 61416, -5107, -5107, -5107, 85328,  3807,
    4087,   337, -5107,  4088,  4089,   337,   337,  4090,   337, -5107,
   -5107,  1616, -5107,  2681, -5107, -5107,  3495, 85328, -5107,  3764,
    2228,  2234, -5107, -5107, -5107, -5107, -5107, -5107,  3325, -5107,
   -5107,  2122, 85328, -5107, -5107, -5107, 85328, -5107,  3809, 85328,
   85328, 37444, -5107,  1541,  1643,   306, -5107,  4091, 85328,  3318,
   -5107, -5107, -5107,  3988, 85328, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107,   707,  3645, -5107,  4109, 68736,  2720, 61904, 61904,
    2720, -5107,    37, -5107, 57024,112070,  3812,  3399, -5107,   246,
    3896,  2681, 61904,  1478,  1425,107776,  3153,  3849,  4033, 40899,
    1517, -5107,  3814,  3981, -5107,  3823,  3817, -5107, -5107, 85328,
    3734, 60440,  2171,  1951,  4289,    81,  2178, -5107, 70200,  4020,
    3645,  4109,  4249,  3922, -5107,  2090, 85328,  3451,  3922,   477,
   85328,  3277, -5107,108752, 32899, 32899, -5107,  3829, -5107,  3834,
    7703, -5107,  3909,  3831, -5107, -5107, -5107, -5107, -5107, -5107,
    3911,  3838, 85328, -5107,  3841, -5107,  3844, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, 85328, -5107, 85328, -5107,   286, -5107,
    3970, -5107,   286,  1616, -5107, 85328, 85328, 85328, 85328,  3294,
     354, -5107,  4164, 60928, -5107, -5107,  2172, 85328, -5107, -5107,
    3926,  2681,106800, -5107,  1616, -5107,  4240,   143,  4175, -5107,
   -5107, -5107,   961,   961,   961,  4131,   961,   961,   961, -5107,
   32899, 13272, -5107,  3847, -5107, 13272,  6983, 13272,  4030, -5107,
    2181, 32899, -5107,  3759,  3759,  3759,  4426,  4179, -5107,  1016,
    3851,  3759,  3759,  3759,   474,   474,   289,   289,   289,  4190,
     838, 13272, 13272, -5107, -5107,  3855, -5107, -5107, -5107,  3440,
   -5107, 33909,  4027,  4301, -5107, -5107, -5107,  3900,  3904,  3859,
   -5107, 32899, 34414,  3862,113018,  4066, -5107,  1875, 32899, 32899,
    1116, -5107,  3739, 32899,112070,  2192,  1116,   486, 32899,  4085,
    4373, 32899, 32899,  5674,  7082,  3869, 32899,108264, -5107, -5107,
   -5107,  2196, 32899, 85328, 85328, 85328, 85328, -5107, -5107, -5107,
   84352, 84840, 84352,  3871, 39428, 27924,  2087,  3879, 85328, -5107,
   -5107,  3875, 40899,  4143,  4074, -5107, 40899,  4074,  1608,  4074,
    4154,  3984, 46291, -5107, -5107,  3885, -5107,  4106, -5107, 25409,
    1970, 13272,  4345,  4222, 32899,  3908,  3910,  3913, 13272, 13272,
   32899, -5107,   477,  4222,   477, -5107, -5107,  2681,  3914, -5107,
   85328, 49730, -5107, -5107, -5107, -5107, -5107,  4138, 13272, 30879,
   -5107,  2090,  2733, 85328,  1772,   665, -5107,  3928, 85328, -5107,
    3876, 13272, -5107,  3990,  2200, -5107, -5107, -5107, -5107, -5107,
   -5107,  4006, 70688,  4248, -5107, 32899,  2210, -5107,  3962,  4356,
     173,  2212,  2214,  1729, -5107,  3318, -5107,  1659,  4228,   473,
   -5107,   286, -5107,112070, -5107, 85328, 85328, -5107, -5107, -5107,
   -5107, 85328,  2909, -5107, -5107, 85328, 85328, 85328, 85328, -5107,
   61904, 85328, -5107, 85328, -5107, 57024,  2674,  1541,  4243,  4161,
   -5107,   354, -5107,  1541,  4173,   364, 85328, -5107, -5107,  2878,
   -5107,112070,  2225, -5107,  2238,   286,   286, -5107, -5107, -5107,
   -5107, -5107, -5107,  3953,   335,  3945,  4396,  4041, 85328, 85328,
   85328, -5107, 85328, -5107, 61904, 85328, 85328,  2681,  2681,112070,
    3946, -5107,  2681,  2681,  3949, -5107, 61904, 85328, 85328, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
    4031, -5107, 32899,  4389, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, 61904, 85328,  4045, -5107,  4047, -5107,   809,
   -5107, -5107, 85328, 85328, 85328, 85328,  4304, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, 85328, -5107, 85328,
   -5107, -5107,   477,   477,112070,   286,   286, -5107, -5107, -5107,
   -5107, -5107, 61904, -5107, -5107,  4242,   337, -5107,   337,   337,
   -5107, -5107,   337, -5107,  3959,  2254, -5107,   476, -5107,  1729,
    1791,  4293, -5107,  4296, 32899, -5107,  1583,  4426, -5107,  4357,
    4440, -5107, -5107, -5107, -5107,  3318,  2194,  4028, 66296,  1292,
   -5107,  4274,   232,  4198, 68736,   347,  1788,  3979,  4105, -5107,
    2720,  2720,  4298, 85328,  1517,  4038, 85328,  4448, -5107, -5107,
   -5107, -5107, -5107, -5107, 61904,  3606,  2255, -5107,  4221,  1094,
    4317, 85328, 32899,  3745, -5107,  1411,  4320, -5107,   477, -5107,
   -5107,  4118,  3399, -5107,  2090, 85328,  4217, 68736,  3451,  2265,
   -5107, -5107, -5107,  4029,  4437,  1581, -5107,   347,  4020,   987,
   85328,   924,  4034,  4461, -5107, -5107,  4322,  4220,  3994, -5107,
   13272, 13272,   477,113492,  3976,112070,  4335, 85328,   199,  4299,
     286, -5107,   286,   286, -5107, 85328, -5107, -5107,  3294,  3294,
    3294, -5107,  4219, -5107, -5107,  4290,106800,  4004,   237, -5107,
   -5107,   286, 60928, -5107, -5107, -5107, -5107, -5107,   961, -5107,
   -5107, -5107, 13272, -5107, -5107, -5107, -5107,  7138, 37444,  4336,
   -5107,  4011,112070, -5107,  4012,  2270,  2272, 38448,  4174, -5107,
   -5107, -5107,  7998,  4061, 13272,  4127,  4015,  4016,  1116,  1116,
    3739,  2289, -5107,  1116, 32899, 32899,  1116,  1116, 32899, -5107,
   -5107,  8550,  4213, -5107, -5107,  8936, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, 58000,  4022,  3648, 84352,  4032, 85328,  2087,
   40899, -5107, -5107,  1978, -5107, 40899,  4302, -5107, 40899, 66296,
   -5107, 85328,  4035, 85328, -5107,   704, 34919, 32899,  4058, -5107,
   -5107, -5107,  3919, -5107,  4058, -5107,  4024, -5107,  4042,  4037,
   85328,  2855, -5107,   635, -5107, -5107,  4447, 41879,  4390, 32899,
   -5107, -5107, -5107, -5107, 60928,  4253, 60928,  1729,  9752,  3318,
   41879, 50708, 85328, 85328, 85328,  4203,  3318,  4028, -5107, -5107,
   -5107, -5107, -5107, -5107,  4044, -5107, -5107, -5107, -5107,  4119,
   -5107, -5107,    33,  3389, -5107,  2303, -5107,  4514,  4393, -5107,
   -5107, -5107, -5107, -5107, -5107,  4227, -5107, -5107, -5107, -5107,
   46784, 32899, -5107, 61904, 85328, -5107,  4129, -5107, -5107, -5107,
   -5107, -5107, 43840, 49730, -5107,  1118,  4049,  4050,   247, -5107,
   -5107, -5107, 85328,  9858,  4054,    40,  3389, 85328, 85328,  4055,
    4057,  4059,  1650,  1473,  1730,  3294,  4377, -5107, -5107, -5107,
   -5107,  4227, -5107, -5107, -5107,   337, -5107, -5107, -5107, -5107,
   57024, -5107,  2661, -5107,  2681,   459, 66296,  4520,  4520, 85328,
   -5107,  9989,  4288, -5107, -5107,  4372,  4028,  4319,  4365, -5107,
    4064, 85328,  4246,  4068, 85328,  4065,  4200,  1164,  1164, 85328,
   85328, 85328, -5107, -5107, 85328,  2314,  2090,  2720,  3828, -5107,
    1478,  4418, 68736,  4470,  3734,   407, -5107, -5107,  1411, -5107,
    1332,  4444,  4126, -5107, 85328,  4555,  3451,  3645, 85328,  4084,
   -5107, -5107, 70200,  4307,  2674,113966,  3867,  4020,  1581,  4231,
   -5107,  4232, -5107,  4176, -5107,  1285, -5107,  2090, 85328, 77520,
   41879, -5107,112544, -5107,  2321, -5107, -5107, -5107,  4165,  3527,
    4209,  4212,  4099, 85328,   842, -5107, -5107, -5107, -5107,   232,
   -5107, 85328,  4142, -5107,  2681,  4104,   232, -5107,   379, -5107,
   -5107,  4791, 37444,112070,  2322, 32899, -5107, 32899, -5107,  4558,
   -5107, -5107, -5107,   100, -5107, -5107, -5107,  1116,  1116,  1116,
   -5107,  4559,  3919, -5107, -5107,  2337,  4583, 36434,  4539, -5107,
   85328,  2338, -5107, 32899,  4113, -5107, -5107, 40899,  1978,  4115,
    2344, 85328,  2349,112070,  4116,  4123,    53,  4124, 25915,  4110,
   -5107, -5107, -5107, -5107, -5107, 13272, 13272, 85328, -5107,  4130,
   -5107, -5107, 85328, -5107, -5107,  4171, 85328,  2350, -5107,   744,
   13272,  1559,   189,   379,  4356,  4028, -5107,  4132, -5107, -5107,
   -5107,  1266,  1266, 85328,  4028, -5107, -5107, 85328,  4210, -5107,
   -5107, 57024,  4438, -5107,  4187, -5107,   724,  1005,  3389, 85328,
  112070, -5107,   145,  4467, -5107,112070,112070, -5107, -5107, -5107,
   32899,  4224, -5107, -5107, -5107,  1093,   893, 67760, -5107, -5107,
   85328, 85328, 85328, 85328, 85328,   286, -5107,  2351, -5107, 42859,
   -5107, -5107,  3097,   477,  3097,  1676, -5107, -5107,  3097, -5107,
    3097, -5107, -5107, -5107, -5107,  1616,  4515,  4520,   948, -5107,
   -5107, -5107,  1879,  4378,  4139, -5107,  1223,  4358,  4230,  4147,
   -5107, 66296,  3143,  3645,  4109, 85328, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107,  2356,  3734, 85328,  4485,  3399,
    4034, -5107, 85328,  4191, -5107, 40899, -5107, -5107, -5107,  3097,
   -5107,   112,  4162,  4509,  3734,  2090, -5107,  4020,  3645,  4109,
   -5107, -5107, -5107,  4163, -5107,  3922,  1581,  3867, -5107, -5107,
   -5107, -5107,  4601,  4382,  4604,  3451, -5107,  3277,  2362, -5107,
    7703,113492,112070,  4535,  4206,  4226, -5107, -5107,  4225, 85328,
   -5107, -5107,  3734,  4180, -5107,  2681, -5107,  4791,  2367, -5107,
    2377,  2392,  4341,  4235, -5107, 32899,  1112,  3733, 58000,  4184,
   -5107, 37444,  2394, -5107,  4678, 85328,  2400, -5107, 13272, 85328,
   -5107, -5107, 32899, -5107,  2413, -5107, -5107, 32899,  4185, 32899,
   -5107, 34919,  4172, -5107,  4647, -5107, -5107,  2090, -5107,  3527,
   41879, -5107,  4318, -5107,  4519, -5107, 85328,  4234, 49730,  3483,
    3483,  2194, -5107,  1729, -5107, 85328, -5107,  4139, 32899, -5107,
    4196,  4282, -5107, -5107,  2418,  1504,  4366,  4366,  2423,  2434,
   10110, 85328, -5107, -5107, -5107, -5107, -5107, -5107,  2444, -5107,
   -5107, -5107, -5107,  2463, -5107,  2464,  2681,  3402,  1730,  3402,
   -5107,  3294, -5107, -5107, 57024, -5107, 58976, -5107, -5107, -5107,
     477, -5107,   477,  4432, 85328, 52172,   477,   477,  3959,   477,
   -5107, -5107, -5107,  4563,  4502, -5107,  1951, -5107, -5107, -5107,
   -5107,   202, -5107,  4423,  4424, 85328, -5107,  4207,  2468,   347,
    4339,  3734, -5107, -5107, -5107, 85328,  4683,  4684, -5107,  1106,
   85328,  3745, 85328, -5107, -5107, -5107, 32899,  4394, -5107,  4034,
    1581,   347,  4020,  2674, 42369,   924,  3867,  3922,  4433, -5107,
    4434, -5107,  4216,  3399,  3976, -5107, -5107,   349,  4546,  4547,
   -5107, -5107, -5107,  2681,  2484, -5107, -5107, -5107, -5107, -5107,
    3440, 35424, 35424,  4223, -5107, -5107, 85328,  4426,  4218, 36434,
   57024,  2491, -5107,110648, -5107,  2497,  2498, -5107,  2499, 34919,
    2508, -5107, 85328,  4233, -5107, -5107, -5107, 45311, 60928,  1266,
    4238, -5107,  4239, -5107, -5107,  4319,  1729,  3389, -5107, 13272,
     477, 85328, 66296,  4672, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107,  3389,  4308,  1093, -5107,   893, -5107, 67760, -5107, 85328,
   -5107, -5107,  2514, -5107, -5107, -5107, 85328,  3814, -5107,  3814,
   -5107, -5107, -5107, -5107,  4371, -5107,  1537,  1138,  1138,  4609,
   -5107,  4287, -5107, -5107,  4247, -5107,  4362, 85328, -5107, -5107,
    1118,  2090, 68736,  3734, -5107, -5107, 10189, 66296, -5107,  3867,
    4020,  1581, 32899,  2520, -5107,  4356,   173,  4176,  3922,   924,
   -5107, -5107, 41879,  3922, -5107, -5107, -5107,  2547, 66296, 66296,
    2522, -5107, 36939,  4380,   813, 11430, -5107, -5107, -5107, -5107,
    2524, 38448, -5107, -5107, -5107, 85328,  4453,  1222, -5107,  4395,
   -5107,  2535, -5107, -5107, -5107,     5,   379,  3483, 32899,  1729,
   -5107,  4358, -5107,  3389, -5107, 85328, -5107,  4250, -5107, -5107,
   -5107, -5107, -5107, 58976,  3814,  4126, -5107, -5107,  4728, -5107,
     312, -5107, -5107, -5107, 85328,  3734,  3946,  4034, -5107, -5107,
    4251,  3922,  1581,  3867, 10356,  4706, 42369, 85328, 85328, -5107,
   -5107,  4176,  2537,  3527, -5107,  2648, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107,  4252,  4254, -5107,  4727, -5107, -5107, -5107,
   -5107, -5107, -5107,  3648, -5107, -5107, 37444, 37444,  4487, -5107,
    1222, -5107,  4257, -5107, -5107, -5107, -5107, -5107, 10431, -5107,
   -5107, -5107,  1093, -5107,  4607, -5107, -5107, -5107,  3734, -5107,
   -5107, 56536,   924,  3867,  3922,  4356,  4261, -5107, -5107, -5107,
   -5107, -5107,  3399, -5107,  2024, -5107, -5107,  2147,  2406,  4346,
    4582, 35929,  4690,  4426,  4426, -5107, -5107, 32899, -5107,  1729,
    2548,  4449, -5107, -5107,  2550, -5107, -5107, -5107, -5107,  4176,
    3922,   924, 85328, 58488,  3922, -5107,  2648,  4383,  4384, -5107,
   85328, 10505, -5107, 66296, -5107, 56536, -5107, -5107,  4176, -5107,
    4265,  3527, -5107,  4311,  4312,  2568, -5107,  4271, -5107, -5107,
    4385, -5107,  4608,  4611, -5107, 56536,  4285, 66296, 66296,  2569,
   58488, -5107, -5107, -5107,  4281,  4486,  4286,  2681,  4292, -5107
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1918,  1492,   683,  1583,  1582,  1604,  1492,  1473,     0,   273,
       0,     0,  1589,     0,  1492,  1475,   459,  1164,     0,     0,
       0,     0,   683,  1492,     0,  1918,     0,     0,     0,     0,
       0,  1931,     0,  1605,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1492,  1478,     0,     0,     0,  1938,
       0,     0,     0,     0,  1931,     0,     0,  1591,     0,     0,
       0,     0,     0,     2,     4,    83,    84,    33,    32,   106,
      62,    18,    73,   145,   144,   146,    49,    42,    91,    28,
      30,    46,    50,    76,    78,    52,    64,   119,    74,    26,
      72,   100,    79,   104,    57,    12,    13,    58,    14,    59,
      15,    60,    16,   115,    85,   107,    37,    71,    25,    51,
      81,    82,     5,    53,    93,    89,    11,    67,    68,    70,
      97,    98,    99,   127,   102,   140,    48,   137,   112,   113,
     133,   114,   134,     9,   116,    61,    17,   130,   129,   131,
      92,    54,    94,    80,   105,   128,    29,   132,    21,    22,
      24,    23,    69,    31,    77,    34,   103,   135,   124,   118,
     141,   139,   147,   120,    86,     7,     8,   108,     6,    27,
      56,    10,    36,    35,    55,    47,   143,    38,  1589,    39,
       0,    43,   136,   125,    40,    66,    19,    96,    65,    20,
      95,   123,    75,   101,    45,    63,    41,   111,   110,    44,
     126,   109,    87,   117,    90,   121,   122,   142,    88,   138,
    1888,  1887,  1940,  1891,  1917,     0,  1903,  1491,  1490,  1471,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     682,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1502,
       0,     0,     0,     0,  1766,     0,     0,     0,  2523,  2538,
    2539,  2540,  2541,  2542,  2543,  2544,  2545,   427,  2546,  2547,
    2548,  2549,  2550,  2551,  2552,  2553,  2554,  2555,  2556,  2557,
    2558,  2849,  2850,  2852,  2851,  2853,  2854,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2855,  2856,  2566,  2567,  2568,  2569,
    2570,  2571,  2857,  2572,  2573,  2574,  2575,  2577,  2576,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,
    2589,  2590,  2591,  2592,  2593,  2594,  2595,  2596,  2858,  2859,
    2597,  2598,  2599,  2600,  2601,  2602,  2603,  2604,  2605,  2606,
    2607,  2608,  2609,  2610,  2611,  2612,  2613,  2614,  2615,  2616,
    2617,  2618,  2619,  2620,  2621,  2622,  2623,  2624,  2625,  2626,
    2627,  2628,  2629,  2860,  2630,  2631,  2632,  2633,  2861,  2634,
    2635,  2636,  2862,  2637,  2638,  2639,  2640,  2641,  2642,  2643,
    2644,  2863,  2864,  2645,  2646,  2647,  2648,  2649,  2650,  2651,
    2652,  2653,  2654,  2655,  2656,  2657,  2658,  2659,  2660,  2661,
    2662,  2865,  2663,  2664,  2665,  2666,  2866,  2867,  2868,  2667,
    2668,  2669,  2670,  2671,  2672,  2673,  2674,  2869,  2675,  2676,
    2677,  2678,  2679,  2680,  2681,  2682,  2683,  2684,  2685,  2686,
    2687,  2688,  2689,  2690,  2691,  2692,  2693,  2694,  2870,  2871,
    2695,  2696,  2697,  2698,  2872,  2699,  2700,  2701,  2873,  2702,
    2874,  2875,  2703,  2704,  2705,  2706,  2707,  2708,  2709,  2710,
    2711,  2712,  2713,  2876,  2714,  2877,  2715,  2716,  2717,  2718,
    2719,  2720,  2721,  2722,  2723,  2724,  2725,  2726,  2878,  2727,
    2879,  2728,  2731,  2729,  2730,  2732,  2733,  2734,  2735,  2736,
    2737,  2738,  2739,  2740,  2741,  2742,  2880,  2743,  2744,  2745,
    2746,  2747,  2748,  2749,  2750,  2751,  2752,  2753,  2754,  2755,
    2756,  2757,  2758,  2759,  2760,  2761,  2762,  2763,  2764,  2765,
    2881,  2766,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,
    2775,  2776,  2777,  2778,  2779,  2780,  2781,  2782,  2882,  2783,
    2784,  2785,  2786,  2787,  2788,  2883,  2789,  2790,  2791,  2792,
    2793,  2794,  2795,  2796,  2797,  2798,  2799,  2800,  2801,  2802,
    2884,  2803,  2804,  2805,  2806,  2807,  2808,  2809,  2810,  2811,
    2885,  2886,  2812,  2813,  2887,  2814,  2888,  2815,  2816,  2817,
    2818,  2819,  2820,  2821,  2822,  2823,  2824,  2825,  2826,  2827,
    2828,  2829,  2830,  2831,  2832,  2833,  2889,  2890,  2834,  2835,
    2836,  2837,  2838,  2839,  2840,  2841,  2842,  2843,  2844,  2845,
    2891,  2892,  2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,
    2901,  2846,  2847,  2848,   426,  1878,  2491,  2524,  2525,  1588,
    1561,   683,     0,  1476,   458,  1918,     0,     0,     0,     0,
    1735,     0,     0,     0,     0,   915,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   196,     0,     0,     0,     0,     0,   484,   483,
       0,     0,     0,  1137,   489,     0,     0,     0,     0,     0,
     671,  1821,  2729,  1819,  1879,   274,   277,   278,   275,   276,
    2513,     0,  1261,  1262,  1264,     0,     0,     0,  1274,   955,
     956,     0,     0,     0,   964,     0,     0,     0,     0,   953,
       0,     0,     0,     0,     0,   969,   966,     0,   970,   967,
     950,   968,     0,   957,     0,   949,     0,     0,  1274,   971,
       0,     0,   951,     0,     0,     0,     0,  1477,     0,  2607,
    1818,   490,     0,  1918,     0,  1783,  1784,  1785,  1589,  1774,
    1786,  1779,  1781,  1780,  1782,  1778,  2512,  2539,  1077,  1077,
    1077,  1077,  1074,  1075,  1077,  1077,  1077,  2751,     0,     0,
    1056,     0,  1058,  2514,  1077,  1082,   550,   550,   550,     0,
    1081,  1086,   550,     0,  1468,  1511,  2496,  1930,     0,  2631,
       0,  1057,     0,     0,  1467,  1731,     0,  2812,  1810,     0,
       0,  1289,  1285,  1287,  1288,  1286,     0,     0,     0,  2769,
    1482,   258,  2780,  2885,  2812,   257,   252,   253,   226,  2543,
       0,     0,  1081,     0,  1479,     0,  2487,  1480,  1038,  1937,
    1935,     0,  2478,  2564,  2581,  2678,   249,  2762,  2770,  2780,
    2885,  2812,  2845,   205,   215,   210,     0,   267,  2780,  2885,
    2812,   263,  1502,     0,  1904,  2042,     0,  1470,  1469,  1732,
    1590,     0,  1593,     0,  2746,  1908,  1911,  1599,  1909,  1900,
       0,     0,     1,  1918,     0,  1587,     0,  1611,  1699,  1700,
    1701,     0,  1615,  1702,     0,     0,     0,  1619,  1623,  1703,
    1627,  1632,  1704,  1705,     0,  1640,  1644,  1706,  1646,  1651,
    1707,  1655,     0,     0,  1658,  1662,  1666,     0,  1672,  1708,
    1676,  1680,  1607,  1610,  1612,  1934,  1934,     0,  1934,     0,
    1892,  1900,  1895,  1899,     0,     0,     0,     0,  2523,  2902,
    2903,  2904,  2905,  2906,  2907,  2908,  2909,  2910,  2911,  2912,
    2913,  2914,  2915,  2916,  2917,  2918,  2919,  2920,  2921,  2922,
    2923,  2924,     0,     0,     0,  2497,  2524,  2528,     0,     0,
       0,   974,     0,  1514,  2492,  1123,     0,     0,     0,     0,
       0,     0,     0,  1173,  1172,  2529,  2519,  2520,     0,  2517,
    2518,  2530,  2531,  2532,     0,     0,  2651,     0,     0,     0,
       0,   384,  1738,     0,  2389,  2400,  2401,  2402,  2568,  2634,
    2397,  2398,  2399,  2391,  2392,  2393,  2394,  2395,  2396,     0,
       0,  1256,  2390,     0,  2651,     0,     0,   175,     0,   152,
       0,     0,  2651,     0,     0,     0,     0,     0,     0,     0,
       0,  2651,     0,     0,     0,     0,     0,   175,  2683,     0,
     152,  2651,     0,     0,  1496,     0,     0,     0,  1498,  1501,
    1472,  1773,  2489,  1722,     0,  1726,     0,  1723,  1729,  1724,
    1564,     0,  2487,     0,     0,     0,  1008,  1001,     0,  1009,
    1016,     0,     0,  1018,     0,     0,  1002,     0,     0,     0,
       0,  1021,  1022,     0,  1023,  1003,  1024,  1025,  1004,  1026,
    1005,  1027,     0,     0,     0,     0,  1006,     0,     0,     0,
    1486,     0,  1812,  1814,  1813,  1811,   550,     0,     0,     0,
    1733,  1734,     0,  2651,     0,     0,   152,     0,  1549,     0,
    2651,  2783,   152,     0,     0,   488,   487,   152,  2517,     0,
       0,   486,   485,     0,   593,     0,  2568,  2634,     0,  1163,
       0,  1414,   152,  2651,     0,   198,  2651,   759,     0,  2651,
    1599,     0,   686,     0,     0,   870,  2683,   152,     0,     0,
       0,     0,     0,     0,  1140,     0,     0,     0,   670,   683,
    1822,  1820,     0,  1265,   251,   250,  1263,   962,  2651,  1205,
     374,   374,     0,     0,  2651,  2729,  1533,  2526,  2116,  2118,
    2121,  2148,  2126,  2148,  2148,  2112,  2112,  2616,  2128,  2651,
    2113,  2114,  2153,     0,  2148,  2112,  2112,  2117,     0,  2115,
    2156,  2156,  2143,   374,   978,  2097,  2098,  2099,  2100,  2129,
    2130,  2101,  2135,  2136,  2140,  2102,  2170,  2112,  2527,   963,
       0,   954,  2651,   374,  1169,  2651,  2521,   185,     0,     0,
     952,     0,   384,     0,  2568,  2634,  2651,   374,  1258,     0,
    2651,   181,     0,  2651,   374,  2651,   687,     0,     0,  2651,
     374,  2651,  2683,   183,     0,  2651,   374,   972,  2651,   374,
    2651,     0,     0,     0,     0,  1815,     0,  1776,  2889,  1791,
       0,  1787,  1794,  1790,  1918,  1077,  1076,     0,  1077,     0,
    1077,     0,  1077,     0,  1077,     0,     0,     0,  1077,  2515,
    2516,  1059,     0,  1083,     0,     0,  1090,  1089,  1088,     0,
       0,     0,  1091,     0,  2045,  1849,     0,     0,  1739,     0,
       0,     0,  1465,     0,  1485,     0,     0,     0,  1140,  1292,
       0,  1290,  1281,  1282,  1481,   256,   254,     0,     0,     0,
       0,     0,     0,  1487,     0,     0,  2470,     0,  2471,  2488,
       0,     0,     0,  2500,  2502,  2503,  2403,  2473,     0,  2850,
    2852,  2851,  2853,  2854,  2462,     0,  2855,  2856,  2857,  2904,
    2305,  2288,  2299,  2306,  2289,  2291,  2300,  2303,  2858,  2859,
    2236,  2860,  2861,  2510,  2862,  2863,  2864,  2866,  2867,  2868,
    2869,  2293,  2295,  2870,  2871,     0,  2511,  2873,  2874,  2875,
    2710,  2877,  2878,  2880,  2881,  2301,  2302,  2883,  2884,  2297,
    2298,  2885,  2886,  2887,  2888,  2509,     0,  2304,  2890,  2892,
    2893,  2894,  2895,  2897,  2898,  2899,  2900,     0,     0,     0,
    2484,     0,  2268,     0,  2105,  2106,  2131,  2132,  2107,  2137,
    2138,  2108,     0,  2483,  2173,  2354,  2267,  2284,     0,  2273,
    2274,     0,  2266,  2262,  1920,  2479,     0,  2263,  2499,  2501,
    2463,  1920,  2477,   218,   269,     0,   270,  2485,  2780,   206,
     248,   220,   247,   221,   219,     0,  2566,   207,     0,     0,
     208,     0,     0,     0,     0,   266,   264,     0,  1474,     0,
    2042,     0,  2038,  2037,  2041,   983,  1577,  1575,  1576,  1574,
       0,  1571,  1573,  1592,  1589,  2413,     0,  1910,     0,     0,
       0,  1890,  1889,     3,  1597,  1596,     0,  1594,  2803,  1578,
    1599,  1645,  1616,  1620,  1624,  1633,     0,  1641,  1647,  1652,
    1684,  1614,  1685,  1663,  1667,  1673,  1677,  1681,  1686,  1617,
    1621,  1625,  1634,     0,  1642,  1648,  1653,  1656,     0,  1659,
    1664,  1668,  1674,  1678,  1682,  1687,  1670,  1618,  1622,  1626,
    1635,     0,  1643,  1649,  1654,  1657,     0,  1660,  1665,  1669,
    1675,  1679,  1683,  1671,  1688,  1689,  1690,  1691,  1692,  1693,
    1636,  1694,  1695,  1650,  1696,  1697,  1661,  1698,     0,     0,
    1609,  1600,     0,  1932,  1933,     0,     0,     0,     0,     0,
       0,     0,     0,  1986,  1948,  1949,  1951,  1983,  1987,  1995,
       0,  1896,     0,     0,  2047,     0,     0,     0,     0,     0,
       0,  1204,  2498,     0,   384,     0,     0,     0,     0,     0,
     975,     0,     0,     0,  1520,     0,  1522,  1523,  1524,     0,
       0,  1525,  1526,  1514,   260,  1532,  1530,  1513,  1515,  1528,
       0,     0,     0,     0,     0,     0,     0,  1541,     0,   189,
     190,     0,   703,   683,     0,  2651,     0,     0,     0,     0,
       0,  1212,  1219,     0,     0,     0,  1221,     0,     0,     0,
       0,     0,  1213,  1211,  1214,   262,  1225,  1242,  1245,     0,
    1171,  1174,     0,     0,   593,     0,     0,     0,  1348,     0,
       0,     0,     0,     0,     0,     0,     0,  1348,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   285,   287,   298,   365,   366,   364,
     662,     0,     0,     0,   665,     0,  2651,     0,     0,     0,
     593,     0,     0,     0,     0,  1260,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   150,
     151,   156,     0,     0,     0,     0,     0,     0,     0,   648,
     661,     0,     0,     0,     0,     0,   658,     0,     0,   152,
     290,   638,   644,     0,     0,     0,   766,   765,     0,     0,
       0,     0,     0,  1439,  1437,     0,     0,     0,     0,  1539,
    1538,     0,     0,     0,     0,     0,  1348,     0,   279,   281,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   419,   420,     0,     0,     0,
     156,     0,     0,     0,     0,   292,     0,     0,  1497,  1494,
    1495,     0,  1500,     0,     0,  1807,     0,     0,     0,     0,
       0,     0,  1560,     0,  1015,     0,     0,     0,     0,  1017,
       0,  1010,     0,     0,  1007,  2568,  2634,     0,     0,     0,
       0,     0,     0,     0,  1020,     0,     0,     0,     0,   461,
       0,     0,   867,     0,     0,     0,     0,     0,     0,   878,
       0,  1514,     0,  1548,     0,     0,     0,     0,   696,     0,
    2651,     0,   154,   593,   857,     0,     0,     0,     0,  1736,
       0,   916,     0,   868,   489,     0,     0,     0,  1418,  1413,
     154,     0,     0,   192,     0,     0,   763,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   808,   807,
       0,     0,     0,   869,     0,     0,   154,     0,  2651,   641,
    2651,     0,   550,   550,     0,     0,  1139,  1142,     0,     0,
       0,     0,  1882,  1884,  1883,     0,  1881,     0,   372,   373,
       0,  1248,   865,  1273,     0,     0,  2651,  1535,  2147,  2134,
    2142,  2141,     0,  2123,  2122,  2120,     0,  2119,     0,  2148,
    2148,  2146,  2125,  2124,  2097,     0,     0,     0,  2152,     0,
    2150,     0,   945,  2093,  2089,     0,  2159,  2160,  2161,  2158,
    2171,  2157,     0,  2103,  2162,  2112,  2109,   965,     0,     0,
    1246,     0,     0,  1748,  2651,   374,  1752,   593,  2651,   374,
    2651,     0,  2651,     0,     0,     0,  1250,   374,     0,     0,
       0,  1441,     0,   961,   959,   958,   960,     0,     0,   943,
       0,     0,     0,  2651,   374,     0,     0,   938,     0,   940,
       0,     0,  2651,   152,     0,     0,     0,     0,  1918,     0,
     237,   238,   236,  1792,   239,  1793,  1789,  1775,     0,  1067,
       0,  1071,     0,  1062,     0,  1068,     0,  1063,  1060,  1061,
       0,  1066,     0,     0,   551,   553,     0,     0,  2594,  2615,
       0,  2640,  2671,  2672,  2770,  2776,     0,  2807,  2817,     0,
    1092,  1118,  1087,   777,     0,     0,  1859,     0,     0,     0,
       0,  1466,  2651,   152,  2420,     0,  1918,     0,     0,     0,
       0,   255,   227,     0,     0,     0,  1120,     0,  2769,  1484,
       0,  2469,     0,  2533,  2925,  2926,  2927,  2928,  2929,  2930,
    2931,  2932,  2933,  2934,  2935,  2936,  2937,  2938,  2939,  2940,
    2941,  2942,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2950,
    2951,  2952,  2953,  2954,  2955,  2956,  2957,  2958,  2959,  2960,
    2961,  2962,  2963,  2964,  2965,  2966,  2967,  2968,  2969,  2970,
    2971,  2972,  2973,  2974,  2975,  2976,  2977,  2978,  2979,  2980,
    2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2990,  2989,
    2991,  2992,  2993,  2994,  2995,  2996,  2997,  2998,  2999,  3000,
    3001,  3002,  3003,  3004,  3005,  3006,  3007,  3008,  3009,  3010,
    2466,  2465,  2494,  2534,  2535,  2536,  2537,  2472,  1037,   683,
       0,  2264,     0,  2271,  2272,  2461,     0,     0,     0,     0,
       0,     0,  2270,  2428,     0,     0,     0,     0,     0,  2196,
       0,     0,     0,  2441,     0,  2447,     0,     0,  2233,     0,
       0,     0,     0,     0,     0,     0,     0,  2197,  2177,  2178,
    2268,  2413,     0,  2269,  2506,     0,  2170,  2482,  2403,     0,
    2400,  2401,  2402,     0,     0,     0,  2476,     0,  2411,     0,
       0,  2211,  2409,  2213,     0,     0,     0,     0,  2397,  2398,
    2399,  2391,  2392,  2393,  2394,  2395,  2396,  2407,  2193,     0,
       0,  2356,     0,  2192,     0,     0,  1999,     0,  2504,  2464,
    1999,   271,   272,   268,     0,     0,   223,   222,     0,   241,
     245,   246,   217,   244,     0,   240,   225,  2345,  2344,   224,
     216,   213,   211,   228,   230,   231,   214,   212,   265,     0,
    2039,     0,     0,     0,   374,  1587,     0,  1587,  1996,     0,
    1912,     0,  1916,  1587,     0,  1584,     0,     0,  1587,  1637,
    1638,  1628,  1629,  1639,  1630,     0,  1607,  1709,  1721,  1715,
    2685,  1711,  1712,  1716,  1713,     0,  1607,  1717,  1608,     0,
    1613,  1907,  1906,  1941,  1942,  1156,  1905,  1966,  1967,  1962,
       0,     0,     0,  1992,  1990,  1958,  1952,  1957,  1955,     0,
    1959,  2173,  1985,  1894,  1946,  1947,  1950,  1893,     0,  1988,
       0,  1862,  1986,  1951,  1846,     0,  1824,     0,  2048,     0,
       0,     0,     0,     0,  1184,  1186,     0,  1185,     0,  1188,
       0,  1197,     0,     0,  1183,  1202,     0,  1191,  1189,   593,
     593,     0,  1537,     0,     0,   976,     0,     0,     0,     0,
    1521,     0,     0,  2807,   259,  1524,  1529,  1516,  1527,     0,
       0,     0,     0,     0,  1122,  1121,     0,     0,  1144,     0,
       0,     0,  1544,   539,     0,   371,     0,     0,     0,     0,
       0,     0,     0,     0,   863,   860,     0,     0,   859,     0,
     701,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   739,     0,  1348,     0,   771,     0,  1223,     0,     0,
    1220,  1222,     0,  1226,     0,     0,  1224,  1217,  1218,  2770,
    2780,  2812,   261,  1244,     0,  1243,  1241,  1166,     0,  1167,
       0,     0,  1745,     0,     0,     0,  2626,  2651,  2698,  2721,
     306,   325,     0,  1347,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   611,   605,   603,   604,   607,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   351,
       0,     0,   354,   353,     0,     0,   369,     0,     0,     0,
     358,   337,     0,     0,   338,     0,     0,   357,     0,     0,
       0,     0,   663,   664,     0,     0,     0,     0,  1348,     0,
     294,     0,  1751,   300,   383,  1744,     0,  1440,  1438,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1257,     0,
     794,     0,     0,     0,     0,     0,  1420,     0,     0,   178,
       0,   173,   177,     0,     0,     0,     0,   646,   647,   660,
       0,   651,   652,   649,   653,   654,     0,     0,     0,     0,
       0,     0,     0,   645,     0,     0,   761,   760,   764,     0,
       0,     0,     0,  1431,     0,  1237,     0,     0,  1429,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1294,
    1293,     0,     0,     0,     0,     0,     0,   906,     0,     0,
       0,     0,     0,     0,     0,     0,   180,   781,     0,   780,
       0,   174,   179,     0,     0,     0,     0,     0,     0,     0,
     235,  1493,  1499,  1772,  2490,  1806,  1802,  1802,  1802,     0,
    1728,     0,  1725,  1563,  2495,  1562,     0,     0,     0,     0,
    1019,     0,     0,     0,     0,     0,     0,     0,  1011,  1012,
    1013,  1014,     0,     0,     0,     0,     0,     0,   433,     0,
     435,     0,  2526,     0,   894,   866,     0,     0,     0,   880,
       0,   883,   886,     0,  1512,     0,   508,     0,     0,     0,
       0,   689,   739,     0,     0,   492,   187,  1737,     0,     0,
       0,   591,   590,   592,     0,   915,     0,     0,     0,     0,
     796,     0,     0,     0,  1237,  1417,   149,   196,   198,   490,
       0,   197,   199,   201,   202,   203,   200,   204,     0,   758,
     762,     0,     0,     0,     0,     0,     0,   685,     0,     0,
       0,     0,     0,   809,   813,   812,   816,   814,     0,   810,
       0,     0,  2068,     0,     0,   172,     0,     0,   636,   640,
       0,     0,     0,     0,   492,   593,   387,  2651,     0,   550,
       0,  2651,     0,  1141,     0,     0,     0,     0,     0,     0,
       0,     0,  1880,   374,  1206,     0,  1534,     0,     0,     0,
       0,   374,  2145,  2144,  2094,  2090,     0,     0,     0,     0,
     979,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2110,   374,  1170,   186,  2522,     0,   947,  1747,     0,  1442,
       0,     0,     0,     0,   374,  1259,   935,   182,  1765,   374,
     688,     0,   374,   184,     0,     0,     0,   680,   374,   973,
     374,     0,   374,     0,   696,  1742,     0,  1795,  1796,  1817,
    2651,   550,  1777,  1788,  1064,  1073,  1072,  1070,  1069,  1065,
       0,  1084,     0,   549,     0,     0,     0,  1098,  1099,     0,
       0,  1097,  1100,     0,  1102,  1094,  1093,  1103,  1104,     0,
       0,  1120,   775,     0,     0,     0,     0,  1856,     0,  1854,
       0,  2046,  1858,  1847,     0,     0,     0,  1865,  1867,  1868,
       0,     0,   696,  1809,     0,  1808,     0,   629,     0,     0,
    1291,     0,     0,  1081,     0,     0,   374,     0,  1483,  1730,
    2467,  2470,     0,  1039,  1045,     0,     0,     0,     0,     0,
       0,  1048,  1049,  1050,  1041,  1051,  1052,  1042,  1053,     0,
    1043,     0,     0,     0,     0,  2474,  2424,     0,  2425,     0,
       0,  2460,  2456,     0,     0,     0,     0,     0,  2429,  2432,
    2433,  2434,  2431,  2435,  2430,     0,     0,  2436,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2881,     0,     0,
       0,     0,  2237,     0,     0,  2384,     0,  2413,  2446,     0,
       0,     0,     0,     0,     0,  2413,  2452,     0,     0,     0,
       0,  2343,     0,  2340,     0,     0,     0,     0,  2473,     0,
       0,  2507,  2174,  2188,  2189,  2190,  2194,  2481,     0,  2475,
       0,     0,  2175,  2202,     0,  2453,  2229,     0,  2234,  2217,
       0,  2210,     0,  2215,  2219,  2198,     0,  2195,     0,  2476,
    2412,     0,  2410,     0,  2185,  2186,  2187,  2179,  2180,  2181,
    2182,  2183,  2184,  2191,  2388,  2386,  2387,     0,     0,     0,
    2364,     0,     0,  2214,  2643,  2678,     0,  1931,  1931,  1931,
    1919,  1929,  2480,     0,  2063,     0,     0,     0,     0,  2276,
       0,  2417,  1940,  2415,  1189,  2063,  2486,     0,     0,  2170,
       0,  2042,  2044,     0,   981,   982,   980,  1568,  1599,  1572,
    1567,  1565,  1587,  2414,  1598,  1914,     0,     0,  1580,  1599,
    1595,  1586,  1585,     0,  1579,  1631,     0,  1601,  1714,  1607,
    1603,     0,  1606,     0,  1154,  1155,     0,  1159,     0,     0,
    1960,  1993,     0,  1984,     0,  1964,  1965,  1956,  1994,  1860,
       0,  1989,  1898,  1897,     0,  2066,     0,     0,     0,  1838,
    1826,     0,  2049,     0,  1999,  1870,     0,  2473,  1997,  1390,
    1295,  1355,  1187,     0,  2112,  1198,     0,  1182,     0,  1181,
    2112,     0,  1199,     0,  2112,  1746,  1743,  1391,  1296,  1356,
     977,  1392,  1297,  1357,  1393,  1298,  1531,  1519,  1518,  1517,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   844,  2651,   374,  1542,  1394,     0,
    1299,   370,  1543,  1358,  1547,   862,   861,     0,     0,  1359,
       0,   702,     0,   706,     0,   708,   709,   710,     0,     0,
       0,   711,     0,  2568,  2634,   713,   716,   723,   728,   718,
       0,     0,   730,   724,     0,     0,     0,     0,     0,     0,
     736,   741,     0,     0,     0,     0,     0,     0,     0,  1215,
    1216,  1395,  1302,     0,  1360,  1165,     0,  1303,   188,     0,
       0,   286,  2651,   308,     0,   367,   326,   743,   844,  1350,
     305,   335,   368,     0,     0,   350,   345,   346,   344,   602,
     609,     0,     0,   612,  2651,   374,  2651,   374,     0,     0,
       0,     0,     0,   347,   342,   343,   339,     0,     0,     0,
     352,  2542,  2617,  2781,     0,   747,   749,     0,   754,   355,
    1322,   381,   380,   379,     0,   359,     0,   388,   391,     0,
     356,   333,   336,   334,   616,   615,   330,   299,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1432,  1237,     0,
    1430,     0,  2493,     0,     0,  1252,     0,  1398,  1361,     0,
    1381,     0,     0,     0,     0,   788,  1421,  1423,  1410,  1309,
    1422,   176,  1337,   165,     0,     0,   161,     0,     0,     0,
       0,   155,     0,  1401,  1310,     0,     0,   291,   639,   650,
     655,  1316,   659,   656,  1371,   657,  1408,  1311,  1312,  1404,
    1340,  1366,  1411,     0,  1433,  1313,  1237,  1426,  1428,     0,
    1348,     0,   280,   282,     0,   303,     0,  1314,     0,  1364,
    1403,  1339,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1550,     0,     0,     0,     0,     0,     0,   374,     0,
       0,     0,  1350,  2651,   374,  1402,     0,  1345,     0,  1379,
       0,   421,     0,  1338,     0,     0,   293,  1318,  1373,     0,
       0,   233,   232,   234,     0,  1805,  1805,  1805,  1727,     0,
    1029,   988,  1028,     0,  2615,     0,   987,   989,     0,     0,
       0,   990,     0,     0,     0,     0,   986,   984,   985,  1488,
     432,     0,   460,     0,     0,     0,     0,   893,     0,     0,
       0,     0,   882,     0,     0,     0,     0,  1540,     0,   152,
       0,     0,   700,     0,     0,     0,   695,   738,   743,     0,
       0,     0,     0,   491,   495,   499,   500,   501,     0,     0,
       0,     0,   166,   153,     0,   858,  1749,     0,     0,   924,
       0,   550,     0,   798,  1416,  1415,     0,  1412,     0,   198,
     191,     0,     0,   759,     0,  1763,  1761,  1599,     0,     0,
     387,   877,   875,   874,   876,     0,     0,     0,   898,   873,
       0,  2067,  2069,     0,     0,     0,     0,     0,     0,   629,
     494,     0,     0,   553,   597,     0,     0,     0,     0,   387,
       0,     0,     0,  1176,     0,  1194,  1177,     0,     0,     0,
       0,  1230,  1237,  1231,  1207,     0,     0,   668,  1885,  1886,
       0,  1249,     0,  1536,     0,  2111,  2127,   946,     0,  2155,
    2154,  2156,  2156,     0,  2095,     0,  2139,  2164,  2165,  2166,
    2167,  2168,  2169,     0,  2163,  2104,  1247,   374,   374,     0,
     374,     0,   374,  1251,  1443,     0,   944,     0,     0,   374,
     937,   939,     0,   941,     0,   693,  1740,     0,     0,  1085,
     552,     0,     0,     0,     0,  1096,   666,  1101,     0,  1113,
    1108,  1110,     0,  1114,   774,     0,     0,  1857,  1850,  1852,
    1851,     0,     0,  1848,     0,  2706,  1757,     0,  1863,     0,
    1864,     0,   691,  2421,   936,     0,   635,  1283,  1284,     0,
       0,   374,     0,  1115,  1489,  2469,     0,     0,     0,  1046,
    1040,     0,     0,  1044,     0,  1047,     0,     0,  1936,  2422,
    2423,     0,     0,     0,  2457,     0,     0,  2318,     0,  2290,
    2292,  2308,     0,  2319,  2275,  2320,  2294,  2296,     0,  2404,
       0,     0,  2309,     0,  2239,  2240,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2255,  2254,  2310,  2383,     0,     0,  2444,
    2445,  2311,     0,     0,  2451,     0,     0,     0,  2316,  2321,
       0,     0,     0,     0,  2327,     0,  2348,     0,     0,     0,
    2265,  2414,     0,     0,     0,     0,     0,     0,     0,     0,
    2235,  2218,  2212,     0,  2216,  2220,     0,     0,     0,  2206,
       0,     0,  2204,  2230,  2200,     0,     0,  2231,     0,     0,
       0,  2283,     0,     0,  1931,  1931,  1931,  1931,  1928,     0,
       0,     0,     0,  2766,  2901,     0,  2023,  1998,  2000,  2010,
    2023,  2028,  2023,  2285,  2061,  2286,     0,  2487,     0,  1969,
    1940,  1940,  1940,  2282,     0,     0,     0,     0,  1939,  1969,
     209,     0,   242,   229,  2040,     0,  1587,     0,  1566,  1915,
    1918,  1587,  1710,  1602,  1718,  1943,     0,  2405,  1159,     0,
    1945,     0,     0,  1991,  1953,  1861,  1845,     0,  1843,  1830,
    1832,  1831,     0,     0,  1833,  2473,     0,  1843,  1825,  1875,
       0,     0,  2066,     0,  1874,     0,  2112,  1179,  1180,     0,
    1203,     0,  1125,  1126,     0,  1124,     0,     0,     0,   538,
    1143,     0,     0,     0,   844,     0,     0,   542,     0,  1545,
       0,  1409,  1336,   704,   705,     0,   717,     0,   726,   725,
       0,     0,     0,     0,     0,     0,     0,   712,   732,   672,
     733,   735,     0,     0,   734,   737,   740,  1348,     0,   772,
    1324,     0,  1377,  1209,  1351,     0,  1168,     0,     0,     0,
       0,     0,     0,   508,   329,     0,     0,     0,   396,     0,
     310,   318,   394,   324,     0,  1354,   361,     0,     0,     0,
       0,   332,     0,   322,   348,   340,   349,   341,   360,     0,
     362,     0,   751,   752,   750,   746,     0,   753,   755,     0,
     385,     0,     0,     0,     0,   617,  1397,     0,  1348,     0,
     295,     0,  1320,     0,  1375,   304,   301,  1434,  1237,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1380,     0,     0,     0,     0,   793,     0,   790,     0,     0,
     158,   157,     0,   164,     0,     0,     0,     0,  1236,     0,
    1435,     0,     0,     0,     0,     0,     0,   403,     0,   302,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   422,   376,     0,
     901,     0,     0,     0,   424,     0,     0,     0,     0,     0,
    1396,  1304,  2594,  1801,     0,  1799,  1797,  1798,     0,     0,
       0,     0,   999,     0,     0,     0,     0,     0,     0,   437,
     438,   152,   436,     0,   430,   431,   433,     0,   892,  2710,
    2391,  2392,   890,   896,   887,   889,   891,   888,     0,   895,
     844,     0,     0,   879,   884,   885,     0,  1750,     0,     0,
       0,     0,   523,     0,     0,     0,   514,     0,     0,  1237,
     507,   510,   511,     0,     0,   696,  1764,  1762,   699,   697,
     698,   731,     0,   494,   530,   577,     0,   168,     0,     0,
     169,   167,     0,  1770,     0,     0,     0,   387,   795,     0,
     792,     0,     0,   194,   490,     0,   763,     0,     0,     0,
    1237,   684,   815,   818,   811,     0,   897,   899,   871,     0,
     743,     0,     0,   641,     0,   550,  1818,   624,     0,   579,
     494,   577,     0,   599,   386,     0,     0,   629,   599,     0,
       0,  1144,  1175,     0,     0,     0,  1227,  1232,  1228,     0,
       0,  1190,     0,  1229,  1208,  1162,  1460,  1461,  1458,  1459,
       0,     0,     0,  1877,     0,  2133,     0,  2151,  2149,  2091,
    2096,  2172,   948,  1444,     0,   931,     0,   933,   374,   782,
       0,   681,   374,   152,  1741,     0,     0,     0,     0,  1095,
       0,  1111,     0,     0,  1078,  1117,     0,     0,  1855,  1853,
       0,     0,     0,  1866,   152,   627,     0,  1120,     0,  1079,
    1119,  2468,     0,     0,     0,     0,     0,     0,     0,  2426,
       0,  2459,  2455,     0,  2287,  2427,     0,  2439,  2438,  2384,
       0,     0,  2238,  2250,  2251,  2252,  2440,     0,  2260,     0,
       0,  2247,  2248,  2249,  2241,  2242,  2243,  2244,  2245,  2246,
    2253,  2449,  2448,  2442,  2443,     0,  2313,  2314,  2315,  2450,
    2322,     0,  2559,  2349,  2326,  2342,  2341,     0,     0,     0,
    2329,     0,     0,  2338,     0,  2385,  2508,  2176,     0,     0,
    2203,  2454,  2221,     0,     0,     0,  2199,  2404,     0,     0,
       0,     0,     0,  2208,     0,     0,     0,  2367,  2362,  2363,
    2381,     0,     0,     0,     0,     0,     0,  1922,  1921,  1927,
    2023,  2028,  2023,     0,     0,  1900,     0,  2010,     0,  2022,
    2008,  2021,     0,     0,  2034,  2032,     0,  2034,     0,  2034,
       0,  2002,     0,  2024,  2004,  2021,  2006,     0,  2053,     0,
    2488,  2062,     0,  1982,     0,     0,     0,     0,  2418,  2419,
       0,  2416,  2277,  1982,     0,  2043,  1569,     0,     0,  1581,
       0,     0,  1944,  1157,  1158,  1961,  1954,  2590,  2064,     0,
    1844,     0,     0,     0,  1835,  1841,  1823,     0,     0,  1871,
    1843,  1872,  1200,     0,     0,  1192,  1131,  1134,  1132,  1130,
    1133,     0,     0,     0,   844,     0,     0,   558,     0,  1151,
    1151,     0,     0,   544,   621,  1237,   847,     0,     0,     0,
     845,   374,  1300,     0,   727,     0,     0,   722,   720,   719,
     721,     0,   673,  1407,  1301,     0,     0,     0,     0,  1210,
       0,     0,  1323,     0,   307,     0,   504,     0,   319,     0,
     315,     0,  1349,     0,     0,     0,     0,   314,   398,     0,
     395,     0,     0,   610,     0,   374,   374,   327,   363,   748,
     382,   389,   390,   393,     0,     0,     0,     0,     0,     0,
       0,  1353,     0,  1436,     0,     0,     0,     0,     0,     0,
     925,   908,     0,     0,   926,   927,     0,     0,     0,  1254,
    1255,  1253,  1382,  1383,  1388,  1385,  1384,  1387,  1389,  1386,
       0,  1307,     0,     0,   786,   162,   159,   160,   163,  1334,
    1317,  1372,  1427,     0,     0,     0,  1315,     0,  1365,     0,
    1330,  1326,     0,     0,     0,     0,     0,  1406,  1344,  1370,
    1405,  1342,  1368,  1341,  1367,  1343,  1369,     0,  1335,     0,
    2071,   905,     0,     0,     0,   374,   374,   904,   784,  1319,
    1374,  1800,     0,  1804,  1767,     0,     0,   991,     0,     0,
     993,   994,     0,   996,   442,     0,  1759,     0,   804,   864,
       0,     0,   881,   843,     0,   512,     0,   518,   521,     0,
       0,   525,   526,   524,   513,  1237,   550,   620,     0,     0,
     854,     0,   690,     0,   492,     0,   527,     0,     0,   496,
     171,   170,     0,     0,  1237,     0,     0,     0,   799,   803,
     801,   800,   802,   797,     0,   788,     0,   198,  2651,     0,
       0,     0,     0,   622,  1424,     0,   828,   872,     0,  2070,
     778,     0,   387,   637,     0,     0,     0,   492,   629,     0,
     497,   502,   503,   508,     0,   593,   578,     0,   579,     0,
       0,   601,  1510,     0,   630,   632,     0,     0,     0,  1178,
    1195,  1196,     0,     0,  1237,     0,     0,     0,     0,   675,
     374,  2092,   374,   374,  1280,     0,   942,   696,  1107,  1106,
    1105,   667,     0,  1109,   776,     0,     0,     0,  1753,   696,
     628,   374,     0,  1055,  1034,  1054,  1033,  1035,     0,  1032,
    1030,  1031,  2458,  2307,  2317,  2437,  2383,  2414,     0,     0,
    2261,     0,     0,  2312,  2891,     0,     0,     0,     0,  2346,
    2347,  2328,     0,  2697,  2333,     0,     0,     0,  2227,  2225,
    2222,     0,  2223,  2207,     0,     0,  2205,  2201,     0,  2232,
    2353,     0,  2369,  2366,  2380,  2414,  1926,  1925,  1924,  1923,
    2009,  2005,  2007,     0,  2896,     0,  2012,  2019,     0,  2001,
       0,  2033,  2029,     0,  2030,     0,     0,  2031,     0,     0,
    2003,     0,  2019,     0,  2060,  1940,     0,     0,  2358,  2280,
    2281,  2278,  1940,  2505,  2358,   243,     0,  1913,  1719,     0,
       0,  1842,  1827,     0,  1828,  1834,     0,     0,     0,     0,
    1876,  1869,  1193,  1201,     0,     0,     0,   540,     0,  1237,
       0,     0,     0,  1153,  1153,     0,  1237,   620,   849,   848,
     851,   846,   850,  1546,     0,   714,   715,   729,  1325,     0,
    1378,  1332,     0,  1859,   309,     0,   744,     0,     0,   311,
     397,   399,   312,   313,   316,   376,   608,   606,   331,   321,
       0,     0,   328,     0,     0,  1321,     0,  1376,  1328,  1399,
    1305,  1362,     0,     0,   914,     0,     0,     0,     0,  1400,
    1306,  1363,     0,     0,     0,     0,  1859,     0,     0,     0,
       0,     0,     0,     0,     0,  1555,     0,  1352,   375,   903,
     902,   376,   423,  1346,  1803,     0,   992,   997,   998,   995,
       0,   429,   439,   434,     0,   463,     0,  1271,  1271,     0,
     844,     0,     0,   509,   522,     0,   620,   557,     0,   515,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1771,  1425,     0,     0,     0,   791,   790,  1419,
     193,     0,   492,     0,   743,     0,   822,   823,   817,   819,
       0,   830,   834,   900,     0,     0,   629,   494,     0,     0,
    1816,   493,     0,     0,   505,     0,   597,   579,   593,     0,
     594,     0,   598,   614,   600,     0,  1503,     0,     0,     0,
       0,  1233,     0,  1239,     0,  1189,  1160,  1234,     0,  2063,
       0,     0,     0,     0,   679,  1272,   932,   934,   783,   694,
    1112,     0,     0,  1758,     0,     0,   692,  1116,   374,  1036,
    2385,  2256,     0,     0,     0,     0,  2323,     0,  2324,  2351,
    2350,  2330,  2334,     0,  2331,  2332,  2224,  2228,  2226,  2209,
    2355,     0,  1940,  2382,  2056,     0,  2059,     0,     0,  2011,
       0,     0,  2013,     0,     0,  2015,  2017,     0,     0,     0,
       0,     0,     0,  2491,     0,  2589,  2864,  2765,     0,  1968,
    1970,  1973,  1975,  1974,  1976,  1972,  1981,     0,  1902,     0,
    1901,  1570,     0,  2406,  2065,     0,     0,     0,  1145,     0,
    1873,  1113,     0,   374,  1151,   620,   559,  2710,   560,  1150,
    1152,  1156,  1156,     0,   620,   844,   707,     0,     0,   288,
     742,     0,     0,   320,   378,   392,  1940,     0,  1859,     0,
       0,   912,   921,   921,   909,     0,     0,   928,  1308,   787,
       0,     0,   283,  1331,  1327,     0,     0,     0,  1557,  1558,
       0,     0,     0,     0,     0,   374,  1000,     0,   466,   473,
     443,   448,  1549,     0,  1549,     0,   445,   450,  1549,   444,
    1549,   449,   441,  1760,   464,   152,     0,  1271,     0,  1268,
    1267,   842,     0,   548,   643,   516,     0,   568,   619,     0,
     855,     0,     0,   494,   577,     0,   537,   536,   532,   531,
     533,   534,   535,   529,   528,     0,   743,  1768,   918,   387,
    1510,   785,     0,     0,   756,     0,   820,   825,   824,  1549,
     829,     0,     0,     0,   743,     0,   625,   579,   494,   577,
     498,   508,   583,     0,   584,   599,   593,   597,   595,   596,
     626,   613,     0,     0,     0,   629,  1559,  1144,     0,  1238,
       0,     0,     0,     0,     0,     0,  1275,   674,     0,     0,
     678,   669,   743,     0,  1755,     0,  1080,  2257,     0,  2258,
       0,     0,     0,  2336,  2335,     0,  2372,  2061,     0,     0,
    2055,     0,     0,  2085,     0,     0,     0,  2020,  2036,     0,
    2016,  2014,     0,  2025,     0,  2027,  2277,     0,     0,     0,
    1977,     0,  2357,  2359,     0,  2279,  1720,     0,  1840,  2063,
       0,  1837,     0,  1127,     0,  1128,  1153,   563,     0,  1159,
    1159,   550,   844,   541,  1333,     0,   745,   643,     0,   323,
       0,     0,   296,  1329,     0,     0,   923,   923,     0,     0,
       0,     0,   410,   417,   416,   411,   409,   418,     0,   414,
     408,   407,   412,     0,   405,     0,     0,  1551,     0,  1552,
    1553,  1556,   425,   440,     0,   471,     0,   469,   468,   470,
       0,   457,     0,     0,     0,     0,     0,     0,   442,     0,
    1266,  1270,  1269,     0,     0,   517,     0,   519,   554,   555,
     556,     0,   520,   564,   565,     0,   852,     0,     0,     0,
       0,   743,   576,   767,  1769,     0,     0,     0,  1504,     0,
       0,   623,     0,   831,   832,   827,     0,     0,   779,  1510,
     593,     0,   579,   506,     0,   601,   597,   599,     0,  1507,
       0,   631,     0,   387,  1237,  1240,  1235,  1464,     0,     0,
     677,   676,   773,     0,     0,  2259,  2339,  2325,  2352,  2337,
    2368,     0,     0,     0,  2054,  2057,     0,  2088,     0,     0,
       0,     0,  2074,     0,  2018,     0,     0,  2026,     0,     0,
       0,  1971,     0,     0,  1829,  1839,  1146,     0,     0,  1156,
       0,   844,     0,  1148,  1147,   557,   543,  1859,   317,   377,
       0,     0,     0,     0,   919,   922,   910,   911,   930,   929,
     789,  1859,     0,     0,   401,     0,   400,     0,   404,     0,
     467,   476,     0,   474,   446,   452,     0,   456,   454,   453,
     447,   451,   428,   462,     0,   547,     0,     0,     0,     0,
     566,     0,   567,   618,     0,   856,     0,     0,   769,   917,
       0,     0,   492,   743,   821,   826,     0,     0,  1505,   597,
     579,   593,     0,     0,   585,  1151,  1151,   614,   599,   601,
    1508,  1509,     0,   599,  1161,  1463,  1462,  1918,     0,     0,
       0,  1754,  2849,  2590,  2819,     0,  2370,  2373,  2371,  2365,
       0,     0,  2086,  2087,  2072,     0,     0,  2076,  2035,  2052,
    1979,     0,  1978,  2360,  2361,  2063,   374,  1159,     0,   545,
     561,   568,   289,  1859,   913,     0,   284,     0,   415,   413,
     406,  1554,   472,     0,   455,   834,   642,   573,     0,   572,
       0,   570,   569,   853,     0,   743,   907,  1510,   757,   833,
       0,   599,   593,   597,     0,   582,     0,  1153,  1153,   479,
     481,   614,     0,  2063,  1446,  1918,  1445,  1447,  1455,  1452,
    1454,  1453,  1451,  1278,  1279,  1756,     0,  2377,  2376,  2375,
    2379,  2378,  2058,     0,  2075,  2078,     0,     0,     0,  2084,
    2077,  2079,     0,  2050,  1980,  1836,  1129,  1149,     0,   844,
     297,   920,     0,   475,     0,   571,   575,   574,   743,   768,
    1506,   837,   601,   597,   599,  1151,     0,   580,   586,   588,
     587,   477,   387,  1135,     0,  1456,  1450,  1900,  1887,     0,
       0,     0,     0,  2081,  2082,  2083,  2080,     0,   562,   546,
       0,     0,   770,   839,     0,   835,   838,   840,   841,   614,
     599,   601,  1153,     0,   599,  1448,  1918,     0,     0,  2374,
       0,     0,   402,     0,   805,     0,   480,   482,   614,   589,
       0,  2063,  1449,     0,     0,     0,  2051,     0,   836,   478,
       0,  1136,     0,     0,  2073,   837,     0,     0,     0,     0,
       0,  1276,  1277,   806,     0,     0,     0,     0,     0,   581
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5107, -5107, -5107,  3918, -5107, -1005,   -93,  2956, -1632, -5107,
   -5107, -5107,  1324, -5107, -5107, -5107, -5107,  3822, -5107,  1960,
   -2753, -5107, -5107,   164,  3766, -1472,   137,  3319,  1593, -5107,
   -1269, -5107, -5107,  -652,   107, -5107,  3774,   297, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107,  -941, -5107,  2108,  1350,
   -5107,  2188,  1421,  5161, -3087, -5107, -5107,  -862, -1659, -3574,
   -5107,   690, -5107,   726, -4606,  -872, -5107, -4992, -5107, -1044,
    -864, -5107, -5107,  2096, -5107, -5107, -5107,   584, -5107,    55,
    -735, -5107, -5107, -5107, -5107, -5107, -5107, -5107,  -720, -5107,
   -5107,  -965,   177,    42, -2763, -4144, -5107, -5107,   540,  -335,
   -1656, -5107, -3964, -5107,    54, -4153, -5107, -5107, -5107,  -295,
   -1619,  1528, -5107,  -768, -1268,  1864,  -827, -5107,  -173, -5107,
    -940,  -734,  -731,  -863, -4174, -4669, -5107, -5107, -5107, -5107,
    -969, -1631, -4949, -4194, -4631, -5107, -5107, -5107, -4691, -4110,
   -4965, -3757,  1538, -5107,   181, -3485, -3579,   186,   512, -5107,
     187,   200, -5107,   528,  -655, -1018, -1760, -5107,  -966, -5107,
   -5107, -5107, -3279, -5107, -5107, -5107, -5107,    58, -5107, -5107,
   -5107, -5107, -2882, -5107, -5107, -5107, -5107, -5107, -5107, -3032,
    2051,  2052, -5107, -3494, -5107,  -996, -5107,   739, -3323,  1434,
   -5107, -5107,  1197,  3843,   563, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -1877, -5107, -5107, -5107, -5107,    57,  -268, -5107,
   -5107, -5107, -5107, -5107, -5107,   203, -5107,  2083,  1200, -5107,
   -5107,  -265, -5107, -5107, -5107, -5107, -5107, -5107,  -915, -1061,
   -1037, -5107, -3320, -5107, -5107, -5107,  -232,  -480, -5107, -5107,
   -5107, -5107, -5107,  -828, -5107,  1282, -3500, -5107, -5107,  1299,
   -5107, -5107, -5107, -5107, -5107,  -812,  -156,  3009, -5107,  -392,
    -595, -5107, -5107, -5107,  -145, -5107, -5107, -5107, -5107, -5107,
   -5107, -5107, -5107, -1201,  -139,  -924,  -609, -5107, -5107, -5107,
   -5107, -5107, -2633, -5107, -5107, -5107, -5107, -4028, -5107,  4902,
    2193,  -155,   204, -5107,   -34,    59,  3614, -1287, -2974,   533,
    -354, -5107, -5107, -5107, -2883, -5107, -5107, -5107, -5107, -3896,
     206, -5107,  3604, -5107, -4196, -4974, -3945, -4453, -4827, -5005,
   -3884, -5107, -5107, -5107, -5107,  -371,  -228, -5107, -5107, -1641,
    2475, -2282, -5107, -2400,   586,  1647,  3830, -3073,  -163,  2964,
   -4200,  -759, -3631, -5107, -5107, -2689,  -498, -5107, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107,  -659,  2902,  -231, -5107, -5107,
    4245, -5107, -4744, -5107,  4229, -5107, -5107, -5107, -5107,  2814,
    2816, -5107,  2817, -5107, -5107, -1647,  1388, -5107, -5107, -5107,
   -5107,   791, -5107, -5107, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107, -3264,   777, -5107, -5107, -5107, -5107, -5107,  -798,  -963,
   -5107, -5107,   207, -5107, -5107, -5107, -5107,  2487, -1003,  -784,
    4098,   208, -5106, -5107, -5107, -1322, -5107,  3307, -5107, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -5107, -3010, -5107, -5107,
   -4851, -5107, -5107, -5107, -5107, -5107,  2589,  2592,    49, -2227,
     -39, -5107, -5107, -5107,  2582, -1099, -5107, -5107, -2204, -5107,
   -5107, -5107,  3368,  3113,  3114, -1683, -5107, -5107, -5107, -5107,
   -5107, -5107,  -207,  -967, -1666,  2584, -5107, -5107, -5107, -5107,
   -5107, -5107, -3646, -4177, -5107, -5107, -5107, -5107, -5107, -5107,
   -5107,  -625, -5107,  2896, -5107, -5107, -5107, -5107, -5107,  -321,
   -1241, -5107, -5107, -5107, -2041,   211,   638, -5107,    10, -5107,
   -5107,   -27, -5107,   395, -5107, -5107, -3794,    12, -5107, -5107,
   -5107, -5107, -4826, -5107, -5107,  2852,  1174,    17,  -690,   960,
   -3130, -5107,   213,     2, -5107, -5107,    16,    72,   -58,   -41,
     -31,     1,   138,  3461, -5107, -5107,  3521, -5107,   -14,  1746,
   -5107, -5107,  -907,  -177, -5107,  1744,  -714,  2551,  3378,  3394,
   -5107,  1735, -5107, -5107,  1742, -5107,  1017,  -664,  -494, -5107,
   -5107, -5107, -5107,   436,  -697,  2558, -5107,  3387, -5107, -5107,
   -5107, -2169, -3183, -3796,  1048, -3793, -3725,   488,   475, -1823,
    -247,   -42, -1395, -5107,  -813,  3401, -5107, -5107,  1060,  -452,
   -5107, -5107,  -450, -3136,   996, -5107, -4755, -2611,  1067,  -909,
    -751, -5107,  -835, -5107,  -623,  -546,  3023, -1181, -5107, -5107,
   -1140, 16432, -5107, -5107, -5107, 16810, 17608, -5107, -5107, 17685,
   17887, -5107,  -983, 18548, 13084, -1142, -2124,  -443, 15548, -2170,
    -412, -2963, -5107, -3919, -2664, -5107, -5107, -5107,  -197,  1128,
      -3, -5107, -4787, -5107, -5107,    35, -5107,  -627, -5107,  -626,
   -5107, -5107, -5107,  -606, -4398,  2706, -5107, -5107, -5107,  -234,
   -5107, 19521, -3081, -5107,  -743, -3102, -3071, -3780, -2139, -5107,
   -5107, -5107, -5107, -5107, -5107, -5107, -2266, -3664,  -785,  1878,
   -5107, -5107,  1972, -5107, -5107, -5107, -1315,  2005,  -782, -2943,
    1882, -5107,  -808,  2710,  -805,  6646,  -230,  8661,  -611, -2554,
   -1446, -1793, -5107,  2422, -4030,   -26,   -16,    -4,  -215,  -119,
    -460,  3815,  8775,  -665, -1307, 11609, 15549, 14039, -3499
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    62,    63,    64,    65,  1771,  2816,  2671,  3652,  3653,
      66,    67,  1767,    68,    69,    70,    71,  1673,    72,  1154,
    1933,  2841,    73,  2484,   854,   855,   856,  2362,  2363,  2751,
    2364,  2352,  1481,  2084,  1695,   826,   827,  1655,  1696,    75,
      76,  1475,  2343,    77,    78,    79,  1734,  2642,  1819,  2643,
    1735,  1736,  1667,  1981,  4750,  5519,  3445,  1750,  2627,  3706,
    3446,  3447,  4101,  4102,  4189,  5544,  5545,  5537,  5543,  5538,
    5539,    80,  1835,  1836,    81,    82,  4246,  3611,  3614,  4241,
    5111,  5112,  5362,   646,  2790,  5365,  5366,  5347,  5348,  5558,
    5702,  5703,  2842,  1925,  3702,  4339,  3643,  4849,  3644,  4850,
    3645,  4851,  3627,  4280,  4281,  4790,  4282,  3646,  4806,  5393,
    3647,  2503,  5575,  2885,  2106,  2104,  5377,  4606,  4607,  5671,
    5582,  5583,  5584,  5811,  4808,  4855,  4856,  5887,  5423,  5743,
    5744,  1919,  4343,  4861,  5183,  3410,  2599,  3413,  1737,  5430,
    1738,  5129,  3324,    84,   755,  1961,  3816,   756,  2888,   687,
     757,  2843,    89,  2878,  5577,  2879,  1792,  2680,  5540,  3787,
      90,  1179,  4068,  5204,  5450,  5451,    91,   258,    92,  1943,
      93,    94,  2811,  3636,    95,  2520,  3341,    96,    97,  3370,
    3371,  3372,    98,  4093,  5045,  1739,  3434,  3435,  3436,  3437,
    4127,    99,  1936,  2850,  2851,   100,   101,   102,   103,  3004,
    3005,   104,  2738,   105,   106,   107,   108,  4167,  4714,  4825,
    3485,  3663,  4310,  4823,   109,  2844,  1951,  2868,  2869,  4836,
    5158,  5159,  5160,  5409,  5734,  5162,  5411,  5605,  5413,  5914,
    5915,  5120,  4047,  4620,   111,  4799,  4800,  1915,   112,  2518,
     113,   114,   115,  1899,  2800,  2801,  4253,  1892,  2793,  2794,
    4325,  4326,   116,  3561,   117,  4690,  4691,   688,  5596,  5526,
    5686,   118,   119,  4694,  4695,   120,   121,   122,   123,   124,
     744,   745,   746,  1276,  1277,  3294,  1223,   125,  2374,   126,
    1108,  1109,  3591,   127,  1361,  3062,  3063,  4904,   128,   780,
    1296,  1297,  2845,   130,   789,  3033,   791,  2119,  3789,  3790,
    4404,   131,   132,  3001,  3036,   133,  1660,  2494,  2495,  4601,
    2846,   689,  1967,  2892,  3319,  5287,  5288,  5023,  5301,  3247,
    4000,   135,   690,  1700,  2568,  1243,  1244,  2895,  3714,  2461,
    2462,  2463,  4360,  2464,  3716,  2465,  1631,  2466,  1189,  1190,
    3722,  3723,  3724,  4356,  4363,  3524,  5193,  5194,   136,  1698,
    2566,   137,   138,   139,  1755,  1019,  1257,  1258,   140,   702,
     703,   141,  5369,   142,  1193,   143,  5202,   144,   145,   817,
     818,  1340,  1341,   146,   147,  2585,  4104,   148,   149,   150,
    3479,  3480,  4706,   151,   152,  1928,  1929,  2834,  2835,   153,
     154,  3526,  3527,   155,   156,   157,  5836,  5894,  5895,  5896,
    4370,  5757,  5838,  1332,   159,   160,   161,   219,  1058,  1059,
    1060,  2847,  5186,   163,   164,  1656,  1657,  1658,  1659,  2489,
     165,   166,   167,   168,   169,   170,   171,  1904,   172,   173,
    5340,   174,   175,  1862,   176,  1510,  1511,   177,   178,  1529,
     640,   872,  1514,  1526,  1527,  1520,   179,   180,  1601,  2409,
     922,   923,   924,  2396,  2405,  2406,   181,   182,   183,   184,
    1120,   185,  3806,  1327,  2075,  2966,   186,   187,   188,   189,
     190,   191,  3807,  4775,   192,   193,   194,   195,  4302,   196,
     197,   759,  1290,  1291,  1292,  2086,   198,  2967,   199,  3585,
    4225,  2756,   200,  1336,  1111,   760,  1285,   202,   761,  2445,
    3269,  4012,  4013,  4014,  4017,  5008,  4580,   762,  3265,   205,
    2126,  3010,  3013,  3261,   206,  3016,  3017,   763,  3274,  3275,
    3276,  4020,   764,   782,  1182,  2901,   765,  1442,   211,   212,
     213,   881,   875,   876,  3227,   215,  2336,  3190,   798,  1605,
     841,   842,   929,  3978,  2413,  2414,  2436,  2437,  1614,  1615,
    2426,  2428,  3249,  2429,  3257,  2419,  4553,  5269,  5270,  5271,
    5272,  5273,  5274,  4988,  2432,  2433,  1617,  1618,  1619,  2441,
     216,  3194,  3957,  3958,  3959,  4529,  4530,  4544,  4540,  4972,
    5255,  3960,  1503,  1504,  1325,  1625,  4980,  5863,  3961,  5244,
    5245,  5470,  4548,  3969,  4008,  3690,  3691,  3692,  3962,  5651,
    5652,  5860,  5861,  5472,  5473,  2467,  2014,  1225,  1443,  1226,
    2026,  1444,  1997,  1228,  1445,  1446,  1447,  1231,  1448,  1449,
    1450,  1234,  1989,  1451,  1452,  2008,  2023,  2024,  1515,  5474,
    1454,  1455,  1456,  3964,  1457,  4483,  4936,  4925,  3122,  3123,
    2359,  4479,  3902,  2331,  3180,  5278,  5492,  5493,  3941,  4508,
    4952,  5242,  5643,  5766,  5767,  1458,  1459,  1460,  3177,  2327,
    1022,  1461,  4255,  2329,  3116,  3202,  3203,  2135,  2254,  3069,
    3085,  3086,  3096,  3861,  3104,  3109,  3889,  3890,  3117,  3146,
    1462,  3071,  3072,  3845,  2256,  1463,  1358,  2152,  1632,  2251,
    3141,  1471,  1464,  1465,  2120,   865,  5251,  1062,   973,  3471,
    2241,  1071,   795,  1466,  1467,  1468,  1469,  1744,   988,  1246,
    1247,   636,   965,   990,  3438,   637,   638,   967,  2246
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     783,   214,   981,   880,  1021,   704,   783,  1020,  1148,   831,
     203,   864,   204,   634,   796,  1791,   209,   207,  1316,  1317,
    1318,   694,   784,  2083,  1322,  1620,   214,  1028,   784,  1001,
    1061,  2693,  1743,  1748,  1472,   930,  1185,  2004,  1796,  1476,
     866,  1049,  2502,  1126,  2247,  1840,  2103,  1640,  2035,  1183,
    2242,  2580,  3642,  1505,  1359,  3200,  1852,   962,  2569,   686,
    3821,  1940,  3287,  3289,  2145,  1993,  1994,  1490,  2763,  3979,
    2601,  2620,   210,  2572,   758,  2002,  2003,  2873,  4094,  2010,
     743,  4006,  3775,   970,   972,  3670,   790,   976,  2581,  1293,
    4074,  4364,  1790,  3970,  3971,  3025,  4608,   210,  3473,  1859,
    1196,  1818,   832,  3101,  4675,  2370,  4321,    74,  4122,  1036,
    4124,  1845,   989,  3068,  4572,  3558,  1046,  4257,  3793,  2645,
    4337,  1901,  4609,  1029,  4265,  4257,  3972,  1908,  1287,  4646,
    1516,  1270,  1912,   879,  4826,  4348,  3596,  1050,  3597,   885,
    3812,  4603,  3601,  4019,  4291,  3667,  4495,  1930,  3217,  4805,
    3221,  3606,  3607,  3608,  4865,  4868,  3228,  5024,  4410,  4526,
    4874,  3234,  1956,  2719,  2720,  3998,  1224,  4858,  4543,  2715,
    5184,  3205,  3131,   932,  2893,  2760,  1916,    83,  5248,   825,
    3286,    85,  1185,   933,  2954,  3910,    86,    87,   861,  5178,
    2757,  2758,  3237,  2475,  1224,  1483,  4857,  5302,   878,  5136,
      88,  1701,  3240,   110,   129,  4148,   134,   158,   162,  1042,
    4025,   201,  4334,   208,   853,  1613,  5438,  5309,  5431,  2562,
    1990,  1991,  1697,  4586, -2636,  4463,  5260,  5425,  5262,   766,
    3963,  2001,  1616,  2299, -2673,  4541, -2696,  4546,  3493, -2732,
     766,  1978,  5342,  5343,  1952, -2526,   700,   644,  1993,  1994,
    5022,  5177,  2372, -2526, -2526, -2527, -2148,   766,  2822,  1978,
    5332, -2554,  2305, -2527, -2527,   766, -2640,  1261,  2002,  2003,
     766,  1978,  4818,  3659,  2602, -2112, -2776,  5214, -2128,  1669,
    2010,  1273,  2817,  4354,  2036,  3212,   931,  1298,  2831,  1978,
    1359,  2726, -2153,  3632,  5598, -2817,  5509,  5510, -2498,  2307,
    3867,  3963,  3139,  3581, -2836, -2143, -2907,  2385,   700,  2508,
    1598,  3139,  1524,  2025, -2907, -2907,   700,  2247,  5525,   700,
    1923, -2156,  1492,  3335,  3494,  1352,  2085,  5717,  3035,  3843,
    2496,  2486,  2242, -2497,  4024,  4283,  2124,  1953,  2334,  4075,
     700,   700,   700,  2583,  5542,  2818, -2639,  1978,  1889, -2389,
    2497,  3797,  4244,  2821,  2713,   766, -2389,  2882,  1740,  2127,
    1802,  1480,  4845,   766,   870,   700,  5463,  2989,  1855,  2420,
    4596,  4819,  1302,   766,  5370,  2504,  5755,  5200,  4070, -2156,
    1948,  2583,  3452,  2883,  3495, -2495,  2247,  3760,  4846,  3762,
    2037,  1849,  4183,  1990,  1991,  4906,  4907,  1506,  4909,  4910,
    4911,  1670,   772,  1949,  1803,  2505,  2937,  3181,  2421,  1978,
    3633,  2505,   772,  5308,   772,  4320,  2498,   772,  1804, -2694,
    5331,  2001,  1978,  2583,     3,     4,   773,  4692,  4793,  1978,
    2550,  2388,  5876,  1021,  5488,  2499,   773,  1856,   773,   772,
    1978,   773,  3496,  1501,  3801,  2665,  1137,  1320,  1669,  2557,
    1609,  2349,  1740,   700,  1054,  -152,  1152,   766,  1144,  2386,
    -152,  4820,  4812,   773,  2299,  2583,  2870,  4187,  2299,  3379,
    1167,   639,  3968,  5603,  2357,  2422,  4098,  3552,  5617,  1485,
    3225,   700,   700,   772,  3686,  3867,  4648,  1852,  2731,  1021,
    3687,  4031,  5522,  2305,  5047,  3174,  1992,  2305,  2476,  3226,
    5051,  2583,  3175,  5738,  2345,  4659,  5484,   773,  5426,  5604,
    2373,  3553, -2408,  1124,  1252,  1279,  4021,  1128,   884, -2408,
    4188,  1611,  2353,  2358,   772,  2551,  2423,  2365,  2365,  3965,
    2307,  3802,  1979,  1321,  2307,  1868,  1160,  4693,  1898,  1599,
    3819,  2076,  1138,  1165,  2032,  3497,  4813,  2558,   773,  3193,
    1979,  2032,  1138,  3182,  4319,  2506,  4597,  1055,  2583,  1883,
    2265,  4649,  1979,  4598,  2299,  5756,  1138,  3380,  2350,  1493,
    1670,  1507,  1950,  1508,  1805,  2619,  1895,  3798,  1850,  2804,
    1979,  4794,  2500,  2884,  1987,  5405,  -465,  5877,  4847,  5464,
    2424,  2802,  3453,  2305,  2603,  5031,  2677,  1897,  3634,  4245,
    3965,  4262,  1056,  1356,  4599,  4075,  2604,  1357,  2605,  1185,
    1857,  2696,  3590,  1806,  1299,  1301,  1303,  1807,  4821,  1305,
    1306,  1307,  2064,  5570,  5201,  4600,  1110,  1185,  2335,  1312,
    2307,  2990,  4672,  4257,  1121,  4170,  1502,  1671,  1979,   979,
    1494,  4284,  4071,  3336,  2509,  2125,   214,  2871,  3070,  1133,
    5718,  1808,  1754,  1348,  2032,  1112,  3582,  1113,  1321,  4355,
    2293,  1115,  1114,  4709,  5787,  1057, -2694,  5748,  1212,  2087,
    2125,  3140,  3213,  1937,  3498,  2606,  2832,  1525,  1356,  5669,
    3930,  2809,  1357,  2819,  3499,  1184,   704,  3500,  2339,  2714,
    2351,  1980,   871,  3635,  4822,  1185,   880,  5699,  2292,  1107,
    1979,  2501,   645,  5799,  2727,  1672,  2387,  5215,  2248,  2011,
    1988,  5880,  2547,  1979,  4941, -2389,  1898,   210,  1600,  1294,
    1979,  2029,  3239,  2556,  4613,  2326,  3744,  4184,  4543,   778,
     779,  1979, -2640,  4817, -2636,  2545,  4969, -2694,  3248,  2045,
    4973,   783, -2776,   783, -2673,   783, -2696, -2526,  5610, -2732,
   -2694,   783,  1309,  1310,   214,  1621,  1324, -2527, -2148,   778,
     779, -2817,  1634,  1295,  4040,  1300,  4898,  1304,  4864,  3374,
   -2836, -2554,  2470,  1308,  4915, -2640, -2640,  1992,  5832,  4147,
    1996,  2688,  5431,  1311,  2691, -2776, -2776,  1704,  2005,  2134,
    5821,  1334,  3882,  1286, -2153,  4960,  5011,  4962,  1356,  2047,
   -2498,  2698,  1357,  1289, -2817, -2817,  2640, -2143, -2907,  2006,
    2295,  3462,  2678, -2836, -2836,  2681,  2682,  1353,  2337,   695,
    1185,  3208,  2872,  2007,  1324,   210,   879,  1473,  1185,  1185,
    1482,  1184,  1484,  2347,  2980, -2497,  4840,  4180,  3295,  3296,
     932,  5506,  5061,  1851,   778,   779,  2005,  4635,  2752,  3867,
     933,  5792,  1741,  1742,  1509,  1021, -2639,  1872,  1877,  2066,
    2121,  3176,   778,   779,  2958,  5796,  5431,  2006,  3006,  1752,
    1753,  2732,  1854,  1321,  5884,  4239,  4240,  2137, -2408,  2032,
    5219,  2009,  4021,  2450,   214,  2930,  4027,  2379,  4028,  5174,
    4403,  5770,  2146,   203,  1624,   204,  3375,  1740,   700,   209,
     207,  2733,   766,  1661,  4678,  4561,  2442,  2772,  2988,  5364,
    4334,  1865,  3395,  3200,  3200,  3200,  4313,  2998,  2379,  3393,
    1512,  1769,  3402,  2443,  5184,  5032,  1898,   811,  3864,  3865,
    1898,  1240,  1913,  3884,  5920,  2805,  3065,  2666,  1676,  2565,
    4779,   980,  4366,  5741,  1770, -2112,  1741,  1742,  2594,  -152,
    -152,  1134,  5006,   931,  5431,   210,  4594,  2323,  2324,  2325,
    2326,  3548,  1644,  3455,  2814,  4232,   700,  5870,  4778,  1885,
    3914,  3915,   783,  5431,  3879,  3880,  3881,  3882,  2247,  1870,
    2708,  3349,  2420,  5726,  5747,  5848,  5571,  5089,  2510,  3963,
      74,  3463,  3963,  3799,   261,  3988,  4415,  3137,   927,  3556,
    5889,  5890,  4733,  4095,  3549,  5740,  3007,  1921,  1922,  1479,
     934,  5090,  1517,  1487,  4803,  5501,  2912,  2913,   927,   812,
    2864,  2421,  2707,  5417,  2247,  1662,  2417,  3259,  2496,  1594,
    3300, -2112,  4367,  4365,  1965,  3993,  1829,  3418,  3550,  3501,
    4814,  2033,  1830,   700,  5246,  4233,  4234,  4010,  1645,  1038,
    3469,  2321,  2322,  2323,  2324,  2325,  2326,   262,  5184,  5532,
      83,  1714,  1715,  1716,    85,  2795,  5902,  3441,  2964,    86,
      87,  5822,  4584,  4573,   802,  4608,  3588,  3554,  3963,  1039,
    1654,  4707,  2948,    88,  4011,  3982,   110,   129,  4609,   134,
     158,   162,  2562,  4879,   201,  5939,   208,  1740,   700,  2658,
     935,  4609,   766,  1313,  3419,  4022,   696,  1646,  5448,  3501,
    2865,  3555,  5179,  1972,  2498,  2041,  2043,  2016,  5831,  2693,
    3365,  2418,  3365,  2984,  2298,  4096,  3442,  2299,  3022,  5849,
    1761,  5180,  1938,  2499,  4574,  3291,  4833,  1644,  2511,  2423,
    2088,  3260,  5224,  2090,  1824,  2092,  2656,  2094,  5572,  2096,
    4416,  4919,  1366,  2100,  3656,  3867,  2305,  4920,  1831,  3868,
    3869,  3870,  1944,  2053,  2815,  1898, -2908,   697,  5535,  2242,
    1595,  1973,  5007,  5249,  5252,   825,  1811,  4734,  1366,  5256,
     813,  3867,  5258,  2016,  1663,  3868,  3869,  3870,  1825,  4368,
    5386,  5184,  5502,  2307,  2778,  2886,  3366,  2017,  3366,  5807,
    2431,  1898,  4488,  2424,  1647, -2112,  1945,  2054,  2654,  3008,
    5590,   698,  4062,   699,  4804,  3976,  4254,  3557,  3443,  3800,
    3308,  2595,  -738,  1645,  4254,  5856,   814,  1664,   815,  1898,
    5184,  5615,  3009,  1241,  2512,  4554,  4903,  1971,  2779,  5589,
    5624,  5622,  3078,  4364,   700,  5612,  5387,  3266,   263,  2909,
    5212,  5919,  1762,  3715,  3704,  5388,  4063,  2018,  1184,  5532,
    2019,  1665,  2485,  2017,  2828,  4369,   783,   701,  5165,  5170,
    5305,  4609,   803,  1725,  5611,  1974,  1184,  2004,  5634,  5091,
    2500,  1871,  1646,  3350,  5017,  5389,  1314,  2657,  3965,  2381,
    5938,  3965,  5827,  5828,  3159,   214,  5449,  4921,  4687,  2089,
    4298,  2091,  3244,  2093,  1175,  2095,  5181,  2097,  2098,  2099,
    2995,  2996,  3448, -2908,  2101,  2131,  2985,  1832, -2908,  4361,
    2767,   816,  5046,  2018,  5131,  5536,  2019,  1975,  2866,  2150,
     260,  4097,  4098,   936,  1666,  2782,  3877,  3878,  3879,  3880,
    3881,  3882,  5857,  2867,  1184,  5533,  3871,  5432,  5534,  3292,
    3481,   264,  3293,  3079, -2908,  5433,  3963,  2986,  2806,  5390,
    1833,  4099,  1826,  3750,  5846,   265,   210,  3872,  5535,  5375,
    5391,  1609,  3365,  2020,  2906,  2882,  1651,  3965,  1652,  1647,
    1946,  2055,  2596,   880,  3369,  5521,  3369,  4845,  2829,  2911,
     925,  1741,  1742,  3872,  1834,  3245,  5504,  3444,  2683,  2501,
    3528,  2883,  5578,  4802,  5808,  2597,  2314, -2112,  4688,  3310,
     266,  1763,  2780,  4846,  1293,  3542, -2112,   267,  1992, -2112,
    1639,  3543, -2112,  5749,  2897,  2628,  2469,  2294,  3267,  1976,
    4064,  1853,  5922,  3080,  3873,   639,  2296,  1648,  2905,  2020,
    2253,  3160,  1611,  5458,  5641,  3747,  3161,  4985,  3366,  2952,
    2338,  5132,  1224,  2972,  1764,   926,  5760,  5613,  5010,  4683,
    3873,  5480,   783,  2262,   968,  2920,  3420,   783,   783,  1184,
    4299,   811,  2355,  2356,  5642,  2377,  1827,  1184,  1184,  2020,
    1649,  1054,  3162,  4561,    42,  3367,  1612,  1176,  1765,  4992,
    5809,  2021,  5858,  3081,  1947,  2056,  3082,  5859,  2278,    49,
    3628,  3311, -2908,  5929,  2646,  3748,  2629,  3064,  2293,  3067,
    2022,  2951,  1224,  2290,  1650,  3074,  2032,  1854,  5810,   839,
    4689,  3088,  3089,  3090,  1021,  5536,  2781,  5434,  3368,  5579,
     927,  3106,  3108,  3421,  4901,   641,  3118,  3544,  5507,  2684,
    5524,    53,  2685,   969,  4065,  5528,  5529,  5512,  2647,  5246,
    1603,  1651,  1177,  1652,  5830,  5666,  3002,  2021,  1178,  5833,
    5315,  4257,  2648,   812,  2411,  2412,  5392,  2416,  2514,  3963,
    4788,  2933,  1777,  3963,   933,   933,  2839,   933,  1725,  2341,
    1624,  4609,  2515,    58,  1055,  2613,   797,  5416,  2947,  1793,
    4797,  1741,  1742,  3026,   793,  4438,  1778,    59,  4767,  4789,
    2953,  5152,  4770,  4771,  1653,  4773,  2598, -2908,   660,  3083,
    5580,  4152,  3094,  5732,  2321,  2322,  2323,  2324,  2325,  2326,
      60,  2020,   642,  2753,  4464,  5673,  5674,  5882,   840,  1056,
    3163,  4834,  1794,  3391,  3268,  3258,  3369,  5829,  3874,  3875,
    3876,  3003,  3877,  3878,  3879,  3880,  3881,  3882,  1779,  1766,
    3147,  1054,   783,  4268,  2342,  3965,  3148,  2931,  3508,  1604,
    5404,  3454,  2840,   783,  3874,  3875,  3876,   664,  3877,  3878,
    3879,  3880,  3881,  3882,   833,  5156,   928,   931,   931,  2032,
     931,  3149,  1584,   217,  3483,  2721,  2722,  2723,  2724,  4087,
    5921,   809,  1057,  5407,  3200,  5745,  3545,  5157,  4443,  4444,
    4445,  4446,  4429,  4271,  4451,  4452,  4453,  4454,  4455,  4456,
    4457,  4458,  4459,  4460,  3509,  1309,  1310,  1756,  4839,  2739,
    1493,  5891,  3512,   751,   813,  3515,  5937,  3084,   217,   218,
    5941,  2540,  4254,  4153,  3757,  3507,  2773,  2774,  2516,  3546,
    2991,  1780,  4181,  3570,    19,  4086,  5408,  1795,  2693,  1830,
    1489,  4676,   783,  3132,  1055,   783,   783,  2649,  2799,  4566,
    4499,  4500,  4705,  3484,  4569,  4273,  4791,  4088,  1004,  3532,
     814,  2710,   815,  3547,   218,  1005,  1006,  1007,   810,  2697,
     217,  2517,  5028,  1609,   752,  3150,  2703,  4534,  1610,  1781,
    3151,  1494,  1782, -2517,  1757,  2650,  3152,  -175,  5683,  1056,
    5372,  2932,  3576,  2692,  1348,  2859,  2860,  2861,  2862,  5936,
    1021,  1021,  3900,  2838,  2945,  1600,  3984,  2904,  3907,  4535,
    4182,  5341,  3470,  2857,  1185,  5597,   218,  -175,  5949,  4677,
    4882,   660,  4883,  4609,  4975,  2739, -1900,  2836,  2960,  1784,
    2590,  4792,  2591,   678,  4537,   679,  1774,   783,  3486,  3487,
   -1900,  4616,  3490,  5122,  1611, -1900,  5621,  5029,  4276,   805,
    3236,  3102,  1057,  2875,  2610,  1831,  2583,  2965,  3965,  3120,
    1924,  3305,  3965,  5684,  1654,  1585,  3493,  2584,  2987,  1654,
    1168,  2810,  2992,  4185,  2994,  3675,  2299,  2997,  1786,  1775,
     664,  4390,  4154,  5940,  3551,  1591,  3648,  2611,  1612,  -634,
    2490, -1900,  5593,  5867,  3322,  4277,  1168,  5745,  3919,  2592,
    1787,  2491,  4447,  2934,  3920,  1169,  1586,  1769,  4448,  2849,
    5608, -1900,  3318,  4278,  5447,  2856,  5027,  2959,  5218,  2492,
    5964,  1820,  2962,  1789,  1635,  4155,  1592,  1587,  4617,  3921,
    1770,  1169,  2739,  5338,  1654,  5137,  5563,  3153,  1654,  4568,
     838,  5564,  2307,  3000,  2621,  2746,  1170,  3154,  5632,  5316,
    4267,  3323,  3494,  3322,  4539, -1900,  5339,    39,  5314,  4156,
    2910,  5116,  2078,  1636,  1821,  2079, -1900,  1637,  1822, -1144,
    3347,  2918,  4315,  2919,  1854,  5513,  1777,  3523,  5516,  2923,
     862,  5138,  3362,  4364,  2032,  4618,  2929,    49,  2747,  4619,
    3963,  4616, -1900,  5117,  1171,  5209,  5565,  3963,  1823,  3987,
    1778,  1638,  3963,  2622,  5345,  3963, -1900,  5216,   869,  3665,
    4043, -1900,  3495,    49,  4279,  3255,  3256,  3786,  4179,  4402,
    1171,  3681,  3682,  3683,  3684,  3233,  3397,  1021,   873,    53,
    5291,  5135,  5293,  3689,  3963,  5806,  4344,  4449,  3922,  5753,
    3996,  1917,  5573,  1918,  3923,  4046,  3491,  3963,  4450,  2968,
     883,    42,  1779,  5443,  2669,    53,   678, -1900,   679,  2672,
    4403,  5035,  5036, -1939,  5150,  3649,  3698,  4533, -1939,   214,
    3496,    58,  2493,  3011,  5169,  2748,  1769, -1900,  4617,  2583,
    2974,  2668,  2975,   684,  2976,    59,  2977,  5728,  2978,  2749,
    2600,  4787,  2979,  3018,  3018,  2005,  5126,    58,  2005,  1770,
    3032,  3388,  3678,  3019,  3019,   882,   653,  1627,    60,  3986,
    5338,  3709, -1900,  2623,  4752,  5143,  2006,  2750,  1289,  2006,
    3991, -1900,    61,  5106,  2736,  5107,  5108,   214,  2742,  5109,
    2007,  1641, -1900,  5339, -1939,  4618,  1112,  4753,  1113,  4619,
     210,  2624,  1115,  1114,  2930,  1780,  4132,  4534,    61,  4593,
    1628,  1854,  3528, -1899,  1992,  3734,  2476,  2621,  3142,  4133,
    5631,   975,  1954,  1799,  2061,  2005,  2625, -1899,  2626,  3231,
    2965,   937, -1899,  3497,  1642,  5196,  4533,  1356, -1939,  4535,
    1521,  1357,  5676,  4149,  1629,  1955,  2006,  2062,  4735,   977,
    5338,  4266,  3031,  1781,  4536,  3924,  1782,  3687,   210,   660,
    2009,  1999,  2000,  2619,  4537,  3925,  1800,  2692,  1643,   781,
     994,  4736,  5601,  5339,  2683,   781,  2622,  3963, -1899, -2808,
    3650, -1138,  2632,  1185,  3076,  3077,  4150,   766,  2633,  5818,
    4538,  3091,  3092,   766,  2365,   998,  3727,  3087, -1899,   660,
    1801,  3620,  4614,  1784,  1010,  1011,  1012,   999,  1013,  1014,
    1015,  1016,  1017,  1018,  1044,  5253,  4534,  3200,   664,  3130,
    4151,  3839,  3200,  1135,  3840,  1136,  2379,  1356,  3200,  3841,
    3124,  1357,   700,  3127,  3651,  2690,   766,  2610, -1900,    49,
    2139,  1185, -1899,  2140,  3963,  3977,  3733,  1021,  4535,  3965,
    3355,  3351,  1786, -1899,  3769,  1003,  3965,  3061,   664, -1963,
   -1963,  3965,  3498,  4536,  3965,  1992,  2802,  1639,  5924,  3671,
    2611,  5879,  3499,  4537,  1787,  3500,  3893, -2808,  3895,  3896,
    5295,    53,  3279,  1141,  4539,  1142,  2623,  5304,  3209,  4658,
    3974,  3975,  5560,  3965,  5562,  4226,  4227,  1789,  5566,  4538,
    5567,  5789,  3297,  1772,  1053,  3387,  3965,  3866,  3301,  3343,
    4026,  1063,  3304,  5665,  2624,  2684,  1064,  2375,  2685,  3894,
    2376,  1837,  3528,    58,  1841,  2378,  4076,  2383,  2379,  2969,
    2384,  3145,  2379, -2808,  5912,  3345,  3346,    59,  3328,  2625,
    2252,  2626,    61,   783,  3357,   925,  3359, -2808,  1065,  5602,
    3363,  3917, -2808,  4103,  -490,  2981,  1066, -2808,  2982, -1940,
      60,  2621,  1067, -2808, -1940,  3250, -2808,  4322,  2983,  3023,
   -2808,  2982,  3024,  3980,    61,  1512,  2619,  4332,  5254,  1068,
    4636,  3224,  4079,  3381,  1854,  4644,  3586,  3587,  4650,  3943,
    4657,  1069,  3963,  4539,   678,  1122,   679,  3278, -2808, -1899,
    2379,  1138,  1117,  1125,  4841,  3492,   681,  3312,  1127,  3315,
     926,  3270,    49,   783,  1129,  1139,  3385,   683, -2808,  3386,
    2622,  1924,  5346,  1184,  2899,  1356,  2900, -2498,  3813,  1357,
   -1940,  3749,  3751,  3752,   678,  3309,   679,  4135,  3944,  3475,
    3945,  4679,  3476,   259,  1140,  3617,  3439,  3928,  3618,  3828,
    3373,   643,  1145,  3622,    53,  3963,  3623,  1992,  2621,  2476,
     747,  1924, -2808,  3834,  1149,  3735, -2808,   210,  2379,  4140,
    3946,  1158,  3947, -2808, -1940,  3573,  3965,  3776,  -490,  2716,
    3777,   834,  5925,  4418,  5926,   927,  3477,  3963,  3779,  3808,
    1173,  2982,  3809,  1484,  3488,  1185,    58,  3510,  1163,  5909,
    3513,  1138,  -633,  3396,  3589,  3503,  3810,  4867,  3838,  3809,
      59,  2379,  1172,  3847,     3,     4,  2379,  2622,  3853,  3854,
    3855,  2379,  2379,  2379,  1192,  3516,  3886,  1174,  4318,  2379,
    2623,  3519, -2808,    60,  3899,  3522,  3904,  2379,  2621,  3905,
    5398,  5192,  4780,  3965,  4781,  3065,  4475,    61,  3540,  4377,
    4378,  1187,  4125,  4130, -2810,  4126,  4131,  4160,  2624,  4352,
    4161,  3565,  4353,  4375,  4470,  4480,  2379,  4471,  4481,  1324,
    1324,  1138,  4491,  1324,  4285,  2379,  2745,  1248,  4582,  3595,
    3467,  4583,   751,  2625,  1239,  2626,  4587,  3602,  3603,  4588,
    1249,  1253,   963,   797,  3605,  4592,  1250,  2622,  3293,  5865,
    4252,  3963,   982,    19,   783,  1521,  1259, -1888,  4252,  3621,
    4254,  4615,   783,  4286,  2982,   783,  1267,  1262,  2621, -2808,
    2619,  1274,  1606,  4663,  1608,  1185,  1854,  2623,  1282,  4842,
    4894,   928,  2982,  2125,  1283,  1284,  3102,  3102,  4053,  4916,
     766,  3102,  2379,   752,  5786,  4178, -2808,  5893, -2808, -2808,
    4942,  1315, -2810,  3024,  4954,  2624,  3376,  2379,  5013,  3065,
    1326,  3293,  3715,  5350,  4974,  3677,  4977,  3568,  5019,  4852,
    5025,  5020,  5026,  2982,  1319,  2982,  1323,  2622,  3102,  3102,
    2625,  1329,  2626,  5056, -2808,  1331,  1854, -2808, -2808, -2808,
    1333,  3965,  1335,  3700,  4268,  1330,  5057,  1337,  5221,  1854,
    3592,  4269,  1338,  3592,  1339,  3592,  1345,  2623, -2810,  3592,
    3785,  5351,  5113,  5149,  4270,  5114,  5114,  2619,  3592,  3592,
    3592,  1346, -2810,  5171,  4611,  4612,  5172, -2810,  5226,  3200,
    5228,  5227, -2810,  2379,  1347,  2624,  3464,  5352, -2810,  3963,
    1324, -2810,  5439,  4263,  4271, -2810,  4272,  5236,  4055,  2298,
    3024,  3759,  2299,  3761,  3965,  5951,  1349,  1348,  3657,  5353,
    2625,  5310,  2626,  5354,  5311,  4066,  1350,  1351,  5834,    35,
    3831,  1354,  5399, -2810,  3448,  2982,  4673,  3676,  1360,  5440,
    5459,  2305,  5441,  3024,  1491,  5355,  3965,  2623,  5356,  1355,
    1362, -2908,  3680, -2810,  1488,  5467,  5477,  2619,  5468,  1854,
    4032,  4033,  5483,  5357,  3481,  4329,  4273,  5485,  5499,  5553,
    4329,  5500,  5554,  3963,  5592,  2624,  4425,  2344,  2307,  1495,
    5623,  1496,  3528,  5500,  3710,  5635,    39,  1497,  3024,  3827,
    3791,  3672,  1184,  4274,  1513,  5636,  2930, -2810,  3905,  1519,
    2625, -2810,  2626,  4307,  1518,  3743,  3745,  3699, -2810,  4658,
    5637,  3753,  5648,  2379,  1531,  5649,    49,  3814,  5654,  2298,
    1521,  1854,  2299,  1777,  1522,  3791, -2908, -2908, -2908,    49,
      35,  5657,  1021,  3836,  4329,  1548,  5682,  2619,  4157,  3024,
    4159,  5688,  1565,  1566,  3024,  5754,  5358,  1778,  1590,  2621,
    1184,  2305,  5689,  3916,  4275,  3024,  5359,  1583,    53,  4276,
    3965,  2306,  5692,   210,  1588,  5693,  1366, -2810,  1589,  3867,
    1593,    53,  1602,  3868,  3869,  3870,  1596,   783,  1185,  5169,
    1185,  5694,  5696,  4223,  5695,  5697,  5725,  1852,  2307,  2819,
    4489,  4288,  4406,  4290,  1597,  1607,  1622,  5044, -2908,  1779,
      58,  5360,  5761, -2908,   753,  5114,  4277,  3528,  2622,  5774,
    1623,  1626,  5775,    58,    59,  5778,  5779,  5780,  1854,  2379,
    2379,  1630,  3997,  4208,  4278,  1633,  5782,    59,   797,  2379,
      49,  1639,  5802,  5361,  4165,  5803,  1699,    60,  5825, -2908,
    5845,  5826,  5852,  5114,  5003,  4329,  1674,  1705, -2528,  4173,
      60,   754,   880,  5864, -2810,  5892,  5491,  4229,  5500,  1702,
    1706,  1749,  5457,  1185,  5835,  1758,  5932,  4177,  5934,  5693,
    4653,  5935,    53,  4555,  4556,  4557,  4358,  1754,  1759, -2825,
    1118, -2810,  1760, -2810, -2810,  2621,  5954,  5963,  1766,  5775,
    5935,  2314,  1780,  4035,  1768,  1773,   880,  1798,  3965,  1776,
    1812,  1813,  1828,  4651,  1838,  1839,  1842,  1847,  2308,  1848,
    1858,  2621,  1860,  2309,    58,    49,  1861,  1863,  2623, -2810,
    1864,  1873, -2810, -2810, -2810,  4279,  1866,  1869,    59,  1874,
    4440,  1880,  1881,  1884,  1887,  1888,  1891,  1894,   963,  1896,
    1781,  1902,  1903,  1782,  2622,  1906,  2624,  2298,   982,  2312,
    2299,    60,  1907,  1909,  2692,  4632,  2621,    53,  1914,  1898,
    1926,  1927,  1931,  1932,  4469,    61, -1457,  3397, -1457,  5192,
    2622,  2625,  3965,  2626,  -195,  1934,  4252, -2825,  1941,  2305,
    1935,  3872,  2290,  3949,  3950,  3951,  1939, -2908,  1942, -2908,
    1784,  4108,  3981,  1957,   783,  4550,  4374,  1964,  4297,    58,
    4300,  2314,  1966,  4186,  1184,  1970,  4704,   240,  2619,  4511,
    1977,  1983,  1984,    59,  1988,  2622,  2307,  1985,  1992,  1995,
     880,  4058,  1996,  4059,  4060,  4061,  2290,  2621,  4051,  4219,
    1998,  4758,  2013, -2825,  5176,  2015,    60,  2027,  2028,  1786,
    2031,  2032,  2044,  3145,  2048,  2247,  4774, -2825,  3873,  2049,
      61,  2050, -2825,  2298,  2623,  2052,  2299, -2825,  2057,  3937,
    2058,  1787,  2060, -2825,  2065,  2068, -2825,  2071,  2070,  2077,
   -2825,  2074,  2102,  2128,  4637,  3956,  2129,  2130,  2136,  3065,
    2623,  2141,  2624,  2143,  1789,  2305,  2622,  2144,  2147,  2249,
    2250,  3927, -2908, -2116, -2118, -2908, -2121,  2316, -2825,  2321,
    2322,  2323,  2324,  2325,  2326, -2126,  2257,  2625,  2624,  2626,
    4433,  5647,  2258,  4937,  2259, -2113,  2260,  2261, -2825,    61,
    2263,  2264,  2307,  2265, -2114,  2623,  2266,  2267,  2268,  2270,
   -2117,  4442,  2271,  2625,  1184,  2626, -2908, -2115,  2272,  2273,
    2274, -2908,  2330,  2275,  2619,  4680,  3956,  2276,  2332,  4136,
     879,  2298,  2334,  2624,  2299,  2277,  4465,  2279,  2300,  2301,
    2302,  2280, -2825,  2281,  2282,  2283, -2825,  2284,  2285,  4417,
    2619,  2286,  2348, -2825,  2360,  2303,  2335, -2908,  2625,  2344,
    2626,  2368,  1501,  2305,  2371,  2382,  2389,  2390,  2391,  2392,
    2134,  2393,  3997,  2306,  2394,  2395,  2623,  4498,  4887,  2408,
    3997,  1610,  2317,  1612,  2438, -2908, -2908, -2908,  2440,  2321,
    2322,  2323,  2324,  2325,  2326,  2619,  2449,  2451,  2452,  4899,
    2307,  2453,  2471,  2472,  2624,  2473,  2474,  2479,  2476,  2314,
    2477,  4128, -2825,  2478,  2480,  2481,  2482,  2507,  2488,  2513,
    2519,  2542, -2908,  2546,  4891,  2548,  2552, -2908,  2549,  2625,
    2554,  2626,  3874,  3875,  3876,  2555,  3877,  3878,  3879,  3880,
    3881,  3882,  2570,  2571,  2573,  4230,  3102,  3102,  3102,  3102,
    4220,  2586,  3102,  3102,  3102,  3102,  3102,  3102,  3102,  3102,
    3102,  3102,  2588, -2908,  2587,  2593,  2619,  2589,  2607,  2608,
    2612,  4171,  2614,   797,  2615,  2630,  2616,  2617,  2618,  4473,
    2631,  2619,  2634,  2635,  2636,  2298,   963,  2661,  2299,  2651,
    2662,  2655,  2300,  2301,  2302,  2641,  2652,   982,  2679, -2825,
    2667,  2686,  2663,  2664,  2670, -2908,  2674,  2689,  3102,  3102,
    1725,  2675,  2702,  2705,  2687,  2314,  2694,  2305,  2695,  2709,
    2308,  2711,  2699,  2700,  2712,  2309, -2825,  2306, -2825, -2825,
    2701,  2704,  2728,  2729,  2734,  4210,  2735,  5427,  5145,  2706,
    2755,  2717,  2718,  4852,  4399,  2730,  2310,  2311,  2740,  2761,
    2744,  2766,  2768,  2776,  2307,  2769,  2771,  2770,  2775,  2777,
    4394,  2312,  2783,  2784, -2825,  2785,  2786, -2825, -2825, -2825,
    2787,  2789,  3592,  2788,  2791,  2796,  2797,  2798,  2803,  2807,
     783,  2808,  2820,  2823,  2813,  4242,  2824,  1968,   783,  2825,
    4256,  2833,  2827,  2837,  2848,  4287,  2313,  2852,  4256,  2853,
    2858,  4761,  2854,  2855,  1795,  2881,  2863,  1184,  2874,  1184,
   -2908, -2908,  2890,  2314,  2877,  4301,  2315,  2321,  2322,  2323,
    2324,  2325,  2326,  4392,  2880,  2894,  2896,  2898,  2902,  2908,
    2907,  2914,  2916,  2917,  2921,  2922,  2935,  2924,  2925,  2739,
    2926,  2927,  2938,  2940,  2928,  2941,  2942,  2943,  2955,  2956,
    2963,  2999,  2993,  3012,  3014,  3037,  3015,  3034,  3021,  4401,
    4351,  3039,  4327,  3041,  3070,  3075,  2299,  3119,  3125,  3138,
    3129,  3144,  3156,  3179,  2308,  5050,  5903,  5904,  3158,  2309,
    3178,  3193,  3207,  3210,  3211,  3233,  3235,  3214,  1600,  3215,
    3238,  4357,  1184,  4420,  3242,  3241,  3271,  3264,  3252,   926,
    2310,  2311,  4376,  3243,  3251,  3283,  3253,  3254,  3282,  2316,
    3285,  3313,  3316,  3327,  4347,  2312, -2908,  3318,  4926,  3332,
    3337,  3338,  3320,  2321,  2322,  2323,  2324,  2325,  2326,  3321,
    3348,  3340,  3352,  3360,  3342,  3361,  4373,  2298,  3344,  3364,
    2299,  3377,  3378,  1324,  2300,  2301,  2302,  3383,  1485,  4815,
    2313,  4505,  1489,  3404,  3394,  3403,  3409,  1366,  3411,  3412,
    3867,  5001,  3422,  3428, -2908, -2908, -2908,  2314,  3449,  2305,
     210,  3458,  3429,  3018,  3459,  3465,  3468,  3502,  3523,  2306,
    3560,  3451,  3572,  3019,  3466,  5616,  3583,  3579,  3461,  3474,
    3580,  3584,   210,  5349,  3482,  1854,   783,  3236,  3593,  3598,
    3604,  3599,  3600,  3609,  3612,  3613,  2307,  3615,  3630,  3626,
    3631,  3616,  3610,  3639,  2317,  3624,  3640,  2318,  2319,  2320,
    3655,  2321,  2322,  2323,  2324,  2325,  2326,  3654,  4810,  4811,
    3658,  3128,   792,  3662,   794,  3660,  3679,  3666,  3664,  3674,
     804,  3685,  3694,  3688,  3693,  3696,   820,   828,   792,  3102,
    3697,   836,   837,  3701,  3695,   828,   828,  3707,   836,  3705,
     868,  3708,  3711,  2316,  3712,  3725,  3726,  4662,   880,  4664,
    3728,  3729,  3730,  3732,  3738,  3736,  3739,  3754,  3741,  2020,
    3740,  3765,  3742,  3746,  3755,  3768,  4486,   880,  3997,  3767,
    3772,  3774,  3778,  2298,  3781,  3782,  2299,  3783,  3784,  3792,
    3035,  3795,  4999,  2066,  2029,  3796,  3803,  3811,  3804,  3822,
    1321,  3815,  3794,  4627,  4628,  4629,  4630,  3820,  3997,  3824,
    4513,  4514,  4515,  4516,  3832,  2305,  2308,  3833,  3829,  3835,
    3852,  2309,  3830,  3849,  3850, -2908,  3851,  3856,  2134, -2381,
    3857,  2379,  3863,  4633,  3859,  3862,  2693,  3901,  3913,  3918,
    4005,  4023, -2908, -2908,  3885,  3891,  3935,  3898,  3912,  3926,
    3940,  3989,  2307,  3936,  3938,  3999,  3939,  2312,  2317,  5739,
    3942,  2318,  2319,  2320,  3990,  2321,  2322,  2323,  2324,  2325,
    2326,   214,  3973,  3777,  3968,  4003,  4009,  4007,  4016,  4029,
    1112,  4045,  1113,  4034,  4037,  4048,  1115,  1114,  2290,  4763,
    4036,  3717, -2908,  4057,  4050,  4083,  4072,  4073,  4085,  4090,
    4091,  4764,  4041,  4042,  4520,  4089,  4092,  4525,  5127,  2314,
    4106,  4107,  4110,  4112,  4121,   964,  1677,   971,   971,   974,
    4109,   971,  4129,  4119,  4118,   983,  4120,  4501,   836,  3873,
    4141,  1002,  4145,  1023,  4162,  4134,  4166,  2125,  4168,  4164,
     836,  4169,   210,   971,  4172,  4192,   836,  4174,  4175,  4176,
     971,  4190,   836,  1678,  4191,  4193,  4737,  5034,  5264,  4740,
    5557,  4194,  4205,  4195,  4197,  5279,  4196,  4200,  4209,  5155,
    4202,  4198, -2908,  1366,  4252,  4199,  3867, -2908,  4204,  4213,
    3868,  3869,  3870,  4201,  4203,  1138,   783,  4206,  4211,  4215,
    5823,  4216,  4965,  2726,  4218,  5055,  4256,  4944,  4224,  4228,
    4231,  4235,  4236,  4782,  4238,  2316,  4243,  4247,  4258,  4261,
    4785,  4295,  4304, -2908,  4305,  4296,   783,  4308,  4309,  5547,
    1680,  5549,   783,  5074,  4311,  4312,  4708,  4314,  4317,  4329,
    4328,  4331,  4338,  4716,  4342,  4345,  4717,  4346,  4718,  4341,
    4349,  4350,  4362,  4372,  4715,  4384,  4888,  4889,  4890,  4395,
    4379,  4396,  4397,  4386,  5397,  1681,  4381,  4398,  4405,  4407,
    5042,  4408,  4380,  4409,  4422,  2314,  4412,  4411,  4400,  4421,
    4423,  5883,  4424,  4827,  4426,  4427,  2252,  4428,  4432,  3888,
    4757,  3867, -2380,  3887,  4493,  3718,  4466,  4441,  5101,  4467,
    1682,  4482,  2739,   927,  4468,  3592,  4474,  4776,  4512,  3592,
    3592,  4523,  3592,  4506,  1309,  1310,  4547,  4552,  4576,  4579,
    2317,  4581,  4585,  2318,  2319,  2320,  4494,  2321,  2322,  2323,
    2324,  2325,  2326,  4602,  4497,  4524,  1683,  5349,  4595,  4549,
    4623,  4625,  4562, -2908, -2908, -2908,  4532,  3877,  3878,  3879,
    3880,  3881,  3882,  5085,  4570,  4638,  4564,  4567,  4631,  4639,
    4626,  4571,  4640,  4641,  4643,  4645,  4647,  4661,  4668,  4682,
    1685, -2908,  4684,  4685,  3791,  4776,  4686,  5701,  4696,  4697,
    4698,  4699,  4700,  4701,  4710,  4712,  5707,  5709,  4713,  4723,
    4724,  4732,  4729,  4747,  4749,  1686,  4751,  4652,  3872,  4754,
    4766,  4768,  4769,  4772,  4798,  4765,  4784,  4807,  4795,  4816,
    4832,  4824,  4835,  4831,  4844,  2982,    42,  4854,  4838,  5197,
    1688,  4837,  4859,  4866,  5395,  5466,  4877,  1021,  1689,  4860,
    4872,  4873,  4876,  5773,  4875,  4878,  4885,  1690,  4892,  4880,
    4881,  4896,  4900,  4902,  4908,  4913,  2564,  4918,  4922,  4928,
    5568,  4862,  5298,  4923,  5147, -2382,  4927,  4931,  4929,  4970,
    1692,  4971,  4930,  4935,   783,  3873,  2134,  4950,  4963,  1693,
    4978,  1366,  4968,  5559,  3867,  4897, -2908,  4966,  3868,  3869,
    3870,  3956,  4983,  2321,  2322,  2323,  2324,  2325,  2326,   963,
    4979,  4984,   963,  4986,  3720,  4945,  4905,  4905,  4905,  5520,
    4905,  4905,  4905,  4987,  5322,  2297,  4989,   210,  4990,  5000,
    2298,  4991,  4997,  2299,  5009,  5012,  5016,  2300,  2301,  2302,
    5594,  5014,  5021,  5022,  1366,  5030,  5049,  3867,  5804,  5048,
    1694,  3868,  3869,  3870,  2303,  3721,  3523,  2304,  5052,  5060,
     982,   982,  2305,  5062,  5063,  1072,  5082,  5075,  5064,  5084,
    5078,   836,  2306,   964,  5096,  5105,  5110,   971,  1532,   974,
    5087,   971,  5088,  5118,  5119,  5125,  5133,  5124,  5128,  5134,
    1002,  5140,  1023,  5146,  5461,  5141,  5139,  1155,  5144,  2307,
     971,  5151,  5153,  5161,  5164,  5175,  5187,   971,  5168,  5173,
    5188,  5190,  5092,  5093,  5185,  5095,  3102,  5189,  5198,  5203,
    5210,  5211,  5213,  5230,  5222,  5229,  5232,  1533,  5223,  5225,
    5241,   964,  5233,  5234,  5235,  2292,   974,  5277,  5257,  5247,
    5289,   983,  5281,   982,  5701,  1534,  1002,  5286,  1023,  5250,
    5292,  4996,  5261,  5303,  5307,  5283,  4993,  5104,  4995,  5312,
    5344,  5282,  5306,  5313,  5319,  5368,  5325,  5326,  5716,   971,
    1535,  5330,  5335,  4794,  5336,  5069,  5337,  5374,  5015,  5376,
    5378,  5379,  5381,  5384,  5918,  5382,  5385,  5079,  5402,  3874,
    3875,  3876,  5403,  3877,  3878,  3879,  3880,  3881,  3882,  5410,
    5415,  5412,  5419,  5428,  5429,  5094,  3872,  5002,  5004,  5421,
    5442,  1732,  5444,  5317,  3956,  5445,  1536,  5446,  3956,  2308,
    5098,  5455,  5453,   836,  2309,  1328,  5462,  5465,  5469,  5475,
    5479,  5491,  5482,  1537,  5486,   783,  5497,  5515,  5918,   783,
    5487,  5489,   836,  5517,  1344,  2310,  2311,  5518,  5495,  5508,
    5525,  5531,  5569,  1138,  5574,  5581,  5576,  5585,  5918,  3872,
    2312,  5053,  5595,   210,   210,  5586,  1470,  1470,  2338,   836,
     828,  5072,  5073,  3873,   828,  5600,  5076,  5077,  5607,  5606,
    5614,  5618,  5546,  5619,  5620,  5627,  5628,  2134,   836,  5630,
    5638,   836,  5663,  5662,  1185,  2313,  1366,  5633,  1470,  3867,
    5639,  5646,  5659,  3868,  3869,  3870,  5629,  5668,  5667,  5681,
     836,  5670,  2314,  5685,  5680,  2315,  5167,  5706,  5714,  5715,
    5719,  5721,  1538,  5650,  5724,  5727,  3873,  4208,  5730,  5731,
    5737,  1539,  5640,  5752,  5750,  5751,  5758,  5759,  1540,  5771,
    5795,  5769,  5805,  5797,  5717,  5718,  5099,  5100,  5814,  5656,
    4507,  5847,  5862,  5675,  5658,  5788,  5660,  5790,  5855,  5875,
    3592,   836,  3592,  3592,  5886,  5813,  3592,  5872,  5881,  5901,
    5928,  4242,  5905,  5899,  5907,  5900,  5911,  1541,  5923,  1542,
    5930,  5927,  1543,  5950,  2134,  5933,  5943,  5944,  5955,  2134,
    2134,  5952,  5953,  3791,  1002,  1544,  5956,  1021,  5957,  5965,
    1545,  5958,  5960,  5967,  5966,   836,  2741,  3668,  2316,  1366,
    5969,  1523,  3867,  3983,  1546,  1810,  3868,  3869,  3870,  1002,
    3102,  1703,  1809,  2367,   836,  1328,  4146,  1547,  3533,  3457,
    4100,  4671,  5163,   971,   971,  5800,  3997,  4660,  5910,  5798,
    4777,  3571,  5115,  5712,  5700,  3102,  4809,  5420,  5873,  1021,
    5123,  1677,  5323,  5394,  5321,  4039,  3780,  5296,  5791,  5672,
    5722,  5869,  5720,   828,   828,  5812,  5191,  5888,  4863,  4044,
    5166,  4843,  5678,  3637,  3638,  4669,  4123,  3874,  3875,  3876,
    4316,  3877,  3878,  3879,  3880,  3881,  3882,  1797,  1678,  4830,
    5401,  1328,  5148,  5299,  5300,  5300,  3625,  4324,  5367,   964,
    5874,  1185,  4905,  5406,  5959,  3791,  5626,  3791,  5948,  5380,
     983,  3872,  5588,  2317,  1023,  4264,  2318,  2319,  2320,  1679,
    2321,  2322,  2323,  2324,  2325,  2326,   210,  4259,  5816,  5324,
    3874,  3875,  3876,   971,  3877,  3878,  3879,  3880,  3881,  3882,
    2826,  5527,  5687,  5327,   801,  2122,  4893,  5503,  3288,  4869,
    4030,  2903,  2138,  5625,   963,  1680,  2944,  1186,  1893,   836,
    4212,   982,  4702,  3028,  1002,  3029,  4722,  3030,  1328,  5837,
    1498,   971,   971,  5942,  2487,  3219,  3230,  1268,  3873,  3220,
    2410,  3232,  2759,  2762,  4848,  2973,  5285,  5785,  5005,  2380,
    1681,  4589,  3020,  4413,   836,   836,   836,  3995,   971,  4004,
     964,  4002,  2340,  2435,  3263,  5781,  4563,  5661,  2298,  4994,
    3262,  2299,  5284,  4527,  2439,  2300,  2301,  2302,  2434,  4961,
     974,  5481,  4521,  4976, -2908,  1682,  5645,  5644,  4590,  4522,
    5476,  5945,  2303,  2444,  5854,  5906,  5772,  2915,  5460,  5280,
    2305,  5476,  5546,  4476,   783,  5783,  5768,  5784,  3183,  3933,
    2306,  3931,  3956,  3844,  4256,  3192,  3826,  3956,     0,  5436,
    3956,  1683,  1549,     0,     0,     0,     0,     0,     0,  3102,
       0,     0,     0,  1002,   971,     0,  1328,  2307,     0,   971,
     971,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3873,     0,     0,  1684,  1685,     0,     0,  5363,  3592,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1470,
       0,  1550,     0,     0,     0,     0,     0,  5777,     0,     0,
    1686,     0,     0,     0,  5551,     0,     0,     0,     0,  1551,
       0,     0,     0,     0,     0,     0,     0,  1687,     0,  2105,
    2105,    42,     0,     0,   836,  1688,   792,     0,  1185,     0,
       0,  1328,     0,  1689,  1552,     0,     0,  5437,     0,     0,
       0,     0,  1690,     0,  2298,     0,     0,  2299,     0,     0,
       0,  1691,  5400,  2142,     0,     0,   836,     0,     0,  2149,
       0,  1470,  3874,  3875,  3876,  1692,  3877,  3878,  3879,  3880,
    3881,  3882,     0,     0,  1693,     0,  2305,  2308,  5454,  1470,
    1553,     0,  2309,     0,     0,     0, -2908,     0,     0,     0,
       0,     0,  5548,  5435,  5550,     0,     0,  1554,     0,     0,
     880,     0,     0,  2310,  2311,     0,     0,     0,   210,     0,
    1470,     0,     0,  2307,     0,     0,     0,     0,  2312,     0,
       0,     0,     0,     0,     0,     0,     0,  3102,     0,     0,
       0,     0,     0,     0,     0,  1694,     0,     0,     0,  5655,
       0,     0,  1470,  1470,  1470,     0,  1470,     0,     0,   210,
       0,     0,     0,  2313,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1021,     0,  1470,     0,     0,     0,
    2314,     0,     0,  2315,     0,  3874,  3875,  3876,     0,  3877,
    3878,  3879,  3880,  3881,  3882,     0,  1555,     0,  4502,     0,
       0,     0,     0,     0,     0,  1556,     0,     0,     0,   783,
     783,     0,  1557,     0,   836,     0,     0,     0,  2298,  5541,
    5541,  2299,  1558,   783,     0,  2300,  2301,  2302,     0,  3956,
       0,     0,     0,  1184,     0,     0,     0,  5561,     0,     0,
    2290,     0,  2303, -2908,     0,     0,     0,     0, -2908,  2521,
    2305,     0,     0,  1559,  2522,     0,  1560,     0,     0,  5853,
    2306,     0,     0,     0,     0,     0,     0,  5300,     0,  1561,
       0,     0,     0,     0,  1562,     0,  2316,     0,     0,     0,
       0,     0,     0,     0, -2908,     0,     0,  2307,  1563,     0,
       0,     0,     0,  2523,     0,     0,     0,     0,     0,     0,
       0,  1564,     0,     0,     0,     0,     0,  2524,     0,     0,
       0,     0,     0,  2397,  2407,     0,     0,     0,     0,     0,
       0,     0,  1470,  2525,     0,     0,  1470,  1470,     0,  4776,
       0,  5609,     0,     0,     0,     0,  2314,   836,   836,  2448,
       0,  1470,     0,     0,  3102,  3102,     0,     0,  1002,     0,
       0,     0,     0,     0,  5794,     0,  5729,     0,     0,     0,
       0,     0,     0,     0,   963,   828,     0,     0,     0,     0,
     982,  2526,     0,     0,     0,     0,     0,  3956,     0,     0,
       0,  2317,  2527,     0,  2318,  2319,  2320,   210,  2321,  2322,
    2323,  2324,  2325,  2326,     0,     0,     0,     0,     0,     0,
    2553,  3858,     0,     0,  2528,     0,   828,  2308,     0,  2529,
       0,     0,  2309,  5664,     0,     0,     0,     0,     0,     0,
    5698,   836,  2582,     0,     0,     0,     0,     0,     0,     0,
    5843,  5844, -2908,  2310,  2311,     0,   836,     0,     0,   971,
    1184,     0,     0,     0,  5704,     0,  5705,     0,  2312,  3791,
    5710,  5711,     0,  5713,     0,     0,     0,     0,     0,     0,
    5801,     0,     0,     0,  2644,     0,     0,     0,     0,   210,
       0,     0,     0,  1023,     0,   836,     0,     0,     0,     0,
    2530,     0,     0,  2313,     0,     0,     0,     0,   836,     0,
       0,   836,     0,     0,     0,     0,     0,     0,     0,     0,
    2314,     0,     0,  2315,     0,     0,     0,  4776,     0,     0,
       0,     0,     0,     0,  1677,  3966,     0,     0,     0,  2531,
       0,     0,     0,     0,     0,     0,     0,     0,   836,     0,
       0,     0,     0,     0,     0,     0,     0, -2908,     0,   971,
     971,   971,   971,   836,  2321,  2322,  2323,  2324,  2325,  2326,
       0,  1678,     0,     0,   240,     0,  5871,   836,     0,     0,
       0,     0,     0,     0,  4993,     0,     0,   783,     0,   783,
       0,     0,     0,  2407,     0,  2397,  2764,  5541,   836,  5541,
       0,     0,  2298,     0,     0,  2299,  3966,     0,  5300,  5300,
     971,   971,     0,     0,     0,  2532,  2316,     0,     0,     0,
       0,     0,  2533,     0,     0,  2534,     0,     0,     0,     0,
       0,     0,   971,     0,  2305,     0,     0,  1328,  1680,     0,
       0,     0,     0,     0, -2908,     0,     0,     0,     0,  5961,
    5962,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   836,     0,  2535,     0,     0,     0,  5817,     0,     0,
    2536,  2307,     0,  1681,     0,     0,     0,  2537,   214,   971,
     971,   971,   971,     0,  2538,     0,     0,  5839,     0,  5840,
       0,     0,   836,  5842,  5841,     0,     0,  5898,     0,   836,
       0,     0,  2764,  5300,     0,     0,     0,  1184,  1682,     0,
       0,  2539,   964,     0,     0,   964,     0,     0,     0,     0,
     974,  2317,     0,   210,  2318,  2319,  2320,  1470,  2321,  2322,
    2323,  2324,  2325,  2326,     0,     0,     0,     0,     0,     0,
       0,  3908,     0,     0,  1683,     0,  4948,     0,     0,   210,
       0,     0,     0,     0,     0,     0,   214,     0,     0,     0,
       0,     0,     0,   983,   983,  5839,   783,  5840,     0,     0,
       0,  5842,  5841,     0,     0,  5916,  5541,     0,  1685,  1023,
    1023,     0,     0,     0,  1328,  5917,     0,     0,     0,     0,
       0, -2908,     0,     0,     0,     0, -2908,     0,     0,     0,
     971,   971,     0,  1686,     0,     0,   971,     0,     0,  1002,
       0,     0,   836,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    42,     0,  2563,  5897,  1688,  5916,
       0,     0, -2908,     0,     0,     0,  1689,  2105,     0,  5917,
       0,     0,     0,     0,   971,  1690,   983,   214,     0,  5916,
     836,   836,     0,   971,  2564,     0,  5839,     0,  5840,  5917,
     836,  5968,  5842,  5841,     0,     0,     0,     0,  1692,     0,
       0,     0,     0,   836,     0,     0,     0,  1693,   792,   792,
       0,     0,     0,  3038,  2314,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   210,     0,
       0,     0,  2298,     0,     0,  2299,     0,     0,     0,  2300,
    2301,  2302,     0,     0,     0,     0,     0,     0,  1694,     0,
       0,     0,     0,     0,     0,     0,  2303,     0,     0,     0,
       0,     0,     0,     0,  2305,     0,     0,     0,     0,     0,
       0,     0,  2298,     0,  2306,  2299,     0,     0,     0,  2300,
    2301,  2302,     0,     0,     0,     0,     0,     0,     0,  1567,
   -2908,     0,     0,     0,     0,  1470,  2303,  1470,     0,     0,
       0,  2307,  1470,  1470,  2305,     0,     0,     0,     0,  1470,
    1470,  1470,     0,     0,  2306,  1470,  1023,  1470,  1470,  1470,
    1470,  1470,  1470,     0,  1470,     0,  1470,  1470,     0,     0,
    1470,     0,     0,     0,     0,     0,     0,     0,  1568,     0,
       0,  2307,     0,     0,     0,  1470,  1470,  1470,  1470,     0,
       0,     0,   971,  1470,     0,     0,  1569,  1470,     0,     0,
    1470,     0,     0,  1470,  1470,  1470,  1470,  1470,  1470,  1470,
    1470,  1470,     0,  1470,     0,     0,     0,     0,     0,   836,
    1470,  1570,  1470,     0,     0,     0,     0,     0,     0,   836,
       0,     0,     0,     0,     0, -2908,     0,     0,     0,     0,
       0,     0,  2321,  2322,  2323,  2324,  2325,  2326,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     836,  2308,   836,     0,  1470,     0,  2309,  1571,   836,     0,
       0,  1002,  1002,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1572,     0,     0,  2310,  2311,     0,
    2407,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2308,  2312,     0,     0,     0,  2309,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   836,     0,  2310,  2311,     0,
       0,     0,  3272,     0,  3277,     0,     0,  2313,     0,     0,
       0,     0,  2312,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2314,     0,     0,  2315,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   974,     0,     0,
       0,     0,     0,  1573,     0,     0,   792,  2313,   792,     0,
       0,     0,  1574,     0,     0,     0,     0,     0,     0,  1575,
       0,     0,     0,  2298,  2314,  1470,  2299,  2315,     0,  1576,
    2300,  2301,  2302,     0,     0,     0,     0,   964,     0,   971,
     971,     0,     0,     0,   983,     0,  1023,  2303,   971,     0,
     971,     0,  1982,     0,   971,  2305,     0,   836,     0,     0,
    1577,     0,     0,  1578,     0,  2306,     0,     0,     0,     0,
       0,     0,     0,     0,  3966,     0,  1579,  3966,     0,   828,
    2316,  1580,     0,     0,  2012,     0,     0,     0,     0,     0,
    2582,     0,  2307,     0,     0,  1581,     0,     0,     0,     0,
    3399,   836,     0,     0,  2030,     0,  2298,     0,  1582,  2299,
       0,     0,     0,  2300,  2301,  2302,  3417,     0,  2046,     0,
    2316,     0,   836,     0,     0,  2051,   836,     0,     0,     0,
    2303,  2059,     0,     0,     0,     0,     0,  2067,  2305,     0,
    2069,     0,     0,  1328,     0,     0,     0,     0,  2306,     0,
       0,   836,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3966,     0,     0,  3472,  3472,     0,     0,
       0,     0,     0,     0,     0,  2307,   836,   836,     0,     0,
     836,     0,   974,   828,     0,  2317,     0,     0,  2318,  2319,
    2320,     0,  2321,  2322,  2323,  2324,  2325,  2326,     0,     0,
       0,   971,  4260,     0,   971,     0,     0,     0,     0,     0,
       0,     0,  2308,     0,     0,     0,     0,  2309,     0,     0,
       0,     0,     0,     0,     0,  2317,   836,   836,  2318,  2319,
    2320,     0,  2321,  2322,  2323,  2324,  2325,  2326,  2310,  2311,
       0,  3559,  4434,  3562,  3564,     0,     0,     0,     0,     0,
       0,     0,     0,  2312,     0,  2298,  4674,     0,  2299,     0,
       0,     0,  2300,  2301,  2302,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2407,     0,  1002,     0,     0,  2303,
       0,     0,     0,   971,     0,     0,     0,  2305,  2313,     0,
       0,   971,   971,     0,     0,  2308,     0,  2306,   971,     0,
    2309,     0,     0,     0,     0,  2314,     0,     0,  2315,     0,
       0,  1470,     0,   971,     0,     0,     0,     0,     0,  1777,
       0,  2310,  2311,     0,  2307,     0,     0,     0,     0,     0,
    2582,     0,     0,     0,     0,     0,  2312,     0,     0,     0,
       0,     0,  3472,  1778,   836,     0,     0,   836,     0,     0,
       0,     0,  3669,     0,     0,   792,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1328,     0,   971,
    1470,  2313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3559,  2314,     0,
       0,  2315,   835,     0,     0,  1779,  4652,   971,     0,  3703,
       0,  2316,     0,     0,  2510,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,  1470,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3966,     0,     0,  2308,     0,     0,     0,     0,  2309,
     971,     0,     0,     0,     0,   971,  3472,   971,  3472,     0,
       0,     0,     0,     0,     0,     0,  4653,     0,     0,     0,
    2310,  2311,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2316,  2312,     0,     0,  1780,     0,
       0,     0,     0,     0,     0,     0,     0,  2105,     0,     0,
       0,     0,     0,     0,     0,     0,  2317,     0,     0,  2318,
    2319,  2320,     0,  2321,  2322,  2323,  2324,  2325,  2326,     0,
    2313,     0,     0,  4485,     0,     0,     0,     0,     0,     0,
    1002,     0,     0,     0,     0,     0,  1781,  2314,  2298,  1782,
    2315,  2299,     0,   836,     0,  2300,  2301,  2302,     0,     0,
    2692,     0,     0,     0,  4654,     0,  1470,   964,     0,     0,
       0,     0,  2303,   983,     0,     0,     0,     0,     0,     0,
    2305,     0,     0,     0,     0,     0,     0,   971,     0,   997,
    2306,     0,     0,     0,     0,  1470,  1784,     0,     0,  2317,
    1470,  1033,  2318,  2319,  2320,     0,  2321,  2322,  2323,  2324,
    2325,  2326,     0,  1052,     0,     0,  4565,  2307,     0,     0,
       0,     0,     0,  1470,  1470,  1470,     0,     0,  1470,     0,
       0,     0,     0,     0,     0,     0,  1470,  1470,  1470,  1470,
       0,     0,     0,  2316,     0,  1786,     0,     0,     0,  1470,
       0,     0,  1470,     0,  1470,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3966,  1470,  1470,  1787,  3966,  1470,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1023,     0,  1470,     0,  1470,     0,  1470,     0,     0,
    1789,     0,  4655,     0,     0,     0,  4656,     0,     0,     0,
       0,  2298,     0,     0,  2299,     0,     0,  1470,  2300,  2301,
    2302,   836,     0,     0,     0,     0,     0,     0,  3967,     0,
    1470,  1470,  1470,     0,     0,  2303,     0,     0,     0,     0,
       0,     0,     0,  2305,     0,     0,     0,  2308,  1470,     0,
       0,     0,  2309,  2306,     0,     0,     0,     0,  2317,     0,
       0,  2318,  2319,  2320,     0,  2321,  2322,  2323,  2324,  2325,
    2326,  3992,     0,  2310,  2311,  4575,  3994,     0,  1470,     0,
    2307,     0,     0,  1470,     0,     0,     0,     0,  2312,  1470,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3967,
       0,     0,     0,  4015,     0,     0,  4018,     0,  3277,     0,
    2298,  2619,     0,  2299,     0,     0,     0,  2300,  2301,  2302,
       0,     0,     0,  2313,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2303,     0,     0,     0,     0,     0,
    2314,     0,  2305,  2315,     0,     0,     0,     0,     0,     0,
       0,  1470,  2306,  3472,     0,     0,     0,     0,  2105,     0,
       0,     0,     0,     0,     0,     0,  2298,     0,     0,  2299,
       0,     0,     0,  2300,  2301,  2302,     0,     0,     0,  2307,
       0,     0,     0,     0,     0,   971,     0,   971,   971,   971,
    2303,     0,     0,     0,     0,     0,     0,     0,  2305,     0,
    2308,     0,     0,     0,     0,  2309,     0,     0,  2306,     0,
       0,     0,     0,     0,     0,     0,  2936,     0,     0,     0,
    2939,     0,     0,     0,     0,     0,  2310,  2311,  2946,     0,
       0,     0,     0,     0,     0,  2307,  2316,     0,     0,     0,
    5130,  2312,     0,     0,     0,  2957,     0,  3717,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1677,     0,     0,     0,  2313,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1328,
       0,     0,     0,  2314,     0,     0,  2315,     0,     0,  2308,
       0,     0,     0,     0,  2309,     0,  1070,     0,     0,  1678,
       0,     0,  1116,     0,     0,     0,     0,   836,     0,     0,
       0,     0,     0,     0,     0,  2310,  2311,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2312,  2317,     0,     0,  2318,  2319,  2320,     0,  2321,  2322,
    2323,  2324,  2325,  2326,     0,  2308,     0,     0,  4604,     0,
    2309,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2313,  1680,     0,     0,     0,
       0,  2310,  2311,     0,     0,     0,     0,     0,     0,  2316,
       0,     0,  2314,     0,     0,  2315,  2312,     0,     0,     0,
       0,     0,     0,     0,     0,  3966,     0,     0,     0,     0,
       0,  1681,  3966,     0,     0,     0,     0,  3966,     0,   974,
    3966,  5259,     0,     0,     0,     0,     0,     0,     0,   971,
       0,  2313,     0,     0,  3472,  3472,     0,     0,     0,     0,
       0,  3718,     0,     0,     0,     0,  1682,     0,  2314,  3966,
       0,  2315,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3966,     0,     0,  1328,     0,     0,     0,     0,
       0,     0,     0,     0,   836,   836,   836,     0,     0,     0,
       0,     0,  1683,  1342,     0,     0,     0,     0,  2316,  4303,
       0,     0,     0,     0,  2317,   836,     0,  2318,  2319,  2320,
       0,  2321,  2322,  2323,  2324,  2325,  2326,     0,     0,     0,
    1477,  4914,     0,     0,   982,     0,  1685,     0,     0,     0,
    2105,   836,     0,     0,     0,     0,     0,     0,     0,  1500,
    2105,   836,   836,     0,     0,     0,   836,     0,     0,     0,
       0,  1686,     0,     0,  2316,     0,     0,   836,     0,     0,
       0,  1530,     0,     0,     0,  3216,     0,     0,   982,     0,
       0,     0,    42,     0,     0,     0,  3719,     0,     0,     0,
       0,     0,     0,     0,  1689,     0,     0,     0,     0,     0,
       0,     0,     0,  1690,     0,     0,     0,     0,     0,     0,
       0,     0,  2564,  2317,     0,     0,  2318,  2319,  2320,     0,
    2321,  2322,  2323,  2324,  2325,  2326,  1692,   971,     0,     0,
    4949,     0,  1002,     0,  3042,  1693,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     836,     0,  3966,     0,     0,     0,     0,     0,     0,  1002,
    3720,     0,     0,     0,     0,     0,     0,     0,     0,  2317,
       0,     0,  2318,  2319,  2320,   836,  2321,  2322,  2323,  2324,
    2325,  2326,     0,     0,     0,  1747,  5220,     0,  3043,     0,
       0,     0,     0,     0,     0,     0,  1694,     0,  1470,     0,
       0,  3721,     0,     0,     0,     0,     0,  1470,     0,     0,
       0,     0,     0,  1470,     0,  1470,     0,     0,  1470,  3966,
       0,     0,  3044,  1470,  1470,  1470,  1470,     0,     0,  1470,
    1470,  1470,  1470,  1470,  1470,  1470,  1470,  1470,  1470,     0,
       0,     0,  1470,  1470,     0,     0,     0,     0,     0,     0,
       0,  3045,  1470,     0,     0,     0,  1470,     0,     0,     0,
    1470,     0,  3046,     0,     0,     0,     0,     0,  1470,     0,
       0,  1470,     0,  1470,     0,     0,     0,     0,  3717,     0,
       0,     0,  1470,     0,  3047,  1470,  1470,     0,     0,  3048,
    1470,  1470,     0,     0,     0,  4509,     0,  1470,     0,     0,
       0,     0,     0,  1677,   836,   836,   836,   964,     0,     0,
    3967,  4531,     0,     0,     0,  4531,  4545,  4531,     0,     0,
    1911,     0,     0,  1470,     0,     0,     0,     0,     0,  1470,
    1470,  1470,     0,     0,     0,     0,     0,     0,     0,  3049,
    1678,     0,     0,  5587,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1959,  1962,  1963,     0,     0,
    3050,     0,  1470,     0,     0,     0,     0,  3966,     0,     0,
       0,     0,     0,     0,     0,     0,  3277,     0,  1470,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4610,  2105,  2105,     0,
    2764,     0,     0,     0,     0,     0,     0,  1680,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   971,   971,   971,
     971,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3966,     0,     0,     0,   240,     0,     0,  3051,     0,     0,
       0,     0,  1681,     0,     0,     0,  2582,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3966,     0,     0,     0,  3052,  4666,     0,     0,
       0,     0,  3718,     0,   836,  3053,     0,  1682,     0,     0,
       0,     0,  3054,     0,     0,     0,     0,     0,     0,   964,
       0,     0,     0,     0,     0,     0,     0,     0,  3055,     0,
    2298,     0,     0,  2299,     0,  1477,     0,  2300,  2301,  2302,
       0,     0,     0,  1683,  3056,     0,     0,     0,     0,     0,
       0,     0,     0,  3057,  2303,     0,  3058,     0,     0,     0,
       0,     0,  2305,     0,     0,     0,     0,  1477,     0,     0,
       0,     0,  2306,     0,  3059,     0,  2298,  1685,     0,  2299,
       0,     0,     0,  2300,  2301,  2302,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4755,  2307,
    2303,  3060,  1686,     0,     0,     0,  3966,   974,  2305,     0,
       0,     0,     0,  1002,     0,     0,     0,     0,  2306,     0,
       0,     0,     0,    42,     0,     0,     0,  1688,     0,     0,
       0,     0,     0,     0,  3731,  1689,     0,     0,     0,     0,
       0,     0,  3737,     0,  1690,  2307,     0,   971,     0,     0,
       0,   836,     0,  2564,   971,     0,  1470,     0,     0,     0,
       0,     0,  3756,   836,     0,     0,     0,  1692,     0,  4801,
       0,     0,     0,     0,   982,  3763,  1693,     0,     0,     0,
    3764,  2582,     0,  3766,     0,     0,     0,     0,     0,  3770,
       0,  3771,     0,  3773,     0,     0,     0,     0,     0,     0,
     836,  3720,     0,     0,  3967,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3559,  2369,     0,     0,     0,  2308,
       0,     0,     0,  4853,  2309,     0,     0,     0,     0,  5820,
       0,   836,     0,     0,     0,  2764,     0,  1694,     0,  1470,
    1470,     0,  3721,     0,  3966,  2310,  2311,     0,     0,     0,
     982,   982,     0,     0,     0,     0,     0,     0,     0,     0,
    2312,     0,     0,     0,     0,  2308,     0,  3823,     0,  3472,
    2309,  3472,     0,     0,     0,     0,     0,     0,     0,     0,
     836,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2310,  2311,     0,     0,  2313,     0,  1002,     0,     0,
       0,     0,     0,     0,     0,     0,  2312,     0,     0,     0,
       0,     0,  2314,     0,     0,  1470,     0,     0,  3966,     0,
       0,     0,     0,     0,     0,     0,  1470,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2446,
       0,  2313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1470,     0,  2314,     0,
       0,  2315,     0,  1707,     0,     0,  1470,  1470,     0,  1708,
       0,     0,     0,  1470,  1470,     0,     0,     0,  1470,     0,
       0,     0,  1709,  1470,     0,     0,  1470,  1470,     0,     0,
       0,  1470,  4953,     0,     0,     0,     0,  1470,   836,   836,
     836,   836,     0,     0,     0,  4531,  4545,  4531,  2316,  1470,
    4531,     0,     0,  4967,     0,  4674,  1710,  3967,     0,     0,
       0,  3967,  2574,     0,     0,  5947,     0,  4982,     0,     0,
       0,     0,     0,     0,  1470,     0,     0,  2609,     0,  1470,
       0,     0,     0,     0,     0,  1470,     0,     0,     0,   982,
     982,     0,  4674,     0,  2316,  4998,  1023,     0,     0,     0,
       0,     0,     0,     0,  1470,     0,  1711,     0,  4015,  1712,
       0,     0,     0,  3277,  1713,     0,  2660,     0,  1714,  1715,
    1716,     0,     0,     0,     0,  1717,     0,   792,  1718,  2673,
    1470,     0,  2676,     0,     0,     0,  1719,     0,     0,  1707,
       0,     0,     0,     0,     0,  1708,     0,     0,     0,     0,
    3472,  3472,     0,  2317,     0,  1720,  2318,  2319,  2320,     0,
    2321,  2322,  2323,  2324,  2325,  2326,     0,     0,  2582,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5054,     0,     0,  2725,     0,     0,     0,  1721,     0,
       0,     0,  1710,     0,     0,     0,     0,  4049,  2743,  2317,
       0,     0,  2318,  2319,  2320,     0,  2321,  2322,  2323,  2324,
    2325,  2326,     0,     0,     0,     0,  5231,     0,     0,  2765,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1470,     0,     0,
       0,     0,  1711,     0,     0,  2637,     0,  1722,     0,     0,
    1713,  1723,     0,     0,  1714,  1715,  1716,     0,     0,   971,
       0,  1717,  1724,     0,  1718,     0,     0,     0,  2298,     0,
       0,  2299,  1719,  1725,   971,  2300,  2301,  2302,     0,     0,
       0,     0,  2830,     0,  1726,     0,  4111,     0,  4113,     0,
       0,  1720,  2303,     0,     0,     0,     0,     0,     0,     0,
    2305,     0,     0,     0,     0,     0,     0,     0,     0,  1470,
    2306,     0,     0,  2876,     0,     0,     0,  1727,     0,     0,
    2889,     0,     0,   964,  1721,     0,     0,  1728,     0,  2582,
    1729,  1730,     0,     0,     0,     0,     0,  2307,  5142,     0,
       0,  2105,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1470,     0,     0,
       0,  1731,     0,     0,     0,     0,     0,     0,     0,     0,
     971,     0,  3703,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   635,  1722,     0,     0,     0,  1723,     0,   693,
     635,     0,     0,     0,     0,   750,     0,   635,  1724,     0,
       0,     0,   836,   635,     0,     0,  1732,     0,   808,  1725,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1726,  1002,     0,     0,     0,     0,     0,     0,     0,  4207,
     877,   877,     0,  2971,  1733,  4214,     0,     0,     0,     0,
       0,     0,     0,  1470,     0,     0,     0,     0,     0,     0,
       0,     0,  1470,  1727,     0,     0,     0,  2308,     0,     0,
       0,     0,  2309,  2638,     0,     0,  1729,  1730,     0,  1470,
    1470,  1477,  1477,  1470,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2310,  2311,     0,     0,     0,   964,     0,
       0,  4531,     0,     0,  3027,  3967,     0,  2639,  2312,     0,
    3967,     0,     0,  3967,   964,     0,  3559,     0,  5263,     0,
       0,  1470,  1470,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4610,  2313,  1470,     0,     0,     0,     0,     0,
       0,     0,  1732,     0,     0,  4610,  1023,   971,   971,   971,
    2314,     0,     0,  2315,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1733,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1470,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   983,  1023,   978,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1025,     0,  1026,     0,  1030,  1031,     0,  1034,  1035,     0,
    1037,     0,     0,  1043,     0,  1045,     0,     0,  4382,  4383,
       0,  4385,     0,  4387,     0,     0,     0,     0,     0,     0,
    4391,   983,     0,     0,   836,     0,  2316,     0,     0,     0,
       0,     0,     0,     0,  2298,     0,  4801,  2299,     0,   836,
       0,  2300,  2301,  2302,   836,     0,  1328,     0,     0,  3472,
       0,     0,     0,     0,     0,     0,     0,  2582,  2303,     0,
       0,     0,     0,     0,     0,     0,  2305,     0,     0,     0,
    3191,     0,  4419,   836,     0,     0,  2306,  4853,     0,     0,
    3206,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   971,   836,  4610,     0,     0,     0,     0,
       0,     0,     0,  2307,     0,     0,     0,     0,     0,     0,
       0,  3218,     0,  3222,     0,     0,     0,     0,     0,  3229,
       0,     0,     0,     0,     0,     0,     0,  1470,     0,     0,
    1470,  2317,  1470,     0,  2318,  2319,  2320,     0,  2321,  2322,
    2323,  2324,  2325,  2326,     0,     0,     0,     0,  5240,     0,
       0,     0,  1470,     0,     0,     0,     0,     0,  1470,     0,
       0,     0,  3967,     0,     0,     0,  5263,     0,     0,     0,
       0,     0,     0,  1470,     0,     0,  1477,     0,     0,     0,
       0,     0,  5494,     0,     0,     0,     0,  5496,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   836,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2308,     0,     0,     0,     0,  2309,     0,
       0,     0,     0,     0,     0,  1470,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   971,   971,   971,   971,  2310,
    2311,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2312,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2313,
       0,     0,  1328,     0,     0,     0,     0,   836,     0,     0,
    3967,     0,     0,     0,     0,     0,  2314,     0,     0,  2315,
       0,     0,  3400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1707,     0,
       0,     0,     0,  3427,  1708,     0,     0,  3430,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1814,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1470,     0,  3460,   964,     0,     0,  1470,     0,     0,     0,
    5653,     0,     0,     0,     0,     0,     0,  1470,     0,     0,
       0,  1710,  1470,     0,  1470,     0,  1470,     0,     0,     0,
    1119,     0,     0,     0,     0,  4610,     0,     0,     0,  1132,
       0,   971,  2316,  1023,     0,     0,     0,     0,     0,     0,
    1150,  1151,     0,  1470,  1157,     0,     0,  1161,  1162,     0,
       0,     0,  1164,     0,     0,     0,     0,     0,     0,     0,
       0,  1711,     0,  1181,     0,     0,  1815,  3534,  3535,  1713,
       0,     0,     0,  1714,  1715,  1716,     0,     0,  1191,     0,
    1717,     0,     0,  1718,     0,     0,     0,     0,     0,  2105,
    2105,  1719,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1264,     0,  1266,     0,     0,
    1720,     0,     0,     0,     0,     0,     0,  1281,     0,     0,
     971,     0,     0,   750,     0,     0,     0,  5735,     0,     0,
       0,  1470,     0,     0,     0,     0,     0,  2317,     0,  5746,
    2318,  2319,  2320,  1721,  2321,  2322,  2323,  2324,  2325,  2326,
       0,     0,   635,     0,  5243,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1470,  1470,     0,     0,
       0,  3559,     0,     0,  1470,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1470,  3661,     0,  5494,     0,  1343,
       0,     0,  3277,     0,     0,     0,     0,  1237,     0,     0,
       0,     0,  1722,     0,     0,     0,  1723,   983,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1724,     0,     0,
       0,     0,     0,     0,   971,  1237,     0,     0,  1725,     0,
       0,  2105,     0,     0,     0,     0,     0,     0,     0,  1726,
       0,     0,     0,     0,     0,   877,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2582,     0,  4884,
       0,     0,   964,  4886,     0,     0,     0,  1470,     0,     0,
       0,     0,  1727,     0,     0,     0,     0,  4610,     0,     0,
       0,     0,  1816,   983,   983,  1729,  1730,  1470,     0,     0,
       0,     0,     0,     0,     0,     0,  1470,     0,     0,     0,
    5653,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1470,     0,     0,  1817,     0,     0,     0,
     971,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -148,  1668,     0,
       0,  5746,   971,   971,     0,     0,     0,     0,     0,     0,
       0,  1732,     0,     0,     0,     1,     0,     0,     0,     0,
       0,     0,     0,     0,  1751,     2,     0,     3,     4,     0,
       0,  1470,  1470,     0,  3817,     0,     0,     0,     0,  1733,
       5,     0,     0,     0,     0,     6,     7,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     8,     9,     0,
      10,    11,    12,     0,  1846,     0,  1470,     0,    13,     0,
      14,    15,  1470,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,    17,     0,   971,   964,  1867,
       0,     0,     0,     0,     0,  5653,     0,     0,   964,     0,
       0,  1878,     0,    18,  1879,     0,    19,     0,     0,     0,
    2298,     0,     0,  2299,     0,  1882,     0,  2300,  2301,  2302,
    1886,    20,   983,   983,     0,   964,     0,    21,  1890,     0,
       0,    22,  5033,     0,  2303,     0,  1900,    23,     0,     0,
    1905,     0,  2305,     0,     0,     0,    24,     0,    25,     0,
       0,     0,  2306,     0,     0,    26,  1920,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    27,     0,     0,     0,     0,  5058,  5059,     0,  2307,
       0,     0,  3948,     0,     0,     0,     0,  1969,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1237,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2298,     0,     0,  2299,
       0,     0,     0,  2300,  2301,  2302,     0,    29,    30,     0,
    1237,     0,     0,    31,     0,     0,     0,     0,     0,     0,
    2303,     0,     0,     0,     0,    32,     0,  1237,  2305,     0,
       0,     0,     0,     0,    33,    34,     0,     0,  2306,    35,
       0,     0,     0,     0,  2039,     0,  5102,  5103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2307,     0,     0,     0,     0,
       0,     0,     0,  2073,     0,     0,     0,     0,    36,  2308,
       0,     0,     0,     0,  2309,     0,     0,    37,   635,     0,
     635,     0,   635,     0,   635,     0,   635,   635,   635,     0,
       0,     0,    38,   635,     0,  2310,  2311,     0,     0,    39,
      40,     0,    41,     0,  2123,     0,     0,    42,     0,     0,
    2312,     0,    43,  1237,  2133,    44,    45,  2298,     0,     0,
    2299,    46,    47,     0,  2300,  2301,  2302,     0,    48,    49,
       0,     0,     0,     0,     0,     0,     0,    50,     0,     0,
       0,  2303,    51,     0,     0,  2313,     0,     0,     0,  2305,
       0,     0,     0,    52,     0,     0,     0,     0,     0,  2306,
       0,  5205,  2314,  5206,  5207,  2315,     0,     0,     0,     0,
       0,    53,     0,     0,     0,  2308,     0,     0,     0,     0,
    2309,     0,  5217,     0,     0,     0,  2307,     0,     0,     0,
      54,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      55,  2310,  2311,    56,     0,     0,     0,     0,    57,     0,
       0,     0,     0,    58,     0,     0,  2312,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    59,     0,     0,
    1237,     0,     0,     0,     0,     0,     0,     0,  2298,     0,
       0,  2299,     0,     0,     0,  2300,  2301,  2302,  4163,     0,
      60,  2313,     0,     0,     0,     0,     0,     0,  2316,     0,
       0,     0,  2303,     0,    61,     0,     0,  -148,  2314,     0,
    2305,  2315,     0,     0,     0,     0,     0,     0,     0,     0,
    2306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   877,
       0,     0,     0,     0,     0,     0,  2308,  2307,     0,     0,
       0,  2309,     0,     0,     0,     0,     0,  2298,     0,     0,
    2299,     0,     0,     0,  2300,  2301,  2302,     0,     0,     0,
       0,     0,  2310,  2311,     0,     0,     0,     0,     0,     0,
       0,  2303,     0,     0,     0,     0,     0,  2312,     0,  2305,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2306,
       0,     0,     0,  2317,  2316,     0,  2318,  2319,  2320,     0,
    2321,  2322,  2323,  2324,  2325,  2326,     0,     0,     0,     0,
    5294,     0,  2313,     0,     0,     0,  2307,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2314,
       0,     0,  2315,     0,     0,  4292,  4293,  4294,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4306,  2308,     0,     0,
       0,     0,  2309,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4323,  2310,  2311,  2541,     0,     0,     0,     0,
       0,     0,  4333,  4335,     0,     0,     0,  4340,  2312,  2317,
       0,     0,  2318,  2319,  2320,     0,  2321,  2322,  2323,  2324,
    2325,  2326,     0,     0,  2298,     0,  5329,  2299,     0,     0,
       0,  2300,  2301,  2302,     0,  2316,     0,     0,     0,  5456,
       0,     0,     0,  2313,     0,     0,  2308,     0,  2303,     0,
       0,  2309,     0,     0,     0,     0,  2305,     0,     0,     0,
    2314,     0,     0,  2315,     0,  2468,  2306,     0,     0,     0,
       0,     0,  2310,  2311,     0,     0,     0,     0,     0,     0,
    2659,     0,     0,     0,     0,     0,     0,  2312,     0,     0,
       0,     0,     0,  2307,     0,     0,     0,     0,     0,  2298,
       0,     0,  2299,     0,     0,     0,  2300,  2301,  2302,     0,
       0,     0,     0,     0,  5505,     0,     0,     0,     0,     0,
       0,     0,  2313,  2303,     0,     0,  1477,     0,     0,     0,
       0,  2305,     0,     0,  2468,     0,     0,     0,     0,  2314,
    2317,  2306,  2315,  2318,  2319,  2320,     0,  2321,  2322,  2323,
    2324,  2325,  2326,     0,     0,     0,  2316,  5373,     0,     0,
       0,     0,     0,     0,     0,     0,  5552,     0,  2307,     0,
       0,     0,     0,  2298,     0,  2754,  2299,     0,     0,     0,
    2300,  2301,  2302,     0,     0,     0,     0,     0,     0,  1237,
       0,     0,     0,     0,     0,     0,     0,  2303,     0,     0,
       0,     0,     0,     0,     0,  2305,     0,     0,     0,     0,
       0,     0,  1237,  2308,     0,  2306,     0,     0,  2309,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2812,     0,     0,     0,     0,  2316,     0,     0,     0,  2310,
    2311,     0,  2307,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2312,  4517,  4518,  4519,     0,     0,
       0,  2317,     0,     0,  2318,  2319,  2320,     0,  2321,  2322,
    2323,  2324,  2325,  2326,     0,     0,     0,     0,  5690,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2308,  2313,
       0,     0,     0,  2309,     0,     0,     0,     0,     0,     0,
       0,  1237,     0,     0,     0,     0,  2314,     0,     0,  2315,
       0,     0,     0,     0,  2310,  2311,  1237,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2468,     0,     0,  2312,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1237,
    2317,     0,     0,  2318,  2319,  2320,     0,  2321,  2322,  2323,
    2324,  2325,  2326,     0,     0,     0,     0,  5819,     0,     0,
       0,     0,  2308,     0,  2313,     0,     0,  2309,     0,     0,
       0,  2949,     0,  2950,     0,     0,     0,     0,     0,     0,
       0,  2314,     0,     0,  2315,     0,     0,     0,  2310,  2311,
       0,  2961,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2316,  2312,     0,  1237,     0,     0,     0,   635,
       0,   635,     0,   635,     0,   635,     0,   635,     0,  1237,
       0,   635,     0,     0,     0,  4667,     0,     0,  1707,     0,
       0,     0,     0,  1237,  1708,     0,     0,     0,  2313,     0,
       0,     0,     0,     0,     0,     0,  1237,  1814,     0,     0,
       0,     0,     0,     0,     0,  2314,     0,     0,  2315,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2316,     0,     0,
       0,  1710,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1237,  1237,     0,     0,  2298,     0,     0,  2299,
       0,     0,     0,  2300,  2301,  2302,     0,  2317,     0,     0,
    2318,  2319,  2320,     0,  2321,  2322,  2323,  2324,  2325,  2326,
    2303,     0,     0,     0,  5885,     0,     0,     0,  2305,     0,
       0,  1711,     0,     0,     0,     0,  1815,     0,  2306,  1713,
       0,     0,     0,  1714,  1715,  1716,     0,     0,     0,     0,
    1717,  2316,     0,  1718,     0,     0,     0,     0,     0,     0,
       0,  1719,     0,     0,     0,  2307,     0,     0,     0,     0,
       0,     0,  4783,     0,     0,     0,     0,     0,     0,     0,
    1720,     0,  2317,     0,  4796,  2318,  2319,  2320,     0,  2321,
    2322,  2323,  2324,  2325,  2326,     0,     0,     0,     0,  5908,
       0,     0,     0,     0,     0,     0,     0,  5866,     0,     0,
       0,     0,     0,  1721,     0,     0,     0,     0,     0,     0,
       0,  4829,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2889,     0,     0,     0,  2317,     0,     0,  2318,
    2319,  2320,     0,  2321,  2322,  2323,  2324,  2325,  2326,     0,
       0,  2298,  1722,  5946,  2299,     0,  1723,     0,  2300,  2301,
    2302,     0,     0,     0,     0,  2308,     0,  1724,     0,     0,
    2309,     0,     0,     0,     0,  2303,     0,     0,  1725,  3244,
       0,  2971,     0,  2305,     0,     0,     0,     0,     0,  1726,
       0,  2310,  2311,  2306,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2312,     0,     0,     0,
       0,     0,     0,     0,  1237,     0,     0,     0,     0,     0,
    2307,     0,  1727,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3530,     0,     0,  1729,  1730,     0,     0,     0,
       0,  2313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3204,  3280,  3281,     0,     0,     0,  2314,     0,
       0,  2315,  2298,     0,     0,  2299,  3531,     0,     0,  2300,
    2301,  2302,  3245,     0,  3298,  3299,     0,     0,     0,  3302,
    3303,     0,     0,     0,  3306,     0,  2303,     0,     0,     0,
       0,     0,     0,     0,  2305,     0,     0,     0,  3317,  4956,
    4957,  4958,  4959,     0,  2306,  3326,     0,     0,     0,  3329,
    3330,  1732,     0,  3333,  3334,     0,     0,     0,     0,     0,
    3339,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2307,     0,  3356,     0,  3358,     0,     0,     0,  1733,
    2308,     0,     0,     0,     0,  2309,     0,     0,     0,     0,
       0,     0,     0,     0,  2316,  3382,     0,     0,     0,     0,
    3384,     0,     0,     0,     0,     0,  2310,  2311,     0,     0,
       0,     0,     0,  3284,  3389,     0,     0,  2468,  3290,     0,
       0,  2312,     0,     0,     0,  3398,     0,     0,  3401,     0,
       0,     0,  3405,  3408,     0,     0,     0,     0,     0,     0,
       0,  3415,     0,     0,     0,     0,  3423,  3426,     0,     0,
       0,     0,     0,     0,     0,     0,  2313,     0,  3440,     0,
       0,     0,     0,     0,  3450,     0,     0,  3887,     0,     0,
       0,  3456,  3888,  2314,     0,     0,  2315,     0,     0,     0,
       0,  1237,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2308,     0,  1237,     0,     0,  2309,  3478,     0,  2317,
       0,     0,  2318,  2319,  2320,  3489,  2321,  2322,  2323,  2324,
    2325,  2326,     0,     0,  3040,     0,  3504,  2310,  2311,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3511,     0,
       0,  3514,  2312,     0,     0,     0,  3517,  1237,     0,     0,
    3518,     0,  3520,  3521,     0,     0,     0,  3525,     0,     0,
    3529,     0,     0,     0,  3536,  3537,  3538,  3539,     0,  3541,
       0,     0,     0,     0,     0,     0,     0,  2313,     0,  2316,
       0,  2298,  3566,  3567,  2299,  3569,     0,     0,  2300,  2301,
    2302,     0,     0,     0,  2314,  3577,  3578,  2315,     0,     0,
       0,     0,     0,     0,     0,  2303,     0,     0,     0,     0,
       0,     0,     0,  2305,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2306,     0,     0,     0,     0,  2298,     0,
       0,  2299,     0,     0,     0,  2300,  2301,  2302,     0,     0,
       0,     0,     0,  3246,     0,     0,     0,     0,     0,     0,
    2307,     0,  2303,     0,     0,     0,     0,  1707,     0,  3629,
    2305,     0,     0,  1708,     0,     0,     0,     0,     0,     0,
    2306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2317,     0,     0,  2318,  2319,  2320,
    2316,  2321,  2322,  2323,  2324,  2325,  2326,  2307,     0,  3673,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1710,     0,     0,  5199,  2298,     0,     0,  2299,     0,     0,
       0,  2300,  2301,  2302,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2303,     0,
       0,  3846,     0,     0,     0,     0,  2305,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2306,     0,     0,     0,
    1711,     0,  1237,     0,     0,     0,     0,     0,  1713,     0,
    2308,     0,  1714,  1715,  1716,  2309,     0,     0,     0,  1717,
       0,     0,  1718,  2307,     0,     0,     0,     0,     0,  3758,
    1719,     0,  5850,     0,     0,  2317,  2310,  2311,  2318,  2319,
    2320,     0,  2321,  2322,  2323,  2324,  2325,  2326,     0,  1720,
       0,  2312,     0,     0,     0,     0,     0,  2308,     0,     0,
       0,     0,  2309,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1721,  2310,  2311,     0,  2313,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2312,  2468,
       0,     0,     0,  2314,     0,     0,  2315,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3818,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4477,  2313,     0,     0,     0,     0,     0,     0,
       0,  1722,     0,  2308,     0,  1723,     0,     0,  2309,     0,
    2314,     0,     0,  2315,  3837,     0,  1724,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1725,     0,  2310,
    2311,     0,     0,     0,     0,     0,  5851,     0,  1726,     0,
       0,     0,     0,     0,  2312,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5371,     0,     0,     0,  2316,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5383,  1727,     0,     0,     0,  1477,     0,  4478,     0,  2313,
       0,  1843,     0,     0,  1729,  1730,     0,     0,     0,  1237,
       0,     0,     0,     0,     0,     0,  2314,     0,     0,  2315,
       0,     0,     0,     0,  5418,     0,  2316,     0,     0,     0,
    1237,     0,     0,     0,     0,  1844,     0,     0,     0,   966,
       0,     0,     0,     0,  1237,     0,     0,     0,     0,   966,
     991,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   991,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   991,     0,     0,     0,     0,
    1732,     0,     0,     0,  2317,     0,     0,  2318,  2319,  2320,
       0,  2321,  2322,  2323,  2324,  2325,  2326,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1733,     0,
       0,     0,  2316,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2317,     0,     0,  2318,  2319,  2320,     0,  2321,  2322,
    2323,  2324,  2325,  2326,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5511,
       0,     0,     0,     0,  2298,     0,     0,  2299,     0,     0,
       0,  2300,  2301,  2302,     0,     0,     0,     0,     0,     0,
    3204,  3204,  3204,     0,     0,     0,     0,     0,  2303,     0,
       0,     0,     0,     0,     0,     0,  2305,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2306,     0,     0,  4052,
       0,     0,     0,  4054,     0,     0,     0,  2317,     0,  4056,
    2318,  2319,  2320,     0,  2321,  2322,  2323,  2324,  2325,  2326,
       0,     0,     0,  2307,     0,  4067,  4069,     0,     0,     0,
    4069,     0,     0,     0,     0,  4080,  4081,  4082,     0,  4084,
       0,     0,     0,     0,     0,     0,  2298,     0,  5599,  2299,
       0,     0,     0,  2300,  2301,  2302,     0,     0,  2468,     0,
       0,  3290,     0,  3290,  4105,     0,     0,     0,  2468,     0,
    2303,     0,     0,  3892,     0,     0,     0,     0,  2305,  4114,
    4115,  4116,  4117,     0,     0,     0,     0,     0,  2306,     0,
    2298,     0,     0,  2299,     0,     0,     0,  2300,  2301,  2302,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2303,  2307,     0,     0,     0,  1237,
    4137,     0,  2305,  4142,  4143,  4144,     0,     0,     0,     0,
       0,     0,  2306,     0,     0,     0,  1237,     0,     0,     0,
       0,     0,     0,  2308,     0,     0,     0,     0,  2309,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2307,
       0,  2468,     0,     0,     0,     0,     0,     0,     0,  2310,
    2311,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2312,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2313,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4217,     0,  2308,  2314,     0,     0,  2315,
    2309,  4221,     0,     0,     0,     0,     0,     0,     0,  1237,
       0,  1237,     0,     0,     0,     0,     0,   966,  3860,     0,
    3897,  2310,  2311,     0,     0,  4237,     0,     0,     0,     0,
     991,     0,     0,     0,     0,     0,  2312,     0,     0,  2308,
     991,     0,     0,     0,  2309,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   991,  4289,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2310,  2311,     0,     0,     0,
     991,  2313,     0,     0,     0,   966,     0,     0,     0,     0,
    2312,  1238,     0,     0,     0,   966,   991,     0,  2314,     0,
       0,  2315,  2316,     0,  1237,     0,   991,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1238,
     991,     0,     0,     0,  4330,  2313,     0,     0,  1707,  4336,
       0,     0,     0,   991,  1708,     0,     0,     0,  1237,     0,
       0,     0,  2314,     0,     0,  2315,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4371,     0,     0,
       0,  3290,     0,     0,     0,     0,     0,     0,     0,  3290,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1710,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2316,     0,  4388,     0,  4389,     0,
       0,     0,     0,     0,     0,  4393,     0,  2317,     0,     0,
    2318,  2319,  2320,     0,  2321,  2322,  2323,  2324,  2325,  2326,
     966,   966,     0,     0,     0,     0,   991,     0,     0,     0,
       0,  1711,     0,     0,     0,     0,     0,     0,  2316,  1713,
       0,     0,  4414,  1714,  1715,  1716,     0,     0,  1237,     0,
    1717,     0,   966,  1718,     0,     0,     0,     0,     0,     0,
       0,  1719,     0,     0,  3290,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1237,     0,     0,
    1720,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2317,
       0,     0,  2318,  2319,  2320,     0,  2321,  2322,  2323,  2324,
    2325,  2326,     0,  1721,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2317,     0,     0,  2318,  2319,  2320,     0,
    2321,  2322,  2323,  2324,  2325,  2326,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1722,     0,     0,     0,  1723,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1724,     0,     0,
       0,  1237,     0,     0,  2298,     0,     0,  2299,  1725,     0,
       0,  2300,  2301,  2302,     0,     0,     0,     0,     0,  1726,
       0,     0,  1237,     0,     0,     0,     0,     0,  2303,     0,
       0,  3903,     0,     0,     0,     0,  2305,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2306,  1237,     0,     0,
       0,     0,  1727,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2543,   966,     0,  1729,  1730,     0,     0,     0,
    1238,     0,     0,  2307,   966,     0,     0,     0,     0,     0,
       0,  1237,     0,     0,     0,     0,     0,     0,     0,  4621,
       0,  4622,     0,     0,  1238,     0,  2544,     0,  4624,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1238,     0,     0,  4634,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4642,  3204,     0,     0,     0,     0,     0,     0,     0,  2298,
       0,  1732,  2299,     0,     0,     0,  2300,  2301,  2302,     0,
       0,  4665,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2303,   966,     0,     0,     0,     0,  1733,
    4670,  2305,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2306,  4681,     0,  2468,     0,     0,     0,     0,     0,
       0,     0,     0,  2308,     0,     0,     0,     0,  2309,     0,
       0,     0,     0,     0,     0,  4711,     0,  1238,  2307,     0,
       0,     0,     0,     0,     0,     0,  4719,  4720,  4721,  2310,
    2311,     0,     0,     0,  4725,  4726,  4727,  4728,     0,     0,
       0,  4730,  4731,     0,  2312,     0,     0,  4738,  4739,     0,
    4741,  4742,  4743,  4744,  4745,  4746,     0,  4748,   991,     0,
       0,     0,     0,     0,     0,     0,  4756,     0,     0,  4759,
    4760,     0,     0,   991,     0,     0,     0,     0,     0,  2313,
       0,     0,     0,   966,     0,     0,     0,     0,     0,     0,
       0,   991,     0,     0,     0,     0,  2314,  3290,  4069,  2315,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   991,
       0,  4786,     0,     0,     0,     0,     0,  3290,     0,     0,
       0,     0,     0,     0,  1238,     0,   991,     0,  2308,     0,
       0,     0,     0,  2309,     0,     0,     0,     0,     0,     0,
       0,   991,     0,     0,     0,   966,  2243,     0,     0,   991,
       0,     0,     0,     0,  2310,  2311,     0,     0,     0,     0,
       0,     0,     0,   966,     0,     0,     0,     0,     0,  2312,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2316,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   966,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2313,     0,     0,     0,     0,     0,
       0,     0,     0,  4069,     0,     0,     0,     0,     0,     0,
       0,  2314,     0,     0,  2315,     0,   966,   966,   966,     0,
     966,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4895,     0,
     966,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1237,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   991,     0,     0,     0,     0,     0,
       0,     0,   991,   991,     0,     0,     0,  2317,     0,     0,
    2318,  2319,  2320,     0,  2321,  2322,  2323,  2324,  2325,  2326,
       0,     0,     0,     0,     0,     0,     0,     0,  2468,     0,
       0,     0,     0,     0,     0,     0,  2298,  2316,     0,  2299,
       0,     0,     0,  2300,  2301,  2302,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2303,     0,     0,  4484,     0,     0,     0,     0,  2305,     0,
       0,     0,     0,  4430,     0,     0,     0,     0,  2306,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2307,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   966,     0,     0,     0,
     966,   966,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   966,     0,     0,     0,  1238,
       0,     0,  2317,     0,     0,  2318,  2319,  2320,  2243,  2321,
    2322,  2323,  2324,  2325,  2326,     0,     0,     0,     0,  1237,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1237,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2298,     0,     0,  2299,     0,     0,     0,  2300,  2301,  2302,
       0,     0,  5037,     0,     0,     0,  5038,  5039,  5040,  5041,
       0,     0,  5043,     0,  2303,     0,     0,     0,  1238,     0,
       0,     0,  2305,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2306,     0,  3204,  2308,     0,     0,     0,  3204,
    2309,     0,     0,     0,     0,  3204,     0,     0,     0,  5065,
    5066,  5067,     0,  5068,     0,     0,  5070,  5071,     0,  2307,
       0,  2310,  2311,     0,     0,     0,     0,     0,  5080,  5081,
       0,     0,     0,  1238,     0,     0,  2312,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1073,  5086,  1238,     0,     0,  1074,
       0,     0,     0,     0,     0,     0,     0,     0,  1237,     0,
       0,  2313,     0,     0,     0,     0,     0,     0,  5097,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2314,     0,
       0,  2315,     0,     0,     0,     0,     0,     0,  1075,     0,
       0,     0,     0,     0,     0,     0,  1237,     0,     0,     0,
       0,     0,  1076,  1077,     0,     0,     0,   991,     0,     0,
       0,     0,     0,     0,  1078,     0,     0,     0,  1079,     0,
       0,     0,     0,     0,  1237,     0,     0,     0,     0,  2308,
       0,     0,     0,     0,  2309,  1238,     0,  1080,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1238,     0,  5154,     0,     0,  2310,  2311,     0,     0,     0,
    1238,     0,     0,     0,     0,     0,  1081,  2243,     0,     0,
    2312,     0,     0,  1238,  2316,     0,     0,  1082,     0,     0,
       0,  5182,     0,     0,     0,     0,  1083,     0,     0,  1237,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1084,
       0,   991,     0,     0,  1085,  2313,  5208,     0,     0,     0,
       0,   991,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2314,   991,     0,  2315,     0,     0,     0,  1086,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1238,
       0,     0,     0,     0,     0,     0,   966,     0,     0,   966,
       0,     0,     0,  1238,  1087,     0,     0,     0,     0,     0,
       0,   966,     0,     0,     0,     0,     0,  1238,     0,     0,
       0,     0,     0,     0,     0,  1088,     0,     0,     0,  2317,
    1238,     0,  2318,  2319,  2320,     0,  2321,  2322,  2323,  2324,
    2325,  2326,     0,     0,     0,     0,     0,   966,   966,     0,
     991,   991,     0,     0,     0,     0,     0,     0,  5195,     0,
    1237,     0,     0,     0,  1089,     0,     0,   991,  2316,     0,
       0,   635,     0,     0,     0,     0,  1238,  1238,     0,   991,
     991,     0,     0,     0,     0,     0,     0,     0,  1090,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   991,   240,
       0,     0,  1091,     0,     0,     0,     0,  1237,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     966,  1092,     0,     0,     0,  5318,     0,  1093,     0,     0,
    1094,     0,     0,     0,     0,     0,     0,  1095,     0,     0,
    1096,     0,     0,  5328,     0,     0,     0,     0,  5333,  5334,
       0,     0,     0,  1097,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  2317,     0,     0,  2318,  2319,  2320,  1099,
    2321,  2322,  2323,  2324,  2325,  2326,     0,     0,  1100,     0,
       0,  1101,     0,     0,     0,  1102,     0,     0,     0,     0,
       0,     0,  1103,     0,  1104,     0,  1236,     0,     0,  1105,
       0,  5396,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1236,  5414,  1106,     0,     0,     0,
       0,     0,     0,     0,     0,  3290,  3204,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   966,
       0,   966,     0,     0,  4069,     0,   966,   966,     0,     0,
       0,     0,  5452,   966,   966,   966,     0,     0,     0,   966,
       0,   966,   966,   966,   966,   966,   966,     0,   966,     0,
     966,   966,     0,     0,   966,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1238,   966,
     966,   966,   966,  2243,     0,     0,     0,   966,     0,     0,
       0,   966,     0,     0,   966,     0,     0,   966,   966,   966,
     966,   966,   966,   966,   966,   966,     0,   966,     0,     0,
       0,     0,     0,     0,   966,     0,   966,  5498,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1707,
       0,     0,     0,     0,     0,  1708,     0,  3290,  5514,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5523,     0,     0,     0,     0,     0,     0,     0,   966,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1237,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1710,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1237,     0,
       0,     0,     0,     0,     0,     0,  5591,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     991,     0,  1711,     0,     0,     0,     0,  1238,     0,     0,
    1713,  1238,  1238,     0,  1714,  1715,  1716,     0,     0,     0,
     991,  1717,     0,     0,  1718,  2243,   991,     0,     0,     0,
     991,     0,  1719,     0,     0,  1237,     0,     0,   991,     0,
    1237,  1237,     0,     0,     0,     0,     0,     0,     0,     0,
    4069,  1720,     0,     0,     0,     0,   991,     0,     0,   966,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   966,     0,     0,     0,  1238,     0,     0,   966,     0,
       0,     0,     0,     0,  1721,     0,     0,  1238,     0,     0,
       0,     0,   647,     0,     0,     0,     0,   648,     0,     0,
       0,   991,     0,     0,     0,  1236,     0,     0,     0,   649,
       0,     0,     0,     0,     0,     0,  5677,     0,   650,   991,
     991,     0,     0,     0,     0,     0,     0,     0,     0,  1236,
       0,  1238,  5691,     0,     0,     0,   651,     0,     0,     0,
       0,     0,     0,  1722,     0,     0,  1236,  1723,     0,     0,
     652,     0,     0,     0,     0,     0,  5195,  1237,  1724,     0,
       0,     0,   653,  2243,   991,     0,  -916,     0,  2243,  1725,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1726,     0,     0,     0,     0,   654,  5723,     0,     0,     0,
       0,     0,   655,     0,     0,     0,     0,     0,     0,     0,
       0,  5733,     0,     0,   991,     0,  2243,     0,     0,   984,
     993,     0,   991,  1727,   656,     0,     0,     0,     0,   991,
       0,   993,     0,   991,     0,   657,  1729,  1730,     0,     0,
       0,     0,     0,     0,   658,   993,     0,     0,     0,     0,
       0,     0,  1236,   991,     0,     0,     0,   659,     0,   991,
       0,     0,     0,   991,     0,   660,  2243,  1731,     0,   661,
       0,   662,     0,     0,     0,     0,   991,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -1138,     0,   991,
       0,     0,  5793,     0,     0,     0,     0,     0,     0,   991,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   663,
       0,     0,  1732,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   664,     0,     0,     0,     0,     0,
       0,     0,     0,  -634,     0,     0,     0,     0,  5815,     0,
    1733,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     665,     0,     0,     0,     0,   966,  1238,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2243,     0,     0,  1236,
       0,   666,   667,     0,     0,   668,     0,     0,  1237,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   669,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     670,     0,     0,     0,   966,     0,     0,     0,     0,     0,
    -490,     0,     0,     0,     0,  5878,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   671,
       0,     0,     0,     0,     0,     0,     0,     0,   672,     0,
       0,     0,     0,  1238,     0,  -490,     0,   991,   673,     0,
       0,     0,     0,     0,     0,   674,   705,   966,     0,     0,
       0,   706,     0,     0,     0,     0,     0,     0,     0,     0,
     675,     0,     0,   707,     0,     0,     0,   676,     0,     0,
       0,     0,     0,     0,     0,     0,  -490,     0,     0,   677,
     678,     0,   679,   680,     0,     0,     0,     0,     0,     0,
     708,     0,   681,     0,     0,   991,     0,   682,     0,     0,
       0,     0,  2354,   683,   709,     0,     0,   684,     0,     0,
       0,   685,     0,     0,     0,     0,     0,     0,     0,     0,
     710,     0,     0,     0,  -490,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   991,   711,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1238,     0,   991,     0,     0,   712,     0,
       0,     0,     0,   991,     0,     0,     0,     0,     0,   713,
     966,   966,     0,     0,  1238,     0,     0,   966,   714,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1238,     0,
       0,   715,     0,     0,     0,     0,   716,     0,     0,   966,
       0,     0,     0,   717,   966,   718,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     993,   719,     0,     0,     0,     0,     0,   966,   966,   966,
     993,     0,   966,     0,  1236,     0,     0,     0,     0,     0,
     966,   966,   966,   966,   993,     0,     0,     0,  2243,     0,
       0,     0,     0,   966,  2243,     0,   966,     0,   966,     0,
     993,     0,     0,     0,     0,     0,     0,   720,     0,   966,
     966,     0,     0,   966,     0,   984,   993,     0,     0,     0,
       0,     0,     0,     0,   721,     0,   993,   966,     0,   966,
       0,   966,     0,     0,     0,     0,     0,     0,     0,     0,
     993,     0,     0,  1236,     0,   722,   723,     0,     0,     0,
       0,   966,     0,   993,     0,     0,     0,     0,   724,     0,
       0,     0,   966,     0,   966,   966,   966,     0,     0,     0,
     725,     0,     0,     0,     0,     0,     0,     0,     0,   991,
       0,   240,   966,     0,   726,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   966,   727,     0,     0,     0,   966,     0,   728,
       0,  1236,   729,   966,     0,     0,     0,     0,     0,   730,
       0,     0,   731,   966,     0,     0,     0,     0,     0,   732,
       0,     0,     0,     0,     0,     0,   993,     0,     0,     0,
       0,     0,  1238,     0,   733,  1238,     0,  1238,     0,     0,
       0,   734,  1238,     0,     0,     0,     0,     0,     0,     0,
     735,     0,     0,   736,     0,     0,     0,   737,     0,   991,
     991,     0,     0,     0,   738,   966,   739,     0,     0,     0,
       0,   740,     0,     0,   886,     0,     0,     0,   887,     0,
     888,     0,     0,     0,     0,   741,   991,     0,     0,   991,
    1236,     0,     0,  1238,     0,   889,     0,     0,   742,     0,
       0,     0,     0,     0,     0,  1236,     0,     0,     0,     0,
    1238,     0,     0,     0,     0,  1236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,   890,     0,  1238,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     891,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   892,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   893,     0,     0,
    2243,  2243,  2243,     0,     0,   894,     0,     0,     0,     0,
       0,     0,     0,     0,  1236,     0,   895,     0,     0,   896,
       0,     0,     0,     0,     0,     0,     0,   991,  1236,     0,
       0,     0,     0,     0,   897,     0,     0,     0,  2243,     0,
       0,     0,  1236,  1238,     0,  1238,     0,     0,     0,     0,
       0,     0,   898,   991,     0,  1236,   899,     0,     0,   900,
       0,     0,     0,     0,     0,     0,     0,     0,   991,     0,
       0,     0,     0,     0,     0,     0,     0,   901,     0,     0,
       0,     0,     0,  1707,   984,     0,     0,   902,     0,  1708,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1236,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   903,     0,
       0,     0,     0,   904,     0,     0,     0,     0,  1238,     0,
       0,     0,     0,     0,     0,     0,  1710,     0,     0,     0,
     905,     0,     0,     0,     0,     0,     0,     0,   991,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1238,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   906,
       0,     0,     0,     0,     0,  1238,  1711,     0,     0,     0,
       0,     0,  2243,  1238,  1713,     0,     0,     0,  1714,  1715,
    1716,     0,   991,     0,   991,  1717,     0,     0,  1718,     0,
       0,     0,     0,     0,     0,     0,  1719,   991,   907,   991,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   908,
       0,     0,     0,     0,     0,  1720,     0,     0,   909,     0,
       0,     0,     0,     0,   910,   911,     0,     0,  2243,     0,
       0,     0,   912,     0,     0,     0,     0,     0,   993,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1721,     0,
       0,     0,  1238,   993,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   913,     0,   914,   991,  1238,   915,
       0,   993,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1238,   916,     0,     0,   917,     0,   918,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   993,
     919,   920,     0,     0,     0,     0,     0,  1722,     0,     0,
       0,  1723,     0,     0,   921,     0,   993,   991,     0,     0,
       0,     0,  1724,  1236,     0,     0,     0,     0,     0,     0,
       0,   993,     0,  1725,     0,     0,  2245,   991,     0,   993,
       0,     0,     0,     0,  1726,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   991,     0,
       0,   991,     0,     0,     0,     0,     0,  1727,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3390,     0,     0,
    1729,  1730,   966,     0,     0,  1238,     0,     0,     0,     0,
       0,   966,     0,     0,     0,     0,     0,   966,     0,   966,
       0,     0,   966,     0,     0,     0,  1238,   966,   966,   966,
     966,  1731,     0,   966,   966,   966,   966,   966,   966,   966,
     966,   966,   966,     0,     0,     0,   966,   966,     0,     0,
       0,  1238,  1707,     0,     0,     0,   966,     0,  1708,     0,
     966,     0,  2243,     0,   966,     0,     0,     0,     0,     0,
       0,     0,   966,     0,   993,   966,  1732,   966,     0,     0,
       0,     0,   993,   993,     0,  1238,   966,     0,     0,   966,
     966,     0,  1236,     0,   966,   966,  1236,  1236,     0,     0,
       0,   966,     0,     0,  1733,  1710,     0,     0,     0,     0,
       0,   966,     0,     0,   966,     0,     0,     0,     0,     0,
       0,     0,     0,  1707,     0,     0,     0,   966,     0,  1708,
       0,     0,     0,   966,   966,   966,     0,     0,     0,     0,
       0,     0,     0,     0,   886,     0,     0,     0,     0,     0,
     888,     0,     0,     0,     0,  1711,     0,     0,     0,     0,
    1236,     0,     0,  1713,     0,   889,   966,  1714,  1715,  1716,
       0,     0,  1236,     0,  1717,     0,  1710,  1718,     0,     0,
       0,     0,   966,     0,     0,  1719,     0,     0,  1238,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     966,     0,     0,   890,  1720,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1236,     0,     0,     0,
     891,     0,     0,     0,     0,     0,  1711,     0,  2245,     0,
       0,   991,     0,     0,  1713,   892,     0,  1721,  1714,  1715,
    1716,     0,     0,     0,     0,  1717,     0,   893,  1718,     0,
       0,     0,     0,     0,     0,   894,  1719,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   895,     0,     0,   896,
       0,     0,     0,     0,     0,  1720,     0,     0,     0,     0,
       0,     0,     0,     0,   897,  2243,     0,     0,     0,     0,
    2243,  1238,  2243,   966,     0,     0,  1722,     0,     0,     0,
    1723,     0,   898,     0,     0,     0,   899,     0,  1721,   900,
       0,  1724,     0,     0,     0,     0,     0,     0,     0,     0,
    2243,  1238,  1725,     0,     0,     0,     0,   901,     0,     0,
     992,     0,     0,  1726,     0,     0,     0,   902,  2243,     0,
       0,   992,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   991,   992,     0,   991,     0,     0,
       0,     0,     0,     0,     0,     0,  1727,  1722,   903,     0,
       0,  1723,     0,   904,     0,     0,  3574,     0,     0,  1729,
    1730,     0,  1724,   991,     0,     0,     0,     0,     0,     0,
     905,     0,     0,  1725,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1726,     0,     0,  1707,     0,     0,
    3575,     0,     0,  1708,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   993,     0,   906,
     966,  1236,     0,     0,     0,     0,     0,  1727,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4077,     0,     0,
    1729,  1730,     0,     0,     0,  1732,     0,   991,   991,     0,
    1710,     0,     0,  2243,  1238,     0,     0,     0,   907,     0,
       0,   991,     0,     0,     0,     0,     0,     0,   966,   908,
       0,  4078,     0,  1733,     0,     0,     0,  2245,   909,     0,
     991,     0,     0,     0,   910,   911,     0,     0,     0,     0,
       0,     0,   912,     0,     0,     0,     0,     0,     0,     0,
    1711,     0,  1238,   966,   966,     0,     0,     0,  1713,     0,
       0,   993,  1714,  1715,  1716,     0,  1732,     0,  1236,  1717,
       0,   993,  1718,     0,   913,     0,   914,     0,     0,   915,
    1719,     0,     0,   993,     0,     0,     0,     0,     0,     0,
       0,     0,   916,     0,  1733,   917,     0,   918,     0,  1720,
       0,     0,   991,     0,     0,     0,     0,     0,     0,     0,
     919,   920,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   921,     0,     0,     0,     0,   966,
       0,     0,  1721,     0,     0,     0,     0,     0,     0,     0,
     966,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   984,   984,     0,
     993,   993,     0,     0,     0,     0,     0,     0,     0,     0,
     966,     0,     0,     0,     0,     0,     0,   993,     0,     0,
     966,   966,     0,  1238,     0,     0,     0,   966,   966,   993,
     993,  1722,   966,  1238,     0,  1723,     0,   966,  1236,     0,
     966,   966,     0,     0,     0,   966,  1724,     0,   993,     0,
       0,   966,     0,     0,     0,     0,     0,  1725,     0,  1236,
       0,     0,     0,   966,     0,     0,     0,     0,  1726,     0,
       0,   966,     0,  1236,     0,   966,     0,     0,     0,     0,
     984,     0,     0,     0,     0,     0,     0,     0,   966,     0,
       0,     0,     0,   966,     0,     0,     0,     0,     0,   966,
       0,  1727,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4138,     0,     0,  1729,  1730,     0,     0,   966,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     992,     0,     0,     0,   966,  4139,     0,     0,     0,     0,
     992,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1238,     0,   992,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   991,
     992,     0,     0,     0,  2243,     0,     0,     0,     0,     0,
    1732,     0,     0,     0,     0,     0,   992,     0,     0,     0,
    1238,     0,     0,     0,     0,     0,   992,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1733,     0,
     992,     0,     0,   991,     0,     0,     0,     0,  1238,     0,
       0,     0,     0,   992,     0,   991,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   966,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   991,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2245,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1238,     0,     0,     0,  1236,     0,     0,
    1236,   991,  1236,     0,     0,     0,     0,  1236,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1453,
    1453,     0,     0,   966,     0,     0,   992,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   966,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,   991,     0,     0,     0,     0,     0,     0,
       0,   966,     0,     0,     0,  1236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1238,     0,  1238,     0,     0,     0,     0,     0,
     993,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     993,   991,     0,     0,     0,  2245,   993,     0,     0,     0,
     993,     0,     0,     0,     0,     0,     0,   966,   993,     0,
       0,  1238,     0,     0,     0,     0,   966,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   993,     0,     0,     0,
       0,     0,     0,   966,   966,     0,     0,   966,  1236,     0,
    1236,     0,     0,     0,     0,     0,     0,     0,   984,     0,
       0,     0,   966,     0,     0,     0,     0,     0,     0,   966,
       0,     0,     0,     0,   966,     0,     0,   966,   966,     0,
       0,   993,     0,     0,     0,   966,   966,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   993,
     993,     0,     0,     0,     0,     0,   966,     0,   966,     0,
       0,     0,     0,   991,     0,   991,     0,     0,     0,   966,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2245,   993,     0,     0,     0,  2245,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1238,
     966,     0,   991,     0,     0,     0,     0,  1236,     0,     0,
       0,   966,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   993,     0,  2245,     0,     0,     0,
    1236,     0,   993,     0,     0,     0,     0,     0,  1236,   993,
       0,     0,     0,   993,     0,     0,     0,     0,     0,  2243,
       0,     0,     0,     0,     0,   966,     0,     0,     0,     0,
       0,     0,     0,   993,     0,     0,     0,     0,     0,   993,
       0,     0,     0,   993,     0,     0,  2245,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   993,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   993,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   993,
       0,     0,     0,     0,  5424,     0,     0,  1236,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   966,
       0,  1238,     0,  1236,     0,     0,     0,     0,   992,     0,
       0,     0,     0,     0,     0,     0,  1236,     0,     0,     0,
       0,     0,     0,   992,     0,     0,     0,     0,     0,     0,
       0,   966,  1238,     0,   966,     0,   966,     0,     0,     0,
       0,   992,     0,     0,     0,     0,  2245,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   966,     0,     0,     0,
       0,     0,   966,     0,     0,     0,   966,     0,     0,   992,
       0,     0,  1238,     0,     0,     0,     0,   966,     0,     0,
       0,     0,     0,     0,     0,     0,   992,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   992,     0,     0,  2151,     0,  2244,     0,     0,   992,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2243,     0,  2255,     0,     0,     0,     0,     0,     0,  1238,
    1236,     0,     0,     0,  1238,  1238,     0,   993,     0,   966,
       0,     0,     0,     0,     0,     0,   991,     0,     0,     0,
       0,  1236,     0,  2269,     0,     0,     0,     0,   991,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1236,     0,     0,     0,
       0,     0,     0,     0,     0,  2287,  2288,  2289,     0,  2291,
     966,     0,     0,     0,     0,   993,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2333,
    1236,     0,     0,     0,   966,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   992,     0,     0,     0,   993,     0,
       0,     0,   992,   992,     0,     0,     0,     0,     0,     0,
    1238,  1238,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   993,     0,     0,     0,     0,
       0,     0,     0,   993,   966,     0,     0,   966,     0,     0,
     966,     0,     0,     0,     0,     0,     0,   984,     0,     0,
       0,   966,     0,     0,     0,     0,   966,     0,   966,     0,
     966,     0,     0,     0,     0,     0,     0,     0,     0,   966,
       0,     0,     0,  1236,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   966,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1227,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2415,     0,     0,  2245,  2427,
    2430,     0,     0,  2243,  2245,   991,     0,     0,     0,     0,
       0,     0,  1227,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2244,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   966,  1236,     0,     0,     0,
       0,     0,     0,   966,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1236,     0,     0,   993,
     966,   966,     0,     0,     0,     0,     0,     0,   966,  2243,
       0,     0,  1238,     0,     0,     0,     0,     0,   966,     0,
       0,     0,     0,     0,     0,     0,     0,   991,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   966,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1707,     0,     0,   991,     0,     0,  1708,
       0,     0,     0,     0,     0,     0,  1777,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1778,     0,     0,     0,     0,     0,   966,     0,     0,   993,
     993,   966,     0,     0,     0,     0,  1710,     0,     0,     0,
       0,   966,     0,     0,     0,     0,     0,   966,   966,     0,
       0,   966,     0,     0,     0,     0,   993,     0,     0,   993,
     966,     0,     0,     0,     0,     0,     0,   992,     0,  1236,
       0,     0,  1779,     0,     0,     0,     0,   966,     0,     0,
       0,     0,     0,     0,     0,     0,  1711,     0,     0,     0,
       0,     0,   991,     0,  1713,     0,     0,     0,  1714,  1715,
    1716,     0,     0,     0,     0,  1717,     0,     0,  1718,     0,
       0,     0,     0,     0,     0,   966,  1719,  1236,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2244,     0,     0,
       0,     0,     0,     0,     0,  1720,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   966,   966,     0,     0,     0,
    2245,  2245,  2245,     0,     0,     0,     0,     0,     0,     0,
       0,   992,     0,     0,     0,  1780,     0,     0,  1721,     0,
    2243,   992,     0,     0,     0,     0,     0,   993,     0,     0,
       0,     0,     0,   992,     0,     0,     0,     0,  2245,     0,
     966,     0,     0,  1227,     0,     0,   966,     0,     0,     0,
       0,     0,  1229,   993,     0,     0,     0,     0,     0,     0,
       0,     0,   966,  1781,     0,     0,  1782,  1227,   993,     0,
       0,     0,   966,     0,  2243,     0,     0,  1783,     0,     0,
    1229,  1723,     0,     0,  1227,     0,     0,     0,     0,     0,
       0,     0,  1724,     0,  2243,     0,   966,   966,  1236,   966,
       0,     0,     0,  1725,     0,     0,     0,     0,  1236,     0,
     992,   992,     0,  1784,  1726,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   992,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   992,
     992,     0,     0,     0,     0,     0,     0,  1727,   993,     0,
       0,     0,     0,     0,     0,     0,     0,  1785,   992,     0,
    1729,  1730,  1786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1227,     0,     0,     0,  1787,     0,     0,     0,     0,     0,
    1707,  1788,  2245,     0,     0,     0,  1708,     0,     0,     0,
       0,     0,   993,  1777,   993,     0,     0,  1789,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   993,     0,   993,
       0,     0,     0,     0,     0,     0,     0,  1778,     0,     0,
       0,     0,     0,     0,     0,     0,  1732,  1236,     0,     0,
       0,     0,     0,  1710,     0,     0,     0,     0,  2245,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1733,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1236,     0,     0,     0,  1779,
       0,     0,     0,     0,     0,     0,     0,   993,     0,     0,
       0,     0,     0,  1711,     0,     0,     0,  1227,     0,     0,
       0,  1713,     0,  1236,     0,  1714,  1715,  1716,     0,     0,
       0,     0,  1717,     0,     0,  1718,     0,     0,     0,     0,
       0,     0,     0,  1719,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3073,     0,   993,     0,     0,
       0,     0,  1720,     0,     0,     0,     0,     0,  3093,     0,
    3095,     0,     0,  3107,  3110,  3115,     0,   993,     0,     0,
    3121,     0,     0,  3126,     0,     0,     0,     0,  1236,     0,
       0,     0,  1780,     0,     0,  1721,     0,     0,  3133,  3134,
    3135,  3136,     0,  2244,     0,     0,  3143,     0,   993,     0,
    3155,   993,     0,  3157,     0,     0,  3164,  3165,  3166,  3167,
    3168,  3169,  3170,  3171,  3172,     0,  3173,     0,     0,     0,
       0,     0,     0,  1453,     0,  3201,     0,     0,     0,     0,
    1781,  1229,     0,  1782,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1783,     0,     0,     0,  1723,     0,
       0,     0,     0,     0,     0,  1229,     0,     0,     0,  1724,
       0,     0,     0,     0,     0,     0,     0,  3223,     0,     0,
    1725,     0,  1229,     0,     0,     0,     0,     0,     0,     0,
    1784,  1726,  2245,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1727,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3505,     0,     0,  1729,  1730,  1786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     992,     0,     0,     0,     0,     0,  1236,     0,     0,     0,
       0,  1787,     0,     0,     0,     0,     0,     0,  3506,     0,
     992,     0,     0,     0,     0,  2244,   992,     0,  1229,     0,
     992,     0,     0,     0,  1789,     0,     0,     0,   992,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   992,     0,  3331,     0,
       0,     0,  1227,  1732,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1733,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   992,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   993,     0,     0,     0,     0,     0,     0,     0,   992,
     992,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1227,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1236,  1229,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2244,   992,  2245,     0,     0,  2244,     0,
    2245,     0,  2245,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1227,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2245,     0,     0,     0,   992,     0,  2244,     0,     0,  1227,
       0,     0,   992,     0,     0,     0,     0,     0,  2245,   992,
       0,     0,     0,   992,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   993,     0,     0,   993,     0,     0,
       0,     0,     0,   992,     0,     0,     0,     0,     0,   992,
       0,     0,     0,   992,     0,     0,  2244,     0,     0,     0,
       0,     0,     0,   993,     0,     0,   992,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1236,     0,     0,   992,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   992,
       0,     0,     0,     0,     0,     0,     0,     0,  1227,     0,
       0,     0,     0,     0,     0,     0,     0,  1236,     0,     0,
       0,     0,     0,  1227,     0,     0,     0,     0,     0,     0,
    1230,     0,     0,  1227,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1227,   993,   993,     0,
       0,     0,     0,  2245,  3619,     0,     0,  1236,  1230,     0,
       0,   993,     0,     0,     0,     0,  2244,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     993,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1232,     0,     0,
       0,     0,  1227,     0,  1236,     0,     0,     0,     0,  1236,
    1236,     0,     0,     0,     0,     0,  1227,     0,     0,     0,
       0,     0,     0,     0,     0,  1232,     0,     0,     0,     0,
    1227,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1229,     0,   993,  1227,     0,     0,     0,   992,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1227,
    1227,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   992,     0,     0,     0,  1229,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   992,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1229,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   992,     0,     0,     0,     0,
       0,     0,     0,   992,     0,     0,     0,  1229,     0,  3825,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1233,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3842,     0,
       0,     0,     0,  3848,     0,     0,     0,  1233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2291,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3115,
       0,  3115,  3115,     0,     0,     0,     0,     0,  2244,     0,
       0,     0,  3906,     0,  2244,  3909,  1229,  3911,     0,   993,
       0,     0,     0,     0,  2245,     0,     0,     0,     0,  1230,
       0,  1229,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1229,     0,     0,     0,     0,  3929,     0,  3932,     0,
    3934,     0,     0,  1230,  1229,     0,     0,     0,     0,     0,
       0,     0,     0,   993,     0,     0,     0,     0,     0,     0,
    1230,  1227,     0,     0,     0,   993,     0,  1236,     0,     0,
       0,     0,     0,  3201,  3201,  3201,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   992,
       0,  3985,   993,     0,     0,     0,  1232,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1229,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1232,  2415,     0,     0,  1229,     0,  4001,     0,     0,     0,
       0,   993,  2430,     0,     0,     0,     0,  1232,  1229,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1229,     0,     0,     0,     0,  1230,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   992,
     992,     0,     0,   993,  4038,     0,     0,  1229,  1229,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   992,     0,     0,   992,
    1227,     0,     0,     0,  1227,  1227,     0,     0,     0,     0,
       0,     0,     0,  1232,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   993,     0,  1230,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1227,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1233,     0,
    1227,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2244,  2244,  2244,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,   992,     0,  1233,
       0,     0,     0,     0,  1227,     0,     0,     0,  2244,     0,
    1232,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   992,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   992,     0,
       0,     0,     0,   993,     0,   993,   221,     0,     0,   222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,     0,     0,     0,     0,     0,
       0,   225,   993,     0,     0,  1233,     0,     0,     0,  1229,
       0,   984,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   226,     0,     0,     0,     0,   992,     0,
       0,     0,     0,     0,   227,     0,     0,     0,     0,     0,
       0,     0,     0,   228,     0,     0,     0,     0,     0,  2245,
       0,     0,     0,     0,     0,   984,   229,     0,     0,     0,
       0,   230,     0,     0,     0,     0,     0,     0,   231,     0,
     232,     0,  2244,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   992,     0,   992,     0,   233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   992,     0,   992,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1233,     0,     0,     0,     0,     0,  2244,  1227,
       0,     0,   235,     0,     0,     0,     0,     0,  1230,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1235,     0,     0,     0,     0,     0,     0,   992,  1229,     0,
     237,   238,  1229,  1229,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,     0,     0,   239,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   240,  1230,     0,   241,
       0,     0,     0,     0,     0,  1232,     0,   992,     0,     0,
       0,     0,     0,     0,     0,     0,  1227,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1229,   992,   242,     0,
       0,     0,     0,     0,   243,     0,     0,   244,  1229,     0,
    2245,     0,     0,     0,   245,     0,     0,   246,     0,     0,
       0,     0,  1230,     0,     0,     0,     0,     0,   992,     0,
     247,   992,     0,     0,     0,     0,   993,     0,     0,   248,
       0,     0,     0,     0,  1232,  1230,   249,     0,   993,     0,
       0,  4431,  1229,   250,     0,   251,     0,     0,   252,     0,
    4435,     0,   253,     0,     0,     0,  4436,     0,  4437,     0,
       0,   254,     0,     0,     0,     0,   255,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     256,     0,     0,     0,     0,  4461,  4462,     0,     0,  1232,
       0,     0,     0,   257,     0,     0,     0,     0,     0,     0,
       0,     0,  2244,  3121,     0,     0,  1227,     0,     0,     0,
       0,  4487,  1232,     0,  4490,     0,  4492,     0,     0,     0,
       0,     0,     0,     0,  1230,  4496,     0,  1227,     0,     0,
       0,     0,     0,  4503,  4504,     0,     0,     0,     0,  1230,
       0,  1227,     0,     0,     0,     0,     0,     0,     0,  1230,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1230,     0,     0,     0,  4551,  1233,     0,     0,
       0,     0,  4558,  4559,  3201,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1232,     0,     0,     0,  4578,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1232,     0,     0,     0,
       0,  4591,     0,     0,     0,     0,  1232,     0,  1230,     0,
       0,     0,     0,     0,     0,     0,  1233,     0,     0,  1232,
       0,     0,  1230,  2245,     0,   993,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1230,  1229,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1230,
       0,   992,     0,     0,     0,     0,     0,     0,     0,  1235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1235,     0,  1232,     0,     0,     0,     0,
       0,     0,     0,     0,  1233,  1230,  1230,     0,     0,  1232,
    1235,     0,     0,     0,     0,  2244,     0,     0,     0,     0,
    2244,     0,  2244,  1232,     0,     0,     0,     0,     0,  2245,
       0,     0,     0,     0,     0,     0,  1232,     0,     0,     0,
       0,     0,     0,     0,  1229,     0,     0,   993,     0,     0,
    2244,     0,     0,     0,     0,  1227,     0,     0,  1227,     0,
    1227,   984,     0,     0,     0,  1227,     0,     0,  2244,     0,
       0,     0,     0,     0,     0,     0,   993,     0,     0,     0,
       0,     0,  1232,  1232,   992,     0,     0,   992,     0,     0,
       0,     0,     0,  1233,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1235,     0,  1233,     0,
       0,     0,     0,   992,     0,     0,  1227,     0,  1233,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1233,     0,  1227,     0,     0,     0,   984,   984,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1227,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1229,     0,     0,     0,     0,     0,
       0,     0,   993,     0,     0,     0,     0,   992,   992,     0,
       0,     0,     0,  2244,     0,  1229,     0,  1233,     0,     0,
       0,   992,     0,     0,     0,     0,     0,     0,     0,  1229,
       0,  1233,     0,     0,     0,     0,     0,     0,     0,     0,
     992,     0,     0,  1235,     0,  1233,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1233,     0,
       0,     0,  4870,  4871,     0,     0,  1227,  1230,  1227,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2245,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1233,  1233,     0,     0,     0,     0,
       0,     0,   992,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2245,     0,     0,     0,  4912,     0,
       0,     0,     0,     0,  1232,     0,     0,     0,     0,  4917,
       0,  1227,     0,     0,  2245,     0,   984,   984,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1227,     0,     0,     0,  4932,
    4934,     0,     0,     0,     0,     0,  4938,  4939,     0,     0,
       0,  4940,     0,     0,     0,     0,  4943,     0,  1227,  4946,
    4947,     0,     0,     0,  4951,     0,  1227,     0,     0,     0,
    4955,     0,     0,     0,     0,     0,  1230,     0,     0,     0,
    1230,  1230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1229,     0,     0,  1229,  3201,  1229,     0,
       0,     0,  3201,  1229,     0,     0,     0,     0,  3201,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1453,     0,     0,
       0,     0,     0,     0,  1230,  1227,     0,     0,     0,     0,
       0,     0,     0,  1232,     0,     0,  1230,  1232,  1232,     0,
       0,  1227,     0,  5018,  1229,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1227,     0,     0,     0,     0,     0,
       0,  1229,     0,     0,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,     0,     0,     0,  1233,     0,     0,   992,
    1230,     0,     0,     0,  2244,     0,  1229,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1232,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1232,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   992,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   992,     0,  1235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5083,     0,     0,     0,     0,     0,     0,  1232,     0,     0,
       0,     0,   992,     0,     0,     0,     0,     0,  1227,     0,
       0,     0,     0,     0,  1229,     0,  1229,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1227,
       0,     0,  1235,     0,     0,     0,     0,     0,     0,     0,
       0,   992,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1227,  1235,     0,     0,     0,     0,
       0,     0,  5121,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1233,     0,     0,     0,  1233,
    1233,     0,     0,     0,     0,     0,     0,     0,  1227,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1229,
       0,     0,     0,   992,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1229,     0,  1230,     0,     0,     0,     0,
       0,     0,     0,  1233,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1233,  1229,     0,     0,  1235,
       0,     0,     0,     0,  1229,     0,     0,     0,     0,  1235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   992,  1235,     0,     0,     0,     0,     0,     0,     0,
       0,  1227,     0,     0,     0,     0,     0,     0,     0,  1233,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1232,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5237,  5238,     0,     0,  5239,     0,     0,     0,
       0,     0,  1230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1229,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1229,
       0,     0,  1235,     0,  5275,  5276,     0,     0,     0,     0,
       0,     0,  1229,     0,     0,     0,  1235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5290,     0,  1235,
       0,     0,     0,   992,  1227,   992,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1232,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1227,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1235,  1235,     0,     0,  3201,
       0,     0,   992,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1230,     0,     0,  1229,     0,     0,  2244,
       0,     0,     0,     0,     0,     0,     0,  1230,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1229,     0,     0,
       0,     0,     0,     0,  1233,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1229,     0,     0,     0,     0,     0,     0,  1232,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1232,     0,     0,     0,     0,     0,  1229,  1227,     0,     0,
       0,     0,     0,     0,  1232,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3121,     0,     0,     0,     0,     0,     0,
       0,  1233,     0,     0,     0,  1227,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2291,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1229,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2244,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5530,     0,
       0,     0,     0,     0,     0,     0,   992,     0,     0,     0,
       0,  1230,     0,     0,  1230,     0,  1230,     0,   992,     0,
       0,  1230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1233,     0,     0,     0,     0,  1227,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1227,     0,     0,     0,
       0,     0,  1233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1229,     0,     0,     0,  1233,     0,     0,     0,
       0,     0,  1230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1232,  1230,
       0,  1232,  1229,  1232,  2328,     0,     0,     0,  1232,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1230,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1235,     0,     0,     0,
    1235,  1235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1232,
       0,     0,     0,     0,     0,     0,  2328,     0,     0,  5275,
       0,     0,     0,     0,     0,     0,  1232,     0,     0,     0,
       0,     0,     0,     0,     0,  1227,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5679,     0,     0,     0,
       0,  1232,     0,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,  1230,     0,  1230,     0,  1235,     0,     0,     0,
       0,     0,     0,  1227,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2244,     0,   992,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1229,     0,     0,     0,     0,
       0,  1227,     0,     0,     0,     0,     0,     0,     0,     0,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5736,     0,     0,     0,     0,  1232,
       0,  1232,     0,  1229,     0,     0,     0,  1230,     0,     0,
    1233,     0,     0,  1233,     0,  1233,     0,     0,     0,     0,
    1233,     0,     0,     0,     0,     0,  1227,     0,     0,  5765,
    5765,     0,     0,     0,     0,     0,     0,     0,     0,  2244,
       0,  1230,     0,     0,     0,     0,     0,  5275,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   992,     0,     0,
       0,     0,     0,     0,  1230,     0,     0,     0,     0,     0,
       0,  1233,  1230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1232,     0,   992,     0,  1233,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1233,     0,     0,     0,     0,  1232,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5824,     0,     0,     0,  1229,     0,     0,     0,     0,     0,
       0,  1232,     0,     0,  1229,     0,     0,  1227,     0,  1232,
    5765,  1230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1230,     0,     0,
       0,     0,     0,     0,     0,     0,  5868,     0,     0,     0,
    1230,     0,     0,     0,     0,  1235,     0,     0,     0,     0,
       0,     0,   992,     0,  1227,     0,     0,     0,     0,     0,
       0,  1233,     0,  1233,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1232,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1232,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1232,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2244,     0,     0,  1229,     0,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,     0,     0,  1233,     0,     0,  5765,
       0,     0,     0,     0,  1230,  5931,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1229,     0,     0,     0,  1230,     0,     0,     0,     0,
    1233,     0,     0,     0,  2244,     0,     0,     0,     0,     0,
       0,     0,  1227,     0,     0,     0,     0,     0,     0,  1229,
    1230,     0,     0,  1233,  2244,     0,     0,     0,     0,     0,
       0,  1233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1232,     0,     0,  1230,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1232,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1229,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,     0,     0,     0,  1232,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1233,     0,     0,  1235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1233,  1235,     0,     0,
       0,  1232,     0,     0,     0,     0,     0,     0,     0,  1233,
       0,     0,     0,     0,  1227,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1230,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1227,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1229,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1227,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1232,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1229,  1233,     0,     0,     0,     0,     0,     0,
    1230,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1227,     0,  1233,     0,     0,  1227,  1227,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1230,     0,     0,     0,     0,     0,  2328,     0,     0,  1233,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2328,     0,     0,     0,  3103,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2328,  2328,
    2328,     0,  2328,  1233,     0,     0,     0,  1232,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1235,     0,     0,  1235,     0,  1235,     0,     0,     0,
       0,  1235,     0,     0,     0,     0,     0,  1232,     0,     0,
       0,     0,     0,     0,  2328,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1229,     0,     0,     0,  1227,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1235,
       0,     0,     0,  1230,     0,     0,  1233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,  2328,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2328,     0,
       0,  2328,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1232,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1229,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1233,
       0,     0,  1235,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,  1229,     0,     0,     0,     0,  1232,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1233,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1229,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1227,     0,     0,     0,     0,
       0,     0,  1230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1230,     0,     0,     0,     0,  1235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1229,     0,     0,     0,     0,  1229,  1229,     0,     0,     0,
       0,  1235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,  1232,
       0,     0,  1235,     0,     0,     0,     0,     0,     0,  1232,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1230,     0,     0,     0,     0,     0,     0,     0,     0,
    1233,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1235,  1229,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,  1230,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1230,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1232,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1232,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1230,     0,     0,     0,     0,     0,     0,     0,
       0,  1233,     0,     0,  1232,     0,     0,     0,     0,     0,
       0,  1233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1232,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1229,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,  1230,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1233,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1230,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1233,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1232,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1233,  1235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2328,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1232,     0,     0,
       0,     0,     0,     0,  2328,     0,  2328,     0,     0,  3103,
    3103,     0,  3883,     0,  3103,     0,     0,     0,  2328,     0,
       0,  2328,     0,     0,     0,     0,  2328,     0,     0,     0,
       0,  1233,  2328,     0,     0,     0,     0,  2328,     0,     0,
       0,     0,     0,     0,  2328,  2328,  2328,  2328,     0,     0,
       0,  3103,  3103,     0,  2328,     0,     0,     0,  1230,     0,
       0,     0,     0,     0,     0,     0,  2328,     0,  2328,     0,
    1235,     0,     0,     0,     0,  2328,  2328,  2328,  2328,  2328,
    2328,  2328,  2328,  2328,  2328,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2328,  1232,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1230,     0,     0,     0,     0,     0,     0,     0,     0,  1233,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2328,  1235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1230,     0,     0,     0,     0,     0,  1232,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1235,     0,     0,     0,     0,     0,     0,  1232,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1230,     0,
       0,     0,     0,  1230,  1230,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1233,  1232,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1232,     0,     0,     0,     0,
    1232,  1232,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,     0,     0,     0,     0,     0,     0,
    1230,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1233,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1233,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1232,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2328,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1233,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1233,     0,  1235,
       0,     0,  1233,  1233,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1233,
       0,     0,     0,     0,     0,     0,     0,     0,  1232,     0,
       0,     0,     0,     0,     0,     0,  2328,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2328,     0,     0,     0,     0,     0,  2328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3883,  3883,     0,     0,  3103,
    3103,  3103,  3103,     0,     0,  3103,  3103,  3103,  3103,  3103,
    3103,  3103,  3103,  3103,  3103,  3883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1235,     0,     0,     0,  2328,     0,     0,
    2328,     0,  2328,     0,     0,  3883,  3883,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2328,  3103,  3103,  2328,     0,  2328,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2328,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1233,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3103,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,  1235,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2328,     0,     0,     0,  2328,  2328,  2328,     0,
       0,     0,     0,     0,  3883,  3883,  3883,  3883,     0,     0,
       0,     0,  3883,  3883,  3883,  3883,  3883,  3883,  3883,  3883,
    3883,  3883,  2328,  2328,     0,     0,     0,     0,     0,     0,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2328,     0,
       0,  2328,     0,  2328,     0,     0,     0,  2328,     0,     0,
    3883,  3883,     0,     0,  2328,  2328,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2328,     0,     0,     0,     0,     0,     0,  2328,
    2328,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3883,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2328,  2328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2328,     0,     0,     0,     0,  2328,  3103,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2328,     0,  2328,     0,     0,     0,  2328,
    2328,  2328,     0,     0,  2328,     0,     0,  2328,  2328,     0,
       0,     0,  2328,     0,     0,     0,  2328,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2328,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3883,  3103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2328,  2328,
    2328,     0,     0,     0,     0,     0,     0,     0,  3103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2328,  2328,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2328,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3883,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3103,     0,     0,  3883,     0,     0,     0,  2328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2328,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3883,     0,
    3103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2328,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2328,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2328,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2328,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3103,  3103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,
       0,     0,     0,     0,  3883,  3883,     0,   269,   270,   271,
     272,   273,   274,   275,   276,  3195,   278,   279,   280,     0,
       0,     0,     0,  1368,     0,     0,   281,   282,     0,   283,
     284,   285,  2328,   939,   286,   287,   288,   289,   290,   291,
    1369,   940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,
     300,   301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,  1388,  1389,   340,  1390,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,  3196,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,  1391,
     374,   375,   376,   377,  1392,  1393,   379,     0,   380,   381,
    1394,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,  1396,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,  1397,  1398,     0,  1399,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1403,   954,  1404,   450,   451,   452,     0,   453,   454,  1405,
     455,   456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,  1410,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1413,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
    1414,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,  1417,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1421,  1422,     0,     0,   582,   583,  1423,   585,
    1424,  1425,   587,   588,   589,   590,   591,   592,   593,     0,
    1426,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,  1428,  3197,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
    1437,     0,     0,     0,     0,     0,     0,  1438,  1439,  3198,
       0,     0,     0,     0,     0,     0,  1441,  3199,   938,  1363,
     700,  1364,  1365,  1366,   766,  1367,     0,     0,     0,     0,
       0,     0,     0,   269,   270,   271,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,     0,     0,     0,  1368,
       0,     0,   281,   282,     0,   283,   284,   285,     0,   939,
     286,   287,   288,   289,   290,   291,  1369,   940,  1370,  1371,
    1372,  1373,     0,   297,   298,   299,   300,   301,  1374,  1375,
     302,   303,  1376,  1377,   306,     0,   307,   308,   309,   310,
     311,  1378,     0,  1379,     0,   313,   314,   315,   316,   317,
     318,   942,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,   328,     0,   943,   329,   330,   331,  1380,  1381,
    1382,  1383,  1384,  1385,  1386,   332,   333,   334,   335,   336,
    1387,   337,  1388,  1389,   340,  1390,   341,     0,   342,   343,
     344,   345,   346,   347,     0,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,  1207,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,  1391,   374,   375,   376,   377,
    1392,  1393,   379,     0,   380,   381,  1394,   383,     0,   384,
       0,   385,   945,     0,   946,   386,   387,   388,   389,     0,
     390,  1395,     0,  1396,   393,   394,     0,   395,   396,   397,
     398,   399,   947,   400,   401,   402,   403,     0,   404,   405,
     406,   407,   408,   409,     0,   410,   948,   411,   412,   413,
     414,   415,  1397,  1398,     0,  1399,     0,   419,   949,   950,
     420,   951,   421,   422,   423,   424,   425,     0,     0,   426,
    1400,   952,   428,   953,     0,   429,   430,   431,  1401,  1402,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,  1403,   954,  1404,   450,
     451,   452,     0,   453,   454,  1405,   455,   456,   955,   457,
    1406,  1407,   459,  1408,  1409,   462,   463,   464,     0,   465,
     466,   467,     0,     0,   468,  1410,   470,   471,     0,     0,
     472,   473,   956,   474,   957,  1411,   476,   477,   478,   479,
     480,   481,     0,   482,   483,   484,   485,     0,   486,   487,
    1412,   489,   490,   491,   492,   493,   494,     0,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,  1413,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,     0,   524,
     525,   958,   526,   527,   528,   529,  1414,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,    49,   541,   542,
     543,   544,   545,  1415,  1416,   546,   547,   548,   549,   550,
     551,   959,   552,   553,   554,  1417,   556,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,  1418,     0,     0,   571,  1419,   572,   573,  1420,    53,
     574,   960,   575,   576,   577,   578,   579,     0,  1421,  1422,
       0,     0,   582,   583,  1423,   585,  1424,  1425,   587,   588,
     589,   590,   591,   592,   593,     0,  1426,   594,   595,   596,
     597,   598,   599,   600,  1427,     0,   601,   602,   603,   604,
     605,  1288,  1428,     0,   608,   961,   609,   610,   611,   612,
       0,     0,     0,   613,     0,    59,   614,   615,   616,   617,
     618,   619,   620,  1429,  1430,  1431,  1432,   625,  1433,  1434,
    1435,  1436,   630,   631,   632,   633,  1437,     0,    60,     0,
       0,     0,     0,  1438,  1439,     0,     0,     0,     0,     0,
       0,     0,  1441,  5490,   938,  1363,   700,  1364,  1365,  1366,
     766,  1367,     0,     0,     0,     0,     0,     0,     0,   269,
     270,   271,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,     0,     0,     0,  1368,     0,     0,   281,   282,
       0,   283,   284,   285,     0,   939,   286,   287,   288,   289,
     290,   291,  1369,   940,  1370,  1371,  1372,  1373,     0,   297,
     298,   299,   300,   301,  1374,  1375,   302,   303,  1376,  1377,
     306,     0,   307,   308,   309,   310,   311,  1378,     0,  1379,
       0,   313,   314,   315,   316,   317,   318,   942,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,   328,     0,
     943,   329,   330,   331,  1380,  1381,  1382,  1383,  1384,  1385,
    1386,   332,   333,   334,   335,   336,  1387,   337,  1388,  1389,
     340,  1390,   341,     0,   342,   343,   344,   345,   346,   347,
       0,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,  1207,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,  1391,   374,   375,   376,   377,  1392,  1393,   379,     0,
     380,   381,  1394,   383,     0,   384,     0,   385,   945,     0,
     946,   386,   387,   388,   389,     0,   390,  1395,     0,  1396,
     393,   394,     0,   395,   396,   397,   398,   399,   947,   400,
     401,   402,   403,     0,   404,   405,   406,   407,   408,   409,
       0,   410,   948,   411,   412,   413,   414,   415,  1397,  1398,
       0,  1399,     0,   419,   949,   950,   420,   951,   421,   422,
     423,   424,   425,     0,     0,   426,  1400,   952,   428,   953,
       0,   429,   430,   431,  1401,  1402,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,  1403,   954,  1404,   450,   451,   452,     0,   453,
     454,  1405,   455,   456,   955,   457,  1406,  1407,   459,  1408,
    1409,   462,   463,   464,     0,   465,   466,   467,     0,     0,
     468,  1410,   470,   471,     0,     0,   472,   473,   956,   474,
     957,  1411,   476,   477,   478,   479,   480,   481,     0,   482,
     483,   484,   485,     0,   486,   487,  1412,   489,   490,   491,
     492,   493,   494,     0,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,  1413,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,   958,   526,   527,
     528,   529,  1414,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,     0,   541,   542,   543,   544,   545,  1415,
    1416,   546,   547,   548,   549,   550,   551,   959,   552,   553,
     554,  1417,   556,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,  1418,     0,     0,
     571,  1419,   572,   573,  1420,     0,   574,   960,   575,   576,
     577,   578,   579,     0,  1421,  1422,     0,     0,   582,   583,
    1423,   585,  1424,  1425,   587,   588,   589,   590,   591,   592,
     593,     0,  1426,   594,   595,   596,   597,   598,   599,   600,
    1427,     0,   601,   602,   603,   604,   605,   606,  1428,     0,
     608,   961,   609,   610,   611,   612,     0,     0,     0,   613,
       0,     0,   614,   615,   616,   617,   618,   619,   620,  1429,
    1430,  1431,  1432,   625,  1433,  1434,  1435,  1436,   630,   631,
     632,   633,  1437,     0,     0,     0,     0,     0,     0,  1438,
    1439,     0,     0,     0,     0,     0,     0,     0,  1441,  3105,
     938,  1363,   700,  1364,  1365,  1366,   766,  1367,     0,     0,
       0,     0,     0,     0,     0,   269,   270,   271,   272,   273,
     274,   275,   276,     0,   278,   279,   280,     0,     0,     0,
       0,  1368,     0,     0,   281,   282,     0,   283,   284,   285,
       0,   939,   286,   287,   288,   289,   290,   291,  1369,   940,
    1370,  1371,  1372,  1373,     0,   297,   298,   299,   300,   301,
    1374,  1375,   302,   303,  1376,  1377,   306,     0,   307,   308,
     309,   310,   311,  1378,     0,  1379,     0,   313,   314,   315,
     316,   317,   318,   942,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,   328,     0,   943,   329,   330,   331,
    1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,   333,   334,
     335,   336,  1387,   337,  1388,  1389,   340,  1390,   341,     0,
     342,   343,   344,   345,   346,   347,     0,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
    1207,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,  1391,   374,   375,
     376,   377,  1392,  1393,   379,     0,   380,   381,  1394,   383,
       0,   384,     0,   385,   945,     0,   946,   386,   387,   388,
     389,     0,   390,  1395,     0,  1396,   393,   394,     0,   395,
     396,   397,   398,   399,   947,   400,   401,   402,   403,     0,
     404,   405,   406,   407,   408,   409,     0,   410,   948,   411,
     412,   413,   414,   415,  1397,  1398,     0,  1399,     0,   419,
     949,   950,   420,   951,   421,   422,   423,   424,   425,     0,
       0,   426,  1400,   952,   428,   953,     0,   429,   430,   431,
    1401,  1402,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,  1403,   954,
    1404,   450,   451,   452,     0,   453,   454,  1405,   455,   456,
     955,   457,  1406,  1407,   459,  1408,  1409,   462,   463,   464,
       0,   465,   466,   467,     0,     0,   468,  1410,   470,   471,
       0,     0,   472,   473,   956,   474,   957,  1411,   476,   477,
     478,   479,   480,   481,     0,   482,   483,   484,   485,     0,
     486,   487,  1412,   489,   490,   491,   492,   493,   494,     0,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,  1413,   507,   508,   509,   510,   511,     0,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
       0,   524,   525,   958,   526,   527,   528,   529,  1414,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,     0,
     541,   542,   543,   544,   545,  1415,  1416,   546,   547,   548,
     549,   550,   551,   959,   552,   553,   554,  1417,   556,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,  1418,     0,     0,   571,  1419,   572,   573,
    1420,     0,   574,   960,   575,   576,   577,   578,   579,     0,
    1421,  1422,     0,     0,   582,   583,  1423,   585,  1424,  1425,
     587,   588,   589,   590,   591,   592,   593,     0,  1426,   594,
     595,   596,   597,   598,   599,   600,  1427,     0,   601,   602,
     603,   604,   605,   606,  1428,     0,   608,   961,   609,   610,
     611,   612,     0,     0,     0,   613,     0,     0,   614,   615,
     616,   617,   618,   619,   620,  1429,  1430,  1431,  1432,   625,
    1433,  1434,  1435,  1436,   630,   631,   632,   633,  1437,     0,
       0,     0,     0,     0,     0,  1438,  1439,     0,     0,     0,
       0,     0,     0,     0,  1441,  4439,   938,  1363,   700,  1364,
    1365,  1366,   766,  1367,     0,     0,     0,     0,     0,     0,
       0,   269,   270,   271,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,     0,     0,     0,  1368,     0,     0,
     281,   282,     0,   283,   284,   285,     0,   939,   286,   287,
     288,   289,   290,   291,  1369,   940,  1370,  1371,  1372,  1373,
       0,   297,   298,   299,   300,   301,  1374,  1375,   302,   303,
    1376,  1377,   306,     0,   307,   308,   309,   310,   311,  1378,
       0,  1379,     0,   313,   314,   315,   316,   317,   318,   942,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
     328,     0,   943,   329,   330,   331,  1380,  1381,  1382,  1383,
    1384,  1385,  1386,   332,   333,   334,   335,   336,  1387,   337,
    1388,  1389,   340,  1390,   341,     0,   342,   343,   344,   345,
     346,   347,     0,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,  1207,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,  1391,   374,   375,   376,   377,  1392,  1393,
     379,     0,   380,   381,  1394,   383,     0,   384,     0,   385,
     945,     0,   946,   386,   387,   388,   389,     0,   390,  1395,
       0,  1396,   393,   394,     0,   395,   396,   397,   398,   399,
     947,   400,   401,   402,   403,     0,   404,   405,   406,   407,
     408,   409,     0,   410,   948,   411,   412,   413,   414,   415,
    1397,  1398,     0,  1399,     0,   419,   949,   950,   420,   951,
     421,   422,   423,   424,   425,     0,     0,   426,  1400,   952,
     428,   953,     0,   429,   430,   431,  1401,  1402,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,  1403,   954,  1404,   450,   451,   452,
       0,   453,   454,  1405,   455,   456,   955,   457,  1406,  1407,
     459,  1408,  1409,   462,   463,   464,     0,   465,   466,   467,
       0,     0,   468,  1410,   470,   471,     0,     0,   472,   473,
     956,   474,   957,  1411,   476,   477,   478,   479,   480,   481,
       0,   482,   483,   484,   485,     0,   486,   487,  1412,   489,
     490,   491,   492,   493,   494,     0,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,  1413,   507,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,   958,
     526,   527,   528,   529,  1414,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,     0,   541,   542,   543,   544,
     545,  1415,  1416,   546,   547,   548,   549,   550,   551,   959,
     552,   553,   554,  1417,   556,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,  1418,
       0,     0,   571,  1419,   572,   573,  1420,     0,   574,   960,
     575,   576,   577,   578,   579,     0,  1421,  1422,     0,     0,
     582,   583,  1423,   585,  1424,  1425,   587,   588,   589,   590,
     591,   592,   593,     0,  1426,   594,   595,   596,   597,   598,
     599,   600,  1427,     0,   601,   602,   603,   604,   605,   606,
    1428,     0,   608,   961,   609,   610,   611,   612,     0,     0,
       0,   613,     0,     0,   614,   615,   616,   617,   618,   619,
     620,  1429,  1430,  1431,  1432,   625,  1433,  1434,  1435,  1436,
     630,   631,   632,   633,  1437,     0,     0,   268,     0,     0,
       0,  1438,  1439,     0,     0,     0,     0,     0,     0,     0,
    1441,  4510,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,  4528,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0, -2023,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0, -2023,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410, -2023,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
   -2023,   421,   422,   423,   424,   425,     0,     0,   426,   427,
   -2023,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448, -2023,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
   -2023,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,     0,     0,     0,  1197,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1521,   269,   270,   271,   272,   273,   274,   275,
     276,     0,   278,   279,   280,     0,     0,     0,     0,     0,
       0,     0,   281,   282,     0,   283,   284,   285,     0,   939,
     286,   287,   288,   289,   290,     0,  1198,   940,  1199,  1200,
    1201,  1202,     0,   297,   298,   299,   300,   301,     0,     0,
     302,   303,  1203,  1204,   306,     0,   307,   308,   309,   310,
     311,     0,     0,   941,     0,   313,   314,   315,   316,   317,
     318,   942,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,   328,     0,   943,   329,   330,   331,     0,     0,
       0,   944,     0,     0,     0,   332,   333,   334,   335,   336,
       0,   337,  1205,  1206,   340,     0,   341,     0,   342,   343,
     344,   345,   346,   347,     0,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,  1207,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,     0,   379,     0,   380,   381,  1208,   383,     0,   384,
       0,   385,   945,     0,   946,   386,   387,   388,   389,     0,
     390,     0,     0,     0,   393,   394,     0,   395,   396,   397,
     398,   399,   947,   400,   401,   402,   403,  2454,   404,   405,
     406,   407,   408,   409,     0,   410,   948,  2455,   412,   413,
     414,   415,  1210,  1211,     0,  1212,     0,   419,   949,   950,
     420,   951,   421,   422,   423,   424,   425,     0,     0,   426,
       0,   952,   428,   953,     0,   429,   430,   431,     0,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,  1213,   954,  1214,   450,
     451,   452,     0,   453,     0,     0,   455,   456,   955,   457,
       0,     0,   459,  1215,  1216,   462,   463,   464,     0,   465,
     466,   467,     0,     0,   468,   469,   470,   471,     0,     0,
     472,  2457,   956,   474,   957,     0,   476,   477,   478,   479,
     480,   481,     0,   482,   483,   484,   485,     0,   486,   487,
       0,   489,     0,   491,   492,   493,   494,     0,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,  1217,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,     0,   524,
     525,   958,   526,   527,   528,   529,     0,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,     0,   541,   542,
     543,   544,   545,     0,     0,   546,   547,  2458,   549,   550,
     551,   959,   552,   553,   554,  1219,   556,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,     0,     0,     0,   571,     0,   572,   573,     0,     0,
     574,   960,   575,   576,   577,   578,   579,     0,  1220,  1221,
       0,     0,   582,   583,     0,   585,     0,     0,   587,   588,
     589,   590,   591,   592,   593,     0,     0,   594,   595,   596,
     597,   598,   599,   600,     0,     0,   601,   602,   603,   604,
     605,     0,  1222,  2459,   608,   961,   609,   610,   611,   612,
       0,     0,     0,   613,     0,     0,   614,   615,   616,   617,
     618,   619,  1197,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   631,   632,   633,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,  2567,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,     0,
    1198,   940,  1199,  1200,  1201,  1202,     0,   297,   298,   299,
     300,   301,     0,     0,   302,   303,  1203,  1204,   306,     0,
     307,   308,   309,   310,   311,     0,     0,   941,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,     0,     0,     0,   944,     0,     0,     0,   332,
     333,   334,   335,   336,     0,   337,  1205,  1206,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,     0,   379,     0,   380,   381,
    1208,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,     0,     0,     0,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,  2454,   404,   405,   406,   407,   408,   409,     0,   410,
     948,  2455,   412,   413,   414,   415,  1210,  1211,     0,  1212,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,     0,   952,   428,   953,     0,   429,
     430,   431,     0,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1213,   954,  1214,   450,   451,   452,     0,   453,     0,     0,
     455,   456,   955,   457,     0,     0,   459,  1215,  1216,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,   469,
     470,   471,     0,     0,   472,  2457,   956,   474,   957,     0,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,     0,   489,     0,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1217,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
       0,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     547,  2458,   549,   550,   551,   959,   552,   553,   554,  1219,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,     0,     0,     0,   571,     0,
     572,   573,     0,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1220,  1221,     0,     0,   582,   583,     0,   585,
       0,     0,   587,   588,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,     0,     0,
     601,   602,   603,   604,   605,     0,  1222,  2459,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,     0,   938,  1363,   700,
    1364,  1365,  1366,   766,  1367,     0,     0,   631,   632,   633,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,  3713,  1368,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,  1369,   940,  1370,  1371,  1372,
    1373,     0,   297,   298,   299,   300,   301,  1374,  1375,   302,
     303,  1376,  1377,   306,     0,   307,   308,   309,   310,   311,
    1378,     0,  1379,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,   332,   333,   334,   335,   336,  1387,
     337,  1388,  1389,   340,  1390,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,  1391,   374,   375,   376,   377,  1392,
    1393,   379,     0,   380,   381,  1394,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
    1395,     0,  1396,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,  1397,  1398,     0,  1399,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,  1400,
     952,   428,   953,     0,   429,   430,   431,  1401,  1402,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1403,   954,  1404,   450,   451,
     452,     0,   453,   454,  1405,   455,   456,   955,   457,  1406,
    1407,   459,  1408,  1409,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,  1410,   470,   471,     0,     0,   472,
     473,   956,   474,   957,  1411,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,  1412,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1413,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,  1414,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,    49,   541,   542,   543,
     544,   545,  1415,  1416,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,  1417,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
    1418,     0,     0,   571,  1419,   572,   573,  1420,    53,   574,
     960,   575,   576,   577,   578,   579,     0,  1421,  1422,     0,
       0,   582,   583,  1423,   585,  1424,  1425,   587,   588,   589,
     590,   591,   592,   593,     0,  1426,   594,   595,   596,   597,
     598,   599,   600,  1427,     0,   601,   602,   603,   604,   605,
    1288,  1428,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,    59,   614,   615,   616,   617,   618,
     619,   620,  1429,  1430,  1431,  1432,   625,  1433,  1434,  1435,
    1436,   630,   631,   632,   633,  1437,     0,    60,     0,     0,
       0,     0,  1438,  1439,     0,     0,     0,     0,     0,     0,
       0,  1441,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,
       0,     0,     0,     0,     0,     0,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,  1368,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
    1369,   940,  1370,  1371,  1372,  1373,  3111,   297,   298,   299,
     300,   301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,  1388,  1389,   340,  1390,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,  1391,
     374,   375,   376,   377,  1392,  1393,   379,     0,   380,   381,
    1394,   383,     0,   384,     0,   385,   945,  3112,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,  1396,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,  1397,  1398,     0,  1399,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,  3113,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1403,   954,  1404,   450,   451,   452,     0,   453,   454,  1405,
     455,   456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,  1410,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1413,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
    1414,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,  1417,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1421,  1422,     0,  3114,   582,   583,  1423,   585,
    1424,  1425,   587,   588,   589,   590,   591,   592,   593,     0,
    1426,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,  1428,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
    1437,     0,     0,     0,     0,     0,     0,  1438,  1439,     0,
       0,     0,     0,     0,     0,     0,  1441,   938,  1363,   700,
    1364,  1365,  1366,   766,  1367,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,  1368,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,  1369,   940,  1370,  1371,  1372,
    1373,     0,   297,   298,   299,   300,   301,  1374,  1375,   302,
     303,  1376,  1377,   306,     0,   307,   308,   309,   310,   311,
    1378,     0,  1379,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,   332,   333,   334,   335,   336,  1387,
     337,  1388,  1389,   340,  1390,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,  1391,   374,   375,   376,   377,  1392,
    1393,   379,     0,   380,   381,  1394,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
    1395,     0,  1396,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,  1397,  1398,     0,  1399,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,  1400,
     952,   428,   953,     0,   429,   430,   431,  1401,  1402,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1403,   954,  1404,   450,   451,
     452,     0,   453,   454,  1405,   455,   456,   955,   457,  1406,
    1407,   459,  1408,  1409,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,  1410,   470,   471,     0,     0,   472,
     473,   956,   474,   957,  1411,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,  1412,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1413,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,  1414,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,  1415,  1416,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,  1417,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
    1418,     0,     0,   571,  1419,   572,   573,  1420,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1421,  1422,     0,
       0,   582,   583,  1423,   585,  1424,  1425,   587,   588,   589,
     590,   591,   592,   593,     0,  1426,   594,   595,   596,   597,
     598,   599,   600,  1427,     0,   601,   602,   603,   604,   605,
     606,  1428,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,  1429,  1430,  1431,  1432,   625,  1433,  1434,  1435,
    1436,   630,   631,   632,   633,  1437,     0,     0,     0,     0,
       0,     0,  1438,  1439,     0,     0,     0,     0,     0,  2252,
    3066,  1441,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,
       0,     0,     0,     0,     0,     0,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,  1368,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
    1369,   940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,
     300,   301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,  1388,  1389,   340,  1390,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,  1391,
     374,   375,   376,   377,  1392,  1393,   379,     0,   380,   381,
    1394,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,  1396,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,  1397,  1398,     0,  1399,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1403,   954,  1404,   450,   451,   452,     0,   453,   454,  1405,
     455,   456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,  1410,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1413,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
    1414,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,  1417,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1421,  1422,     0,     0,   582,   583,  1423,   585,
    1424,  1425,   587,   588,   589,   590,   591,   592,   593,     0,
    1426,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,  1428,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
    1437,     0,     0,     0,     0,     0,     0,  1438,  1439,  1440,
       0,     0,     0,     0,     0,     0,  1441,   938,  1363,   700,
    1364,  1365,  1366,   766,  1367,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
    2425,   278,   279,   280,     0,     0,     0,     0,  1368,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,  1369,   940,  1370,  1371,  1372,
    1373,     0,   297,   298,   299,   300,   301,  1374,  1375,   302,
     303,  1376,  1377,   306,     0,   307,   308,   309,   310,   311,
    1378,     0,  1379,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,   332,   333,   334,   335,   336,  1387,
     337,  1388,  1389,   340,  1390,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,  1391,   374,   375,   376,   377,  1392,
    1393,   379,     0,   380,   381,  1394,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
    1395,     0,  1396,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,  1397,  1398,     0,  1399,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,  1400,
     952,   428,   953,     0,   429,   430,   431,  1401,  1402,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1403,   954,  1404,   450,   451,
     452,     0,   453,   454,  1405,   455,   456,   955,   457,  1406,
    1407,   459,  1408,  1409,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,  1410,   470,   471,     0,     0,   472,
     473,   956,   474,   957,  1411,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,  1412,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1413,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,  1414,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,  1415,  1416,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,  1417,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
    1418,     0,     0,   571,  1419,   572,   573,  1420,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1421,  1422,     0,
       0,   582,   583,  1423,   585,  1424,  1425,   587,   588,   589,
     590,   591,   592,   593,     0,  1426,   594,   595,   596,   597,
     598,   599,   600,  1427,     0,   601,   602,   603,   604,   605,
     606,  1428,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,  1429,  1430,  1431,  1432,   625,  1433,  1434,  1435,
    1436,   630,   631,   632,   633,  1437,     0,     0,     0,     0,
       0,     0,  1438,  1439,     0,     0,     0,     0,     0,     0,
       0,  1441,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,
       0,     0,     0,     0,     0,     0,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,  1368,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
    1369,   940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,
     300,   301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,  1388,  1389,   340,  1390,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,  1391,
     374,   375,   376,   377,  1392,  1393,   379,     0,   380,   381,
    1394,   383,     0,   384,     0,   385,   945,  3112,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,  1396,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,  1397,  1398,     0,  1399,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1403,   954,  1404,   450,   451,   452,     0,   453,   454,  1405,
     455,   456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,  1410,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1413,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
    1414,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,  1417,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1421,  1422,     0,     0,   582,   583,  1423,   585,
    1424,  1425,   587,   588,   589,   590,   591,   592,   593,     0,
    1426,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,  1428,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
    1437,     0,     0,     0,     0,     0,     0,  1438,  1439,     0,
       0,     0,     0,     0,     0,     0,  1441,   938,  1363,   700,
    1364,  1365,  1366,   766,  1367,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,  1368,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,  1369,   940,  1370,  1371,  1372,
    1373,     0,   297,   298,   299,   300,   301,  1374,  1375,   302,
     303,  1376,  1377,   306,     0,   307,   308,   309,   310,   311,
    1378,     0,  1379,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,   332,   333,   334,   335,   336,  1387,
     337,  1388,  1389,   340,  1390,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,  1391,   374,   375,   376,   377,  1392,
    1393,   379,     0,   380,   381,  1394,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
    1395,     0,  1396,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,  1397,  1398,     0,  1399,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,  1400,
     952,   428,   953,     0,   429,   430,   431,  1401,  1402,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1403,   954,  1404,   450,   451,
     452,     0,   453,   454,  1405,   455,   456,   955,   457,  1406,
    1407,   459,  1408,  1409,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,  1410,   470,   471,     0,     0,   472,
     473,   956,   474,   957,  1411,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,  1412,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1413,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,  1414,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,  1415,  1416,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,  1417,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
    1418,     0,     0,   571,  1419,   572,   573,  1420,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1421,  1422,     0,
       0,   582,   583,  1423,   585,  1424,  1425,   587,   588,   589,
     590,   591,   592,   593,     0,  1426,   594,   595,   596,   597,
     598,   599,   600,  1427,     0,   601,   602,   603,   604,   605,
     606,  1428,  4560,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,  1429,  1430,  1431,  1432,   625,  1433,  1434,  1435,
    1436,   630,   631,   632,   633,  1437,     0,     0,     0,     0,
       0,     0,  1438,  1439,     0,     0,     0,     0,     0,     0,
       0,  1441,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,
       0,     0,     0,     0,     0,     0,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,  1368,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
    1369,   940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,
     300,   301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,  1388,  1389,   340,  1390,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,  1391,
     374,   375,   376,   377,  1392,  1393,   379,     0,   380,   381,
    1394,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,  1396,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,  1397,  1398,     0,  1399,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1403,   954,  1404,   450,   451,   452,     0,   453,   454,  1405,
     455,   456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,  1410,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1413,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
    1414,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,  1417,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1421,  1422,     0,     0,   582,   583,  1423,   585,
    1424,  1425,   587,   588,   589,   590,   591,   592,   593,     0,
    1426,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,  1428,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
    1437,     0,     0,     0,     0,     0,     0,  1438,  1439,     0,
       0,     0,     0,     0,     0,     0,  1441,   938,  1363,   700,
    1364,  1365,  1366,   766,  1367,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,  1368,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,  1369,   940,  1370,  1371,  1372,
    1373,     0,   297,   298,   299,   300,   301,  1374,  1375,   302,
     303,  1376,  1377,   306,     0,   307,   308,   309,   310,   311,
    1378,     0,  1379,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,  4577,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,   332,   333,   334,   335,   336,  1387,
     337,  1388,  1389,   340,  1390,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,  1391,   374,   375,   376,   377,  1392,
    1393,   379,     0,   380,   381,  1394,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
    1395,     0,  1396,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,  1397,  1398,     0,  1399,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,  1400,
     952,   428,   953,     0,   429,   430,   431,  1401,  1402,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1403,   954,  1404,   450,   451,
     452,     0,   453,   454,  1405,   455,   456,   955,   457,  1406,
    1407,   459,  1408,  1409,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,  1410,   470,   471,     0,     0,   472,
     473,   956,   474,   957,  1411,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,  1412,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1413,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,  1414,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,  1415,  1416,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,  1417,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
    1418,     0,     0,   571,  1419,   572,   573,  1420,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1421,  1422,     0,
       0,   582,   583,  1423,   585,  1424,  1425,   587,   588,   589,
     590,   591,   592,   593,     0,  1426,   594,   595,   596,   597,
     598,   599,   600,  1427,     0,   601,   602,   603,   604,   605,
     606,  1428,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,  1429,  1430,  1431,  1432,   625,  1433,  1434,  1435,
    1436,   630,   631,   632,   633,  1437,     0,     0,     0,     0,
       0,     0,  1438,  1439,     0,     0,     0,     0,     0,     0,
       0,  1441,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,
       0,     0,     0,     0,     0,     0,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,  1368,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
    1369,   940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,
     300,   301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,  1388,  1389,   340,  1390,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,  1391,
     374,   375,   376,   377,  1392,  1393,   379,     0,   380,   381,
    1394,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,  1396,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,  1397,  1398,     0,  1399,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1403,   954,  1404,   450,   451,   452,     0,   453,   454,  1405,
     455,   456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,  1410,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1413,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
    1414,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,  1417,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1421,  1422,     0,     0,   582,   583,  1423,   585,
    1424,  1425,   587,   588,   589,   590,   591,   592,   593,     0,
    1426,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,  1428,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,  4924,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
    1437,     0,     0,     0,     0,     0,     0,  1438,  1439,     0,
       0,     0,     0,     0,     0,     0,  1441,   938,  1363,   700,
    1364,  1365,  1366,   766,  1367,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,  1368,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,  1369,   940,  1370,  1371,  1372,
    1373,     0,   297,   298,   299,   300,   301,  1374,  1375,   302,
     303,  1376,  1377,   306,     0,   307,   308,   309,   310,   311,
    1378,     0,  1379,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,   332,   333,   334,   335,   336,  1387,
     337,  1388,  1389,   340,  1390,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,  1391,   374,   375,   376,   377,  1392,
    1393,   379,     0,   380,   381,  1394,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
    1395,     0,  1396,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,  1397,  1398,     0,  1399,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,  1400,
     952,   428,   953,     0,   429,   430,   431,  1401,  1402,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1403,   954,  1404,   450,   451,
    4933,     0,   453,   454,  1405,   455,   456,   955,   457,  1406,
    1407,   459,  1408,  1409,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,  1410,   470,   471,     0,     0,   472,
     473,   956,   474,   957,  1411,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,  1412,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1413,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,  1414,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,  1415,  1416,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,  1417,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
    1418,     0,     0,   571,  1419,   572,   573,  1420,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1421,  1422,     0,
       0,   582,   583,  1423,   585,  1424,  1425,   587,   588,   589,
     590,   591,   592,   593,     0,  1426,   594,   595,   596,   597,
     598,   599,   600,  1427,     0,   601,   602,   603,   604,   605,
     606,  1428,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,  1429,  1430,  1431,  1432,   625,  1433,  1434,  1435,
    1436,   630,   631,   632,   633,  1437,     0,     0,     0,     0,
       0,     0,  1438,  1439,     0,     0,     0,     0,     0,     0,
       0,  1441,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,
       0,     0,     0,     0,     0,     0,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,  1368,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
    1369,   940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,
     300,   301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
    5265,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,  1388,  1389,   340,  1390,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,  1391,
     374,   375,   376,   377,  1392,  1393,   379,     0,   380,   381,
    1394,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,  5266,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,  1397,  1398,     0,  1399,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1403,   954,  1404,   450,   451,   452,     0,   453,   454,  1405,
     455,   456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,  1410,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1413,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,  5267,
    1414,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,  1417,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1421,  1422,     0,     0,   582,   583,  1423,   585,
    1424,  1425,   587,   588,   589,   590,   591,   592,   593,     0,
    1426,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,  1428,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
    1437,     0,     0,     0,     0,     0,     0,  1438,  1439,     0,
       0,     0,     0,     0,     0,     0,  5268,   938,  1363,   700,
    1364,  1365,  1366,   766,  1367,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,  1368,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,  5762,  1369,   940,  1370,  1371,  1372,
    1373,     0,   297,   298,   299,   300,   301,  1374,  1375,   302,
     303,  1376,  1377,   306,     0,   307,   308,   309,   310,   311,
    1378,     0,  1379,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,  5763,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,   332,   333,   334,   335,   336,  1387,
     337,  1388,  1389,   340,  1390,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,  1391,   374,   375,   376,   377,  1392,
    1393,   379,     0,   380,   381,  1394,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
    1395,     0,  1396,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,  1397,  1398,     0,  1399,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,  1400,
     952,   428,   953,     0,   429,   430,   431,  1401,  1402,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1403,   954,  1404,   450,   451,
     452,     0,   453,   454,  1405,   455,   456,   955,   457,  1406,
    1407,   459,  1408,  1409,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,  1410,   470,   471,     0,     0,   472,
     473,   956,   474,   957,  1411,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,  1412,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1413,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,  1414,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,  1415,  1416,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,  1417,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
    1418,     0,     0,   571,  1419,   572,   573,  1420,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1421,  1422,     0,
       0,   582,   583,  1423,   585,  1424,  1425,   587,   588,   589,
     590,  5764,   592,   593,     0,  1426,   594,   595,   596,   597,
     598,   599,   600,  1427,     0,   601,   602,   603,   604,   605,
     606,  1428,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,  1429,  1430,  1431,  1432,   625,  1433,  1434,  1435,
    1436,   630,   631,   632,   633,  1437,     0,     0,     0,     0,
       0,     0,  1438,  1439,     0,     0,     0,     0,     0,     0,
       0,  1441,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,
       0,     0,     0,     0,     0,     0,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,  1368,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
    1369,   940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,
     300,   301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,  5763,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,  1388,  1389,   340,  1390,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,  1391,
     374,   375,   376,   377,  1392,  1393,   379,     0,   380,   381,
    1394,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,  1396,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,  1397,  1398,     0,  1399,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1403,   954,  1404,   450,   451,   452,     0,   453,   454,  1405,
     455,   456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,  1410,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1413,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
    1414,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,  1417,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1421,  1422,     0,     0,   582,   583,  1423,   585,
    1424,  1425,   587,   588,   589,   590,  5764,   592,   593,     0,
    1426,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,  1428,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
    1437,     0,     0,     0,     0,     0,     0,  1438,  1439,     0,
       0,     0,     0,     0,     0,     0,  1441,   938,  1363,   700,
    1364,  1365,  1366,   766,  1367,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,  1368,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,  1369,   940,  1370,  1371,  1372,
    1373,     0,   297,   298,   299,   300,   301,  1374,  1375,   302,
     303,  1376,  1377,   306,     0,   307,   308,   309,   310,   311,
    1378,     0,  1379,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,   332,   333,   334,   335,   336,  1387,
     337,  1388,  1389,   340,  5471,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,  1391,   374,   375,   376,   377,  1392,
    1393,   379,     0,   380,   381,  1394,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
    1395,     0,  1396,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,  1397,  1398,     0,  1399,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,  1400,
     952,   428,   953,     0,   429,   430,   431,  1401,  1402,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1403,   954,  1404,   450,   451,
     452,     0,   453,   454,     0,   455,   456,   955,   457,  1406,
    1407,   459,  1408,  1409,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,  1410,   470,   471,     0,     0,   472,
     473,   956,   474,   957,  1411,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,  1412,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1413,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,  3097,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,  1415,  1416,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,  1417,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
    1418,     0,     0,   571,  1419,   572,   573,  1420,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1421,  1422,     0,
       0,   582,   583,  1423,   585,  1424,  1425,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,  1427,     0,   601,   602,   603,   604,   605,
     606,  1428,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,  1429,  1430,  1431,  1432,   625,  1433,  1434,  1435,
    1436,   630,   631,   632,   633,     0,     0,     0,     0,     0,
       0,     0,  3098,  3099,     0,     0,     0,     0,     0,     0,
       0,  3100,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,
       0,     0,     0,     0,     0,     0,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,  1368,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290, -2908,
    1369,   940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,
     300,   301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,  5763,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,  1388,  1389,   340,  1390,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,  1391,
     374,   375,   376,   377,  1392,  1393,   379,     0,   380,   381,
    1394,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,  1396,   393,   394,
       0,   395,   396,   397,   398,   399, -2908,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,  1397,  1398,     0,  1399,
       0,   419,     0,     0,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428, -2908,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1403,   954,  1404,   450,   451,   452,     0,   453,   454,  1405,
     455,   456,     0,   457,  1406,  1407,   459,  1408,  1409,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,  1410,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1413,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
    1414,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551, -2908,   552,   553,   554,  1417,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1421,  1422,     0,     0,   582,   583,  1423,   585,
    1424,  1425,   587,   588,   589,   590,  5764,   592,   593,     0,
    1426,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,  1428,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
   -2908,     0,     0,     0,     0,     0,     0,  1438,  1439,     0,
       0,     0,     0,     0,     0,     0,  1441,   938,  1363,   700,
    1364,  1365,  1366,   766,  1367,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,  1368,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,  1369,   940,  1370,  1371,  1372,
    1373,     0,   297,   298,   299,   300,   301,  1374,  1375,   302,
     303,  1376,  1377,   306,     0,   307,   308,   309,   310,   311,
    1378,     0,  1379,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,  1380,  1381,  1382,
    1383,  1384,  1385,  1386,   332,   333,   334,   335,   336,  1387,
     337,  1388,  1389,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,  1391,   374,   375,   376,   377,  1392,
    1393,   379,     0,   380,   381,  1394,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
    1395,     0,  1396,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,  1397,  1398,     0,  1399,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,  1400,
     952,   428,   953,     0,   429,   430,   431,  1401,  1402,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1403,   954,  1404,   450,   451,
     452,     0,   453,   454,     0,   455,   456,   955,   457,  1406,
    1407,   459,  1408,  1409,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,  1410,   470,   471,     0,     0,   472,
     473,   956,   474,   957,  1411,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,  1412,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1413,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,  3097,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,  1415,  1416,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,  1417,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
    1418,     0,     0,   571,  1419,   572,   573,  1420,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1421,  1422,     0,
       0,   582,   583,  1423,   585,  1424,  1425,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,  1427,     0,   601,   602,   603,   604,   605,
     606,  1428,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,  1429,  1430,  1431,  1432,   625,  1433,  1434,  1435,
    1436,   630,   631,   632,   633,     0,     0,     0,     0,     0,
       0,     0,  3098,  3099,     0,     0,     0,     0,     0,     0,
       0,  3100,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,
       0,     0,     0,     0,     0,     0,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,  1368,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
    1369,   940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,
     300,   301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,  1388,  1389,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,  1207,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,  1391,
     374,   375,   376,   377,  1392,  1393,   379,     0,   380,   381,
    1394,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,  1396,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,  1397,  1398,     0,  1399,
       0,   419,     0,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
    1403,   954,  1404,   450,   451,   452,     0,   453,   454,     0,
     455,   456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,  1410,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,  1413,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
    3097,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,  1417,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,  1421,  1422,     0,     0,   582,   583,  1423,   585,
    1424,  1425,   587,   588,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,  1428,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
       0,     0,     0,     0,     0,     0,     0,  3098,  3099,     0,
       0,   938,  1363,   700,  1364,  1365,  3100,   766,  1367,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,  1368,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,   291,  1369,
     940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,   300,
     301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,   307,
     308,   309,   310,   311,  1378,     0,  1379,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,   333,
     334,   335,   336,  1387,   337,  1388,  1389,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,  1207,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,  1391,   374,
     375,   376,   377,  1392,  1393,   379,     0,   380,   381,  1394,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,  1395,     0,  1396,   393,   394,     0,
     395,   396,   397,   398,   399,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
     411,   412,   413,   414,   415,  1397,  1398,     0,  1399,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,  1400,   952,   428,   953,     0,   429,   430,
     431,  1401,  1402,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,  1403,
     954,  1404,   450,   451,   452,     0,   453,   454,     0,   455,
     456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,   956,   474,   957,  1411,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,  1412,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,  1413,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,  3097,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,  1415,  1416,   546,   547,
     548,   549,   550,   551,   959,   552,   553,   554,  1417,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,  1418,     0,     0,   571,  1419,   572,
     573,  1420,     0,   574,   960,   575,   576,   577,   578,   579,
       0,  1421,  1422,     0,     0,   582,   583,  1423,   585,  1424,
    1425,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,  1427,     0,   601,
     602,   603,   604,   605,   606,  1428,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,  1429,  1430,  1431,  1432,
     625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,     0,
       0,   938,  1363,   700,  1364,  1365,     0,   766,  1367,     0,
       0,     0,     0,     0,     0,  3100,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,  1368,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,   291,  1369,
     940,  1370,  1371,  1372,  1373,     0,  4472,   298,   299,   300,
     301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,   307,
     308,   309,   310,   311,  1378,     0,  1379,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,   333,
     334,   335,   336,  1387,   337,  1388,  1389,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,  1207,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,  1391,   374,
     375,   376,   377,  1392,  1393,   379,     0,   380,   381,  1394,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,  1395,     0,  1396,   393,   394,     0,
     395,   396,   397,   398,   399,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
     411,   412,   413,   414,   415,  1397,  1398,     0,  1399,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,  1400,   952,   428,   953,     0,   429,   430,
     431,  1401,  1402,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,  1403,
     954,  1404,   450,   451,   452,     0,   453,   454,     0,   455,
     456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,   956,   474,   957,  1411,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,  1412,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,  1413,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,  3097,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,  1415,  1416,   546,   547,
     548,   549,   550,   551,   959,   552,   553,   554,  1417,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,  1418,     0,     0,   571,  1419,   572,
     573,  1420,     0,   574,   960,   575,   576,   577,   578,   579,
       0,  1421,  1422,     0,     0,   582,   583,  1423,   585,  1424,
    1425,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,  1427,     0,   601,
     602,   603,   604,   605,   606,  1428,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,  1429,  1430,  1431,  1432,
     625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,     0,
       0,   938,  1363,   700,  1364,  1365,     0,   766,  1367,     0,
       0,     0,     0,     0,     0,  3100,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,  1368,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,   291,  1369,
     940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,   300,
     301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,   307,
     308,   309,   310,   311,  1378,     0,  1379,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,   333,
     334,   335,   336,  1387,   337,  1388,  1389,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,  1207,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,  1391,   374,
     375,   376,   377,  1392,  1393,   379,     0,   380,   381,  1394,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,  1395,     0,  1396,   393,   394,     0,
     395,   396,   397,   398,   399,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
     411,   412,   413,   414,   415,  1397,  1398,     0,  1399,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,  1400,   952,   428,   953,     0,   429,   430,
     431,  1401,  1402,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,  1403,
     954,  1404,   450,   451,   452,     0,   453,   454,     0,   455,
     456,   955,   457,  1406,  1407,   459,  1408,  1409,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,   956,   474,   957,  1411,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,  1412,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,  1413,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,  3097,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,  1415,  1416,   546,   547,
     548,   549,   550,   551,   959,   552,   553,   554,  1417,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,  1418,     0,     0,   571,  1419,   572,
     573,  1420,     0,   574,   960,   575,   576,   577,   578,   579,
       0,  1421,  1422,     0,     0,   582,   583,  1423,   585,  1424,
    1425,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,  1427,     0,   601,
     602,   603,   604,   605,   606,  1428,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,  1429,  1430,  1431,  1432,
    4964,  1433,  1434,  1435,  1436,   630,   631,   632,   633,     0,
       0,   938,  1363,   700,  1364,  1365,  1366,   766,  1367,     0,
       0,     0,     0,     0,     0,  3100,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,  1368,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,     0,  1369,
     940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,   300,
     301,  1374,  1375,   302,   303,  1376,  1377,   306,     0,   307,
     308,   309,   310,   311,  1378,     0,  1379,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,   333,
     334,   335,   336,  1387,   337,  1388,  1389,   340,  1390,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,  1207,   360,   361,     0,   362,   363,   364,     0,   365,
       0,   367,     0,   368,   369,   370,   371,   372,  1391,   374,
     375,   376,   377,  1392,  1393,   379,     0,   380,   381,  1394,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,  1395,     0,  1396,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
     411,   412,   413,   414,   415,  1397,  1398,     0,  1399,     0,
     419,     0,     0,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,  1400,   952,   428,     0,     0,   429,   430,
     431,  1401,  1402,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,  1403,
     954,  1404,   450,   451,   452,     0,   453,   454,  1405,   455,
     456,     0,   457,  1406,  1407,   459,  1408,  1409,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,  1410,   470,
     471,     0,     0,   472,   473,   956,   474,   957,  1411,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,  1412,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,  1413,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,  1414,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,  1415,  1416,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,  1417,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,  1418,     0,     0,   571,  1419,   572,
     573,  1420,     0,   574,   960,   575,   576,   577,   578,   579,
       0,  1421,  1422,     0,     0,   582,   583,  1423,   585,  1424,
    1425,   587,   588,   589,   590,   591,   592,   593,     0,  1426,
     594,   595,   596,   597,   598,   599,   600,  1427,     0,   601,
     602,   603,   604,   605,   606,  1428,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,  1429,  1430,  1431,  1432,
     625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,     0,
       0,   938,     0,     0,     0,     0,  1438,  1439,     0,     0,
       0,     0,     0,     0,     0,  1441,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,   291,   292,
     940,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,  1375,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,  1378,     0,  1379,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,   333,
     334,   335,   336,  1387,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  1392,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,  1395,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
    3952,     0,   426,  1400,   952,   428,   953,     0,   429,   430,
     431,  1401,  1402,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     954,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,   955,   457,     0,  1407,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,   863,   468,   469,   470,
     471,     0,     0,   472,   473,   956,   474,   957,  1411,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,  1412,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,   530,
    3953,   532,   533,   534,   535,   536,   537,   538,   539,   540,
      49,   541,   542,   543,   544,   545,  1415,  1416,   546,   547,
     548,   549,   550,   551,   959,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,  1418,     0,     0,   571,  1419,   572,
     573,  1420,    53,   574,   960,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,  1423,   585,  1424,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,  1427,     0,   601,
     602,   603,   604,   605,  1288,   607,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,    59,   614,
     615,   616,   617,   618,   619,   620,  1429,  1430,  1431,  1432,
     625,  1433,  1434,  1435,  1436,  3954,   631,   632,   633,     0,
       0,    60,   938,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3955,     0,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,     0,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
     292,   940,   293,   294,   295,   296,     0,   297,   298,   299,
     300,   301,     0,  1375,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1392,     0,   379,     0,   380,   381,
     382,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,   416,   417,     0,   418,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,  3952,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   954,   449,   450,   451,   452,     0,   453,   454,     0,
     455,   456,   955,   457,     0,  1407,   459,   460,   461,   462,
     463,   464,     0,   465,   466,   467,     0,   863,   468,   469,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
     530,  3953,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,   580,   581,     0,     0,   582,   583,  1423,   585,
    1424,     0,   587,   588,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,   607,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,  3954,   631,   632,   633,
       0,     0,   938,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3955,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,     0,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
     292,   940,   293,   294,   295,   296,     0,   297,   298,   299,
     300,   301,     0,  1375,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1392,     0,   379,     0,   380,   381,
     382,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,   416,   417,     0,   418,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   954,   449,   450,   451,   452,     0,   453,   454,     0,
     455,   456,   955,   457,     0,  1407,   459,   460,   461,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,   469,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
     530,  3953,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,   580,   581,     0,     0,   582,   583,  1423,   585,
    1424,     0,   587,   588,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,   607,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,  3954,   631,   632,   633,
       0,     0,   938,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    61,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,     0,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
     292,   940,   293,   294,   295,   296,     0,   297,   298,   299,
     300,   301,     0,  1375,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1392,     0,   379,     0,   380,   381,
     382,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,   416,   417,     0,   418,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   954,   449,   450,   451,   452,     0,   453,   454,     0,
     455,   456,   955,   457,     0,  1407,   459,   460,   461,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,   469,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,   580,   581,     0,     0,   582,   583,  1423,   585,
    1424,     0,   587,   588,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,   607,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
       0,     0,   938,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4605,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,     0,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
     292,   940,   293,   294,   295,   296,     0,   297,   298,   299,
     300,   301,     0,  1375,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,  1378,     0,  1379,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,   332,
     333,   334,   335,   336,  1387,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1392,     0,   379,     0,   380,   381,
     382,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,  1395,     0,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,   416,   417,     0,   418,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,  1400,   952,   428,   953,     0,   429,
     430,   431,  1401,  1402,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   954,   449,   450,   451,   452,     0,   453,   454,     0,
     455,   456,   955,   457,     0,  1407,   459,   460,   461,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,   469,
     470,   471,     0,     0,   472,   473,   956,   474,   957,  1411,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,  1412,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,  1415,  1416,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,  1418,     0,     0,   571,  1419,
     572,   573,  1420,     0,   574,   960,   575,   576,   577,   578,
     579,     0,   580,   581,     0,     0,   582,   583,  1423,   585,
    1424,     0,   587,   588,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,  1427,     0,
     601,   602,   603,   604,   605,   606,   607,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,  1429,  1430,  1431,
    1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,   633,
       0,     0,   985,  1740,   700,     0,     0,     0,   766,     0,
       0,     0,     0,     0,     0,     0,  5742,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,     0,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
     292,   940,   293,   294,   295,   296,     0,   297,   298,   299,
     300,   301,     0,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,     0,   941,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,     0,     0,     0,   944,     0,     0,     0,   332,
     333,   334,   335,   336,     0,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,  2080,   379,     0,   380,   381,
     382,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,   391,     0,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,   416,   417,     0,   418,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,   427,   952,   428,   953,     0,   429,
     430,   431,     0,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   954,   449,   450,   451,   452,     0,   453,   454,     0,
     455,   456,   955,   457,     0,   458,   459,   460,   461,   462,
     463,   464,     0,   465,   466,   467,  2081,     0,   468,   469,
     470,   471,     0,     0,   472,   473,   956,   474,   957,   475,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,     0,     0,   571,     0,
     572,   573,     0,     0,   574,   960,   575,   576,   577,   578,
     579,     0,   580,   581,     0,     0,   582,   583,   584,   585,
     586,  2082,   587,   588,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,     0,     0,
     601,   602,   603,   604,   605,   606,   607,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
       0,     0,   985,     0,     0,     0,     0,  1741,  1742,  5555,
       0,     0,     0,     0,     0,     0,  5556,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     3,
       4,     0,     0,     0,     0,     0,   281,   282,     0,   283,
     284,   285,     0,   939,   286,   287,   288,   289,   290,   291,
     292,   940,   293,   294,   295,   296,     0,   297,   298,   299,
     300,   301,     0,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,     0,   941,     0,   313,
     314,   315,   316,   317,   318,   942,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,   943,   329,
     330,   331,     0,     0,     0,   944,     0,     0,     0,   332,
     333,   334,   335,   336,     0,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,     0,   380,   381,
     382,   383,     0,   384,     0,   385,   945,     0,   946,   386,
     387,   388,   389,     0,   390,   391,     0,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   947,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
     948,   411,   412,   413,   414,   415,   416,   417,     0,   418,
       0,   419,   949,   950,   420,   951,   421,   422,   423,   424,
     425,     0,     0,   426,   427,   952,   428,   953,     0,   429,
     430,   431,     0,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   954,   449,   450,   451,   452,     0,   453,   454,     0,
     455,   456,   955,   457,     0,   458,   459,   460,   461,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,   469,
     470,   471,     0,     0,   472,   473,   956,   474,   957,   475,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,   958,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,    49,   541,   542,   543,   544,   545,     0,     0,   546,
     547,   548,   549,   550,   551,   959,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,     0,     0,   571,     0,
     572,   573,     0,    53,   574,   960,   575,   576,   577,   578,
     579,     0,   580,   581,     0,     0,   582,   583,   584,   585,
     586,     0,   587,   588,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,     0,     0,
     601,   602,   603,   604,   605,  1288,   607,     0,   608,   961,
     609,   610,   611,   612,     0,     0,     0,   613,     0,    59,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
       0,     0,    60,   938,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    61,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,   939,   286,   287,   288,   289,   290,
     291,   292,   940,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,   941,     0,
     313,   314,   315,   316,   317,   318,   942,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,   943,
     329,   330,   331,     0,     0,     0,   944,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,   945,     0,   946,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   947,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,   948,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,   949,   950,   420,   951,   421,   422,   423,
     424,   425,     0,     0,   426,   427,   952,   428,   953,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   954,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,   955,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,   956,   474,   957,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   958,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,   959,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,   960,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
     961,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,     0,     0,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5320,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,    49,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,    53,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,  1288,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
      59,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,     0,     0,    60,   268,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    61,     0,   269,
     270,   271,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,     0,     0,     0,     0,     0,     0,   281,   282,
       0,   283,   284,   285,     0,     0,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,     0,   297,
     298,   299,   300,   301,     0,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,     0,     0,
       0,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,   328,     0,
       0,   329,   330,   331,     0,     0,     0,     0,     0,     0,
       0,   332,   333,   334,   335,   336,     0,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
       0,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     380,   381,   382,   383,     0,   384,     0,   385,     0,     0,
       0,   386,   387,   388,   389,     0,   390,   391,     0,   392,
     393,   394,     0,   395,   396,   397,   398,   399,     0,   400,
     401,   402,   403,     0,   404,   405,   406,   407,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
       0,   418,     0,   419,     0,     0,   420,     0,   421,   422,
     423,   424,   425,     0,     0,   426,   427,     0,   428,     0,
       0,   429,   430,   431,     0,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,     0,   453,
     454,     0,   455,   456,     0,   457,     0,   458,   459,   460,
     461,   462,   463,   464,     0,   465,   466,   467,     0,     0,
     468,   469,   470,   471,     0,     0,   472,   473,     0,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,   490,   491,
     492,   493,   494,     0,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,     0,     0,
     571,     0,   572,   573,     0,     0,   574,     0,   575,   576,
     577,   578,   579,     0,   580,   581,     0,     0,   582,   583,
     584,   585,   586,     0,   587,   588,   589,   590,   591,   592,
     593,     0,     0,   594,   595,   596,   597,   598,   599,   600,
       0,     0,   601,   602,   603,   604,   605,   606,   607,     0,
     608,     0,   609,   610,   611,   612,     0,     0,     0,   613,
       0,     0,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,     0,     0,   268,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1499,   269,
     270,   271,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,     0,     0,     0,     0,     0,     0,   281,   282,
       0,   283,   284,   285,     0,     0,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,     0,   297,
     298,   299,   300,   301,     0,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,     0,     0,
       0,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,   328,     0,
       0,   329,   330,   331,     0,     0,     0,     0,     0,     0,
       0,   332,   333,   334,   335,   336,     0,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
       0,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     380,   381,   382,   383,     0,   384,     0,   385,     0,     0,
       0,   386,   387,   388,   389,     0,   390,   391,     0,   392,
     393,   394,     0,   395,   396,   397,   398,   399,     0,   400,
     401,   402,   403,     0,   404,   405,   406,   407,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
       0,   418,     0,   419,     0,     0,   420,     0,   421,   422,
     423,   424,   425,     0,     0,   426,   427,     0,   428,     0,
       0,   429,   430,   431,     0,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,     0,   453,
     454,     0,   455,   456,     0,   457,     0,   458,   459,   460,
     461,   462,   463,   464,     0,   465,   466,   467,     0,     0,
     468,   469,   470,   471,     0,     0,   472,   473,     0,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,   490,   491,
     492,   493,   494,     0,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,     0,     0,
     571,     0,   572,   573,     0,     0,   574,     0,   575,   576,
     577,   578,   579,     0,   580,   581,     0,     0,   582,   583,
     584,   585,   586,     0,   587,   588,   589,   590,   591,   592,
     593,     0,     0,   594,   595,   596,   597,   598,   599,   600,
       0,     0,   601,   602,   603,   604,   605,   606,   607,     0,
     608,     0,   609,   610,   611,   612,     0,     0,     0,   613,
       0,     0,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,     0,     0,   268,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3273,   269,
     270,   271,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,     0,     0,     0,     0,     0,     0,   281,   282,
       0,   283,   284,   285,     0,     0,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,     0,   297,
     298,   299,   300,   301,     0,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,     0,     0,
       0,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,   328,     0,
       0,   329,   330,   331,     0,     0,     0,     0,     0,     0,
       0,   332,   333,   334,   335,   336,     0,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
       0,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     380,   381,   382,   383,     0,   384,     0,   385,     0,     0,
       0,   386,   387,   388,   389,     0,   390,   391,     0,   392,
     393,   394,     0,   395,   396,   397,   398,   399,     0,   400,
     401,   402,   403,     0,   404,   405,   406,   407,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
       0,   418,     0,   419,     0,     0,   420,     0,   421,   422,
     423,   424,   425,     0,     0,   426,   427,     0,   428,     0,
       0,   429,   430,   431,     0,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,     0,   453,
     454,     0,   455,   456,     0,   457,     0,   458,   459,   460,
     461,   462,   463,   464,     0,   465,   466,   467,     0,     0,
     468,   469,   470,   471,     0,     0,   472,   473,     0,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,   490,   491,
     492,   493,   494,     0,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,     0,     0,
     571,     0,   572,   573,     0,     0,   574,     0,   575,   576,
     577,   578,   579,     0,   580,   581,     0,     0,   582,   583,
     584,   585,   586,     0,   587,   588,   589,   590,   591,   592,
     593,     0,     0,   594,   595,   596,   597,   598,   599,   600,
       0,     0,   601,   602,   603,   604,   605,   606,   607,     0,
     608,     0,   609,   610,   611,   612,     0,     0,     0,   613,
       0,     0,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,     0,     0,   268,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4507,   269,
     270,   271,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,     0,     0,     0,     0,     0,     0,   281,   282,
       0,   283,   284,   285,     0,     0,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,     0,   297,
     298,   299,   300,   301,     0,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,     0,     0,
       0,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,   328,     0,
       0,   329,   330,   331,     0,     0,     0,     0,     0,     0,
       0,   332,   333,   334,   335,   336,     0,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
       0,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     380,   381,   382,   383,     0,   384,     0,   385,     0,     0,
       0,   386,   387,   388,   389,     0,   390,   391,     0,   392,
     393,   394,     0,   395,   396,   397,   398,   399,     0,   400,
     401,   402,   403,     0,   404,   405,   406,   407,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
       0,   418,     0,   419,     0,     0,   420,     0,   421,   422,
     423,   424,   425,     0,     0,   426,   427,     0,   428,     0,
       0,   429,   430,   431,     0,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,     0,   453,
     454,     0,   455,   456,     0,   457,     0,   458,   459,   460,
     461,   462,   463,   464,     0,   465,   466,   467,     0,     0,
     468,   469,   470,   471,     0,     0,   472,   473,     0,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,   490,   491,
     492,   493,   494,     0,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,     0,     0,
     571,     0,   572,   573,     0,     0,   574,     0,   575,   576,
     577,   578,   579,     0,   580,   581,     0,     0,   582,   583,
     584,   585,   586,     0,   587,   588,   589,   590,   591,   592,
     593,     0,     0,   594,   595,   596,   597,   598,   599,   600,
       0,     0,   601,   602,   603,   604,   605,   606,   607,     0,
     608,     0,   609,   610,   611,   612,     0,     0,     0,   613,
       0,     0,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,     0,     0,     0,     0,     0,  1197,  1740,   700,
       0,     0,  1004,   766,     0,     0,     0,     0,  4981,  1005,
    1006,  1007,   269,   270,   271,   272,   273,   274,   275,   276,
    2154,   278,   279,   280,  2155,  2156,  2157,  2158,  2159,  2160,
    2161,   281,   282,  2162,   283,   284,   285,  2163,   939,   286,
     287,   288,   289,   290,     0,  1198,   940,  1199,  1200,  1201,
    1202,  2164,   297,   298,   299,   300,   301,  2165,  2166,   302,
     303,  1203,  1204,   306,  2167,   307,   308,   309,   310,   311,
       0,  2168,   941,  2169,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,  2170,   322,   323,   324,   325,   326,
     327,   328,  2171,   943,   329,   330,   331,  2172,  2173,  2174,
     944,  2175,  2176,  2177,   332,   333,   334,   335,   336,  2178,
     337,  1205,  1206,   340,  2179,   341,  2180,   342,   343,   344,
     345,   346,   347,  2181,   348,   349,   350,   351,   352,  2182,
     353,   354,   355,   356,  2183,   357,   358,  1207,   360,   361,
    2184,   362,   363,   364,  2185,   365,   366,   367,  2186,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
    2187,   379,  2188,   380,   381,  1208,   383,  2189,   384,  2190,
     385,   945,  2191,   946,   386,   387,   388,   389,  2192,   390,
       0,  2193,     0,   393,   394,  2194,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,  2195,   404,   405,   406,
     407,   408,   409,  2196,   410,   948,     0,   412,   413,   414,
     415,  1210,  1211,  2197,  1212,  2198,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,  2199,  2200,   426,     0,
     952,   428,   953,  2201,   429,   430,   431,  2202,  2203,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1213,   954,  1214,   450,   451,
     452,  2204,   453,  4248,  2205,   455,   456,   955,   457,  2206,
       0,   459,  1215,  1216,   462,   463,   464,  2207,   465,   466,
     467,  2208,  2209,   468,  4249,   470,   471,  2210,  2211,   472,
       0,   956,   474,   957,     0,   476,   477,   478,   479,   480,
     481,  2212,   482,   483,   484,   485,  2213,   486,   487,     0,
     489,     0,   491,   492,   493,   494,  2214,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1217,   507,
     508,   509,   510,   511,  2215,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,  2216,   524,   525,
     958,   526,   527,   528,   529,     0,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,  2217,   541,   542,   543,
     544,   545,  2218,  2219,   546,   547,  2458,   549,   550,   551,
     959,   552,   553,   554,  1219,   556,  2220,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
       0,  2221,  2222,   571,  2223,   572,   573,  2224,  2225,   574,
     960,   575,   576,   577,   578,   579,  2226,  1220,  1221,  2227,
    2228,   582,   583,     0,   585,     0,  2229,   587,   588,   589,
     590,   591,   592,   593,  2230,  2231,   594,   595,   596,   597,
     598,   599,   600,  2232,  2233,   601,   602,   603,   604,   605,
       0,  1222,  2234,   608,   961,   609,   610,   611,   612,  2235,
    2236,  2237,   613,  2238,  2239,   614,   615,   616,   617,   618,
     619,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   631,   632,   633,     0,     0,     0,  1010,  1011,
    1012,     0,  4250,  4251,  1015,  1016,  1017,  1018,  1197,  1740,
     700,     0,     0,  1004,   766,     0,     0,     0,     0,     0,
    1005,  1006,  1007,   269,   270,   271,   272,   273,   274,   275,
     276,  2154,   278,   279,   280,  2155,  2156,  2157,  2158,  2159,
    2160,  2161,   281,   282,  2162,   283,   284,   285,  2163,   939,
     286,   287,   288,   289,   290,     0,  1198,   940,  1199,  1200,
    1201,  1202,  2164,   297,   298,   299,   300,   301,  2165,  2166,
     302,   303,  1203,  1204,   306,  2167,   307,   308,   309,   310,
     311,     0,  2168,   941,  2169,   313,   314,   315,   316,   317,
     318,   942,   319,   320,   321,  2170,   322,   323,   324,   325,
     326,   327,   328,  2171,   943,   329,   330,   331,  2172,  2173,
    2174,   944,  2175,  2176,  2177,   332,   333,   334,   335,   336,
    2178,   337,  1205,  1206,   340,  2179,   341,  2180,   342,   343,
     344,   345,   346,   347,  2181,   348,   349,   350,   351,   352,
    2182,   353,   354,   355,   356,  2183,   357,   358,  1207,   360,
     361,  2184,   362,   363,   364,  2185,   365,   366,   367,  2186,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,  2187,   379,  2188,   380,   381,  1208,   383,  2189,   384,
    2190,   385,   945,  2191,   946,   386,   387,   388,   389,  2192,
     390,     0,  2193,     0,   393,   394,  2194,   395,   396,   397,
     398,   399,   947,   400,   401,   402,   403,  2195,   404,   405,
     406,   407,   408,   409,  2196,   410,   948,     0,   412,   413,
     414,   415,  1210,  1211,  2197,  1212,  2198,   419,   949,   950,
     420,   951,   421,   422,   423,   424,   425,  2199,  2200,   426,
       0,   952,   428,   953,  2201,   429,   430,   431,  2202,  2203,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,  1213,   954,  1214,   450,
     451,   452,  2204,   453,  4703,  2205,   455,   456,   955,   457,
    2206,     0,   459,  1215,  1216,   462,   463,   464,  2207,   465,
     466,   467,  2208,  2209,   468,  4249,   470,   471,  2210,  2211,
     472,     0,   956,   474,   957,     0,   476,   477,   478,   479,
     480,   481,  2212,   482,   483,   484,   485,  2213,   486,   487,
       0,   489,     0,   491,   492,   493,   494,  2214,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,  1217,
     507,   508,   509,   510,   511,  2215,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,  2216,   524,
     525,   958,   526,   527,   528,   529,     0,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,  2217,   541,   542,
     543,   544,   545,  2218,  2219,   546,   547,  2458,   549,   550,
     551,   959,   552,   553,   554,  1219,   556,  2220,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,     0,  2221,  2222,   571,  2223,   572,   573,  2224,  2225,
     574,   960,   575,   576,   577,   578,   579,  2226,  1220,  1221,
    2227,  2228,   582,   583,     0,   585,     0,  2229,   587,   588,
     589,   590,   591,   592,   593,  2230,  2231,   594,   595,   596,
     597,   598,   599,   600,  2232,  2233,   601,   602,   603,   604,
     605,     0,  1222,  2234,   608,   961,   609,   610,   611,   612,
    2235,  2236,  2237,   613,  2238,  2239,   614,   615,   616,   617,
     618,   619,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   631,   632,   633,     0,   268,     0,  1010,
    1011,  1012,  1004,  4250,  4251,  1015,  1016,  1017,  1018,  1005,
    1006,  1007,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,  1008,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,  1009,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,     0,   268,     0,  1010,  1011,
    1012,  1004,  1013,  1014,  1015,  1016,  1017,  1018,  1005,  1006,
    1007,   269,   270,   271,   272,   273,   274,   275,   276,     0,
     278,   279,   280,     0,     0,     0,     0,     0,     0,     0,
     281,   282,     0,   283,   284,   285,     0,     0,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
       0,   297,   298,   299,   300,   301,     0,     0,   302,   303,
     304,   305,   306,     0,   307,  1146,   309,   310,   311,   312,
       0,     0,     0,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
     328,     0,     0,   329,   330,   331,     0,     0,     0,     0,
       0,     0,     0,   332,   333,   334,   335,   336,     0,   337,
     338,   339,   340,     0,   341,     0,   342,   343,   344,   345,
     346,   347,     0,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
    1147,     0,   380,   381,   382,   383,     0,   384,     0,   385,
       0,     0,     0,   386,   387,   388,   389,     0,   390,   391,
       0,   392,   393,   394,     0,   395,   396,   397,   398,   399,
       0,   400,   401,   402,   403,     0,   404,   405,   406,   407,
     408,   409,     0,   410,     0,   411,   412,   413,   414,   415,
     416,   417,     0,   418,     0,   419,     0,     0,   420,     0,
     421,   422,   423,   424,   425,     0,     0,   426,   427,     0,
     428,     0,     0,   429,   430,   431,     0,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
       0,   453,   454,     0,   455,   456,     0,   457,     0,   458,
     459,   460,   461,   462,   463,   464,     0,   465,   466,   467,
       0,     0,   468,   469,   470,   471,     0,     0,   472,   473,
       0,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
     490,   491,   492,   493,   494,     0,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   524,   525,     0,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
       0,     0,   571,     0,   572,   573,     0,     0,   574,     0,
     575,   576,   577,   578,   579,     0,   580,   581,     0,     0,
     582,   583,   584,   585,   586,     0,   587,   588,   589,   590,
     591,   592,   593,     0,     0,   594,   595,   596,   597,   598,
     599,   600,     0,     0,   601,   602,   603,   604,   605,   606,
     607,     0,   608,     0,   609,   610,   611,   612,     0,     0,
       0,   613,     0,     0,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,     0,   268,     0,  1010,  1011,  1012,
    1004,  1013,  1014,  1015,  1016,  1017,  1018,  1005,  1006,  1007,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,  1254,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,  1255,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,  1256,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,     0,   268,     0,  1010,  1011,  1012,  1004,
    1013,  1014,  1015,  1016,  1017,  1018,  1005,  1006,  1007,   269,
     270,   271,   272,   273,   274,   275,   276,     0,   278,   279,
     280,     0,     0,     0,     0,     0,     0,     0,   281,   282,
       0,   283,   284,   285,     0,     0,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,     0,   297,
     298,   299,   300,   301,     0,     0,   302,   303,   304,   305,
     306,     0,   307,  1875,   309,   310,   311,   312,     0,     0,
       0,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,   328,     0,
       0,   329,   330,   331,     0,     0,     0,     0,     0,     0,
       0,   332,   333,   334,   335,   336,     0,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
       0,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,  1876,     0,
     380,   381,   382,   383,     0,   384,     0,   385,     0,     0,
       0,   386,   387,   388,   389,     0,   390,   391,     0,   392,
     393,   394,     0,   395,   396,   397,   398,   399,     0,   400,
     401,   402,   403,     0,   404,   405,   406,   407,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
       0,   418,     0,   419,     0,     0,   420,     0,   421,   422,
     423,   424,   425,     0,     0,   426,   427,     0,   428,     0,
       0,   429,   430,   431,     0,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,     0,   453,
     454,     0,   455,   456,     0,   457,     0,   458,   459,   460,
     461,   462,   463,   464,     0,   465,   466,   467,     0,     0,
     468,   469,   470,   471,     0,     0,   472,   473,     0,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,   490,   491,
     492,   493,   494,     0,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,     0,     0,
     571,     0,   572,   573,     0,     0,   574,     0,   575,   576,
     577,   578,   579,     0,   580,   581,     0,     0,   582,   583,
     584,   585,   586,     0,   587,   588,   589,   590,   591,   592,
     593,     0,     0,   594,   595,   596,   597,   598,   599,   600,
       0,     0,   601,   602,   603,   604,   605,   606,   607,     0,
     608,     0,   609,   610,   611,   612,     0,     0,     0,   613,
       0,     0,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,     0,   268,     0,  1010,  1011,  1012,  1004,  1013,
    1014,  1015,  1016,  1017,  1018,  1005,  1006,  1007,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,     0,   268,     0,  1010,  1011,  1012,  1004,  1013,  1014,
    1015,  1016,  1017,  1018,  1005,  1006,  1007,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,   279,   280,     0,
       0,     0,     0,     0,     0,     0,   281,   282,     0,   283,
     284,   285,     0,     0,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,     0,   297,   298,   299,
     300,   301,     0,     0,   302,   303,   304,   305,   306,     0,
     307,  3353,   309,   310,   311,   312,     0,     0,     0,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,   328,     0,     0,   329,
     330,   331,     0,     0,     0,     0,     0,     0,     0,   332,
     333,   334,   335,   336,     0,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,     0,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,  3354,     0,   380,   381,
     382,   383,     0,   384,     0,   385,     0,     0,     0,   386,
     387,   388,   389,     0,   390,   391,     0,   392,   393,   394,
       0,   395,   396,   397,   398,   399,     0,   400,   401,   402,
     403,     0,   404,   405,   406,   407,   408,   409,     0,   410,
       0,   411,   412,   413,   414,   415,   416,   417,     0,   418,
       0,   419,     0,     0,   420,     0,   421,   422,   423,   424,
     425,     0,     0,   426,   427,     0,   428,     0,     0,   429,
     430,   431,     0,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,     0,   453,   454,     0,
     455,   456,     0,   457,     0,   458,   459,   460,   461,   462,
     463,   464,     0,   465,   466,   467,     0,     0,   468,   469,
     470,   471,     0,     0,   472,   473,     0,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,   490,   491,   492,   493,
     494,     0,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,   524,   525,     0,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,     0,     0,   571,     0,
     572,   573,     0,     0,   574,     0,   575,   576,   577,   578,
     579,     0,   580,   581,     0,     0,   582,   583,   584,   585,
     586,     0,   587,   588,   589,   590,   591,   592,   593,     0,
       0,   594,   595,   596,   597,   598,   599,   600,     0,     0,
     601,   602,   603,   604,   605,   606,   607,     0,   608,     0,
     609,   610,   611,   612,     0,     0,     0,   613,     0,     0,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
       0,   268,     0,  1010,  1011,  1012,  1004,  1013,  1014,  1015,
    1016,  1017,  1018,  1005,  1006,  1007,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,  5297,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,  2153,
       0,     0,  1010,  1011,  1012,     0,  1013,  1014,  1015,  1016,
    1017,  1018,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,  2154,   278,   279,   280,  2155,  2156,  2157,  2158,
    2159,  2160,  2161,   281,   282,  2162,   283,   284,   285,  2163,
     939,   286,   287,   288,   289,   290,   291,   292,   940,   293,
     294,   295,   296,  2164,   297,   298,   299,   300,   301,  2165,
    2166,   302,   303,   304,   305,   306,  2167,   307,   308,   309,
     310,   311,   312,  2168,   941,  2169,   313,   314,   315,   316,
     317,   318,   942,   319,   320,   321,  2170,   322,   323,   324,
     325,   326,   327,   328,  2171,   943,   329,   330,   331,  2172,
    2173,  2174,   944,  2175,  2176,  2177,   332,   333,   334,   335,
     336,  2178,   337,   338,   339,   340,  2179,   341,  2180,   342,
     343,   344,   345,   346,   347,  2181,   348,   349,   350,   351,
     352,  2182,   353,   354,   355,   356,  2183,   357,   358,   359,
     360,   361,  2184,   362,   363,   364,  2185,   365,   366,   367,
    2186,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,  2187,   379,  2188,   380,   381,   382,   383,  2189,
     384,  2190,   385,   945,  2191,   946,   386,   387,   388,   389,
    2192,   390,   391,  2193,   392,   393,   394,  2194,   395,   396,
     397,   398,   399,   947,   400,   401,   402,   403,  2195,   404,
     405,   406,   407,   408,   409,  2196,   410,   948,   411,   412,
     413,   414,   415,   416,   417,  2197,   418,  2198,   419,   949,
     950,   420,   951,   421,   422,   423,   424,   425,  2199,  2200,
     426,   427,   952,   428,   953,  2201,   429,   430,   431,  2202,
    2203,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   954,   449,
     450,   451,   452,  2204,   453,   454,  2205,   455,   456,   955,
     457,  2206,   458,   459,   460,   461,   462,   463,   464,  2207,
     465,   466,   467,  2208,  2209,   468,   469,   470,   471,  2210,
    2211,   472,   473,   956,   474,   957,   475,   476,   477,   478,
     479,   480,   481,  2212,   482,   483,   484,   485,  2213,   486,
     487,   488,   489,   490,   491,   492,   493,   494,  2214,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,  2215,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,  2216,
     524,   525,   958,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,  2217,   541,
     542,   543,   544,   545,  2218,  2219,   546,   547,   548,   549,
     550,   551,   959,   552,   553,   554,   555,   556,  2220,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,  2221,  2222,   571,  2223,   572,   573,  2224,
    2225,   574,   960,   575,   576,   577,   578,   579,  2226,   580,
     581,  2227,  2228,   582,   583,   584,   585,   586,  2229,   587,
     588,   589,   590,   591,   592,   593,  2230,  2231,   594,   595,
     596,   597,   598,   599,   600,  2232,  2233,   601,   602,   603,
     604,   605,   606,   607,  2234,   608,   961,   609,   610,   611,
     612,  2235,  2236,  2237,   613,  2238,  2239,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,  2240,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,   867,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,  5708,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,   939,   286,   287,   288,   289,   290,
       0,  1198,   940,  1199,  1200,  1201,  1202,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,  1203,  1204,   306,
       0,   307,   308,   309,   310,   311,     0,     0,   941,     0,
     313,   314,   315,   316,   317,   318,   942,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,   943,
     329,   330,   331,     0,     0,     0,   944,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,  1205,  1206,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,  1207,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,     0,   379,     0,   380,
     381,  1208,   383,     0,   384,     0,   385,   945,     0,   946,
     386,   387,   388,   389,     0,   390,     0,     0,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   947,   400,   401,
     402,   403,  2454,   404,   405,   406,   407,   408,   409,     0,
     410,   948,  2455,   412,   413,   414,   415,  1210,  1211,     0,
    1212,     0,   419,   949,   950,   420,   951,   421,   422,   423,
     424,   425,     0,     0,   426,     0,   952,   428,   953,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,  1213,   954,  1214,   450,   451,   452,     0,   453,     0,
       0,   455,   456,   955,   457,     0,     0,   459,  1215,  1216,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,  2456,   472,  2457,   956,   474,   957,
       0,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,     0,   489,     0,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,  1217,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   958,   526,   527,   528,
     529,     0,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,  2458,   549,   550,   551,   959,   552,   553,   554,
    1219,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,     0,     0,     0,   571,
       0,   572,   573,     0,     0,   574,   960,   575,   576,   577,
     578,   579,     0,  1220,  1221,     0,     0,   582,   583,     0,
     585,     0,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,     0,  1222,  2459,   608,
     961,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,  2792,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   631,   632,
     633,     0,   269,   270,   271,   272,   273,   274,   275,   276,
    2460,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,     0,  1198,   940,  1199,  1200,  1201,
    1202,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,  1203,  1204,   306,     0,   307,   308,   309,   310,   311,
       0,     0,   941,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,     0,     0,     0,
     944,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,  1205,  1206,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
       0,   379,     0,   380,   381,  1208,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
       0,     0,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,  2454,   404,   405,   406,
     407,   408,   409,     0,   410,   948,  2455,   412,   413,   414,
     415,  1210,  1211,     0,  1212,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,     0,
     952,   428,   953,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1213,   954,  1214,   450,   451,
     452,     0,   453,     0,     0,   455,   456,   955,   457,     0,
       0,   459,  1215,  1216,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,  2456,   472,
    2457,   956,   474,   957,     0,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,     0,
     489,     0,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1217,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,     0,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,  2458,   549,   550,   551,
     959,   552,   553,   554,  1219,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
       0,     0,     0,   571,     0,   572,   573,     0,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1220,  1221,     0,
       0,   582,   583,     0,   585,     0,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
       0,  1222,  2459,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   985,  1740,   700,     0,     0,     0,   766,     0,     0,
       0,     0,   631,   632,   633,     0,   269,   270,   271,   272,
     273,   274,   275,   276,  2460,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,   291,   292,
     940,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,   941,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,     0,     0,     0,   944,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,  2361,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,  2080,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,   427,   952,   428,   953,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     954,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,   955,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,  2081,     0,   468,   469,   470,
     471,     0,     0,   472,   473,   956,   474,   957,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,   959,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,   960,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
    2082,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   985,
    1740,   700,     0,     0,     0,   766,  1741,  1742,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
     939,   286,   287,   288,   289,   290,   291,   292,   940,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,   941,     0,   313,   314,   315,   316,
     317,   318,   942,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,   943,   329,   330,   331,     0,
       0,     0,   944,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,  2366,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,  2080,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,   945,     0,   946,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   947,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,   948,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,   949,
     950,   420,   951,   421,   422,   423,   424,   425,     0,     0,
     426,   427,   952,   428,   953,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   954,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,   955,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,  2081,     0,   468,   469,   470,   471,     0,
       0,   472,   473,   956,   474,   957,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   958,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,   959,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,   960,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,  2082,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,   961,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   985,  1740,   700,
       0,     0,     0,   766,  1741,  1742,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,   292,   940,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,   941,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,     0,     0,     0,
     944,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
    2080,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,   427,
     952,   428,   953,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   954,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,   955,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,  2081,     0,   468,   469,   470,   471,     0,     0,   472,
     473,   956,   474,   957,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
     960,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,  2082,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   985,     0,   700,     0,     0,
       0,   766,  1741,  1742,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,   939,   286,   287,   288,
     289,   290,   291,   292,   940,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
     941,     0,   313,   314,   315,   316,   317,   318,   942,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,   943,   329,   330,   331,     0,     0,     0,   944,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,  3307,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,  2080,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,   945,
       0,   946,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   947,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,   948,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,   949,   950,   420,   951,   421,
     422,   423,   424,   425,     0,     0,   426,   427,   952,   428,
     953,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   954,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,   955,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,  2081,
       0,   468,   469,   470,   471,     0,     0,   472,   473,   956,
     474,   957,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   958,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,   959,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,   960,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,  2082,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,   961,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,   766,
     778,   779,     0,     0,     0,     0,     0,     0,   269,   767,
     271,   272,   273,   274,   275,   276,   768,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   769,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   799,   376,   377,   378,     0,   379,     0,   380,
     770,   382,   383,     0,   384,     0,   771,     0,   772,     0,
     386,   387,   388,   389,     0,   390,   391,   800,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,   773,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   774,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   775,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   776,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   777,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,   766,   778,   779,
       0,     0,     0,     0,     0,     0,   269,   767,   271,   272,
     273,   274,   275,   276,   768,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   769,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   770,   382,
     383,     0,   384,     0,   771,     0,   772,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
     773,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   774,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   775,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   776,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   777,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,  2153,
    5913,   700,     0,     0,     0,   766,   778,   779,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,  2154,   278,   279,   280,  2155,  2156,  2157,  2158,
    2159,  2160,  2161,   281,   282,  2162,   283,   284,   285,  2163,
     939,   286,   287,   288,   289,   290,   291,   292,   940,   293,
     294,   295,   296,  2164,   297,   298,   299,   300,   301,  2165,
    2166,   302,   303,   304,   305,   306,  2167,   307,   308,   309,
     310,   311,   312,  2168,   941,  2169,   313,   314,   315,   316,
     317,   318,   942,   319,   320,   321,  2170,   322,   323,   324,
     325,   326,   327,   328,  2171,   943,   329,   330,   331,  2172,
    2173,  2174,   944,  2175,  2176,  2177,   332,   333,   334,   335,
     336,  2178,   337,   338,   339,   340,  2179,   341,  2180,   342,
     343,   344,   345,   346,   347,  2181,   348,   349,   350,   351,
     352,  2182,   353,   354,   355,   356,  2183,   357,   358,   359,
     360,   361,  2184,   362,   363,   364,  2185,   365,   366,   367,
    2186,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,  2187,   379,  2188,   380,   381,   382,   383,  2189,
     384,  2190,   385,   945,  2191,   946,   386,   387,   388,   389,
    2192,   390,   391,  2193,   392,   393,   394,  2194,   395,   396,
     397,   398,   399,   947,   400,   401,   402,   403,  2195,   404,
     405,   406,   407,   408,   409,  2196,   410,   948,   411,   412,
     413,   414,   415,   416,   417,  2197,   418,  2198,   419,   949,
     950,   420,   951,   421,   422,   423,   424,   425,  2199,  2200,
     426,   427,   952,   428,   953,  2201,   429,   430,   431,  2202,
    2203,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   954,   449,
     450,   451,   452,  2204,   453,   454,  2205,   455,   456,   955,
     457,  2206,   458,   459,   460,   461,   462,   463,   464,  2207,
     465,   466,   467,  2208,  2209,   468,   469,   470,   471,  2210,
    2211,   472,   473,   956,   474,   957,   475,   476,   477,   478,
     479,   480,   481,  2212,   482,   483,   484,   485,  2213,   486,
     487,   488,   489,   490,   491,   492,   493,   494,  2214,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,  2215,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,  2216,
     524,   525,   958,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,  2217,   541,
     542,   543,   544,   545,  2218,  2219,   546,   547,   548,   549,
     550,   551,   959,   552,   553,   554,   555,   556,  2220,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,  2221,  2222,   571,  2223,   572,   573,  2224,
    2225,   574,   960,   575,   576,   577,   578,   579,  2226,   580,
     581,  2227,  2228,   582,   583,   584,   585,   586,  2229,   587,
     588,   589,   590,   591,   592,   593,  2230,  2231,   594,   595,
     596,   597,   598,   599,   600,  2232,  2233,   601,   602,   603,
     604,   605,   606,   607,  2234,   608,   961,   609,   610,   611,
     612,  2235,  2236,  2237,   613,  2238,  2239,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,  2153,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
    2154,   278,   279,   280,  2155,  2156,  2157,  2158,  2159,  2160,
    2161,   281,   282,  2162,   283,   284,   285,  2163,   939,   286,
     287,   288,   289,   290,   291,   292,   940,   293,   294,   295,
     296,  2164,   297,   298,   299,   300,   301,  2165,  2166,   302,
     303,   304,   305,   306,  2167,   307,   308,   309,   310,   311,
     312,  2168,   941,  2169,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,  2170,   322,   323,   324,   325,   326,
     327,   328,  2171,   943,   329,   330,   331,  2172,  2173,  2174,
     944,  2175,  2176,  2177,   332,   333,   334,   335,   336,  2178,
     337,   338,   339,   340,  2179,   341,  2180,   342,   343,   344,
     345,   346,   347,  2181,   348,   349,   350,   351,   352,  2182,
     353,   354,   355,   356,  2183,   357,   358,   359,   360,   361,
    2184,   362,   363,   364,  2185,   365,   366,   367,  2186,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
    2187,   379,  2188,   380,   381,   382,   383,  2189,   384,  2190,
     385,   945,  2191,   946,   386,   387,   388,   389,  2192,   390,
     391,  2193,   392,   393,   394,  2194,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,  2195,   404,   405,   406,
     407,   408,   409,  2196,   410,   948,   411,   412,   413,   414,
     415,   416,   417,  2197,   418,  2198,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,  2199,  2200,   426,   427,
     952,   428,   953,  2201,   429,   430,   431,  2202,  2203,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   954,   449,   450,   451,
     452,  2204,   453,   454,  2205,   455,   456,   955,   457,  2206,
     458,   459,   460,   461,   462,   463,   464,  2207,   465,   466,
     467,  2208,  2209,   468,   469,   470,   471,  2210,  2211,   472,
     473,   956,   474,   957,   475,   476,   477,   478,   479,   480,
     481,  2212,   482,   483,   484,   485,  2213,   486,   487,   488,
     489,   490,   491,   492,   493,   494,  2214,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,  2215,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,  2216,   524,   525,
     958,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,  2217,   541,   542,   543,
     544,   545,  2218,  2219,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,   555,   556,  2220,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,  2221,  2222,   571,  2223,   572,   573,  2224,  2225,   574,
     960,   575,   576,   577,   578,   579,  2226,   580,   581,  2227,
    2228,   582,   583,   584,   585,   586,  2229,   587,   588,   589,
     590,   591,   592,   593,  2230,  2231,   594,   595,   596,   597,
     598,   599,   600,  2232,  2233,   601,   602,   603,   604,   605,
     606,   607,  2234,   608,   961,   609,   610,   611,   612,  2235,
    2236,  2237,   613,  2238,  2239,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,  2153,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,  3431,   274,   275,   276,  2154,   278,
     279,   280,  2155,  2156,  2157,  2158,  2159,  2160,  2161,   281,
     282,  2162,   283,   284,   285,  2163,   939,   286,   287,   288,
     289,   290,   291,   292,   940,   293,   294,   295,   296,  2164,
     297,   298,   299,   300,   301,  2165,  2166,   302,   303,   304,
     305,   306,  2167,   307,   308,   309,   310,   311,   312,  2168,
     941,  2169,   313,   314,   315,   316,   317,   318,   942,   319,
     320,   321,  2170,   322,   323,   324,   325,   326,   327,   328,
    2171,   943,   329,   330,   331,  2172,  2173,  2174,   944,  2175,
    2176,  2177,   332,   333,   334,   335,   336,  2178,   337,   338,
     339,   340,  2179,   341,  2180,   342,   343,   344,   345,   346,
     347,  2181,   348,   349,   350,   351,   352,  2182,   353,   354,
     355,   356,  2183,   357,   358,   359,  3432,   361,  2184,   362,
     363,   364,  2185,   365,   366,   367,  2186,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,  2187,   379,
    2188,   380,   381,   382,   383,  2189,   384,  2190,   385,   945,
    2191,   946,   386,   387,   388,   389,  2192,   390,   391,  2193,
     392,   393,   394,  2194,   395,   396,   397,   398,   399,   947,
     400,   401,   402,   403,  2195,   404,   405,   406,   407,   408,
     409,  2196,   410,   948,   411,   412,   413,   414,   415,   416,
     417,  2197,   418,  2198,   419,   949,   950,   420,   951,   421,
     422,   423,   424,   425,  2199,  2200,   426,   427,   952,   428,
     953,  2201,   429,   430,   431,  2202,  2203,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   954,   449,   450,   451,   452,  2204,
     453,   454,  2205,   455,   456,   955,   457,  2206,   458,   459,
     460,   461,   462,   463,   464,  2207,   465,   466,   467,  2208,
    2209,   468,   469,   470,   471,  2210,  2211,   472,   473,   956,
     474,   957,   475,   476,   477,   478,   479,   480,   481,  2212,
     482,   483,   484,   485,  2213,   486,   487,   488,   489,   490,
     491,   492,   493,   494,  2214,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,  2215,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,  2216,   524,   525,   958,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,  2217,   541,   542,   543,   544,   545,
    2218,  2219,  3433,   547,   548,   549,   550,   551,   959,   552,
     553,   554,   555,   556,  2220,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,  2221,
    2222,   571,  2223,   572,   573,  2224,  2225,   574,   960,   575,
     576,   577,   578,   579,  2226,   580,   581,  2227,  2228,   582,
     583,   584,   585,   586,  2229,   587,   588,   589,   590,   591,
     592,   593,  2230,  2231,   594,   595,   596,   597,   598,   599,
     600,  2232,  2233,   601,   602,   603,   604,   605,   606,   607,
    2234,   608,   961,   609,   610,   611,   612,  2235,  2236,  2237,
     613,  2238,  2239,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   938,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,   939,   286,   287,   288,   289,   290,
     291,   292,   940,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,  1375,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,  1378,     0,  1379,     0,
     313,   314,   315,   316,   317,   318,   942,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,   943,
     329,   330,   331,  1380,  1381,  1382,  1383,  1384,  1385,  1386,
     332,   333,   334,   335,   336,  1387,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,  1392,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,   945,     0,   946,
     386,   387,   388,   389,     0,   390,  1395,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   947,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,   948,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,   949,   950,   420,   951,   421,   422,   423,
     424,   425,     0,     0,   426,  1400,   952,   428,   953,     0,
     429,   430,   431,  1401,  1402,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   954,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,   955,   457,     0,  1407,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,   956,   474,   957,
    1411,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,  1412,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   958,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,  1415,  1416,
     546,   547,   548,   549,   550,   551,   959,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,  1418,     0,     0,   571,
    1419,   572,   573,  1420,     0,   574,   960,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,  1423,
     585,  1424,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,  1427,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
     961,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,  1429,  1430,
    1431,  1432,   625,  1433,  1434,  1435,  1436,   630,   631,   632,
     633,   938,  1363,   700,  1364,  1365,     0,   766,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,   291,  1369,
     940,  1370,  1371,  1372,  1373,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,  1376,  1377,   306,     0,   307,
     308,   309,   310,   311,   312,     0,   941,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,     0,     0,     0,   944,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,  1388,  1389,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,  1207,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,  1393,   379,     0,   380,   381,  1394,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
     411,   412,   413,   414,   415,  1397,  1398,     0,  1399,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,   427,   952,   428,   953,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,  1403,
     954,  1404,   450,   451,   452,     0,   453,   454,     0,   455,
     456,   955,   457,  1406,   458,   459,  1408,  1409,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,   956,   474,   957,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,  1413,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,   959,   552,   553,   554,  1417,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,   960,   575,   576,   577,   578,   579,
       0,  1421,  1422,     0,     0,   582,   583,   584,   585,   586,
    1425,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,  1428,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   985,
       0,   700,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
     939,   286,   287,   288,   289,   290,   291,   292,   940,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,   941,     0,   313,   314,   315,   316,
     317,   318,   942,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,   943,   329,   330,   331,     0,
       0,     0,   944,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,  2080,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,   945,     0,   946,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   947,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,   948,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,   949,
     950,   420,   951,   421,   422,   423,   424,   425,     0,     0,
     426,   427,   952,   428,   953,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   954,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,   955,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,  2081,     0,   468,   469,   470,   471,     0,
       0,   472,   473,   956,   474,   957,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   958,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,   959,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,   960,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,  2082,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,   961,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   985,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
    1027,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,   292,   940,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,   941,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,     0,     0,     0,
     944,     0,     0,   986,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,   427,
     952,   428,   953,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   954,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,   955,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,   956,   474,   957,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   987,     0,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
     960,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   985,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,  1047,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,   939,   286,   287,   288,
     289,   290,   291,   292,   940,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
     941,     0,   313,   314,   315,   316,   317,   318,   942,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,   943,   329,   330,   331,     0,     0,     0,   944,     0,
       0,   986,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,   945,
       0,   946,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   947,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,   948,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,   949,   950,   420,   951,   421,
     422,   423,   424,   425,     0,     0,   426,   427,   952,   428,
     953,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,  1048,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   954,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,   955,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,   956,
     474,   957,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   958,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
     987,     0,   546,   547,   548,   549,   550,   551,   959,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,   960,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,   961,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   985,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,   939,   286,   287,   288,   289,   290,
     291,   292,   940,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,   941,     0,
     313,   314,   315,   316,   317,   318,   942,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,   943,
     329,   330,   331,     0,     0,     0,   944,     0,     0,   986,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,   945,     0,   946,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   947,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,   948,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,   949,   950,   420,   951,   421,   422,   423,
     424,   425,     0,     0,   426,   427,   952,   428,   953,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   954,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,   955,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,   956,   474,   957,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   958,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,   987,     0,
     546,   547,   548,   549,   550,   551,   959,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,   960,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,  2737,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
     961,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   985,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,   291,   292,
     940,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,   941,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,     0,     0,     0,   944,     0,     0,   986,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,   391,  3788,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,   427,   952,   428,   953,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     954,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,   955,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,   956,   474,   957,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,   987,     0,   546,   547,
     548,   549,   550,   551,   959,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,   960,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   985,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
     939,   286,   287,   288,   289,   290,   291,   292,   940,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,   941,     0,   313,   314,   315,   316,
     317,   318,   942,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,   943,   329,   330,   331,     0,
       0,     0,   944,     0,     0,   986,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,   945,     0,   946,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   947,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,   948,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,   949,
     950,   420,   951,   421,   422,   423,   424,   425,     0,     0,
     426,   427,   952,   428,   953,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   954,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,   955,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,   956,   474,   957,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   958,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,   987,     0,   546,   547,   548,   549,
     550,   551,   959,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,   960,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,  4762,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,   961,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   985,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,   292,   940,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,   941,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,     0,     0,     0,
     944,     0,     0,   986,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,   427,
     952,   428,   953,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   954,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,   955,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,   956,   474,   957,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   987,     0,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
     960,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   985,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,   939,   286,   287,   288,
     289,   290,   291,   292,   940,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
     941,     0,   313,   314,   315,   316,   317,   318,   942,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,   943,   329,   330,   331,     0,     0,     0,   944,     0,
       0,   986,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,   945,
       0,   946,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   947,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,   948,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,   949,   950,   420,   951,   421,
     422,   423,   424,   425,     0,     0,   426,   427,   952,   428,
     953,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,  1166,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   954,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,   955,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,   956,
     474,   957,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   958,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
     987,     0,   546,   547,   548,   549,   550,   551,   959,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,   960,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,   961,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   985,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,   939,   286,   287,   288,   289,   290,
     291,   292,   940,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,   941,     0,
     313,   314,   315,   316,   317,   318,   942,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,   943,
     329,   330,   331,     0,     0,     0,   944,     0,     0,   986,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,   945,     0,   946,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,  1245,   947,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,   948,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,   949,   950,   420,   951,   421,   422,   423,
     424,   425,     0,     0,   426,   427,   952,   428,   953,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   954,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,   955,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,   956,   474,   957,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   958,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,   987,     0,
     546,   547,   548,   549,   550,   551,   959,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,   960,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
     961,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   985,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,   291,   292,
     940,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,   941,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,     0,     0,     0,   944,     0,     0,   986,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,  1260,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,   427,   952,   428,   953,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     954,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,   955,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,   956,   474,   957,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,   987,     0,   546,   547,
     548,   549,   550,   551,   959,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,   960,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   985,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
     939,   286,   287,   288,   289,   290,   291,   292,   940,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,   941,     0,   313,   314,   315,   316,
     317,   318,   942,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,   943,   329,   330,   331,     0,
       0,     0,   944,     0,     0,   986,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,   945,     0,   946,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,  1271,   947,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,   948,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,   949,
     950,   420,   951,   421,   422,   423,   424,   425,     0,     0,
     426,   427,   952,   428,   953,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,  1272,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   954,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,   955,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,   956,   474,   957,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   958,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,   987,     0,   546,   547,   548,   549,
     550,   551,   959,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,   960,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,   961,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   985,     0,   700,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,   292,   940,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,   941,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,     0,     0,     0,
     944,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,  2346,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,   427,
     952,   428,   953,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   954,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,   955,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,   956,   474,   957,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
     960,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   985,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     3,     4,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,   939,   286,   287,   288,
     289,   290,   291,   292,   940,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
     941,     0,   313,   314,   315,   316,   317,   318,   942,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,   943,   329,   330,   331,     0,     0,     0,   944,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,   945,
       0,   946,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   947,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,   948,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,   949,   950,   420,   951,   421,
     422,   423,   424,   425,     0,     0,   426,   427,   952,   428,
     953,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   954,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,   955,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,   956,
     474,   957,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   958,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,   959,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,   960,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,   961,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   985,     0,   700,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,   939,   286,   287,   288,   289,   290,
     291,   292,   940,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,   941,     0,
     313,   314,   315,   316,   317,   318,   942,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,   943,
     329,   330,   331,     0,     0,     0,   944,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,   945,     0,   946,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   947,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,   948,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,   949,   950,   420,   951,   421,   422,   423,
     424,   425,     0,     0,   426,   427,   952,   428,   953,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   954,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,   955,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,   956,   474,   957,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   958,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,   959,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,   960,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
     961,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   985,     0,   700,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,   291,   292,
     940,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,   941,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,     0,     0,     0,   944,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,  2063,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,   427,   952,   428,   953,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     954,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,   955,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,   956,   474,   957,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,   959,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,   960,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   938,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
     939,   286,   287,   288,   289,   290,   291,   292,   940,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,   941,     0,   313,   314,   315,   316,
     317,   318,   942,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,   943,   329,   330,   331,     0,
       0,     0,   944,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,   945,     0,   946,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   947,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,   948,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,   949,
     950,   420,   951,   421,   422,   423,   424,   425,     0,     0,
     426,   427,   952,   428,   953,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   954,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,   955,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,   956,   474,   957,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   958,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,   959,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,   960,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,   961,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   938,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,   291,   292,   940,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,   941,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,     0,     0,     0,
     944,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
    1188,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,   427,
     952,   428,   953,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   954,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,   955,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,   956,   474,   957,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
     959,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
     960,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   938,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,   939,   286,   287,   288,
     289,   290,   291,   292,   940,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
     941,     0,   313,   314,   315,   316,   317,   318,   942,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,   943,   329,   330,   331,     0,     0,     0,   944,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,   945,
       0,   946,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,  1242,   947,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,   948,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,   949,   950,   420,   951,   421,
     422,   423,   424,   425,     0,     0,   426,   427,   952,   428,
     953,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   954,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,   955,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,   956,
     474,   957,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   958,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,   959,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,   960,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,   961,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   985,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,   939,   286,   287,   288,   289,   290,
     291,   292,   940,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,   941,     0,
     313,   314,   315,   316,   317,   318,   942,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,   943,
     329,   330,   331,     0,     0,     0,   944,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,   945,     0,   946,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   947,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,   948,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,   949,   950,   420,   951,   421,   422,   423,
     424,   425,     0,     0,   426,   427,   952,   428,   953,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   954,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,   955,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,   956,   474,   957,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   958,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,   959,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,   960,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
     961,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,  2496,   307,
     308,   309,   310,   311,   312,     0,     0,  2575,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,  2497,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,  2576,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,  2499,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,  2577,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,  2578,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,  2579,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
    2500,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,  2501,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,  2496,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,  2497,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,  2576,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,  2499,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,  3641,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,  2500,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,  2501,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   829,   275,   276,
     785,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,   786,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,   830,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   787,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   788,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,   785,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
     786,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,  3314,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   787,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   788,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
    2496,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
    2497,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,  2576,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,  2499,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,  2500,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,  2501,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,   785,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,   786,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   787,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     788,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,  2107,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,  2108,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,  2109,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,  2110,   385,     0,     0,     0,  2111,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,  2112,  2113,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,  2114,   536,   537,   538,   539,   540,     0,  2115,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
    2116,   574,     0,  2117,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,  2118,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,   786,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   787,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   788,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,  1040,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,  1041,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
     863,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
    2398,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
    2399,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,  2400,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,  2401,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,  2402,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,  2403,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,  2404,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     3,     4,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,  1528,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,  3406,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,  3407,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
    3424,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,  3425,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,   691,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     692,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,   748,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     749,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,   806,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   807,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
     821,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   822,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   823,   581,     0,
       0,   824,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,   857,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   858,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   859,   581,     0,     0,   860,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,   863,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,   995,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   996,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,  1000,   392,   393,   394,     0,   395,   396,
     397,   398,   399,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,  1143,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,  1180,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,  1251,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,  1474,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
    1485,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   843,   303,   304,   305,  1486,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   846,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   847,   527,   528,   529,   530,   531,   532,
     533,   534,   848,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,  1478,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   850,
     581,     0,     0,   851,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   852,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
    1675,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,   863,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,  1745,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,  1746,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,   821,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,  3184,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
    3185,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,  3186,   574,     0,   575,  3187,   577,  3188,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,  3189,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,  2398,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,   700,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,  4528,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,  4542,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   819,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   843,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   844,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   845,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   846,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   847,   527,   528,   529,   530,   531,   532,   533,   534,
     848,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   849,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   850,   581,     0,
       0,   851,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     852,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     874,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,  1024,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,  1032,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,  1051,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
    1123,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,  1130,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,  1131,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,  1153,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,  1156,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,  1159,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
    1194,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,  1195,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,  1263,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,  1265,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,  1275,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,  1278,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
    1280,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   843,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   846,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   847,
     527,   528,   529,   530,   531,   532,   533,   534,   848,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,  1478,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   850,   581,     0,     0,   851,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   852,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,  1528,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,  1910,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,  1958,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
    1960,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,  1986,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,  2034,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,  2038,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,  2040,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
    2042,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,  2072,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,  2132,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,  2148,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,  2447,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,     0,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   843,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   846,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   847,   527,   528,   529,   530,   531,   532,   533,   534,
     848,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,  1478,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,  2483,   576,   577,   578,   579,     0,   850,   581,     0,
       0,   851,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     852,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   843,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   846,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   847,
     527,   528,   529,   530,   531,   532,   533,   534,  2559,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,  2560,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   850,   581,     0,     0,  2561,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   852,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,  2887,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,  2891,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,  2970,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
    3325,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   843,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   846,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   847,
     527,   528,   529,   530,   531,   532,   533,   534,   848,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,  2560,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   850,   581,     0,     0,  2561,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   852,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,  3392,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,  3414,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,  3416,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
    3563,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,     0,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,     0,
       0,     0,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,     0,   329,   330,   331,     0,     0,     0,     0,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,  3594,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   380,   381,   382,   383,     0,   384,     0,   385,     0,
       0,     0,   386,   387,   388,   389,     0,   390,   391,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,     0,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,     0,   418,     0,   419,     0,     0,   420,     0,   421,
     422,   423,   424,   425,     0,     0,   426,   427,     0,   428,
       0,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,     0,   455,   456,     0,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,   473,     0,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,     0,
       0,   571,     0,   572,   573,     0,     0,   574,     0,   575,
     576,   577,   578,   579,     0,   580,   581,     0,     0,   582,
     583,   584,   585,   586,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,   606,   607,
       0,   608,     0,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,     0,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,     0,
     329,   330,   331,     0,     0,     0,     0,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   380,
     381,   382,   383,     0,   384,     0,   385,     0,     0,     0,
     386,   387,   388,   389,     0,   390,   391,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,     0,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,     0,
     418,     0,   419,     0,     0,   420,     0,   421,   422,   423,
     424,   425,     0,     0,   426,   427,     0,   428,     0,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
       0,   455,   456,     0,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,  3805,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,   473,     0,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,     0,     0,   571,
       0,   572,   573,     0,     0,   574,     0,   575,   576,   577,
     578,   579,     0,   580,   581,     0,     0,   582,   583,   584,
     585,   586,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,   606,   607,     0,   608,
       0,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   268,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,     0,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,     0,   329,   330,
     331,     0,     0,     0,     0,     0,     0,     0,   332,   333,
     334,  4222,   336,     0,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   380,   381,   382,
     383,     0,   384,     0,   385,     0,     0,     0,   386,   387,
     388,   389,     0,   390,   391,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,     0,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,     0,   418,     0,
     419,     0,     0,   420,     0,   421,   422,   423,   424,   425,
       0,     0,   426,   427,     0,   428,     0,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,     0,   453,   454,     0,   455,
     456,     0,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,   473,     0,   474,     0,   475,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,     0,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,     0,     0,   571,     0,   572,
     573,     0,     0,   574,     0,   575,   576,   577,   578,   579,
       0,   580,   581,     0,     0,   582,   583,   584,   585,   586,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,   606,   607,     0,   608,     0,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   380,   381,   382,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,   391,     0,   392,   393,   394,     0,   395,   396,
     397,   398,  4828,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,     0,   418,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,   427,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,     0,   455,   456,     0,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,   473,     0,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,   580,
     581,     0,     0,   582,   583,   584,   585,   586,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,   606,   607,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,     0,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,     0,   329,   330,   331,     0,     0,     0,
       0,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   380,   381,   382,   383,     0,   384,     0,
     385,     0,     0,     0,   386,   387,   388,   389,     0,   390,
     391,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,     0,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   418,     0,   419,     0,     0,   420,
       0,   421,   422,   423,   424,   425,     0,     0,   426,   427,
       0,   428,     0,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,     0,   453,   454,     0,   455,   456,     0,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
     473,     0,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   505,   506,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
       0,   526,   527,   528,   529,   530,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,     0,     0,   571,     0,   572,   573,     0,     0,   574,
       0,   575,   576,   577,   578,   579,     0,   580,   581,     0,
       0,   582,   583,   584,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
     606,   607,     0,   608,     0,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,   939,   286,   287,   288,
     289,   290,     0,  1198,   940,  1199,  1200,  1201,  1202,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,  1203,
    1204,   306,     0,   307,   308,   309,   310,   311,     0,     0,
     941,     0,   313,   314,   315,   316,   317,   318,   942,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,   943,   329,   330,   331,     0,     0,     0,   944,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,  1205,
    1206,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,  1207,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,     0,   379,
       0,   380,   381,  1208,   383,     0,   384,     0,   385,   945,
       0,   946,   386,   387,   388,   389,     0,   390,     0,     0,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   947,
     400,   401,   402,   403,  2454,   404,   405,   406,   407,   408,
     409,     0,   410,   948,  2455,   412,   413,   414,   415,  1210,
    1211,     0,  1212,     0,   419,   949,   950,   420,   951,   421,
     422,   423,   424,   425,     0,     0,   426,     0,   952,   428,
     953,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,  1213,   954,  1214,   450,   451,   452,     0,
     453,     0,     0,   455,   456,   955,   457,     0,     0,   459,
    1215,  1216,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,  2457,   956,
     474,   957,     0,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,     0,   489,     0,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,  1217,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   958,   526,
     527,   528,   529,     0,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,  2458,   549,   550,   551,   959,   552,
     553,   554,  1219,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,     0,     0,
       0,   571,     0,   572,   573,     0,     0,   574,   960,   575,
     576,   577,   578,   579,     0,  1220,  1221,     0,     0,   582,
     583,     0,   585,     0,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,     0,  1222,
    2459,   608,   961,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     631,   632,   633,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
     939,   286,   287,   288,   289,   290,     0,  1198,   940,  1199,
    1200,  1201,  1202,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,  1203,  1204,   306,     0,   307,   308,   309,
     310,   311,     0,     0,   941,     0,   313,   314,   315,   316,
     317,   318,   942,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,   943,   329,   330,   331,     0,
       0,     0,   944,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,  1205,  1206,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,  1207,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,     0,   379,     0,   380,   381,  1208,   383,     0,
     384,     0,   385,   945,     0,   946,   386,   387,   388,   389,
       0,   390,     0,     0,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   947,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,   948,     0,   412,
     413,   414,   415,  1210,  1211,     0,  1212,     0,   419,   949,
     950,   420,   951,   421,   422,   423,   424,   425,     0,     0,
     426,     0,   952,   428,   953,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,  1213,   954,  1214,
     450,   451,   452,     0,   453,     0,     0,   455,   456,   955,
     457,  2555,     0,   459,  1215,  1216,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,     0,   956,   474,   957,     0,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,     0,   489,     0,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
    1217,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   958,   526,   527,   528,   529,     0,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,  2458,   549,
     550,   551,   959,   552,   553,   554,  1219,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,     0,     0,     0,   571,     0,   572,   573,     0,
    4359,   574,   960,   575,   576,   577,   578,   579,     0,  1220,
    1221,     0,     0,   582,   583,     0,   585,     0,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,     0,  1222,     0,   608,   961,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   631,   632,   633,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,   939,   286,   287,   288,   289,   290,
       0,  1198,   940,  1199,  1200,  1201,  1202,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,  1203,  1204,   306,
       0,   307,   308,   309,   310,   311,     0,     0,   941,     0,
     313,   314,   315,   316,   317,   318,   942,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,   943,
     329,   330,   331,     0,     0,     0,   944,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,  1205,  1206,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,  1207,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,     0,   379,     0,   380,
     381,  1208,   383,     0,   384,     0,   385,   945,     0,   946,
     386,   387,   388,   389,     0,   390,     0,     0,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   947,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,   948,     0,   412,   413,   414,   415,  1210,  1211,     0,
    1212,     0,   419,   949,   950,   420,   951,   421,   422,   423,
     424,   425,     0,     0,   426,     0,   952,   428,   953,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,  1213,   954,  1214,   450,   451,   452,     0,   453,  2653,
       0,   455,   456,   955,   457,     0,     0,   459,  1215,  1216,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,     0,   956,   474,   957,
       0,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,     0,   489,     0,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,  1217,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   958,   526,   527,   528,
     529,     0,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,  1218,   549,   550,   551,   959,   552,   553,   554,
    1219,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,     0,     0,     0,   571,
       0,   572,   573,     0,     0,   574,   960,   575,   576,   577,
     578,   579,     0,  1220,  1221,     0,     0,   582,   583,     0,
     585,     0,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,     0,  1222,     0,   608,
     961,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   631,   632,
     633,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,     0,  1198,   940,  1199,  1200,  1201,
    1202,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,  1203,  1204,   306,     0,   307,   308,   309,   310,   311,
       0,     0,   941,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,     0,     0,     0,
     944,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,  1205,  1206,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
       0,   379,     0,   380,   381,  1208,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
       0,     0,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,     0,   412,   413,   414,
     415,  1210,  1211,     0,  1212,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,     0,
     952,   428,   953,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1213,   954,  1214,   450,   451,
     452,     0,   453,  4158,     0,   455,   456,   955,   457,     0,
       0,   459,  1215,  1216,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
       0,   956,   474,   957,     0,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,     0,
     489,     0,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1217,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,     0,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,  1218,   549,   550,   551,
     959,   552,   553,   554,  1219,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
       0,     0,     0,   571,     0,   572,   573,     0,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1220,  1221,     0,
       0,   582,   583,     0,   585,     0,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
       0,  1222,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   631,   632,   633,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,     0,  1198,
     940,  1199,  1200,  1201,  1202,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,  1203,  1204,   306,     0,   307,
     308,   309,   310,   311,     0,     0,   941,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,     0,     0,     0,   944,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,  1205,  1206,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,  1207,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,     0,   379,     0,   380,   381,  1208,
     383,  5776,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,     0,     0,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
       0,   412,   413,   414,   415,  1210,  1211,     0,  1212,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,     0,   952,   428,   953,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,  1213,
     954,  1214,   450,   451,   452,     0,   453,     0,     0,   455,
     456,   955,   457,     0,     0,   459,  1215,  1216,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,     0,   956,   474,   957,     0,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,     0,   489,     0,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,  1217,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,     0,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
    1218,   549,   550,   551,   959,   552,   553,   554,  1219,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,     0,     0,     0,   571,     0,   572,
     573,     0,     0,   574,   960,   575,   576,   577,   578,   579,
       0,  1220,  1221,     0,     0,   582,   583,     0,   585,     0,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,     0,  1222,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   631,   632,   633,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,   939,   286,   287,   288,
     289,   290,     0,  1198,   940,  1199,  1200,  1201,  1202,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,  1203,
    1204,   306,     0,   307,   308,   309,   310,   311,     0,     0,
     941,     0,   313,   314,   315,   316,   317,   318,   942,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,   943,   329,   330,   331,     0,     0,     0,   944,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,  1205,
    1206,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,  1207,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,     0,   379,
       0,   380,   381,  1208,   383,     0,   384,     0,   385,   945,
       0,   946,   386,   387,   388,   389,     0,   390,     0,     0,
       0,   393,   394,     0,   395,   396,   397,   398,  1209,   947,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,   948,     0,   412,   413,   414,   415,  1210,
    1211,     0,  1212,     0,   419,   949,   950,   420,   951,   421,
     422,   423,   424,   425,     0,     0,   426,     0,   952,   428,
     953,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,  1213,   954,  1214,   450,   451,   452,     0,
     453,     0,     0,   455,   456,   955,   457,     0,     0,   459,
    1215,  1216,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,     0,   956,
     474,   957,     0,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,     0,   489,     0,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,  1217,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   958,   526,
     527,   528,   529,     0,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,  1218,   549,   550,   551,   959,   552,
     553,   554,  1219,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,     0,     0,
       0,   571,     0,   572,   573,     0,     0,   574,   960,   575,
     576,   577,   578,   579,     0,  1220,  1221,     0,     0,   582,
     583,     0,   585,     0,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,     0,  1222,
       0,   608,   961,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     631,   632,   633,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
     939,   286,   287,   288,   289,   290,     0,  1198,   940,  1199,
    1200,  1201,  1202,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,  1203,  1204,   306,     0,   307,   308,   309,
     310,   311,     0,     0,   941,     0,   313,   314,   315,   316,
     317,   318,   942,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,   943,   329,   330,   331,     0,
       0,     0,   944,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,  1205,  1206,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,  1207,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,     0,   379,     0,   380,   381,  1208,   383,     0,
     384,     0,   385,   945,     0,   946,   386,   387,   388,   389,
       0,   390,     0,     0,     0,   393,   394,     0,   395,   396,
     397,   398,  1269,   947,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,   948,     0,   412,
     413,   414,   415,  1210,  1211,     0,  1212,     0,   419,   949,
     950,   420,   951,   421,   422,   423,   424,   425,     0,     0,
     426,     0,   952,   428,   953,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,  1213,   954,  1214,
     450,   451,   452,     0,   453,     0,     0,   455,   456,   955,
     457,     0,     0,   459,  1215,  1216,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,     0,   956,   474,   957,     0,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,     0,   489,     0,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
    1217,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,   958,   526,   527,   528,   529,     0,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,  1218,   549,
     550,   551,   959,   552,   553,   554,  1219,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,     0,     0,     0,   571,     0,   572,   573,     0,
       0,   574,   960,   575,   576,   577,   578,   579,     0,  1220,
    1221,     0,     0,   582,   583,     0,   585,     0,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,     0,  1222,     0,   608,   961,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   631,   632,   633,     0,   269,   270,
     271,   272,   273,   274,   275,   276,     0,   278,   279,   280,
       0,     0,     0,     0,     0,     0,     0,   281,   282,     0,
     283,   284,   285,     0,   939,   286,   287,   288,   289,   290,
       0,  1198,   940,  1199,  1200,  1201,  1202,     0,   297,   298,
     299,   300,   301,     0,     0,   302,   303,  1203,  1204,   306,
       0,   307,   308,   309,   310,   311,     0,     0,   941,     0,
     313,   314,   315,   316,   317,   318,   942,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,   328,     0,   943,
     329,   330,   331,     0,     0,     0,   944,     0,     0,     0,
     332,   333,   334,   335,   336,     0,   337,  1205,  1206,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,     0,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,  1207,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,     0,   379,     0,   380,
     381,  1208,   383,     0,   384,     0,   385,   945,     0,   946,
     386,   387,   388,   389,     0,   390,     0,     0,     0,   393,
     394,     0,   395,   396,   397,   398,   399,   947,   400,   401,
     402,   403,     0,   404,   405,   406,   407,   408,   409,     0,
     410,   948,     0,   412,   413,   414,   415,  1210,  1211,     0,
    1212,     0,   419,   949,   950,   420,   951,   421,   422,   423,
     424,   425,     0,     0,   426,     0,   952,   428,   953,     0,
     429,   430,   431,     0,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,  1213,   954,  1214,   450,   451,   452,     0,   453,     0,
       0,   455,   456,   955,   457,     0,     0,   459,  1215,  1216,
     462,   463,   464,     0,   465,   466,   467,     0,     0,   468,
     469,   470,   471,     0,     0,   472,     0,   956,   474,   957,
       0,   476,   477,   478,   479,   480,   481,     0,   482,   483,
     484,   485,     0,   486,   487,     0,   489,     0,   491,   492,
     493,   494,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,  1217,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,   524,   525,   958,   526,   527,   528,
     529,     0,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   547,  1218,   549,   550,   551,   959,   552,   553,   554,
    1219,   556,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,     0,     0,     0,   571,
       0,   572,   573,     0,     0,   574,   960,   575,   576,   577,
     578,   579,     0,  1220,  1221,     0,     0,   582,   583,     0,
     585,     0,     0,   587,   588,   589,   590,   591,   592,   593,
       0,     0,   594,   595,   596,   597,   598,   599,   600,     0,
       0,   601,   602,   603,   604,   605,     0,  1222,     0,   608,
     961,   609,   610,   611,   612,     0,     0,     0,   613,     0,
       0,   614,   615,   616,   617,   618,   619,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   631,   632,
     633,     0,   269,   270,   271,   272,   273,   274,   275,   276,
       0,   278,   279,   280,     0,     0,     0,     0,     0,     0,
       0,   281,   282,     0,   283,   284,   285,     0,   939,   286,
     287,   288,   289,   290,     0,  1198,   940,  1199,  1200,  1201,
    1202,     0,   297,   298,   299,   300,   301,     0,     0,   302,
     303,  1203,  1204,   306,     0,   307,   308,   309,   310,   311,
       0,     0,   941,     0,   313,   314,   315,   316,   317,   318,
     942,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,   328,     0,   943,   329,   330,   331,     0,     0,     0,
     944,     0,     0,     0,   332,   333,   334,   335,   336,     0,
     337,  1205,  1206,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,     0,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,  1207,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
       0,   379,     0,   380,   381,  1208,   383,     0,   384,     0,
     385,   945,     0,   946,   386,   387,   388,   389,     0,   390,
       0,     0,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   947,   400,   401,   402,   403,     0,   404,   405,   406,
     407,   408,   409,     0,   410,   948,     0,   412,   413,   414,
     415,  1210,  1211,     0,  1212,     0,   419,   949,   950,   420,
     951,   421,   422,   423,   424,   425,     0,     0,   426,     0,
     952,   428,   953,     0,   429,   430,   431,     0,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1213,   954,  1214,   450,   451,
     452,     0,   453,     0,     0,   455,   456,   955,   457,     0,
       0,   459,  1215,  1216,   462,   463,   464,     0,   465,   466,
     467,     0,     0,   468,   469,   470,   471,     0,     0,   472,
       0,   956,   474,   957,     0,   476,   477,   478,   479,   480,
     481,     0,   482,   483,   484,   485,     0,   486,   487,     0,
     489,     0,   491,   492,   493,   494,     0,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,  1217,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   524,   525,
     958,   526,   527,   528,   529,     0,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   547,  2458,   549,   550,   551,
     959,   552,   553,   554,  1219,   556,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
       0,     0,     0,   571,     0,   572,   573,     0,     0,   574,
     960,   575,   576,   577,   578,   579,     0,  1220,  1221,     0,
       0,   582,   583,     0,   585,     0,     0,   587,   588,   589,
     590,   591,   592,   593,     0,     0,   594,   595,   596,   597,
     598,   599,   600,     0,     0,   601,   602,   603,   604,   605,
       0,  1222,     0,   608,   961,   609,   610,   611,   612,     0,
       0,     0,   613,     0,     0,   614,   615,   616,   617,   618,
     619,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   631,   632,   633,     0,   269,   270,   271,   272,
     273,   274,   275,   276,     0,   278,   279,   280,     0,     0,
       0,     0,     0,     0,     0,   281,   282,     0,   283,   284,
     285,     0,   939,   286,   287,   288,   289,   290,     0,  1198,
     940,  1199,  1200,  1201,  1202,     0,   297,   298,   299,   300,
     301,     0,     0,   302,   303,  1203,  1204,   306,     0,   307,
     308,   309,   310,   311,     0,     0,   941,     0,   313,   314,
     315,   316,   317,   318,   942,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,   328,     0,   943,   329,   330,
     331,     0,     0,     0,   944,     0,     0,     0,   332,   333,
     334,   335,   336,     0,   337,  1205,  1206,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,     0,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,  1207,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,     0,   379,     0,   380,   381,  1208,
     383,     0,   384,     0,   385,   945,     0,   946,   386,   387,
     388,   389,     0,   390,     0,     0,     0,   393,   394,     0,
     395,   396,   397,   398,   399,   947,   400,   401,   402,   403,
       0,   404,   405,   406,   407,   408,   409,     0,   410,   948,
       0,   412,   413,   414,   415,  1210,  1211,     0,  1212,     0,
     419,   949,   950,   420,   951,   421,   422,   423,   424,   425,
       0,     0,   426,     0,   952,   428,   953,     0,   429,   430,
     431,     0,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,  1213,
     954,  1214,   450,   451,   452,     0,   453,     0,     0,   455,
     456,   955,   457,     0,     0,   459,  1215,  1216,   462,   463,
     464,     0,   465,   466,   467,     0,     0,   468,   469,   470,
     471,     0,     0,   472,     0,   956,   474,   957,     0,   476,
     477,   478,   479,   480,   481,     0,   482,   483,   484,   485,
       0,   486,   487,     0,   489,     0,   491,   492,   493,   494,
       0,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,  1217,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   524,   525,   958,   526,   527,   528,   529,     0,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   547,
       0,   549,   550,   551,   959,   552,   553,   554,  1219,   556,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,     0,     0,     0,   571,     0,   572,
     573,     0,     0,   574,   960,   575,   576,   577,   578,   579,
       0,  1220,  1221,     0,     0,   582,   583,     0,   585,     0,
       0,   587,   588,   589,   590,   591,   592,   593,     0,     0,
     594,   595,   596,   597,   598,   599,   600,     0,     0,   601,
     602,   603,   604,   605,     0,  1222,     0,   608,   961,   609,
     610,   611,   612,     0,     0,     0,   613,     0,     0,   614,
     615,   616,   617,   618,   619,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   631,   632,   633,     0,
     269,   270,   271,   272,   273,   274,   275,   276,     0,   278,
     279,   280,     0,     0,     0,     0,     0,     0,     0,   281,
     282,     0,   283,   284,   285,     0,   939,   286,   287,   288,
     289,   290,     0,     0,   940,     0,     0,     0,     0,     0,
     297,   298,   299,   300,   301,     0,     0,   302,   303,     0,
       0,   306,     0,   307,   308,   309,   310,   311,     0,     0,
     941,     0,   313,   314,   315,   316,   317,   318,   942,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,   328,
       0,   943,   329,   330,   331,     0,     0,     0,   944,     0,
       0,     0,   332,   333,   334,   335,   336,     0,   337,     0,
       0,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,     0,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,     0,   379,
       0,   380,   381,     0,   383,     0,   384,     0,   385,   945,
       0,   946,   386,   387,   388,   389,     0,   390,     0,     0,
       0,   393,   394,     0,   395,   396,   397,   398,   399,   947,
     400,   401,   402,   403,     0,   404,   405,   406,   407,   408,
     409,     0,   410,   948,     0,   412,   413,   414,   415,     0,
       0,     0,     0,     0,   419,   949,   950,   420,   951,   421,
     422,   423,   424,   425,     0,     0,   426,     0,   952,   428,
     953,     0,   429,   430,   431,     0,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   954,     0,   450,   451,   452,     0,
     453,     0,     0,   455,   456,   955,   457,     0,     0,   459,
       0,     0,   462,   463,   464,     0,   465,   466,   467,     0,
       0,   468,   469,   470,   471,     0,     0,   472,     0,   956,
     474,   957,     0,   476,   477,   478,   479,   480,   481,     0,
     482,   483,   484,   485,     0,   486,   487,     0,   489,     0,
     491,   492,   493,   494,     0,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,   524,   525,   958,   526,
     527,   528,   529,     0,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   547,     0,   549,   550,   551,   959,   552,
     553,   554,     0,   556,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,     0,     0,
       0,   571,     0,   572,   573,     0,     0,   574,   960,   575,
     576,   577,   578,   579,     0,     0,     0,     0,     0,   582,
     583,     0,   585,     0,     0,   587,   588,   589,   590,   591,
     592,   593,     0,     0,   594,   595,   596,   597,   598,   599,
     600,     0,     0,   601,   602,   603,   604,   605,     0,     0,
       0,   608,   961,   609,   610,   611,   612,     0,     0,     0,
     613,     0,     0,   614,   615,   616,   617,   618,   619,  5422,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     631,   632,   633,     0,   269,   270,   271,   272,   273,   274,
     275,   276,     0,   278,   279,   280,     0,     0,     0,     0,
       0,     0,     0,   281,   282,     0,   283,   284,   285,     0,
       0,   286,   287,   288,   289,   290,     0,     0,     0,     0,
       0,     0,     0,     0,   297,   298,   299,   300,   301,     0,
       0,   302,   303,     0,     0,   306,     0,   307,   308,   309,
     310,   311,     0,     0,     0,     0,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,   328,     0,     0,   329,   330,   331,     0,
       0,     0,     0,     0,     0,     0,   332,   333,   334,   335,
     336,     0,   337,     0,     0,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,     0,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,     0,   379,     0,   380,   381,     0,   383,     0,
     384,     0,   385,     0,     0,     0,   386,   387,   388,   389,
       0,   390,     0,     0,     0,   393,   394,     0,   395,   396,
     397,   398,   399,     0,   400,   401,   402,   403,     0,   404,
     405,   406,   407,   408,   409,     0,   410,     0,     0,   412,
     413,   414,   415,     0,     0,     0,     0,     0,   419,     0,
       0,   420,     0,   421,   422,   423,   424,   425,     0,     0,
     426,     0,     0,   428,     0,     0,   429,   430,   431,     0,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,     0,     0,
     450,   451,   452,     0,   453,     0,     0,   455,   456,     0,
     457,     0,     0,   459,     0,     0,   462,   463,   464,     0,
     465,   466,   467,     0,     0,   468,   469,   470,   471,     0,
       0,   472,     0,     0,   474,     0,     0,   476,   477,   478,
     479,   480,   481,     0,   482,   483,   484,   485,     0,   486,
     487,     0,   489,     0,   491,   492,   493,   494,     0,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     524,   525,     0,   526,   527,   528,   529,     0,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   547,     0,   549,
     550,   551,     0,   552,   553,   554,     0,   556,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,     0,     0,     0,   571,     0,   572,   573,     0,
       0,   574,     0,   575,   576,   577,   578,   579,     0,     0,
       0,     0,     0,   582,   583,     0,   585,     0,     0,   587,
     588,   589,   590,   591,   592,   593,     0,     0,   594,   595,
     596,   597,   598,   599,   600,     0,     0,   601,   602,   603,
     604,   605,     0,     0,     0,   608,     0,   609,   610,   611,
     612,     0,     0,     0,   613,     0,     0,   614,   615,   616,
     617,   618,   619,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   631,   632,   633
};

static const yytype_int16 yycheck[] =
{
      26,     0,   230,    61,   238,    21,    32,   238,   667,    43,
       0,    53,     0,    11,    30,  1033,     0,     0,   786,   787,
     788,    19,    26,  1292,   792,   932,    25,   242,    32,   236,
     260,  1791,   998,  1000,   842,   212,   701,  1218,  1034,   844,
      54,   256,  1661,   654,  1359,  1050,  1314,   971,  1249,   701,
    1357,  1707,  2815,   866,   836,  2337,  1059,   220,  1699,    17,
    3034,  1160,  2462,  2463,  1351,  1205,  1206,   851,  1861,  3205,
    1717,  1730,     0,  1704,    25,  1215,  1216,  1954,  3398,  1221,
      22,  3264,  2964,   222,   223,  2838,    27,   226,  1707,   754,
    3369,  3722,  1033,  3195,  3196,  2136,  4041,    25,  2652,  1066,
     711,  1042,    43,  2273,  4134,  1500,  3680,     0,  3431,   248,
    3433,  1052,   231,  2252,  3998,  2726,   255,  3616,  3001,  1750,
    3699,  1126,  4041,   242,  3624,  3624,  3197,  1132,   753,  4093,
     873,   740,  1137,    61,  4311,  3709,  2769,   256,  2771,   178,
    3022,  4037,  2775,  3273,  3638,  2834,  3926,  1152,  2375,  4293,
    2377,  2784,  2785,  2786,  4348,  4351,  2383,  4610,  3804,  3955,
    4360,  2388,  1167,  1822,  1823,  3246,   712,  4341,  3961,  1816,
    4861,  2340,  2296,   214,  1967,  1858,  1143,     0,  4965,    42,
    2462,     0,   847,   214,  2061,  3128,     0,     0,    51,  4858,
    1856,  1857,  2396,  1639,   740,   847,  4340,  5024,    60,  4805,
       0,   983,  2406,     0,     0,  3469,     0,     0,     0,   251,
    3283,     0,  3697,     0,    50,   929,  5190,  5043,  5183,  1691,
    1203,  1204,   981,  4017,     0,  3889,  4981,  5176,  4983,     9,
    3193,  1214,   929,    11,     0,  3960,     0,  3962,     3,     0,
       9,    61,  5093,  5094,    35,     5,     5,    52,  1388,  1389,
      77,  4857,    93,    13,    14,     5,     5,     9,  1917,    61,
    5086,     0,    40,    13,    14,     9,     0,   727,  1408,  1409,
       9,    61,    26,  2827,    29,     5,     0,    40,     5,    22,
    1422,   741,  1913,   120,  1251,   120,   214,    26,    26,    61,
    1072,    42,     5,    61,  5400,     0,  5301,  5302,     5,    77,
      11,  3264,    39,    85,     0,     5,     5,    26,     5,    90,
      58,    39,    95,  1237,    13,    14,     5,  1632,   173,     5,
    1148,     5,   178,    29,    89,   178,  1292,   125,   185,   146,
      70,  1653,  1639,     5,  3277,   159,   202,  1165,   221,  3371,
       5,     5,     5,    79,  5336,   173,     0,    61,  1116,    26,
      90,   158,   178,   285,    90,     9,    33,   281,     4,  1326,
      89,   120,   281,     9,   179,     5,   266,   112,    26,   227,
     181,   125,    26,     9,  5118,    90,    27,   178,   190,     5,
      24,    79,    75,   307,   149,   287,  1701,  2941,   307,  2943,
    1252,   288,    90,  1376,  1377,  4423,  4424,     3,  4426,  4427,
    4428,   144,   178,    47,   133,   120,  2037,   361,   266,    61,
     178,   120,   178,   380,   178,  3679,   156,   178,   147,   178,
     380,  1404,    61,    79,    30,    31,   202,   180,   122,    61,
     234,  1530,   120,   667,   381,   175,   202,    95,   202,   178,
      61,   202,   207,   307,   361,   414,   661,   425,    22,   124,
     168,     3,     4,     5,   122,     4,   671,     9,   665,   178,
       9,   215,   425,   202,    11,    79,   151,   120,    11,   124,
     685,   460,   467,   361,    92,   333,   351,   346,  5427,    44,
     251,     5,     5,   178,   287,    11,   195,  1490,    42,   723,
     293,   502,  5318,    40,  4647,    26,   507,    40,   509,   270,
    4653,    79,    33,  5609,    69,   380,  5261,   202,  5177,   397,
     351,   380,    26,   652,   721,   745,   511,   656,   507,    33,
     173,   239,  1488,   141,   178,   329,   384,  1493,  1494,  3193,
      77,   448,   352,   511,    77,  1081,   675,   290,   507,   287,
     178,  1284,   661,   682,   511,   310,   509,   222,   202,   178,
     352,   511,   671,   507,   178,   270,   367,   225,    79,  1105,
     507,   270,   352,   374,    11,   216,   685,   222,   120,   425,
     144,   177,   216,   179,   303,   507,  1122,   384,   475,  1901,
     352,   275,   322,   507,  1195,   178,   127,   275,   507,   489,
     448,  1898,   285,    40,   349,   122,  1777,   178,   366,   425,
    3264,   178,   270,   505,   415,  3637,   361,   509,   363,  1274,
     268,   275,   275,   342,   769,   770,   771,   346,   372,   774,
     775,   776,  1274,  5367,   425,   436,   642,  1292,   511,   784,
      77,   376,  4132,  4132,   650,   275,   500,   380,   352,   112,
     496,   465,   454,   349,   425,   511,   645,   332,   465,   112,
     448,   380,   507,   509,   511,   645,   438,   645,   511,   496,
    1442,   645,   645,  4162,  5669,   333,   425,  5616,   220,  1294,
     511,   408,   507,   425,   439,   430,   414,   460,   505,  5506,
     408,   425,   509,   511,   449,   701,   702,   452,  1470,   425,
     242,   511,   507,   461,   448,  1360,   754,  5548,  1441,   641,
     352,   441,   507,  5695,   455,   448,   425,   470,  1360,   511,
     459,  5817,  1678,   352,  4494,   392,   507,   645,   466,   758,
     352,   511,  2405,  1689,  4044,   503,   506,   425,  4521,   498,
     499,   352,   466,  4307,   510,  1676,  4532,   496,   507,   511,
    4536,   767,   466,   769,   510,   771,   510,   507,  5417,   510,
     509,   777,   778,   779,   753,   932,   798,   507,   507,   498,
     499,   466,   969,   767,  3318,   769,  4412,   771,  4347,   425,
     466,   510,  1634,   777,  4438,   509,   510,   507,  5752,  3468,
     507,  1786,  5747,   781,  1789,   509,   510,   994,   472,  1335,
    5739,   807,   503,   751,   507,  4520,  4590,  4522,   505,  1259,
     507,  1797,   509,   754,   509,   510,  1747,   507,   507,   493,
     507,   425,  1778,   509,   510,  1781,  1782,   833,   507,    26,
    1485,   507,   507,   507,   866,   753,   754,   843,  1493,  1494,
     846,   847,   848,  1485,  2102,   507,  4330,  3526,  2469,  2470,
     881,  5294,   507,   511,   498,   499,   472,   425,  1851,    11,
     881,  5677,   498,   499,   460,  1089,   510,  1085,  1089,   511,
    1320,   392,   498,   499,  2065,  5691,  5831,   493,    20,  1008,
    1009,   425,   511,   511,  5823,   399,   400,  1337,   392,   511,
    4908,   507,   511,  1626,   883,  2025,  3286,   511,  3288,  4853,
     511,  5646,  1352,   883,   936,   883,  2543,     4,     5,   883,
     883,   455,     9,    22,   425,  3976,  1620,  1873,  2109,   450,
    4395,  1074,  2578,  3195,  3196,  3197,  3669,  2118,   511,  2575,
     871,   470,  2588,  1620,  5615,   452,   507,   113,  3098,  3099,
     507,   112,  1139,  3103,  5883,  1902,  2251,  1765,   980,  1698,
    4260,   414,   125,  5612,   493,    34,   498,   499,    58,   498,
     499,   414,   287,   881,  5919,   883,  4029,   500,   501,   502,
     503,   303,     3,  2629,   307,  3598,     5,  5793,  4247,  1108,
    3140,  3141,   998,  5938,   500,   501,   502,   503,  2293,   112,
    1808,   112,   227,  5589,  5615,   172,    38,   178,   120,  3952,
     883,  2638,  3955,   158,    26,  3222,   112,  2304,   294,   128,
    5827,  5828,   173,    22,   346,  5611,   158,  1146,  1147,   845,
     125,   202,   874,   849,   307,   271,  1999,  2000,   294,   205,
     125,   266,   328,  5167,  2339,   144,   170,   274,    70,    43,
    2476,   120,   215,  3722,  1173,  3239,    22,   363,   380,  2671,
    4304,  1248,    28,     5,  4963,  3599,  3600,   412,    89,   350,
     328,   498,   499,   500,   501,   502,   503,    89,  5749,   166,
     883,   137,   138,   139,   883,  1893,  5853,   120,  2073,   883,
     883,  5740,  4015,   170,   246,  5020,  2759,   346,  4041,   380,
     973,  4162,  2049,   883,   449,  3209,   883,   883,  5007,   883,
     883,   883,  2564,  4372,   883,  5922,   883,     4,     5,  1758,
     215,  5020,     9,   324,   430,  3274,   313,   148,   266,  2741,
     215,   380,   125,    52,   156,  1254,  1255,   114,  5749,  2879,
     190,   265,   190,   181,     8,   144,   179,    11,  2133,   316,
      22,   144,  1158,   175,   231,   294,  4319,     3,   270,   384,
    1295,   388,  4922,  1298,    87,  1300,   366,  1302,   200,  1304,
     266,   135,     8,  1308,  2820,    11,    40,   141,   144,    15,
      16,    17,    87,    87,   507,   507,    50,   374,   275,  2476,
     184,   110,   507,  4966,  4970,  1038,  1039,   348,     8,  4975,
     366,    11,  4978,   114,   303,    15,    16,    17,   131,   372,
      26,  5882,   448,    77,    87,  1963,   266,   194,   266,    61,
    1612,   507,    32,   448,   245,   294,   131,   131,  1754,   361,
    5384,   418,    87,   420,   507,   511,  3616,   346,   271,   384,
    2489,   331,   292,    89,  3624,     3,   412,   346,   414,   507,
    5921,  5425,   384,   414,   366,   511,   275,  1179,   131,  5383,
    5440,  5437,     3,  4874,     5,  5419,    82,   120,   280,  1992,
    4896,  5882,   144,  2894,  2885,    91,   131,   254,  1274,   166,
     257,   380,   303,   194,   338,   448,  1292,   229,  4842,  4848,
    5027,  5190,   444,   292,  5418,   214,  1292,  2458,  5455,   470,
     322,   414,   148,   414,  4604,   121,   507,   507,  3952,  1519,
    5921,  3955,  5745,  5746,    50,  1294,   454,   281,   180,  1297,
     187,  1299,    36,  1301,   180,  1303,   319,  1305,  1306,  1307,
    2115,  2116,  2619,   197,  1312,  1331,   374,   303,   202,  3719,
    1866,   507,  4645,   254,    32,   432,   257,   266,   433,  1355,
     299,   350,   351,   448,   453,  1881,   498,   499,   500,   501,
     502,   503,   120,   448,  1360,   252,   202,    62,   255,   508,
    2657,   383,   511,   114,   238,    70,  4319,   415,  1904,   195,
     346,   380,   305,   254,  5762,   397,  1294,   223,   275,  5126,
     206,   168,   190,   370,  1985,   281,   417,  4041,   419,   245,
     305,   305,     3,  1441,   454,   380,   454,   281,   462,  1998,
     154,   498,   499,   223,   380,   129,  5292,   450,   111,   441,
    2707,   307,   179,  4285,   266,    26,   290,   496,   290,   357,
     442,   303,   305,   307,  2079,    22,   505,   449,   507,   508,
     509,    28,   511,  5617,  1970,   187,  1633,  1443,   301,   368,
     305,   425,  5885,   194,   290,   460,  1452,   303,  1984,   370,
    1368,   197,   239,  5223,   332,   194,   202,  4549,   266,  2058,
    1466,   159,  1998,  2078,   346,   219,  5633,  5421,  4588,  4148,
     290,  5257,  1488,  1391,   189,  2011,   363,  1493,  1494,  1485,
     357,   113,  1488,  1489,   362,  1514,   419,  1493,  1494,   370,
     346,   122,   238,  4554,   350,   303,   283,   363,   380,  4560,
     352,   488,   270,   254,   419,   419,   257,   275,  1426,   372,
    2807,   449,   386,  5901,    89,   254,   268,  2250,  2290,  2252,
     507,  2057,  2058,  1441,   380,  2258,   511,   511,   380,    26,
     402,  2264,  2265,  2266,  1758,   432,   419,   242,   346,   306,
     294,  2274,  2275,   430,  4417,   287,  2279,   144,  5295,   252,
    5320,   414,   255,   268,   419,  5325,  5326,  5304,   133,  5468,
      26,   417,   428,   419,  5748,  5500,   154,   488,   434,  5753,
    5060,  5060,   147,   205,  1605,  1606,   402,  1608,   133,  4532,
      29,  2031,    35,  4536,  1605,  1606,    98,  1608,   292,   123,
    1622,  5500,   147,   456,   225,  1724,   414,  5166,  2048,   303,
    4279,   498,   499,   425,   175,  3861,    59,   470,  4231,    58,
    2060,   507,  4235,  4236,   470,  4238,   227,   491,   183,   370,
     387,    22,  2271,   507,   498,   499,   500,   501,   502,   503,
     493,   370,   321,  1853,  3890,  5509,  5510,  5821,   135,   270,
     386,  4320,   346,  2574,   507,  2440,   454,  5747,   494,   495,
     496,   239,   498,   499,   500,   501,   502,   503,   111,   202,
     135,   122,  1678,    70,   198,  4319,   141,  2028,  2676,   135,
    5154,  2628,   184,  1689,   494,   495,   496,   242,   498,   499,
     500,   501,   502,   503,   321,   264,   440,  1605,  1606,   511,
    1608,   166,   180,   427,   346,  1824,  1825,  1826,  1827,   302,
    5884,   302,   333,   361,  3976,  5614,   303,   286,  3868,  3869,
    3870,  3871,  3841,   120,  3874,  3875,  3876,  3877,  3878,  3879,
    3880,  3881,  3882,  3883,  2680,  1741,  1742,   303,  4329,  1838,
     425,  5831,  2688,    98,   366,  2691,  5920,   488,   427,   473,
    5924,  1673,  4132,   144,  2935,  2676,  1875,  1876,   303,   346,
    2111,   204,   302,    22,   119,  3386,   414,   461,  3508,    28,
     391,   302,  1778,  2299,   225,  1781,  1782,   342,  1897,  3986,
    3930,  3931,  4162,   425,  3991,   182,   123,   380,     8,  2710,
     412,  1813,   414,   380,   473,    15,    16,    17,   251,  1795,
     427,   346,   123,   168,   159,   270,  1802,   179,   173,   252,
     275,   496,   255,   346,   380,   380,   281,   350,   294,   270,
    5120,  2029,  2743,   266,   509,  1944,  1945,  1946,  1947,  5919,
    2044,  2045,  3119,  1932,  2045,   466,  3211,  1980,  3125,   211,
     380,   348,  2650,  1942,  2489,  5399,   473,   380,  5938,   380,
    4384,   183,  4386,  5752,   226,  1954,   154,  1930,  2068,   302,
     361,   198,   363,   418,   236,   420,   303,  1873,  2661,  2662,
     168,   122,  2665,   270,   239,   173,  5435,   198,   275,    75,
     511,  2273,   333,  1956,   174,   144,    79,  2074,  4532,  2281,
     445,  2482,  4536,   369,  1767,   373,     3,    90,  2108,  1772,
     338,  1907,  2112,  3530,  2114,  2852,    11,  2117,   351,   346,
     242,  3768,   303,  5923,  2722,   373,    23,   207,   283,   251,
     173,   219,  5396,  5787,   450,   322,   338,  5826,   135,   430,
     373,   184,   135,  2032,   141,   373,   414,   470,   141,  1935,
    5414,   239,   450,   340,  5203,  1941,  4615,  2066,  4902,   202,
    5960,   303,  2071,   396,   303,   346,   414,   435,   209,   166,
     493,   373,  2061,   470,  1837,   157,   270,   432,  1841,  3990,
     228,   275,    77,   470,   248,   303,   414,   442,  5452,  5061,
    3626,   507,    89,   450,   356,   283,   493,   342,  5055,   380,
    1996,   180,   508,   342,   346,   511,   294,   346,   350,   507,
    2526,  2007,   414,  2009,   511,  5305,    35,   470,  5311,  2015,
     427,   203,  2538,  5624,   511,   266,  2022,   372,   346,   270,
    4963,   122,   154,   212,   462,  4887,   330,  4970,   380,   383,
      59,   380,  4975,   307,  5101,  4978,   168,  4899,    75,  2832,
     507,   173,   149,   372,   441,   361,   362,  2993,   511,   470,
     462,  2859,  2860,  2861,  2862,   409,  2582,  2271,   507,   414,
    5014,  4804,  5016,  2871,  5007,   508,  3705,   270,   275,  5623,
     290,   470,   173,   472,   281,  3323,  2667,  5020,   281,  2075,
     510,   350,   111,  5199,  1767,   414,   418,   219,   420,  1772,
     511,  4625,  4626,   168,  4827,   202,   159,    99,   173,  2078,
     207,   456,   355,  2125,  4847,   333,   470,   239,   209,    79,
    2088,   380,  2090,   445,  2092,   470,  2094,  5591,  2096,   347,
      90,  4271,  2100,  2129,  2130,   472,  4795,   456,   472,   493,
    2144,  2571,  2855,  2129,  2130,     0,    90,   303,   493,  3218,
     470,  2889,   440,   417,    24,  4814,   493,   375,  2079,   493,
    3229,   283,   507,  4766,  1837,  4768,  4769,  2136,  1841,  4772,
     507,   303,   294,   493,   239,   266,  2136,    47,  2136,   270,
    2078,   445,  2136,  2136,  3294,   204,   496,   179,   507,   502,
     346,   511,  3469,   154,   507,  2908,   509,   248,  2307,   509,
    5449,   324,   173,   303,   173,   472,   470,   168,   472,  2386,
    2387,   511,   173,   310,   346,  4874,    99,   505,   283,   211,
     508,   509,  5512,   303,   380,   196,   493,   196,   173,   430,
     470,   287,  2143,   252,   226,   432,   255,   293,  2136,   183,
     507,    67,    68,   507,   236,   442,   346,   266,   380,    26,
     268,   196,  5405,   493,   111,    32,   307,  5190,   219,     0,
     357,   205,     4,  2898,  2260,  2261,   346,     9,     4,  5733,
     262,  2267,  2268,     9,  3210,   280,  2898,  2263,   239,   183,
     380,  2797,  4045,   302,   494,   495,   496,   462,   498,   499,
     500,   501,   502,   503,   369,   287,   179,  4549,   242,  2295,
     380,   506,  4554,   418,   506,   420,   511,   505,  4560,   511,
    2283,   509,     5,  2286,   411,   366,     9,   174,   440,   372,
     508,  2956,   283,   511,  5257,  3202,  2907,  2531,   211,  4963,
    2531,  2529,   351,   294,  2956,   405,  4970,  2249,   242,   361,
     362,  4975,   439,   226,  4978,   507,  3623,   509,  5892,   293,
     207,  5815,   449,   236,   373,   452,  3111,    98,  3113,  3114,
    5019,   414,  2451,   418,   356,   420,   417,  5026,  2354,  4099,
      13,    14,  5352,  5007,  5354,  3586,  3587,   396,  5358,   262,
    5360,  5671,  2471,  1029,   229,  2570,  5020,  3100,  2477,  2522,
    3284,    43,  2481,  5499,   445,   252,   425,   508,   255,  3112,
     511,  1047,  3679,   456,  1050,   508,  3372,   508,   511,   508,
     511,  2309,   511,   154,  5878,  2524,  2525,   470,  2507,   470,
     505,   472,   507,  2419,  2533,   154,  2535,   168,    43,  5409,
    2539,  3144,   173,  3399,   338,   508,   187,   178,   511,   168,
     493,   248,    43,   184,   173,  2419,   187,  3685,   508,   508,
     191,   511,   511,  3207,   507,  2376,   507,  3695,   450,    43,
    4077,   508,  3373,  2552,   511,  4091,  2757,  2758,  4097,  3182,
    4099,    43,  5405,   356,   418,   507,   420,   508,   219,   440,
     511,  2570,   253,   430,  4331,  2670,   430,  2491,   268,  2493,
     219,  2445,   372,  2489,   430,   268,   508,   441,   239,   511,
     307,   445,  5105,  2489,   470,   505,   472,   507,  3024,   509,
     239,  2924,  2925,  2926,   418,  2489,   420,  3454,   418,   508,
     420,  4138,   511,     6,   456,   508,  2615,  3156,   511,  3045,
    2542,    14,   405,   508,   414,  5468,   511,   507,   248,   509,
      23,   445,   283,  3059,   348,   508,   287,  2445,   511,  3460,
     418,   187,   420,   294,   283,  2740,  5190,   508,   462,   366,
     511,    44,   508,  3820,   510,   294,  2655,  5500,   508,   508,
      94,   511,   511,  2559,  2663,  3210,   456,  2686,   369,  5869,
    2689,  2670,   251,  2579,  2761,  2674,   508,  4350,   508,   511,
     470,   511,   251,   508,    30,    31,   511,   307,   508,   508,
     508,   511,   511,   511,   196,  2694,   508,   205,  3677,   511,
     417,  2700,   353,   493,   508,  2704,   508,   511,   248,   511,
    5144,  4873,   470,  5257,   472,  3910,  3903,   507,  2717,  3741,
    3742,   253,   508,   508,     0,   511,   511,   508,   445,   508,
     511,  2730,   511,   508,   508,   508,   511,   511,   511,  2661,
    2662,  2740,   508,  2665,  3629,   511,   366,   268,   508,  2768,
    2646,   511,    98,   470,   430,   472,   508,  2776,  2777,   511,
      86,   405,   220,   414,  2783,   508,   462,   307,   511,  5785,
    3616,  5614,   230,   119,  2680,   508,    58,   510,  3624,  2798,
    5060,   508,  2688,  3630,   511,  2691,   369,   202,   248,   440,
     507,   229,   926,   508,   928,  3340,   511,   417,   162,   508,
     508,   440,   511,   511,   287,   507,  3098,  3099,  3340,   508,
       9,  3103,   511,   159,  5668,  3523,   467,  5833,   469,   470,
     508,   507,    98,   511,   508,   445,   366,   511,   508,  4024,
     187,   511,  4353,    52,  4537,  2854,  4539,  2733,   508,  4338,
     508,   511,   508,   511,   287,   511,   366,   307,  3140,  3141,
     470,   470,   472,   508,   505,   511,   511,   508,   509,   510,
     162,  5405,   507,  2882,    70,   470,   508,    58,  4918,   511,
    2766,    77,   462,  2769,   460,  2771,    44,   417,   154,  2775,
    2990,   100,   508,   508,    90,   511,   511,   507,  2784,  2785,
    2786,   490,   168,   508,  4042,  4043,   511,   173,   508,  5061,
     508,   511,   178,   511,   225,   445,   366,   126,   184,  5752,
    2832,   187,  5192,  3621,   120,   191,   122,   508,  3344,     8,
     511,  2940,    11,  2942,  5468,  5941,   291,   509,  2824,   148,
     470,   508,   472,   152,   511,  3361,   291,   287,   271,   272,
    3048,   425,   508,   219,  4131,   511,  4133,  2853,   173,   508,
     508,    40,   511,   511,   291,   174,  5500,   417,   177,   507,
     287,    50,  2858,   239,   490,   508,   508,   507,   511,   511,
    3310,  3311,   508,   192,  4161,   511,   182,   508,   508,   508,
     511,   511,   511,  5826,   508,   445,  3832,   511,    77,    44,
     508,   490,  4179,   511,  2890,   508,   342,   225,   511,  3042,
    2999,  2839,  2898,   209,   177,   508,  4026,   283,   511,   507,
     470,   287,   472,  3661,   511,  2921,  2922,  2881,   294,  4659,
     508,  2927,   508,   511,   308,   511,   372,  3026,   508,     8,
     508,   511,    11,    35,   508,  3034,    15,    16,    17,   372,
     272,   508,  3156,  3062,   511,   414,   508,   507,  3474,   511,
    3476,   508,   414,   430,   511,  5624,   275,    59,   462,   248,
    2956,    40,   508,   152,   270,   511,   285,   430,   414,   275,
    5614,    50,   508,  2881,   414,   511,     8,   353,   414,    11,
     357,   414,   511,    15,    16,    17,   414,  2993,  3633,  5732,
    3635,   508,   508,  3584,   511,   511,   508,  3980,    77,   511,
      32,  3633,  3795,  3635,   414,    58,   178,  4643,   197,   111,
     456,   330,   508,   202,   460,   511,   322,  4304,   307,   508,
     221,   507,   511,   456,   470,   508,   508,   508,   511,   511,
     511,   507,  3246,  3559,   340,   268,   508,   470,   414,   511,
     372,   509,   508,   362,  3484,   511,   507,   493,   508,   238,
     508,   511,   508,   511,   301,   511,   474,   202,   507,  3499,
     493,   507,  3100,   508,   440,   508,   511,  3593,   511,   346,
     160,   202,  5222,  3718,   507,   509,   508,   366,   508,   511,
     182,   511,   414,  3970,  3971,  3972,  3718,   507,   160,     0,
     648,   467,   287,   469,   470,   248,   508,   508,   202,   511,
     511,   290,   204,  3313,   346,   287,  3144,   346,  5752,   160,
     202,   160,   287,  4098,   173,   346,   160,   237,   197,   122,
     287,   248,    58,   202,   456,   372,   450,   287,   417,   505,
     253,   280,   508,   509,   510,   441,   507,   430,   470,   462,
    3863,   369,   173,   229,   173,   508,   507,    70,   706,   270,
     252,   187,    35,   255,   307,   270,   445,     8,   716,   238,
      11,   493,   187,   474,   266,  4069,   248,   414,     5,   507,
     287,   173,   270,    44,  3897,   507,   508,  3703,   510,  5441,
     307,   470,  5826,   472,    44,   270,  4132,    98,    89,    40,
     435,   223,  3100,  3187,  3188,  3189,   270,   386,   303,    50,
     302,  3411,  3208,   462,  3210,  3967,  3732,   462,  3648,   456,
    3650,   290,    86,   366,  3210,   173,  4162,   325,   507,  3942,
     160,   160,   507,   470,   459,   307,    77,   160,   507,   317,
    3268,  3350,   507,  3352,  3353,  3354,  3144,   248,  3337,   366,
     160,  4217,    34,   154,  4855,   507,   493,   474,   160,   351,
     160,   511,   160,  3161,   160,  4550,  4241,   168,   290,   187,
     507,   160,   173,     8,   417,   160,    11,   178,   173,  3177,
     160,   373,   160,   184,   160,   160,   187,   287,   160,   414,
     191,   507,   507,   112,   366,  3193,   507,   507,    35,  4584,
     417,   237,   445,   173,   396,    40,   307,   173,   173,   287,
     507,   152,   491,     5,     5,    50,     5,   386,   219,   498,
     499,   500,   501,   502,   503,     5,   507,   470,   445,   472,
    3846,  5471,   507,  4484,   173,     5,   507,   507,   239,   507,
     507,   507,    77,   507,     5,   417,   507,   507,   507,   507,
       5,  3867,   507,   470,  3340,   472,   197,     5,   507,   507,
     507,   202,   471,   507,   507,   366,  3264,   507,   299,  3458,
    3268,     8,   221,   445,    11,   507,  3892,   507,    15,    16,
      17,   507,   283,   507,   507,   507,   287,   507,   507,  3819,
     507,   507,    35,   294,   102,    32,   511,   238,   470,   511,
     472,   237,   307,    40,   173,    35,   462,   462,   187,   187,
    3926,   462,  3616,    50,   187,   202,   417,   152,  4393,   270,
    3624,   173,   491,   283,   173,   494,   495,   496,   281,   498,
     499,   500,   501,   502,   503,   507,   380,   425,   425,  4414,
      77,   366,   425,   461,   445,   425,   366,   366,   509,   290,
     425,  3437,   353,   425,   239,   425,   425,   425,   496,    90,
     366,   160,   197,   287,  4400,   287,   425,   202,   371,   470,
     425,   472,   494,   495,   496,   275,   498,   499,   500,   501,
     502,   503,   425,   449,   417,  3594,  3868,  3869,  3870,  3871,
    3579,   307,  3874,  3875,  3876,  3877,  3878,  3879,  3880,  3881,
    3882,  3883,   268,   238,   287,    58,   507,   287,   205,   361,
     281,  3497,   507,   414,   425,    90,   163,   425,   195,  3901,
     511,   507,   303,   202,   160,     8,  1074,   414,    11,   450,
     414,   425,    15,    16,    17,   380,   450,  1085,    58,   440,
     113,    58,   425,   425,   425,   386,   425,   259,  3930,  3931,
     292,   425,   366,   328,   425,   290,   425,    40,   425,   417,
     197,   307,   425,   425,   307,   202,   467,    50,   469,   470,
     425,   425,    42,    42,   366,  3561,   511,  5178,  4816,   425,
     174,   425,   425,  5172,  3784,   425,   223,   224,   425,   178,
     425,   223,   287,   287,    77,   223,   223,   474,   223,   287,
    3777,   238,   287,   223,   505,   223,   223,   508,   509,   510,
      70,   470,  3598,   425,   435,   507,    35,   160,    24,   287,
    3616,   160,   470,   285,   270,  3611,    89,  1175,  3624,   120,
    3616,    58,   450,   160,   160,  3631,   273,   187,  3624,   202,
     245,  4222,   160,   287,   461,    35,   281,  3633,   270,  3635,
     491,   386,   173,   290,   270,  3651,   293,   498,   499,   500,
     501,   502,   503,  3772,   270,   507,    35,   229,   368,   507,
     160,    34,   423,   423,   505,   505,   160,   425,   425,  3768,
     425,   507,   160,   160,   425,   450,   160,   450,   160,   160,
     270,   425,   280,   274,   112,    70,   178,   178,   270,  3788,
    3712,   508,  3688,   512,   465,   507,    11,   259,   259,   423,
     511,   507,   507,   169,   197,  4651,  5856,  5857,   425,   202,
     187,   178,   427,   511,   508,   409,   187,   195,   466,   195,
     462,  3717,  3718,  3822,   407,   509,    35,   450,   227,   219,
     223,   224,  3738,   511,   384,    58,   288,   511,   296,   386,
     508,   366,   507,   275,  3708,   238,   491,   450,  4471,   275,
     425,   425,   227,   498,   499,   500,   501,   502,   503,   227,
     430,   425,   462,   369,   253,   173,  3730,     8,   507,   229,
      11,   275,   162,  3795,    15,    16,    17,   287,    44,  4305,
     273,  3938,   391,   237,   270,   162,     3,     8,   507,   136,
      11,  4579,   237,   237,    15,    16,    17,   290,    48,    40,
    3708,   425,   361,  3809,   417,   425,   328,   346,   470,    50,
     196,   285,   376,  3809,   511,  5426,   333,   425,   287,   511,
     425,   173,  3730,  5110,   287,   511,  3832,   511,    35,   223,
     229,   450,   450,   288,   285,   383,    77,   205,   187,   470,
     202,   496,   327,   160,   491,   496,   281,   494,   495,   496,
       5,   498,   499,   500,   501,   502,   503,   414,  4298,  4299,
     173,   508,    27,    35,    29,   462,   328,   383,   415,   175,
      35,   281,   160,   507,   376,   160,    41,    42,    43,  4271,
     160,    46,    47,   281,   507,    50,    51,   270,    53,   470,
      55,    35,   270,   386,   287,   287,   229,  4107,  3936,  4109,
     193,   193,   173,    35,   505,   508,   490,   257,   508,   370,
     490,   229,   508,   508,   508,   173,  3912,  3955,  4132,   376,
     287,   160,   270,     8,   202,   202,    11,   202,   474,    23,
     185,   507,  4571,   511,   511,   178,   256,   160,   178,    58,
     511,   470,   425,  4062,  4063,  4064,  4065,   287,  4162,   288,
    3944,  3945,  3946,  3947,   280,    40,   197,   462,   430,   229,
     178,   202,   414,   508,   508,    50,   508,   508,  4494,   299,
     508,   511,   507,  4072,   508,   508,  5716,   309,   490,   178,
     247,   496,   223,   224,   508,   508,   425,   508,   508,   507,
     298,   251,    77,   507,   507,   492,   507,   238,   491,  5610,
     507,   494,   495,   496,   507,   498,   499,   500,   501,   502,
     503,  3990,   508,   511,   467,   448,   456,   467,   287,    58,
    3990,   205,  3990,   287,   287,   160,  3990,  3990,  3936,  4224,
     291,    35,   273,   474,   425,   213,   425,   425,   275,   270,
     160,  4228,   507,   507,  3952,   425,   292,  3955,  4796,   290,
     371,   507,   160,   160,   237,   220,    60,   222,   223,   224,
     507,   226,   205,   470,   371,   230,   371,   152,   233,   290,
     162,   236,   120,   238,   496,   507,   450,   511,   239,   425,
     245,   310,  3990,   248,   310,   249,   251,   447,   425,   425,
     255,   425,   257,    97,   425,   249,  4195,  4623,  4985,  4198,
    5349,   249,   287,   425,   366,  4992,   425,   366,   270,  4832,
     366,   425,   197,     8,  5060,   425,    11,   202,   366,   160,
      15,    16,    17,   425,   425,  4224,  4132,   425,   380,   425,
    5741,   425,  4524,    42,   425,  4661,  4132,    32,   425,   425,
     223,   223,   223,  4262,   223,   386,   507,   190,     3,   508,
    4269,   508,   328,   238,   435,   511,  4162,     3,   173,  5340,
     164,  5342,  4168,  4689,   507,    44,  4162,   348,   112,   511,
     508,   173,   507,  4169,   287,    35,  4172,   160,  4174,   508,
     425,   160,   173,   190,  4168,   450,  4396,  4397,  4398,   160,
     506,   366,   366,   450,  5141,   199,   508,   366,   291,   376,
    4640,   158,   506,   158,   223,   290,   425,   507,   511,   506,
     223,  5822,   223,  4312,   223,   223,   505,   223,   150,   178,
    4216,    11,   299,   173,   178,   229,   508,   511,  4754,   508,
     234,   461,  4331,   294,   508,  4231,   508,  4243,   511,  4235,
    4236,   178,  4238,   467,  4250,  4251,   493,   187,   288,   353,
     491,   455,    88,   494,   495,   496,   507,   498,   499,   500,
     501,   502,   503,   173,   508,   507,   270,  5554,   435,   507,
      35,   450,   508,   494,   495,   496,   511,   498,   499,   500,
     501,   502,   503,  4723,   509,   425,   508,   507,   229,   213,
     450,   507,    58,   417,   160,   507,   182,   435,   371,   425,
     304,   386,   425,   425,  4403,  4311,   366,  5556,   425,   425,
     366,   508,   508,   508,   346,   507,  5564,  5565,   470,    58,
     417,   173,   456,   162,    77,   329,   160,   112,   223,   435,
     223,   223,   223,   223,   326,   508,   507,   208,   227,   507,
     287,   425,   341,   474,    35,   511,   350,   307,   511,  4875,
     354,   508,    83,  4349,  5139,  5242,   425,  4571,   362,   417,
     511,   507,   511,  5650,   435,   507,   376,   371,   184,   508,
     506,   425,   112,   178,   223,   508,   380,   178,   507,    58,
    5365,  4345,  5021,   508,  4824,   299,   339,   508,   468,   226,
     394,   297,   468,   511,  4400,   290,  4922,   508,   507,   403,
     226,     8,   507,  5349,    11,  4411,   491,   508,    15,    16,
      17,  4319,   507,   498,   499,   500,   501,   502,   503,  1977,
     416,   295,  1980,    58,   428,    32,  4422,  4423,  4424,  5316,
    4426,  4427,  4428,   191,  5073,     3,   508,  4345,   508,   281,
       8,   508,   508,    11,   496,   435,   178,    15,    16,    17,
    5397,   425,   470,    77,     8,   207,   275,    11,  5706,   196,
     464,    15,    16,    17,    32,   469,   470,    35,   275,   496,
    2028,  2029,    40,   508,    58,   640,   425,   511,   417,    70,
     511,   646,    50,   648,   160,   223,   507,   652,   113,   654,
     425,   656,   425,   180,   178,    35,   202,   120,   450,   281,
     665,   376,   667,    35,  5227,   187,   507,   672,   450,    77,
     675,   270,   175,   173,   376,    58,    35,   682,   281,   470,
     178,   507,  4732,  4733,   470,  4735,  4918,   287,   173,   210,
     291,   221,   508,   339,   178,  4927,   455,   162,   507,   507,
     307,   706,   395,   508,   508,  5268,   711,   469,   226,   507,
     140,   716,   508,  2111,  5803,   180,   721,    90,   723,   507,
     287,  4567,   507,   340,   425,   508,  4562,  4762,  4564,    35,
     173,   509,   508,   160,   425,    35,   507,   507,  5576,   744,
     205,   507,   507,   275,   507,  4684,   507,   195,  4602,   250,
     205,   507,   326,   508,  5881,   507,   376,  4696,   160,   494,
     495,   496,   112,   498,   499,   500,   501,   502,   503,   145,
      35,   465,   508,   362,   362,  4734,   223,  4581,  4582,   292,
     435,   425,   393,  5063,  4532,   393,   251,   508,  4536,   197,
    4749,   507,   470,   798,   202,   800,    58,    58,    35,    80,
     507,   511,   507,   268,   508,  4651,   455,   417,  5935,  4655,
     507,   507,   817,   195,   819,   223,   224,   450,   508,   507,
     173,   417,   127,  4762,   266,   287,   507,   417,  5955,   223,
     238,  4655,   167,  4581,  4582,   508,   841,   842,  4674,   844,
     845,  4687,  4688,   290,   849,   474,  4692,  4693,   159,   507,
     507,    70,  5337,   291,    70,   140,   470,  5223,   863,   454,
     339,   866,    35,   511,  5349,   273,     8,   507,   873,    11,
     455,   507,   507,    15,    16,    17,   470,   178,   380,   417,
     885,   467,   290,   337,   508,   293,  4845,   275,   145,   207,
     287,   287,   357,    35,   507,   376,   290,  5263,    35,    35,
     326,   366,  5465,   507,   291,   291,   180,   180,   373,   511,
      58,   508,   361,   425,   125,   448,  4752,  4753,   376,  5482,
     507,   361,   347,  5511,  5487,   507,  5489,   508,   295,    21,
    4766,   936,  4768,  4769,    48,   508,  4772,   507,   507,    32,
     178,  4777,   275,   511,   507,   511,   159,   412,   507,   414,
      80,   425,   417,   508,  5320,   326,   393,   393,   507,  5325,
    5326,   470,   470,  4902,   969,   430,   401,  5021,   180,   508,
     435,   180,   507,   507,   308,   980,  1840,  2837,   386,     8,
     508,   883,    11,  3210,   449,  1039,    15,    16,    17,   994,
    5222,   989,  1038,  1494,   999,  1000,  3466,   462,  2710,  2631,
    3399,  4131,  4838,  1008,  1009,  5697,  5060,  4101,  5872,  5693,
    4246,  2735,  4777,  5568,  5554,  5247,  4296,  5172,  5803,  5073,
    4786,    60,  5073,  5138,  5072,  3317,  2982,  5020,  5675,  5508,
    5584,  5791,  5583,  1038,  1039,  5718,  4872,  5826,  4346,  3321,
    4844,  4333,  5517,  2812,  2812,  4126,  3432,   494,   495,   496,
    3673,   498,   499,   500,   501,   502,   503,  1034,    97,  4316,
    5148,  1066,  4825,  5022,  5023,  5024,  2803,  3687,  5116,  1074,
    5805,  5556,  4908,  5158,  5955,  5014,  5442,  5016,  5935,  5131,
    1085,   223,  5382,   491,  1089,  3623,   494,   495,   496,   128,
     498,   499,   500,   501,   502,   503,  4844,  3618,  5730,  5075,
     494,   495,   496,  1108,   498,   499,   500,   501,   502,   503,
    1921,  5323,  5527,  5078,    32,  1321,  4403,  5291,  2463,  4353,
    3293,  1977,  1338,  5441,  2522,   164,  2044,   702,  1118,  1134,
    3562,  2529,  4161,  2139,  1139,  2139,  4179,  2140,  1143,  5757,
     862,  1146,  1147,  5926,  1657,  2376,  2384,   738,   290,  2377,
    1602,  2387,  1858,  1860,  4336,  2079,  5003,  5667,  4583,  1518,
     199,  4021,  2130,  3809,  1169,  1170,  1171,  3243,  1173,  3254,
    1175,  3249,  1471,  1615,  2443,  5659,  3979,  5491,     8,  4563,
    2442,    11,  5000,  3955,  1617,    15,    16,    17,  1614,  4521,
    1195,  5258,  3952,  4538,   223,   234,  5468,  5467,  4022,  3952,
    5250,  5930,    32,  1622,  5775,  5860,  5649,  2004,  5225,  4994,
      40,  5261,  5697,  3905,  5060,  5662,  5642,  5663,  2332,  3161,
      50,  3159,  4970,  3071,  5060,  2335,  3041,  4975,    -1,  5188,
    4978,   270,   113,    -1,    -1,    -1,    -1,    -1,    -1,  5471,
      -1,    -1,    -1,  1248,  1249,    -1,  1251,    77,    -1,  1254,
    1255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   290,    -1,    -1,   303,   304,    -1,    -1,  5114,  5105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1284,
      -1,   162,    -1,    -1,    -1,    -1,    -1,  5653,    -1,    -1,
     329,    -1,    -1,    -1,  5344,    -1,    -1,    -1,    -1,   180,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,    -1,  1314,
    1315,   350,    -1,    -1,  1319,   354,  1321,    -1,  5803,    -1,
      -1,  1326,    -1,   362,   205,    -1,    -1,  5189,    -1,    -1,
      -1,    -1,   371,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,   380,  5146,  1348,    -1,    -1,  1351,    -1,    -1,  1354,
      -1,  1356,   494,   495,   496,   394,   498,   499,   500,   501,
     502,   503,    -1,    -1,   403,    -1,    40,   197,  5214,  1374,
     251,    -1,   202,    -1,    -1,    -1,    50,    -1,    -1,    -1,
      -1,    -1,  5341,  5187,  5343,    -1,    -1,   268,    -1,    -1,
    5268,    -1,    -1,   223,   224,    -1,    -1,    -1,  5146,    -1,
    1405,    -1,    -1,    77,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5649,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   464,    -1,    -1,    -1,  5479,
      -1,    -1,  1437,  1438,  1439,    -1,  1441,    -1,    -1,  5187,
      -1,    -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5508,    -1,  1461,    -1,    -1,    -1,
     290,    -1,    -1,   293,    -1,   494,   495,   496,    -1,   498,
     499,   500,   501,   502,   503,    -1,   357,    -1,   152,    -1,
      -1,    -1,    -1,    -1,    -1,   366,    -1,    -1,    -1,  5335,
    5336,    -1,   373,    -1,  1499,    -1,    -1,    -1,     8,  5335,
    5336,    11,   383,  5349,    -1,    15,    16,    17,    -1,  5257,
      -1,    -1,    -1,  5349,    -1,    -1,    -1,  5353,    -1,    -1,
    5268,    -1,    32,   197,    -1,    -1,    -1,    -1,   202,    20,
      40,    -1,    -1,   414,    25,    -1,   417,    -1,    -1,  5771,
      50,    -1,    -1,    -1,    -1,    -1,    -1,  5506,    -1,   430,
      -1,    -1,    -1,    -1,   435,    -1,   386,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    77,   449,    -1,
      -1,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   462,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,  1598,  1599,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1607,    94,    -1,    -1,  1611,  1612,    -1,  5455,
      -1,  5415,    -1,    -1,    -1,    -1,   290,  1622,  1623,  1624,
      -1,  1626,    -1,    -1,  5856,  5857,    -1,    -1,  1633,    -1,
      -1,    -1,    -1,    -1,  5682,    -1,  5595,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3042,  1650,    -1,    -1,    -1,    -1,
    3048,   142,    -1,    -1,    -1,    -1,    -1,  5405,    -1,    -1,
      -1,   491,   153,    -1,   494,   495,   496,  5415,   498,   499,
     500,   501,   502,   503,    -1,    -1,    -1,    -1,    -1,    -1,
    1685,   511,    -1,    -1,   175,    -1,  1691,   197,    -1,   180,
      -1,    -1,   202,  5497,    -1,    -1,    -1,    -1,    -1,    -1,
    5546,  1706,  1707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5758,  5759,   386,   223,   224,    -1,  1721,    -1,    -1,  1724,
    5556,    -1,    -1,    -1,  5560,    -1,  5562,    -1,   238,  5668,
    5566,  5567,    -1,  5569,    -1,    -1,    -1,    -1,    -1,    -1,
    5699,    -1,    -1,    -1,  1749,    -1,    -1,    -1,    -1,  5497,
      -1,    -1,    -1,  1758,    -1,  1760,    -1,    -1,    -1,    -1,
     251,    -1,    -1,   273,    -1,    -1,    -1,    -1,  1773,    -1,
      -1,  1776,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     290,    -1,    -1,   293,    -1,    -1,    -1,  5633,    -1,    -1,
      -1,    -1,    -1,    -1,    60,  3193,    -1,    -1,    -1,   290,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1813,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   491,    -1,  1824,
    1825,  1826,  1827,  1828,   498,   499,   500,   501,   502,   503,
      -1,    97,    -1,    -1,   325,    -1,  5795,  1842,    -1,    -1,
      -1,    -1,    -1,    -1,  5680,    -1,    -1,  5693,    -1,  5695,
      -1,    -1,    -1,  1858,    -1,  1860,  1861,  5693,  1863,  5695,
      -1,    -1,     8,    -1,    -1,    11,  3264,    -1,  5827,  5828,
    1875,  1876,    -1,    -1,    -1,   366,   386,    -1,    -1,    -1,
      -1,    -1,   373,    -1,    -1,   376,    -1,    -1,    -1,    -1,
      -1,    -1,  1897,    -1,    40,    -1,    -1,  1902,   164,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,  5957,
    5958,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1926,    -1,   414,    -1,    -1,    -1,  5731,    -1,    -1,
     421,    77,    -1,   199,    -1,    -1,    -1,   428,  5757,  1944,
    1945,  1946,  1947,    -1,   435,    -1,    -1,  5757,    -1,  5757,
      -1,    -1,  1957,  5757,  5757,    -1,    -1,  5835,    -1,  1964,
      -1,    -1,  1967,  5922,    -1,    -1,    -1,  5803,   234,    -1,
      -1,   462,  1977,    -1,    -1,  1980,    -1,    -1,    -1,    -1,
    1985,   491,    -1,  5731,   494,   495,   496,  1992,   498,   499,
     500,   501,   502,   503,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   511,    -1,    -1,   270,    -1,   152,    -1,    -1,  5757,
      -1,    -1,    -1,    -1,    -1,    -1,  5835,    -1,    -1,    -1,
      -1,    -1,    -1,  2028,  2029,  5835,  5872,  5835,    -1,    -1,
      -1,  5835,  5835,    -1,    -1,  5881,  5872,    -1,   304,  2044,
    2045,    -1,    -1,    -1,  2049,  5881,    -1,    -1,    -1,    -1,
      -1,   197,    -1,    -1,    -1,    -1,   202,    -1,    -1,    -1,
    2065,  2066,    -1,   329,    -1,    -1,  2071,    -1,    -1,  2074,
      -1,    -1,  2077,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   350,    -1,   352,  5835,   354,  5935,
      -1,    -1,   238,    -1,    -1,    -1,   362,  2102,    -1,  5935,
      -1,    -1,    -1,    -1,  2109,   371,  2111,  5926,    -1,  5955,
    2115,  2116,    -1,  2118,   380,    -1,  5926,    -1,  5926,  5955,
    2125,  5967,  5926,  5926,    -1,    -1,    -1,    -1,   394,    -1,
      -1,    -1,    -1,  2138,    -1,    -1,    -1,   403,  2143,  2144,
      -1,    -1,    -1,  2148,   290,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5926,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    -1,    -1,    -1,    -1,   464,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    50,    11,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     386,    -1,    -1,    -1,    -1,  2250,    32,  2252,    -1,    -1,
      -1,    77,  2257,  2258,    40,    -1,    -1,    -1,    -1,  2264,
    2265,  2266,    -1,    -1,    50,  2270,  2271,  2272,  2273,  2274,
    2275,  2276,  2277,    -1,  2279,    -1,  2281,  2282,    -1,    -1,
    2285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,
      -1,    77,    -1,    -1,    -1,  2300,  2301,  2302,  2303,    -1,
      -1,    -1,  2307,  2308,    -1,    -1,   180,  2312,    -1,    -1,
    2315,    -1,    -1,  2318,  2319,  2320,  2321,  2322,  2323,  2324,
    2325,  2326,    -1,  2328,    -1,    -1,    -1,    -1,    -1,  2334,
    2335,   205,  2337,    -1,    -1,    -1,    -1,    -1,    -1,  2344,
      -1,    -1,    -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,
      -1,    -1,   498,   499,   500,   501,   502,   503,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2375,   197,  2377,    -1,  2379,    -1,   202,   251,  2383,    -1,
      -1,  2386,  2387,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   268,    -1,    -1,   223,   224,    -1,
    2405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   197,   238,    -1,    -1,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2440,    -1,   223,   224,    -1,
      -1,    -1,  2447,    -1,  2449,    -1,    -1,   273,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   290,    -1,    -1,   293,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2482,    -1,    -1,
      -1,    -1,    -1,   357,    -1,    -1,  2491,   273,  2493,    -1,
      -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,    -1,    -1,     8,   290,  2510,    11,   293,    -1,   383,
      15,    16,    17,    -1,    -1,    -1,    -1,  2522,    -1,  2524,
    2525,    -1,    -1,    -1,  2529,    -1,  2531,    32,  2533,    -1,
    2535,    -1,  1191,    -1,  2539,    40,    -1,  2542,    -1,    -1,
     414,    -1,    -1,   417,    -1,    50,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3952,    -1,   430,  3955,    -1,  2564,
     386,   435,    -1,    -1,  1223,    -1,    -1,    -1,    -1,    -1,
    2575,    -1,    77,    -1,    -1,   449,    -1,    -1,    -1,    -1,
    2585,  2586,    -1,    -1,  1243,    -1,     8,    -1,   462,    11,
      -1,    -1,    -1,    15,    16,    17,  2601,    -1,  1257,    -1,
     386,    -1,  2607,    -1,    -1,  1264,  2611,    -1,    -1,    -1,
      32,  1270,    -1,    -1,    -1,    -1,    -1,  1276,    40,    -1,
    1279,    -1,    -1,  2628,    -1,    -1,    -1,    -1,    50,    -1,
      -1,  2636,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4041,    -1,    -1,  2651,  2652,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,  2661,  2662,    -1,    -1,
    2665,    -1,  2667,  2668,    -1,   491,    -1,    -1,   494,   495,
     496,    -1,   498,   499,   500,   501,   502,   503,    -1,    -1,
      -1,  2686,   508,    -1,  2689,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   197,    -1,    -1,    -1,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   491,  2711,  2712,   494,   495,
     496,    -1,   498,   499,   500,   501,   502,   503,   223,   224,
      -1,  2726,   508,  2728,  2729,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   238,    -1,     8,  4134,    -1,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2759,    -1,  2761,    -1,    -1,    32,
      -1,    -1,    -1,  2768,    -1,    -1,    -1,    40,   273,    -1,
      -1,  2776,  2777,    -1,    -1,   197,    -1,    50,  2783,    -1,
     202,    -1,    -1,    -1,    -1,   290,    -1,    -1,   293,    -1,
      -1,  2796,    -1,  2798,    -1,    -1,    -1,    -1,    -1,    35,
      -1,   223,   224,    -1,    77,    -1,    -1,    -1,    -1,    -1,
    2815,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,  2827,    59,  2829,    -1,    -1,  2832,    -1,    -1,
      -1,    -1,  2837,    -1,    -1,  2840,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2852,    -1,  2854,
    2855,   273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2872,   290,    -1,
      -1,   293,    46,    -1,    -1,   111,   112,  2882,    -1,  2884,
      -1,   386,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2907,  2908,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4319,    -1,    -1,   197,    -1,    -1,    -1,    -1,   202,
    2935,    -1,    -1,    -1,    -1,  2940,  2941,  2942,  2943,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,
     223,   224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   386,   238,    -1,    -1,   204,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2982,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,    -1,   498,   499,   500,   501,   502,   503,    -1,
     273,    -1,    -1,   508,    -1,    -1,    -1,    -1,    -1,    -1,
    3015,    -1,    -1,    -1,    -1,    -1,   252,   290,     8,   255,
     293,    11,    -1,  3028,    -1,    15,    16,    17,    -1,    -1,
     266,    -1,    -1,    -1,   270,    -1,  3041,  3042,    -1,    -1,
      -1,    -1,    32,  3048,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    -1,    -1,    -1,  3062,    -1,   233,
      50,    -1,    -1,    -1,    -1,  3070,   302,    -1,    -1,   491,
    3075,   245,   494,   495,   496,    -1,   498,   499,   500,   501,
     502,   503,    -1,   257,    -1,    -1,   508,    77,    -1,    -1,
      -1,    -1,    -1,  3098,  3099,  3100,    -1,    -1,  3103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3111,  3112,  3113,  3114,
      -1,    -1,    -1,   386,    -1,   351,    -1,    -1,    -1,  3124,
      -1,    -1,  3127,    -1,  3129,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4532,  3140,  3141,   373,  4536,  3144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3156,    -1,  3158,    -1,  3160,    -1,  3162,    -1,    -1,
     396,    -1,   398,    -1,    -1,    -1,   402,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,  3182,    15,    16,
      17,  3186,    -1,    -1,    -1,    -1,    -1,    -1,  3193,    -1,
    3195,  3196,  3197,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,   197,  3213,    -1,
      -1,    -1,   202,    50,    -1,    -1,    -1,    -1,   491,    -1,
      -1,   494,   495,   496,    -1,   498,   499,   500,   501,   502,
     503,  3236,    -1,   223,   224,   508,  3241,    -1,  3243,    -1,
      77,    -1,    -1,  3248,    -1,    -1,    -1,    -1,   238,  3254,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3264,
      -1,    -1,    -1,  3268,    -1,    -1,  3271,    -1,  3273,    -1,
       8,   507,    -1,    11,    -1,    -1,    -1,    15,    16,    17,
      -1,    -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,
     290,    -1,    40,   293,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3316,    50,  3318,    -1,    -1,    -1,    -1,  3323,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    -1,    -1,  3350,    -1,  3352,  3353,  3354,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,
     197,    -1,    -1,    -1,    -1,   202,    -1,    -1,    50,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2035,    -1,    -1,    -1,
    2039,    -1,    -1,    -1,    -1,    -1,   223,   224,  2047,    -1,
      -1,    -1,    -1,    -1,    -1,    77,   386,    -1,    -1,    -1,
    4798,   238,    -1,    -1,    -1,  2064,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    -1,    -1,    -1,   273,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3454,
      -1,    -1,    -1,   290,    -1,    -1,   293,    -1,    -1,   197,
      -1,    -1,    -1,    -1,   202,    -1,   640,    -1,    -1,    97,
      -1,    -1,   646,    -1,    -1,    -1,    -1,  3482,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   223,   224,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     238,   491,    -1,    -1,   494,   495,   496,    -1,   498,   499,
     500,   501,   502,   503,    -1,   197,    -1,    -1,   508,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   164,    -1,    -1,    -1,
      -1,   223,   224,    -1,    -1,    -1,    -1,    -1,    -1,   386,
      -1,    -1,   290,    -1,    -1,   293,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4963,    -1,    -1,    -1,    -1,
      -1,   199,  4970,    -1,    -1,    -1,    -1,  4975,    -1,  3584,
    4978,  4979,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3594,
      -1,   273,    -1,    -1,  3599,  3600,    -1,    -1,    -1,    -1,
      -1,   229,    -1,    -1,    -1,    -1,   234,    -1,   290,  5007,
      -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5020,    -1,    -1,  3630,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3639,  3640,  3641,    -1,    -1,    -1,
      -1,    -1,   270,   817,    -1,    -1,    -1,    -1,   386,  3654,
      -1,    -1,    -1,    -1,   491,  3660,    -1,   494,   495,   496,
      -1,   498,   499,   500,   501,   502,   503,    -1,    -1,    -1,
     844,   508,    -1,    -1,  5072,    -1,   304,    -1,    -1,    -1,
    3685,  3686,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   863,
    3695,  3696,  3697,    -1,    -1,    -1,  3701,    -1,    -1,    -1,
      -1,   329,    -1,    -1,   386,    -1,    -1,  3712,    -1,    -1,
      -1,   885,    -1,    -1,    -1,  2374,    -1,    -1,  5116,    -1,
      -1,    -1,   350,    -1,    -1,    -1,   354,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   371,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   380,   491,    -1,    -1,   494,   495,   496,    -1,
     498,   499,   500,   501,   502,   503,   394,  3772,    -1,    -1,
     508,    -1,  3777,    -1,    25,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3795,    -1,  5190,    -1,    -1,    -1,    -1,    -1,    -1,  3804,
     428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,  3820,   498,   499,   500,   501,
     502,   503,    -1,    -1,    -1,   999,   508,    -1,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   464,    -1,  3843,    -1,
      -1,   469,    -1,    -1,    -1,    -1,    -1,  3852,    -1,    -1,
      -1,    -1,    -1,  3858,    -1,  3860,    -1,    -1,  3863,  5257,
      -1,    -1,   113,  3868,  3869,  3870,  3871,    -1,    -1,  3874,
    3875,  3876,  3877,  3878,  3879,  3880,  3881,  3882,  3883,    -1,
      -1,    -1,  3887,  3888,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   142,  3897,    -1,    -1,    -1,  3901,    -1,    -1,    -1,
    3905,    -1,   153,    -1,    -1,    -1,    -1,    -1,  3913,    -1,
      -1,  3916,    -1,  3918,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,  3927,    -1,   175,  3930,  3931,    -1,    -1,   180,
    3935,  3936,    -1,    -1,    -1,  3940,    -1,  3942,    -1,    -1,
      -1,    -1,    -1,    60,  3949,  3950,  3951,  3952,    -1,    -1,
    3955,  3956,    -1,    -1,    -1,  3960,  3961,  3962,    -1,    -1,
    1134,    -1,    -1,  3968,    -1,    -1,    -1,    -1,    -1,  3974,
    3975,  3976,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,
      97,    -1,    -1,  5381,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1169,  1170,  1171,    -1,    -1,
     251,    -1,  4007,    -1,    -1,    -1,    -1,  5405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4021,    -1,  4023,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4041,  4042,  4043,    -1,
    4045,    -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4062,  4063,  4064,
    4065,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5468,    -1,    -1,    -1,   325,    -1,    -1,   328,    -1,    -1,
      -1,    -1,   199,    -1,    -1,    -1,  4091,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5500,    -1,    -1,    -1,   357,  4112,    -1,    -1,
      -1,    -1,   229,    -1,  4119,   366,    -1,   234,    -1,    -1,
      -1,    -1,   373,    -1,    -1,    -1,    -1,    -1,    -1,  4134,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   389,    -1,
       8,    -1,    -1,    11,    -1,  1319,    -1,    15,    16,    17,
      -1,    -1,    -1,   270,   405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   414,    32,    -1,   417,    -1,    -1,    -1,
      -1,    -1,    40,    -1,    -1,    -1,    -1,  1351,    -1,    -1,
      -1,    -1,    50,    -1,   435,    -1,     8,   304,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4213,    77,
      32,   462,   329,    -1,    -1,    -1,  5614,  4222,    40,    -1,
      -1,    -1,    -1,  4228,    -1,    -1,    -1,    -1,    50,    -1,
      -1,    -1,    -1,   350,    -1,    -1,    -1,   354,    -1,    -1,
      -1,    -1,    -1,    -1,  2903,   362,    -1,    -1,    -1,    -1,
      -1,    -1,  2911,    -1,   371,    77,    -1,  4262,    -1,    -1,
      -1,  4266,    -1,   380,  4269,    -1,  4271,    -1,    -1,    -1,
      -1,    -1,  2931,  4278,    -1,    -1,    -1,   394,    -1,  4284,
      -1,    -1,    -1,    -1,  5682,  2944,   403,    -1,    -1,    -1,
    2949,  4296,    -1,  2952,    -1,    -1,    -1,    -1,    -1,  2958,
      -1,  2960,    -1,  2962,    -1,    -1,    -1,    -1,    -1,    -1,
    4315,   428,    -1,    -1,  4319,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4329,  1499,    -1,    -1,    -1,   197,
      -1,    -1,    -1,  4338,   202,    -1,    -1,    -1,    -1,  5737,
      -1,  4346,    -1,    -1,    -1,  4350,    -1,   464,    -1,  4354,
    4355,    -1,   469,    -1,  5752,   223,   224,    -1,    -1,    -1,
    5758,  5759,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,    -1,    -1,   197,    -1,  3036,    -1,  4384,
     202,  4386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4395,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   223,   224,    -1,    -1,   273,    -1,  4412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,   290,    -1,    -1,  4430,    -1,    -1,  5826,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4441,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1623,
      -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4471,    -1,   290,    -1,
      -1,   293,    -1,    22,    -1,    -1,  4481,  4482,    -1,    28,
      -1,    -1,    -1,  4488,  4489,    -1,    -1,    -1,  4493,    -1,
      -1,    -1,    41,  4498,    -1,    -1,  4501,  4502,    -1,    -1,
      -1,  4506,  4507,    -1,    -1,    -1,    -1,  4512,  4513,  4514,
    4515,  4516,    -1,    -1,    -1,  4520,  4521,  4522,   386,  4524,
    4525,    -1,    -1,  4528,    -1,  5923,    75,  4532,    -1,    -1,
      -1,  4536,  1706,    -1,    -1,  5933,    -1,  4542,    -1,    -1,
      -1,    -1,    -1,    -1,  4549,    -1,    -1,  1721,    -1,  4554,
      -1,    -1,    -1,    -1,    -1,  4560,    -1,    -1,    -1,  5957,
    5958,    -1,  5960,    -1,   386,  4570,  4571,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4579,    -1,   125,    -1,  4583,   128,
      -1,    -1,    -1,  4588,   133,    -1,  1760,    -1,   137,   138,
     139,    -1,    -1,    -1,    -1,   144,    -1,  4602,   147,  1773,
    4605,    -1,  1776,    -1,    -1,    -1,   155,    -1,    -1,    22,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,
    4625,  4626,    -1,   491,    -1,   174,   494,   495,   496,    -1,
     498,   499,   500,   501,   502,   503,    -1,    -1,  4643,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4656,    -1,    -1,  1828,    -1,    -1,    -1,   207,    -1,
      -1,    -1,    75,    -1,    -1,    -1,    -1,  3326,  1842,   491,
      -1,    -1,   494,   495,   496,    -1,   498,   499,   500,   501,
     502,   503,    -1,    -1,    -1,    -1,   508,    -1,    -1,  1863,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4712,    -1,    -1,
      -1,    -1,   125,    -1,    -1,   128,    -1,   266,    -1,    -1,
     133,   270,    -1,    -1,   137,   138,   139,    -1,    -1,  4734,
      -1,   144,   281,    -1,   147,    -1,    -1,    -1,     8,    -1,
      -1,    11,   155,   292,  4749,    15,    16,    17,    -1,    -1,
      -1,    -1,  1926,    -1,   303,    -1,  3415,    -1,  3417,    -1,
      -1,   174,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4784,
      50,    -1,    -1,  1957,    -1,    -1,    -1,   336,    -1,    -1,
    1964,    -1,    -1,  4798,   207,    -1,    -1,   346,    -1,  4804,
     349,   350,    -1,    -1,    -1,    -1,    -1,    77,  4813,    -1,
      -1,  4816,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4832,    -1,    -1,
      -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4845,    -1,  4847,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    11,   266,    -1,    -1,    -1,   270,    -1,    18,
      19,    -1,    -1,    -1,    -1,    24,    -1,    26,   281,    -1,
      -1,    -1,  4877,    32,    -1,    -1,   425,    -1,    37,   292,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     303,  4896,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3558,
      59,    60,    -1,  2077,   453,  3564,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4918,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4927,   336,    -1,    -1,    -1,   197,    -1,    -1,
      -1,    -1,   202,   346,    -1,    -1,   349,   350,    -1,  4944,
    4945,  2115,  2116,  4948,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   223,   224,    -1,    -1,    -1,  4963,    -1,
      -1,  4966,    -1,    -1,  2138,  4970,    -1,   380,   238,    -1,
    4975,    -1,    -1,  4978,  4979,    -1,  4981,    -1,  4983,    -1,
      -1,  4986,  4987,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5007,   273,  5009,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   425,    -1,    -1,  5020,  5021,  5022,  5023,  5024,
     290,    -1,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5061,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5072,  5073,   228,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     239,    -1,   241,    -1,   243,   244,    -1,   246,   247,    -1,
     249,    -1,    -1,   252,    -1,   254,    -1,    -1,  3757,  3758,
      -1,  3760,    -1,  3762,    -1,    -1,    -1,    -1,    -1,    -1,
    3769,  5116,    -1,    -1,  5119,    -1,   386,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,  5131,    11,    -1,  5134,
      -1,    15,    16,    17,  5139,    -1,  5141,    -1,    -1,  5144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5152,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
    2334,    -1,  3821,  5168,    -1,    -1,    50,  5172,    -1,    -1,
    2344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5188,  5189,  5190,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2375,    -1,  2377,    -1,    -1,    -1,    -1,    -1,  2383,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5222,    -1,    -1,
    5225,   491,  5227,    -1,   494,   495,   496,    -1,   498,   499,
     500,   501,   502,   503,    -1,    -1,    -1,    -1,   508,    -1,
      -1,    -1,  5247,    -1,    -1,    -1,    -1,    -1,  5253,    -1,
      -1,    -1,  5257,    -1,    -1,    -1,  5261,    -1,    -1,    -1,
      -1,    -1,    -1,  5268,    -1,    -1,  2440,    -1,    -1,    -1,
      -1,    -1,  5277,    -1,    -1,    -1,    -1,  5282,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5303,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   197,    -1,    -1,    -1,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,  5330,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5340,  5341,  5342,  5343,   223,
     224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
      -1,    -1,  5397,    -1,    -1,    -1,    -1,  5402,    -1,    -1,
    5405,    -1,    -1,    -1,    -1,    -1,   290,    -1,    -1,   293,
      -1,    -1,  2586,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    -1,  2607,    28,    -1,    -1,  2611,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5465,    -1,  2636,  5468,    -1,    -1,  5471,    -1,    -1,    -1,
    5475,    -1,    -1,    -1,    -1,    -1,    -1,  5482,    -1,    -1,
      -1,    75,  5487,    -1,  5489,    -1,  5491,    -1,    -1,    -1,
     649,    -1,    -1,    -1,    -1,  5500,    -1,    -1,    -1,   658,
      -1,  5506,   386,  5508,    -1,    -1,    -1,    -1,    -1,    -1,
     669,   670,    -1,  5518,   673,    -1,    -1,   676,   677,    -1,
      -1,    -1,   681,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   125,    -1,   692,    -1,    -1,   130,  2711,  2712,   133,
      -1,    -1,    -1,   137,   138,   139,    -1,    -1,   707,    -1,
     144,    -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,  5564,
    5565,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   734,    -1,   736,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,   746,    -1,    -1,
    5595,    -1,    -1,   752,    -1,    -1,    -1,  5602,    -1,    -1,
      -1,  5606,    -1,    -1,    -1,    -1,    -1,   491,    -1,  5614,
     494,   495,   496,   207,   498,   499,   500,   501,   502,   503,
      -1,    -1,   781,    -1,   508,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5641,  5642,    -1,    -1,
      -1,  5646,    -1,    -1,  5649,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5659,  2829,    -1,  5662,    -1,   818,
      -1,    -1,  5667,    -1,    -1,    -1,    -1,   712,    -1,    -1,
      -1,    -1,   266,    -1,    -1,    -1,   270,  5682,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   281,    -1,    -1,
      -1,    -1,    -1,    -1,  5699,   740,    -1,    -1,   292,    -1,
      -1,  5706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,
      -1,    -1,    -1,    -1,    -1,   874,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5732,    -1,  4388,
      -1,    -1,  5737,  4392,    -1,    -1,    -1,  5742,    -1,    -1,
      -1,    -1,   336,    -1,    -1,    -1,    -1,  5752,    -1,    -1,
      -1,    -1,   346,  5758,  5759,   349,   350,  5762,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5771,    -1,    -1,    -1,
    5775,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5788,    -1,    -1,   380,    -1,    -1,    -1,
    5795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,   977,    -1,
      -1,  5826,  5827,  5828,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   425,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1003,    28,    -1,    30,    31,    -1,
      -1,  5856,  5857,    -1,  3028,    -1,    -1,    -1,    -1,   453,
      43,    -1,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    71,    -1,
      73,    74,    75,    -1,  1053,    -1,  5901,    -1,    81,    -1,
      83,    84,  5907,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    98,    -1,  5922,  5923,  1078,
      -1,    -1,    -1,    -1,    -1,  5930,    -1,    -1,  5933,    -1,
      -1,  1090,    -1,   116,  1093,    -1,   119,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,  1104,    -1,    15,    16,    17,
    1109,   134,  5957,  5958,    -1,  5960,    -1,   140,  1117,    -1,
      -1,   144,  4621,    -1,    32,    -1,  1125,   150,    -1,    -1,
    1129,    -1,    40,    -1,    -1,    -1,   159,    -1,   161,    -1,
      -1,    -1,    50,    -1,    -1,   168,  1145,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   184,    -1,    -1,    -1,    -1,  4665,  4666,    -1,    77,
      -1,    -1,  3186,    -1,    -1,    -1,    -1,  1176,   201,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1081,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,   240,   241,    -1,
    1105,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,
      32,    -1,    -1,    -1,    -1,   258,    -1,  1122,    40,    -1,
      -1,    -1,    -1,    -1,   267,   268,    -1,    -1,    50,   272,
      -1,    -1,    -1,    -1,  1253,    -1,  4755,  4756,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1282,    -1,    -1,    -1,    -1,   311,   197,
      -1,    -1,    -1,    -1,   202,    -1,    -1,   320,  1297,    -1,
    1299,    -1,  1301,    -1,  1303,    -1,  1305,  1306,  1307,    -1,
      -1,    -1,   335,  1312,    -1,   223,   224,    -1,    -1,   342,
     343,    -1,   345,    -1,  1323,    -1,    -1,   350,    -1,    -1,
     238,    -1,   355,  1218,  1333,   358,   359,     8,    -1,    -1,
      11,   364,   365,    -1,    15,    16,    17,    -1,   371,   372,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,
      -1,    32,   385,    -1,    -1,   273,    -1,    -1,    -1,    40,
      -1,    -1,    -1,   396,    -1,    -1,    -1,    -1,    -1,    50,
      -1,  4880,   290,  4882,  4883,   293,    -1,    -1,    -1,    -1,
      -1,   414,    -1,    -1,    -1,   197,    -1,    -1,    -1,    -1,
     202,    -1,  4901,    -1,    -1,    -1,    77,    -1,    -1,    -1,
     433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     443,   223,   224,   446,    -1,    -1,    -1,    -1,   451,    -1,
      -1,    -1,    -1,   456,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   470,    -1,    -1,
    1335,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    15,    16,    17,  3482,    -1,
     493,   273,    -1,    -1,    -1,    -1,    -1,    -1,   386,    -1,
      -1,    -1,    32,    -1,   507,    -1,    -1,   510,   290,    -1,
      40,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1518,
      -1,    -1,    -1,    -1,    -1,    -1,   197,    77,    -1,    -1,
      -1,   202,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,
      -1,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    -1,   238,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    -1,    -1,   491,   386,    -1,   494,   495,   496,    -1,
     498,   499,   500,   501,   502,   503,    -1,    -1,    -1,    -1,
     508,    -1,   273,    -1,    -1,    -1,    77,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   290,
      -1,    -1,   293,    -1,    -1,  3639,  3640,  3641,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3660,   197,    -1,    -1,
      -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3686,   223,   224,  1674,    -1,    -1,    -1,    -1,
      -1,    -1,  3696,  3697,    -1,    -1,    -1,  3701,   238,   491,
      -1,    -1,   494,   495,   496,    -1,   498,   499,   500,   501,
     502,   503,    -1,    -1,     8,    -1,   508,    11,    -1,    -1,
      -1,    15,    16,    17,    -1,   386,    -1,    -1,    -1,  5218,
      -1,    -1,    -1,   273,    -1,    -1,   197,    -1,    32,    -1,
      -1,   202,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
     290,    -1,    -1,   293,    -1,  1630,    50,    -1,    -1,    -1,
      -1,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,    -1,
    1759,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    -1,    -1,    -1,  5293,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,    32,    -1,    -1,  3820,    -1,    -1,    -1,
      -1,    40,    -1,    -1,  1699,    -1,    -1,    -1,    -1,   290,
     491,    50,   293,   494,   495,   496,    -1,   498,   499,   500,
     501,   502,   503,    -1,    -1,    -1,   386,   508,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5345,    -1,    77,    -1,
      -1,    -1,    -1,     8,    -1,  1854,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,  1754,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,  1777,   197,    -1,    50,    -1,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1909,    -1,    -1,    -1,    -1,   386,    -1,    -1,    -1,   223,
     224,    -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,  3949,  3950,  3951,    -1,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,    -1,   498,   499,
     500,   501,   502,   503,    -1,    -1,    -1,    -1,   508,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   197,   273,
      -1,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1866,    -1,    -1,    -1,    -1,   290,    -1,    -1,   293,
      -1,    -1,    -1,    -1,   223,   224,  1881,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1891,    -1,    -1,   238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1904,
     491,    -1,    -1,   494,   495,   496,    -1,   498,   499,   500,
     501,   502,   503,    -1,    -1,    -1,    -1,   508,    -1,    -1,
      -1,    -1,   197,    -1,   273,    -1,    -1,   202,    -1,    -1,
      -1,  2050,    -1,  2052,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   290,    -1,    -1,   293,    -1,    -1,    -1,   223,   224,
      -1,  2070,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   386,   238,    -1,  1970,    -1,    -1,    -1,  2088,
      -1,  2090,    -1,  2092,    -1,  2094,    -1,  2096,    -1,  1984,
      -1,  2100,    -1,    -1,    -1,  4119,    -1,    -1,    22,    -1,
      -1,    -1,    -1,  1998,    28,    -1,    -1,    -1,   273,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2011,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   290,    -1,    -1,   293,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   386,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2057,  2058,    -1,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,   491,    -1,    -1,
     494,   495,   496,    -1,   498,   499,   500,   501,   502,   503,
      32,    -1,    -1,    -1,   508,    -1,    -1,    -1,    40,    -1,
      -1,   125,    -1,    -1,    -1,    -1,   130,    -1,    50,   133,
      -1,    -1,    -1,   137,   138,   139,    -1,    -1,    -1,    -1,
     144,   386,    -1,   147,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   155,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    -1,  4266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     174,    -1,   491,    -1,  4278,   494,   495,   496,    -1,   498,
     499,   500,   501,   502,   503,    -1,    -1,    -1,    -1,   508,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5786,    -1,    -1,
      -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4346,    -1,    -1,    -1,   491,    -1,    -1,   494,
     495,   496,    -1,   498,   499,   500,   501,   502,   503,    -1,
      -1,     8,   266,   508,    11,    -1,   270,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,   197,    -1,   281,    -1,    -1,
     202,    -1,    -1,    -1,    -1,    32,    -1,    -1,   292,    36,
      -1,  4395,    -1,    40,    -1,    -1,    -1,    -1,    -1,   303,
      -1,   223,   224,    50,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2299,    -1,    -1,    -1,    -1,    -1,
      77,    -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   346,    -1,    -1,   349,   350,    -1,    -1,    -1,
      -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2337,  2452,  2453,    -1,    -1,    -1,   290,    -1,
      -1,   293,     8,    -1,    -1,    11,   380,    -1,    -1,    15,
      16,    17,   129,    -1,  2473,  2474,    -1,    -1,    -1,  2478,
    2479,    -1,    -1,    -1,  2483,    -1,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,  2497,  4513,
    4514,  4515,  4516,    -1,    50,  2504,    -1,    -1,    -1,  2508,
    2509,   425,    -1,  2512,  2513,    -1,    -1,    -1,    -1,    -1,
    2519,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,  2532,    -1,  2534,    -1,    -1,    -1,   453,
     197,    -1,    -1,    -1,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   386,  2554,    -1,    -1,    -1,    -1,
    2559,    -1,    -1,    -1,    -1,    -1,   223,   224,    -1,    -1,
      -1,    -1,    -1,  2458,  2573,    -1,    -1,  2462,  2463,    -1,
      -1,   238,    -1,    -1,    -1,  2584,    -1,    -1,  2587,    -1,
      -1,    -1,  2591,  2592,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2600,    -1,    -1,    -1,    -1,  2605,  2606,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,  2617,    -1,
      -1,    -1,    -1,    -1,  2623,    -1,    -1,   173,    -1,    -1,
      -1,  2630,   178,   290,    -1,    -1,   293,    -1,    -1,    -1,
      -1,  2526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   197,    -1,  2538,    -1,    -1,   202,  2656,    -1,   491,
      -1,    -1,   494,   495,   496,  2664,   498,   499,   500,   501,
     502,   503,    -1,    -1,   506,    -1,  2675,   223,   224,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2687,    -1,
      -1,  2690,   238,    -1,    -1,    -1,  2695,  2582,    -1,    -1,
    2699,    -1,  2701,  2702,    -1,    -1,    -1,  2706,    -1,    -1,
    2709,    -1,    -1,    -1,  2713,  2714,  2715,  2716,    -1,  2718,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,   386,
      -1,     8,  2731,  2732,    11,  2734,    -1,    -1,    15,    16,
      17,    -1,    -1,    -1,   290,  2744,  2745,   293,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,
      -1,    -1,    -1,   450,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    32,    -1,    -1,    -1,    -1,    22,    -1,  2808,
      40,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,
      50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
     386,   498,   499,   500,   501,   502,   503,    77,    -1,  2848,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      75,    -1,    -1,  4877,     8,    -1,    -1,    11,    -1,    -1,
      -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,
     125,    -1,  2797,    -1,    -1,    -1,    -1,    -1,   133,    -1,
     197,    -1,   137,   138,   139,   202,    -1,    -1,    -1,   144,
      -1,    -1,   147,    77,    -1,    -1,    -1,    -1,    -1,  2938,
     155,    -1,   172,    -1,    -1,   491,   223,   224,   494,   495,
     496,    -1,   498,   499,   500,   501,   502,   503,    -1,   174,
      -1,   238,    -1,    -1,    -1,    -1,    -1,   197,    -1,    -1,
      -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   207,   223,   224,    -1,   273,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,  2894,
      -1,    -1,    -1,   290,    -1,    -1,   293,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3029,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   319,   273,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   266,    -1,   197,    -1,   270,    -1,    -1,   202,    -1,
     290,    -1,    -1,   293,  3063,    -1,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   292,    -1,   223,
     224,    -1,    -1,    -1,    -1,    -1,   316,    -1,   303,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5119,    -1,    -1,    -1,   386,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5134,   336,    -1,    -1,    -1,  5139,    -1,   404,    -1,   273,
      -1,   346,    -1,    -1,   349,   350,    -1,    -1,    -1,  3024,
      -1,    -1,    -1,    -1,    -1,    -1,   290,    -1,    -1,   293,
      -1,    -1,    -1,    -1,  5168,    -1,   386,    -1,    -1,    -1,
    3045,    -1,    -1,    -1,    -1,   380,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,  3059,    -1,    -1,    -1,    -1,   230,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,    -1,    -1,
     425,    -1,    -1,    -1,   491,    -1,    -1,   494,   495,   496,
      -1,   498,   499,   500,   501,   502,   503,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,    -1,
      -1,    -1,   386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   491,    -1,    -1,   494,   495,   496,    -1,   498,   499,
     500,   501,   502,   503,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5303,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,
    3195,  3196,  3197,    -1,    -1,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,  3338,
      -1,    -1,    -1,  3342,    -1,    -1,    -1,   491,    -1,  3348,
     494,   495,   496,    -1,   498,   499,   500,   501,   502,   503,
      -1,    -1,    -1,    77,    -1,  3364,  3365,    -1,    -1,    -1,
    3369,    -1,    -1,    -1,    -1,  3374,  3375,  3376,    -1,  3378,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,  5402,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,  3283,    -1,
      -1,  3286,    -1,  3288,  3403,    -1,    -1,    -1,  3293,    -1,
      32,    -1,    -1,    35,    -1,    -1,    -1,    -1,    40,  3418,
    3419,  3420,  3421,    -1,    -1,    -1,    -1,    -1,    50,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    15,    16,    17,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    77,    -1,    -1,    -1,  3344,
    3459,    -1,    40,  3462,  3463,  3464,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    -1,    -1,    -1,  3361,    -1,    -1,    -1,
      -1,    -1,    -1,   197,    -1,    -1,    -1,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,  3386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,
     224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3572,    -1,   197,   290,    -1,    -1,   293,
     202,  3580,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3474,
      -1,  3476,    -1,    -1,    -1,    -1,    -1,   648,   312,    -1,
     178,   223,   224,    -1,    -1,  3604,    -1,    -1,    -1,    -1,
     661,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,   197,
     671,    -1,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   685,  3634,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   223,   224,    -1,    -1,    -1,
     701,   273,    -1,    -1,    -1,   706,    -1,    -1,    -1,    -1,
     238,   712,    -1,    -1,    -1,   716,   717,    -1,   290,    -1,
      -1,   293,   386,    -1,  3559,    -1,   727,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   740,
     741,    -1,    -1,    -1,  3693,   273,    -1,    -1,    22,  3698,
      -1,    -1,    -1,   754,    28,    -1,    -1,    -1,  3593,    -1,
      -1,    -1,   290,    -1,    -1,   293,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3726,    -1,    -1,
      -1,  3616,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3624,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   386,    -1,  3765,    -1,  3767,    -1,
      -1,    -1,    -1,    -1,    -1,  3774,    -1,   491,    -1,    -1,
     494,   495,   496,    -1,   498,   499,   500,   501,   502,   503,
     841,   842,    -1,    -1,    -1,    -1,   847,    -1,    -1,    -1,
      -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,   386,   133,
      -1,    -1,  3811,   137,   138,   139,    -1,    -1,  3703,    -1,
     144,    -1,   873,   147,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   155,    -1,    -1,  3719,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3732,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   491,
      -1,    -1,   494,   495,   496,    -1,   498,   499,   500,   501,
     502,   503,    -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   491,    -1,    -1,   494,   495,   496,    -1,
     498,   499,   500,   501,   502,   503,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   266,    -1,    -1,    -1,   270,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   281,    -1,    -1,
      -1,  3846,    -1,    -1,     8,    -1,    -1,    11,   292,    -1,
      -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,   303,
      -1,    -1,  3867,    -1,    -1,    -1,    -1,    -1,    32,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    50,  3892,    -1,    -1,
      -1,    -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   346,  1074,    -1,   349,   350,    -1,    -1,    -1,
    1081,    -1,    -1,    77,  1085,    -1,    -1,    -1,    -1,    -1,
      -1,  3926,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4048,
      -1,  4050,    -1,    -1,  1105,    -1,   380,    -1,  4057,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1122,    -1,    -1,  4073,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4089,  3976,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,   425,    11,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,  4110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,  1175,    -1,    -1,    -1,    -1,   453,
    4129,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,  4141,    -1,  4029,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   197,    -1,    -1,    -1,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,  4164,    -1,  1218,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4175,  4176,  4177,   223,
     224,    -1,    -1,    -1,  4183,  4184,  4185,  4186,    -1,    -1,
      -1,  4190,  4191,    -1,   238,    -1,    -1,  4196,  4197,    -1,
    4199,  4200,  4201,  4202,  4203,  4204,    -1,  4206,  1259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4215,    -1,    -1,  4218,
    4219,    -1,    -1,  1274,    -1,    -1,    -1,    -1,    -1,   273,
      -1,    -1,    -1,  1284,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1292,    -1,    -1,    -1,    -1,   290,  4132,  4247,   293,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1320,
      -1,  4270,    -1,    -1,    -1,    -1,    -1,  4162,    -1,    -1,
      -1,    -1,    -1,    -1,  1335,    -1,  1337,    -1,   197,    -1,
      -1,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1352,    -1,    -1,    -1,  1356,  1357,    -1,    -1,  1360,
      -1,    -1,    -1,    -1,   223,   224,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1374,    -1,    -1,    -1,    -1,    -1,   238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4372,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   290,    -1,    -1,   293,    -1,  1437,  1438,  1439,    -1,
    1441,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4407,    -1,
    1461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1485,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1493,  1494,    -1,    -1,    -1,   491,    -1,    -1,
     494,   495,   496,    -1,   498,   499,   500,   501,   502,   503,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4353,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,   386,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      32,    -1,    -1,    35,    -1,    -1,    -1,    -1,    40,    -1,
      -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    50,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1607,    -1,    -1,    -1,
    1611,  1612,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1626,    -1,    -1,    -1,  1630,
      -1,    -1,   491,    -1,    -1,   494,   495,   496,  1639,   498,
     499,   500,   501,   502,   503,    -1,    -1,    -1,    -1,  4484,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    15,    16,    17,
      -1,    -1,  4631,    -1,    -1,    -1,  4635,  4636,  4637,  4638,
      -1,    -1,  4641,    -1,    32,    -1,    -1,    -1,  1699,    -1,
      -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    -1,  4549,   197,    -1,    -1,    -1,  4554,
     202,    -1,    -1,    -1,    -1,  4560,    -1,    -1,    -1,  4678,
    4679,  4680,    -1,  4682,    -1,    -1,  4685,  4686,    -1,    77,
      -1,   223,   224,    -1,    -1,    -1,    -1,    -1,  4697,  4698,
      -1,    -1,    -1,  1754,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,  4724,  1777,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4623,    -1,
      -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,  4747,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   290,    -1,
      -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4661,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,  1838,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    -1,
      -1,    -1,    -1,    -1,  4689,    -1,    -1,    -1,    -1,   197,
      -1,    -1,    -1,    -1,   202,  1866,    -1,   113,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1881,    -1,  4831,    -1,    -1,   223,   224,    -1,    -1,    -1,
    1891,    -1,    -1,    -1,    -1,    -1,   142,  1898,    -1,    -1,
     238,    -1,    -1,  1904,   386,    -1,    -1,   153,    -1,    -1,
      -1,  4860,    -1,    -1,    -1,    -1,   162,    -1,    -1,  4754,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
      -1,  1932,    -1,    -1,   180,   273,  4885,    -1,    -1,    -1,
      -1,  1942,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   290,  1954,    -1,   293,    -1,    -1,    -1,   205,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1970,
      -1,    -1,    -1,    -1,    -1,    -1,  1977,    -1,    -1,  1980,
      -1,    -1,    -1,  1984,   230,    -1,    -1,    -1,    -1,    -1,
      -1,  1992,    -1,    -1,    -1,    -1,    -1,  1998,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,   491,
    2011,    -1,   494,   495,   496,    -1,   498,   499,   500,   501,
     502,   503,    -1,    -1,    -1,    -1,    -1,  2028,  2029,    -1,
    2031,  2032,    -1,    -1,    -1,    -1,    -1,    -1,  4873,    -1,
    4875,    -1,    -1,    -1,   290,    -1,    -1,  2048,   386,    -1,
      -1,  5000,    -1,    -1,    -1,    -1,  2057,  2058,    -1,  2060,
    2061,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2079,   325,
      -1,    -1,   328,    -1,    -1,    -1,    -1,  4922,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2111,   357,    -1,    -1,    -1,  5064,    -1,   363,    -1,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,    -1,
     376,    -1,    -1,  5082,    -1,    -1,    -1,    -1,  5087,  5088,
      -1,    -1,    -1,   389,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   398,   491,    -1,    -1,   494,   495,   496,   405,
     498,   499,   500,   501,   502,   503,    -1,    -1,   414,    -1,
      -1,   417,    -1,    -1,    -1,   421,    -1,    -1,    -1,    -1,
      -1,    -1,   428,    -1,   430,    -1,   712,    -1,    -1,   435,
      -1,  5140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   740,  5164,   462,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5060,  5061,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2250,
      -1,  2252,    -1,    -1,  5203,    -1,  2257,  2258,    -1,    -1,
      -1,    -1,  5211,  2264,  2265,  2266,    -1,    -1,    -1,  2270,
      -1,  2272,  2273,  2274,  2275,  2276,  2277,    -1,  2279,    -1,
    2281,  2282,    -1,    -1,  2285,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2299,  2300,
    2301,  2302,  2303,  2304,    -1,    -1,    -1,  2308,    -1,    -1,
      -1,  2312,    -1,    -1,  2315,    -1,    -1,  2318,  2319,  2320,
    2321,  2322,  2323,  2324,  2325,  2326,    -1,  2328,    -1,    -1,
      -1,    -1,    -1,    -1,  2335,    -1,  2337,  5286,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    -1,    -1,    28,    -1,  5192,  5307,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5319,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2379,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5223,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5263,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5385,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2451,    -1,   125,    -1,    -1,    -1,    -1,  2458,    -1,    -1,
     133,  2462,  2463,    -1,   137,   138,   139,    -1,    -1,    -1,
    2471,   144,    -1,    -1,   147,  2476,  2477,    -1,    -1,    -1,
    2481,    -1,   155,    -1,    -1,  5320,    -1,    -1,  2489,    -1,
    5325,  5326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5449,   174,    -1,    -1,    -1,    -1,  2507,    -1,    -1,  2510,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2522,    -1,    -1,    -1,  2526,    -1,    -1,  2529,    -1,
      -1,    -1,    -1,    -1,   207,    -1,    -1,  2538,    -1,    -1,
      -1,    -1,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      -1,  2552,    -1,    -1,    -1,  1081,    -1,    -1,    -1,    37,
      -1,    -1,    -1,    -1,    -1,    -1,  5515,    -1,    46,  2570,
    2571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1105,
      -1,  2582,  5531,    -1,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,   266,    -1,    -1,  1122,   270,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,  5441,  5442,   281,    -1,
      -1,    -1,    90,  2614,  2615,    -1,    94,    -1,  2619,   292,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     303,    -1,    -1,    -1,    -1,   113,  5585,    -1,    -1,    -1,
      -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5600,    -1,    -1,  2655,    -1,  2657,    -1,    -1,   230,
     231,    -1,  2663,   336,   142,    -1,    -1,    -1,    -1,  2670,
      -1,   242,    -1,  2674,    -1,   153,   349,   350,    -1,    -1,
      -1,    -1,    -1,    -1,   162,   256,    -1,    -1,    -1,    -1,
      -1,    -1,  1218,  2694,    -1,    -1,    -1,   175,    -1,  2700,
      -1,    -1,    -1,  2704,    -1,   183,  2707,   380,    -1,   187,
      -1,   189,    -1,    -1,    -1,    -1,  2717,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,  2730,
      -1,    -1,  5681,    -1,    -1,    -1,    -1,    -1,    -1,  2740,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,
      -1,    -1,   425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,  5727,    -1,
     453,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     268,    -1,    -1,    -1,    -1,  2796,  2797,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2807,    -1,    -1,  1335,
      -1,   289,   290,    -1,    -1,   293,    -1,    -1,  5653,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     328,    -1,    -1,    -1,  2855,    -1,    -1,    -1,    -1,    -1,
     338,    -1,    -1,    -1,    -1,  5814,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   357,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   366,    -1,
      -1,    -1,    -1,  2894,    -1,   373,    -1,  2898,   376,    -1,
      -1,    -1,    -1,    -1,    -1,   383,    20,  2908,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     398,    -1,    -1,    37,    -1,    -1,    -1,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   414,    -1,    -1,   417,
     418,    -1,   420,   421,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,   430,    -1,    -1,  2956,    -1,   435,    -1,    -1,
      -1,    -1,  1488,   441,    78,    -1,    -1,   445,    -1,    -1,
      -1,   449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    -1,    -1,    -1,   462,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2999,   113,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3024,    -1,  3026,    -1,    -1,   142,    -1,
      -1,    -1,    -1,  3034,    -1,    -1,    -1,    -1,    -1,   153,
    3041,  3042,    -1,    -1,  3045,    -1,    -1,  3048,   162,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3059,    -1,
      -1,   175,    -1,    -1,    -1,    -1,   180,    -1,    -1,  3070,
      -1,    -1,    -1,   187,  3075,   189,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     661,   205,    -1,    -1,    -1,    -1,    -1,  3098,  3099,  3100,
     671,    -1,  3103,    -1,  1630,    -1,    -1,    -1,    -1,    -1,
    3111,  3112,  3113,  3114,   685,    -1,    -1,    -1,  3119,    -1,
      -1,    -1,    -1,  3124,  3125,    -1,  3127,    -1,  3129,    -1,
     701,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,  3140,
    3141,    -1,    -1,  3144,    -1,   716,   717,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   268,    -1,   727,  3158,    -1,  3160,
      -1,  3162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     741,    -1,    -1,  1699,    -1,   289,   290,    -1,    -1,    -1,
      -1,  3182,    -1,   754,    -1,    -1,    -1,    -1,   302,    -1,
      -1,    -1,  3193,    -1,  3195,  3196,  3197,    -1,    -1,    -1,
     314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3210,
      -1,   325,  3213,    -1,   328,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1754,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3243,   357,    -1,    -1,    -1,  3248,    -1,   363,
      -1,  1777,   366,  3254,    -1,    -1,    -1,    -1,    -1,   373,
      -1,    -1,   376,  3264,    -1,    -1,    -1,    -1,    -1,   383,
      -1,    -1,    -1,    -1,    -1,    -1,   847,    -1,    -1,    -1,
      -1,    -1,  3283,    -1,   398,  3286,    -1,  3288,    -1,    -1,
      -1,   405,  3293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     414,    -1,    -1,   417,    -1,    -1,    -1,   421,    -1,  3310,
    3311,    -1,    -1,    -1,   428,  3316,   430,    -1,    -1,    -1,
      -1,   435,    -1,    -1,    22,    -1,    -1,    -1,    26,    -1,
      28,    -1,    -1,    -1,    -1,   449,  3337,    -1,    -1,  3340,
    1866,    -1,    -1,  3344,    -1,    43,    -1,    -1,   462,    -1,
      -1,    -1,    -1,    -1,    -1,  1881,    -1,    -1,    -1,    -1,
    3361,    -1,    -1,    -1,    -1,  1891,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1904,    -1,
      -1,    -1,    -1,    81,    -1,  3386,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,    -1,    -1,
    3431,  3432,  3433,    -1,    -1,   133,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1970,    -1,   144,    -1,    -1,   147,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3458,  1984,    -1,
      -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,  3469,    -1,
      -1,    -1,  1998,  3474,    -1,  3476,    -1,    -1,    -1,    -1,
      -1,    -1,   180,  3484,    -1,  2011,   184,    -1,    -1,   187,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,
      -1,    -1,    -1,    22,  1085,    -1,    -1,   215,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2057,  2058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,  3559,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,
     268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3579,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
      -1,    -1,    -1,    -1,    -1,  3616,   125,    -1,    -1,    -1,
      -1,    -1,  3623,  3624,   133,    -1,    -1,    -1,   137,   138,
     139,    -1,  3633,    -1,  3635,   144,    -1,    -1,   147,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   155,  3648,   346,  3650,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   357,
      -1,    -1,    -1,    -1,    -1,   174,    -1,    -1,   366,    -1,
      -1,    -1,    -1,    -1,   372,   373,    -1,    -1,  3679,    -1,
      -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,  1259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   207,    -1,
      -1,    -1,  3703,  1274,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   412,    -1,   414,  3718,  3719,   417,
      -1,  1292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3732,   430,    -1,    -1,   433,    -1,   435,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1320,
     448,   449,    -1,    -1,    -1,    -1,    -1,   266,    -1,    -1,
      -1,   270,    -1,    -1,   462,    -1,  1337,  3768,    -1,    -1,
      -1,    -1,   281,  2299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1352,    -1,   292,    -1,    -1,  1357,  3788,    -1,  1360,
      -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3819,    -1,
      -1,  3822,    -1,    -1,    -1,    -1,    -1,   336,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,    -1,    -1,
     349,   350,  3843,    -1,    -1,  3846,    -1,    -1,    -1,    -1,
      -1,  3852,    -1,    -1,    -1,    -1,    -1,  3858,    -1,  3860,
      -1,    -1,  3863,    -1,    -1,    -1,  3867,  3868,  3869,  3870,
    3871,   380,    -1,  3874,  3875,  3876,  3877,  3878,  3879,  3880,
    3881,  3882,  3883,    -1,    -1,    -1,  3887,  3888,    -1,    -1,
      -1,  3892,    22,    -1,    -1,    -1,  3897,    -1,    28,    -1,
    3901,    -1,  3903,    -1,  3905,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3913,    -1,  1485,  3916,   425,  3918,    -1,    -1,
      -1,    -1,  1493,  1494,    -1,  3926,  3927,    -1,    -1,  3930,
    3931,    -1,  2458,    -1,  3935,  3936,  2462,  2463,    -1,    -1,
      -1,  3942,    -1,    -1,   453,    75,    -1,    -1,    -1,    -1,
      -1,  3952,    -1,    -1,  3955,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,  3968,    -1,    28,
      -1,    -1,    -1,  3974,  3975,  3976,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,
    2526,    -1,    -1,   133,    -1,    43,  4007,   137,   138,   139,
      -1,    -1,  2538,    -1,   144,    -1,    75,   147,    -1,    -1,
      -1,    -1,  4023,    -1,    -1,   155,    -1,    -1,  4029,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4041,    -1,    -1,    81,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2582,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,   125,    -1,  1639,    -1,
      -1,  4072,    -1,    -1,   133,   113,    -1,   207,   137,   138,
     139,    -1,    -1,    -1,    -1,   144,    -1,   125,   147,    -1,
      -1,    -1,    -1,    -1,    -1,   133,   155,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,    -1,   147,
      -1,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   162,  4126,    -1,    -1,    -1,    -1,
    4131,  4132,  4133,  4134,    -1,    -1,   266,    -1,    -1,    -1,
     270,    -1,   180,    -1,    -1,    -1,   184,    -1,   207,   187,
      -1,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4161,  4162,   292,    -1,    -1,    -1,    -1,   205,    -1,    -1,
     231,    -1,    -1,   303,    -1,    -1,    -1,   215,  4179,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4195,   256,    -1,  4198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   336,   266,   246,    -1,
      -1,   270,    -1,   251,    -1,    -1,   346,    -1,    -1,   349,
     350,    -1,   281,  4224,    -1,    -1,    -1,    -1,    -1,    -1,
     268,    -1,    -1,   292,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   303,    -1,    -1,    22,    -1,    -1,
     380,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1838,    -1,   307,
    4271,  2797,    -1,    -1,    -1,    -1,    -1,   336,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,    -1,    -1,
     349,   350,    -1,    -1,    -1,   425,    -1,  4298,  4299,    -1,
      75,    -1,    -1,  4304,  4305,    -1,    -1,    -1,   346,    -1,
      -1,  4312,    -1,    -1,    -1,    -1,    -1,    -1,  4319,   357,
      -1,   380,    -1,   453,    -1,    -1,    -1,  1898,   366,    -1,
    4331,    -1,    -1,    -1,   372,   373,    -1,    -1,    -1,    -1,
      -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     125,    -1,  4353,  4354,  4355,    -1,    -1,    -1,   133,    -1,
      -1,  1932,   137,   138,   139,    -1,   425,    -1,  2894,   144,
      -1,  1942,   147,    -1,   412,    -1,   414,    -1,    -1,   417,
     155,    -1,    -1,  1954,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   430,    -1,   453,   433,    -1,   435,    -1,   174,
      -1,    -1,  4403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     448,   449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   462,    -1,    -1,    -1,    -1,  4430,
      -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4441,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2028,  2029,    -1,
    2031,  2032,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4471,    -1,    -1,    -1,    -1,    -1,    -1,  2048,    -1,    -1,
    4481,  4482,    -1,  4484,    -1,    -1,    -1,  4488,  4489,  2060,
    2061,   266,  4493,  4494,    -1,   270,    -1,  4498,  3024,    -1,
    4501,  4502,    -1,    -1,    -1,  4506,   281,    -1,  2079,    -1,
      -1,  4512,    -1,    -1,    -1,    -1,    -1,   292,    -1,  3045,
      -1,    -1,    -1,  4524,    -1,    -1,    -1,    -1,   303,    -1,
      -1,  4532,    -1,  3059,    -1,  4536,    -1,    -1,    -1,    -1,
    2111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4549,    -1,
      -1,    -1,    -1,  4554,    -1,    -1,    -1,    -1,    -1,  4560,
      -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   346,    -1,    -1,   349,   350,    -1,    -1,  4579,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     661,    -1,    -1,    -1,  4605,   380,    -1,    -1,    -1,    -1,
     671,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4623,    -1,   685,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4640,
     701,    -1,    -1,    -1,  4645,    -1,    -1,    -1,    -1,    -1,
     425,    -1,    -1,    -1,    -1,    -1,   717,    -1,    -1,    -1,
    4661,    -1,    -1,    -1,    -1,    -1,   727,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,    -1,
     741,    -1,    -1,  4684,    -1,    -1,    -1,    -1,  4689,    -1,
      -1,    -1,    -1,   754,    -1,  4696,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4712,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4723,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4754,    -1,    -1,    -1,  3283,    -1,    -1,
    3286,  4762,  3288,    -1,    -1,    -1,    -1,  3293,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   841,
     842,    -1,    -1,  4784,    -1,    -1,   847,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4798,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3344,    -1,
      -1,    -1,    -1,  4824,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4832,    -1,    -1,    -1,  3361,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4873,    -1,  4875,    -1,    -1,    -1,    -1,    -1,
    2451,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2471,  4902,    -1,    -1,    -1,  2476,  2477,    -1,    -1,    -1,
    2481,    -1,    -1,    -1,    -1,    -1,    -1,  4918,  2489,    -1,
      -1,  4922,    -1,    -1,    -1,    -1,  4927,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2507,    -1,    -1,    -1,
      -1,    -1,    -1,  4944,  4945,    -1,    -1,  4948,  3474,    -1,
    3476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2529,    -1,
      -1,    -1,  4963,    -1,    -1,    -1,    -1,    -1,    -1,  4970,
      -1,    -1,    -1,    -1,  4975,    -1,    -1,  4978,  4979,    -1,
      -1,  2552,    -1,    -1,    -1,  4986,  4987,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2570,
    2571,    -1,    -1,    -1,    -1,    -1,  5007,    -1,  5009,    -1,
      -1,    -1,    -1,  5014,    -1,  5016,    -1,    -1,    -1,  5020,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3559,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2614,  2615,    -1,    -1,    -1,  2619,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5060,
    5061,    -1,  5063,    -1,    -1,    -1,    -1,  3593,    -1,    -1,
      -1,  5072,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2655,    -1,  2657,    -1,    -1,    -1,
    3616,    -1,  2663,    -1,    -1,    -1,    -1,    -1,  3624,  2670,
      -1,    -1,    -1,  2674,    -1,    -1,    -1,    -1,    -1,  5110,
      -1,    -1,    -1,    -1,    -1,  5116,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2694,    -1,    -1,    -1,    -1,    -1,  2700,
      -1,    -1,    -1,  2704,    -1,    -1,  2707,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2717,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2730,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2740,
      -1,    -1,    -1,    -1,  5175,    -1,    -1,  3703,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5190,
      -1,  5192,    -1,  3719,    -1,    -1,    -1,    -1,  1259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3732,    -1,    -1,    -1,
      -1,    -1,    -1,  1274,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5222,  5223,    -1,  5225,    -1,  5227,    -1,    -1,    -1,
      -1,  1292,    -1,    -1,    -1,    -1,  2807,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5247,    -1,    -1,    -1,
      -1,    -1,  5253,    -1,    -1,    -1,  5257,    -1,    -1,  1320,
      -1,    -1,  5263,    -1,    -1,    -1,    -1,  5268,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1337,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1352,    -1,    -1,  1356,    -1,  1357,    -1,    -1,  1360,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5311,    -1,  1374,    -1,    -1,    -1,    -1,    -1,    -1,  5320,
    3846,    -1,    -1,    -1,  5325,  5326,    -1,  2898,    -1,  5330,
      -1,    -1,    -1,    -1,    -1,    -1,  5337,    -1,    -1,    -1,
      -1,  3867,    -1,  1405,    -1,    -1,    -1,    -1,  5349,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3892,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1437,  1438,  1439,    -1,  1441,
    5381,    -1,    -1,    -1,    -1,  2956,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1461,
    3926,    -1,    -1,    -1,  5405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1485,    -1,    -1,    -1,  2999,    -1,
      -1,    -1,  1493,  1494,    -1,    -1,    -1,    -1,    -1,    -1,
    5441,  5442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3026,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3034,  5465,    -1,    -1,  5468,    -1,    -1,
    5471,    -1,    -1,    -1,    -1,    -1,    -1,  3048,    -1,    -1,
      -1,  5482,    -1,    -1,    -1,    -1,  5487,    -1,  5489,    -1,
    5491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5500,
      -1,    -1,    -1,  4029,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5518,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   712,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1607,    -1,    -1,  3119,  1611,
    1612,    -1,    -1,  5554,  3125,  5556,    -1,    -1,    -1,    -1,
      -1,    -1,   740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1639,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5606,  4132,    -1,    -1,    -1,
      -1,    -1,    -1,  5614,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4162,    -1,    -1,  3210,
    5641,  5642,    -1,    -1,    -1,    -1,    -1,    -1,  5649,  5650,
      -1,    -1,  5653,    -1,    -1,    -1,    -1,    -1,  5659,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5668,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5682,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,  5697,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,    -1,    -1,    -1,    -1,  5737,    -1,    -1,  3310,
    3311,  5742,    -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,
      -1,  5752,    -1,    -1,    -1,    -1,    -1,  5758,  5759,    -1,
      -1,  5762,    -1,    -1,    -1,    -1,  3337,    -1,    -1,  3340,
    5771,    -1,    -1,    -1,    -1,    -1,    -1,  1838,    -1,  4305,
      -1,    -1,   111,    -1,    -1,    -1,    -1,  5788,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,
      -1,    -1,  5803,    -1,   133,    -1,    -1,    -1,   137,   138,
     139,    -1,    -1,    -1,    -1,   144,    -1,    -1,   147,    -1,
      -1,    -1,    -1,    -1,    -1,  5826,   155,  4353,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1898,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5856,  5857,    -1,    -1,    -1,
    3431,  3432,  3433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1932,    -1,    -1,    -1,   204,    -1,    -1,   207,    -1,
    5881,  1942,    -1,    -1,    -1,    -1,    -1,  3458,    -1,    -1,
      -1,    -1,    -1,  1954,    -1,    -1,    -1,    -1,  3469,    -1,
    5901,    -1,    -1,  1081,    -1,    -1,  5907,    -1,    -1,    -1,
      -1,    -1,   712,  3484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5923,   252,    -1,    -1,   255,  1105,  3499,    -1,
      -1,    -1,  5933,    -1,  5935,    -1,    -1,   266,    -1,    -1,
     740,   270,    -1,    -1,  1122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   281,    -1,  5955,    -1,  5957,  5958,  4484,  5960,
      -1,    -1,    -1,   292,    -1,    -1,    -1,    -1,  4494,    -1,
    2031,  2032,    -1,   302,   303,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2048,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2060,
    2061,    -1,    -1,    -1,    -1,    -1,    -1,   336,  3579,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,  2079,    -1,
     349,   350,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1218,    -1,    -1,    -1,   373,    -1,    -1,    -1,    -1,    -1,
      22,   380,  3623,    -1,    -1,    -1,    28,    -1,    -1,    -1,
      -1,    -1,  3633,    35,  3635,    -1,    -1,   396,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3648,    -1,  3650,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   425,  4623,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,  3679,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4661,    -1,    -1,    -1,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3718,    -1,    -1,
      -1,    -1,    -1,   125,    -1,    -1,    -1,  1335,    -1,    -1,
      -1,   133,    -1,  4689,    -1,   137,   138,   139,    -1,    -1,
      -1,    -1,   144,    -1,    -1,   147,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2257,    -1,  3768,    -1,    -1,
      -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,  2270,    -1,
    2272,    -1,    -1,  2275,  2276,  2277,    -1,  3788,    -1,    -1,
    2282,    -1,    -1,  2285,    -1,    -1,    -1,    -1,  4754,    -1,
      -1,    -1,   204,    -1,    -1,   207,    -1,    -1,  2300,  2301,
    2302,  2303,    -1,  2304,    -1,    -1,  2308,    -1,  3819,    -1,
    2312,  3822,    -1,  2315,    -1,    -1,  2318,  2319,  2320,  2321,
    2322,  2323,  2324,  2325,  2326,    -1,  2328,    -1,    -1,    -1,
      -1,    -1,    -1,  2335,    -1,  2337,    -1,    -1,    -1,    -1,
     252,  1081,    -1,   255,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,   270,    -1,
      -1,    -1,    -1,    -1,    -1,  1105,    -1,    -1,    -1,   281,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2379,    -1,    -1,
     292,    -1,  1122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     302,   303,  3903,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4875,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   336,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   346,    -1,    -1,   349,   350,   351,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2451,    -1,    -1,    -1,    -1,    -1,  4922,    -1,    -1,    -1,
      -1,   373,    -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,
    2471,    -1,    -1,    -1,    -1,  2476,  2477,    -1,  1218,    -1,
    2481,    -1,    -1,    -1,   396,    -1,    -1,    -1,  2489,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2507,    -1,  2510,    -1,
      -1,    -1,  1630,   425,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   453,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4072,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2570,
    2571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1699,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5060,  1335,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2614,  2615,  4126,    -1,    -1,  2619,    -1,
    4131,    -1,  4133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1754,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4161,    -1,    -1,    -1,  2655,    -1,  2657,    -1,    -1,  1777,
      -1,    -1,  2663,    -1,    -1,    -1,    -1,    -1,  4179,  2670,
      -1,    -1,    -1,  2674,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4195,    -1,    -1,  4198,    -1,    -1,
      -1,    -1,    -1,  2694,    -1,    -1,    -1,    -1,    -1,  2700,
      -1,    -1,    -1,  2704,    -1,    -1,  2707,    -1,    -1,    -1,
      -1,    -1,    -1,  4224,    -1,    -1,  2717,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5192,    -1,    -1,  2730,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2740,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1866,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5223,    -1,    -1,
      -1,    -1,    -1,  1881,    -1,    -1,    -1,    -1,    -1,    -1,
     712,    -1,    -1,  1891,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1904,  4298,  4299,    -1,
      -1,    -1,    -1,  4304,  2796,    -1,    -1,  5263,   740,    -1,
      -1,  4312,    -1,    -1,    -1,    -1,  2807,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   712,    -1,    -1,
      -1,    -1,  1970,    -1,  5320,    -1,    -1,    -1,    -1,  5325,
    5326,    -1,    -1,    -1,    -1,    -1,  1984,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   740,    -1,    -1,    -1,    -1,
    1998,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1630,    -1,  4403,  2011,    -1,    -1,    -1,  2898,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2057,
    2058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2956,    -1,    -1,    -1,  1699,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5442,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2999,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1754,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3026,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3034,    -1,    -1,    -1,  1777,    -1,  3041,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   712,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3070,    -1,
      -1,    -1,    -1,  3075,    -1,    -1,    -1,   740,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3100,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3111,
      -1,  3113,  3114,    -1,    -1,    -1,    -1,    -1,  3119,    -1,
      -1,    -1,  3124,    -1,  3125,  3127,  1866,  3129,    -1,  4640,
      -1,    -1,    -1,    -1,  4645,    -1,    -1,    -1,    -1,  1081,
      -1,  1881,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1891,    -1,    -1,    -1,    -1,  3158,    -1,  3160,    -1,
    3162,    -1,    -1,  1105,  1904,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4684,    -1,    -1,    -1,    -1,    -1,    -1,
    1122,  2299,    -1,    -1,    -1,  4696,    -1,  5653,    -1,    -1,
      -1,    -1,    -1,  3195,  3196,  3197,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3210,
      -1,  3213,  4723,    -1,    -1,    -1,  1081,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1105,  3243,    -1,    -1,  1984,    -1,  3248,    -1,    -1,    -1,
      -1,  4762,  3254,    -1,    -1,    -1,    -1,  1122,  1998,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2011,    -1,    -1,    -1,    -1,  1218,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3310,
    3311,    -1,    -1,  4824,  3316,    -1,    -1,  2057,  2058,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3337,    -1,    -1,  3340,
    2458,    -1,    -1,    -1,  2462,  2463,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1218,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4902,    -1,  1335,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2526,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1081,    -1,
    2538,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3431,  3432,  3433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    25,  3458,    -1,  1122,
      -1,    -1,    -1,    -1,  2582,    -1,    -1,    -1,  3469,    -1,
    1335,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3499,    -1,
      -1,    -1,    -1,  5014,    -1,  5016,    75,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,
      -1,   120,  5063,    -1,    -1,  1218,    -1,    -1,    -1,  2299,
      -1,  5072,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,  3579,    -1,
      -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,  5110,
      -1,    -1,    -1,    -1,    -1,  5116,   175,    -1,    -1,    -1,
      -1,   180,    -1,    -1,    -1,    -1,    -1,    -1,   187,    -1,
     189,    -1,  3623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3633,    -1,  3635,    -1,   205,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3648,    -1,  3650,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1335,    -1,    -1,    -1,    -1,    -1,  3679,  2797,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,  1630,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     712,    -1,    -1,    -1,    -1,    -1,    -1,  3718,  2458,    -1,
     289,   290,  2462,  2463,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   740,    -1,
      -1,    -1,    -1,    -1,    -1,   314,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   325,  1699,    -1,   328,
      -1,    -1,    -1,    -1,    -1,  1630,    -1,  3768,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2894,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2526,  3788,   357,    -1,
      -1,    -1,    -1,    -1,   363,    -1,    -1,   366,  2538,    -1,
    5311,    -1,    -1,    -1,   373,    -1,    -1,   376,    -1,    -1,
      -1,    -1,  1754,    -1,    -1,    -1,    -1,    -1,  3819,    -1,
     389,  3822,    -1,    -1,    -1,    -1,  5337,    -1,    -1,   398,
      -1,    -1,    -1,    -1,  1699,  1777,   405,    -1,  5349,    -1,
      -1,  3843,  2582,   412,    -1,   414,    -1,    -1,   417,    -1,
    3852,    -1,   421,    -1,    -1,    -1,  3858,    -1,  3860,    -1,
      -1,   430,    -1,    -1,    -1,    -1,   435,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     449,    -1,    -1,    -1,    -1,  3887,  3888,    -1,    -1,  1754,
      -1,    -1,    -1,   462,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3903,  3905,    -1,    -1,  3024,    -1,    -1,    -1,
      -1,  3913,  1777,    -1,  3916,    -1,  3918,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1866,  3927,    -1,  3045,    -1,    -1,
      -1,    -1,    -1,  3935,  3936,    -1,    -1,    -1,    -1,  1881,
      -1,  3059,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1891,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1904,    -1,    -1,    -1,  3968,  1630,    -1,    -1,
      -1,    -1,  3974,  3975,  3976,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1866,    -1,    -1,    -1,  4007,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1881,    -1,    -1,    -1,
      -1,  4023,    -1,    -1,    -1,    -1,  1891,    -1,  1970,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1699,    -1,    -1,  1904,
      -1,    -1,  1984,  5554,    -1,  5556,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1998,  2797,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2011,
      -1,  4072,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1081,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1105,    -1,  1970,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1777,  2057,  2058,    -1,    -1,  1984,
    1122,    -1,    -1,    -1,    -1,  4126,    -1,    -1,    -1,    -1,
    4131,    -1,  4133,  1998,    -1,    -1,    -1,    -1,    -1,  5650,
      -1,    -1,    -1,    -1,    -1,    -1,  2011,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2894,    -1,    -1,  5668,    -1,    -1,
    4161,    -1,    -1,    -1,    -1,  3283,    -1,    -1,  3286,    -1,
    3288,  5682,    -1,    -1,    -1,  3293,    -1,    -1,  4179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5697,    -1,    -1,    -1,
      -1,    -1,  2057,  2058,  4195,    -1,    -1,  4198,    -1,    -1,
      -1,    -1,    -1,  1866,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1218,    -1,  1881,    -1,
      -1,    -1,    -1,  4224,    -1,    -1,  3344,    -1,  1891,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1904,    -1,  3361,    -1,    -1,    -1,  5758,  5759,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3386,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3024,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5803,    -1,    -1,    -1,    -1,  4298,  4299,    -1,
      -1,    -1,    -1,  4304,    -1,  3045,    -1,  1970,    -1,    -1,
      -1,  4312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3059,
      -1,  1984,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4331,    -1,    -1,  1335,    -1,  1998,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2011,    -1,
      -1,    -1,  4354,  4355,    -1,    -1,  3474,  2299,  3476,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5881,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2057,  2058,    -1,    -1,    -1,    -1,
      -1,    -1,  4403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5935,    -1,    -1,    -1,  4430,    -1,
      -1,    -1,    -1,    -1,  2299,    -1,    -1,    -1,    -1,  4441,
      -1,  3559,    -1,    -1,  5955,    -1,  5957,  5958,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3593,    -1,    -1,    -1,  4481,
    4482,    -1,    -1,    -1,    -1,    -1,  4488,  4489,    -1,    -1,
      -1,  4493,    -1,    -1,    -1,    -1,  4498,    -1,  3616,  4501,
    4502,    -1,    -1,    -1,  4506,    -1,  3624,    -1,    -1,    -1,
    4512,    -1,    -1,    -1,    -1,    -1,  2458,    -1,    -1,    -1,
    2462,  2463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3283,    -1,    -1,  3286,  4549,  3288,    -1,
      -1,    -1,  4554,  3293,    -1,    -1,    -1,    -1,  4560,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4579,    -1,    -1,
      -1,    -1,    -1,    -1,  2526,  3703,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2458,    -1,    -1,  2538,  2462,  2463,    -1,
      -1,  3719,    -1,  4605,  3344,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3732,    -1,    -1,    -1,    -1,    -1,
      -1,  3361,    -1,    -1,    -1,    -1,    -1,    -1,  1630,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2299,    -1,    -1,  4640,
    2582,    -1,    -1,    -1,  4645,    -1,  3386,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2538,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4684,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4696,    -1,  1699,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4712,    -1,    -1,    -1,    -1,    -1,    -1,  2582,    -1,    -1,
      -1,    -1,  4723,    -1,    -1,    -1,    -1,    -1,  3846,    -1,
      -1,    -1,    -1,    -1,  3474,    -1,  3476,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3867,
      -1,    -1,  1754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3892,  1777,    -1,    -1,    -1,    -1,
      -1,    -1,  4784,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2458,    -1,    -1,    -1,  2462,
    2463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3926,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3559,
      -1,    -1,    -1,  4824,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3593,    -1,  2797,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2526,  1866,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2538,  3616,    -1,    -1,  1881,
      -1,    -1,    -1,    -1,  3624,    -1,    -1,    -1,    -1,  1891,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4902,  1904,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4029,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2582,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2797,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4944,  4945,    -1,    -1,  4948,    -1,    -1,    -1,
      -1,    -1,  2894,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3703,    -1,    -1,    -1,    -1,  1970,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3719,
      -1,    -1,  1984,    -1,  4986,  4987,    -1,    -1,    -1,    -1,
      -1,    -1,  3732,    -1,    -1,    -1,  1998,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5009,    -1,  2011,
      -1,    -1,    -1,  5014,  4132,  5016,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2894,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4162,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2057,  2058,    -1,    -1,  5061,
      -1,    -1,  5063,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3045,    -1,    -1,  3846,    -1,    -1,  5110,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3059,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3867,    -1,    -1,
      -1,    -1,    -1,    -1,  2797,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3892,    -1,    -1,    -1,    -1,    -1,    -1,  3024,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3045,    -1,    -1,    -1,    -1,    -1,  3926,  4305,    -1,    -1,
      -1,    -1,    -1,    -1,  3059,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5225,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2894,    -1,    -1,    -1,  4353,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5268,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4029,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2299,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5330,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5337,    -1,    -1,    -1,
      -1,  3283,    -1,    -1,  3286,    -1,  3288,    -1,  5349,    -1,
      -1,  3293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3024,    -1,    -1,    -1,    -1,  4484,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4494,    -1,    -1,    -1,
      -1,    -1,  3045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4132,    -1,    -1,    -1,  3059,    -1,    -1,    -1,
      -1,    -1,  3344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3283,  3361,
      -1,  3286,  4162,  3288,  1453,    -1,    -1,    -1,  3293,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3386,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2458,    -1,    -1,    -1,
    2462,  2463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3344,
      -1,    -1,    -1,    -1,    -1,    -1,  1515,    -1,    -1,  5491,
      -1,    -1,    -1,    -1,    -1,    -1,  3361,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4623,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5518,    -1,    -1,    -1,
      -1,  3386,    -1,    -1,  2526,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3474,    -1,  3476,    -1,  2538,    -1,    -1,    -1,
      -1,    -1,    -1,  4661,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5554,    -1,  5556,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4305,    -1,    -1,    -1,    -1,
      -1,  4689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2582,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5606,    -1,    -1,    -1,    -1,  3474,
      -1,  3476,    -1,  4353,    -1,    -1,    -1,  3559,    -1,    -1,
    3283,    -1,    -1,  3286,    -1,  3288,    -1,    -1,    -1,    -1,
    3293,    -1,    -1,    -1,    -1,    -1,  4754,    -1,    -1,  5641,
    5642,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5650,
      -1,  3593,    -1,    -1,    -1,    -1,    -1,  5659,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5668,    -1,    -1,
      -1,    -1,    -1,    -1,  3616,    -1,    -1,    -1,    -1,    -1,
      -1,  3344,  3624,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3559,    -1,  5697,    -1,  3361,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3386,    -1,    -1,    -1,    -1,  3593,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5742,    -1,    -1,    -1,  4484,    -1,    -1,    -1,    -1,    -1,
      -1,  3616,    -1,    -1,  4494,    -1,    -1,  4875,    -1,  3624,
    5762,  3703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3719,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5788,    -1,    -1,    -1,
    3732,    -1,    -1,    -1,    -1,  2797,    -1,    -1,    -1,    -1,
      -1,    -1,  5803,    -1,  4922,    -1,    -1,    -1,    -1,    -1,
      -1,  3474,    -1,  3476,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3703,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3719,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3732,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5881,    -1,    -1,  4623,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2894,    -1,    -1,    -1,  3559,    -1,    -1,  5901,
      -1,    -1,    -1,    -1,  3846,  5907,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4661,    -1,    -1,    -1,  3867,    -1,    -1,    -1,    -1,
    3593,    -1,    -1,    -1,  5935,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5060,    -1,    -1,    -1,    -1,    -1,    -1,  4689,
    3892,    -1,    -1,  3616,  5955,    -1,    -1,    -1,    -1,    -1,
      -1,  3624,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3846,    -1,    -1,  3926,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3867,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4754,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3024,    -1,    -1,    -1,    -1,  3892,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3703,    -1,    -1,  3045,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3719,  3059,    -1,    -1,
      -1,  3926,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3732,
      -1,    -1,    -1,    -1,  5192,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4029,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5223,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4875,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5263,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4029,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4922,  3846,    -1,    -1,    -1,    -1,    -1,    -1,
    4132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5320,    -1,  3867,    -1,    -1,  5325,  5326,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4162,    -1,    -1,    -1,    -1,    -1,  2255,    -1,    -1,  3892,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2269,    -1,    -1,    -1,  2273,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2287,  2288,
    2289,    -1,  2291,  3926,    -1,    -1,    -1,  4132,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3283,    -1,    -1,  3286,    -1,  3288,    -1,    -1,    -1,
      -1,  3293,    -1,    -1,    -1,    -1,    -1,  4162,    -1,    -1,
      -1,    -1,    -1,    -1,  2333,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5060,    -1,    -1,    -1,  5442,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3361,
      -1,    -1,    -1,  4305,    -1,    -1,  4029,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3386,    -1,  2415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2427,    -1,
      -1,  2430,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4132,
      -1,    -1,  3474,    -1,  3476,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5223,    -1,    -1,    -1,    -1,  4353,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4162,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5263,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5653,    -1,    -1,    -1,    -1,
      -1,    -1,  4484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4494,    -1,    -1,    -1,    -1,  3559,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5320,    -1,    -1,    -1,    -1,  5325,  5326,    -1,    -1,    -1,
      -1,  3593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3616,    -1,    -1,    -1,    -1,  4484,
      -1,    -1,  3624,    -1,    -1,    -1,    -1,    -1,    -1,  4494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3703,  5442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3719,    -1,  4661,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3732,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4689,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4623,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4661,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4484,    -1,    -1,  4689,    -1,    -1,    -1,    -1,    -1,
      -1,  4494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3846,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3867,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4754,
    3892,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5653,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3926,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4875,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4922,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4661,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4875,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4689,  4029,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3073,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4922,    -1,    -1,
      -1,    -1,    -1,    -1,  3093,    -1,  3095,    -1,    -1,  3098,
    3099,    -1,  3101,    -1,  3103,    -1,    -1,    -1,  3107,    -1,
      -1,  3110,    -1,    -1,    -1,    -1,  3115,    -1,    -1,    -1,
      -1,  4754,  3121,    -1,    -1,    -1,    -1,  3126,    -1,    -1,
      -1,    -1,    -1,    -1,  3133,  3134,  3135,  3136,    -1,    -1,
      -1,  3140,  3141,    -1,  3143,    -1,    -1,    -1,  5060,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3155,    -1,  3157,    -1,
    4132,    -1,    -1,    -1,    -1,  3164,  3165,  3166,  3167,  3168,
    3169,  3170,  3171,  3172,  3173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3223,  5060,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4875,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4922,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3331,  4305,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5263,    -1,    -1,    -1,    -1,    -1,  5192,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4353,    -1,    -1,    -1,    -1,    -1,    -1,  5223,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5320,    -1,
      -1,    -1,    -1,  5325,  5326,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5060,  5263,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5320,    -1,    -1,    -1,    -1,
    5325,  5326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5192,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5442,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3619,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5320,    -1,  4661,
      -1,    -1,  5325,  5326,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4689,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5442,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5653,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3825,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3842,    -1,    -1,    -1,    -1,    -1,  3848,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3864,  3865,    -1,    -1,  3868,
    3869,  3870,  3871,    -1,    -1,  3874,  3875,  3876,  3877,  3878,
    3879,  3880,  3881,  3882,  3883,  3884,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4875,    -1,    -1,    -1,  3906,    -1,    -1,
    3909,    -1,  3911,    -1,    -1,  3914,  3915,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3929,  3930,  3931,  3932,    -1,  3934,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4922,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3985,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4001,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4038,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5060,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5320,    -1,
      -1,    -1,    -1,  5325,  5326,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4431,    -1,    -1,    -1,  4435,  4436,  4437,    -1,
      -1,    -1,    -1,    -1,  4443,  4444,  4445,  4446,    -1,    -1,
      -1,    -1,  4451,  4452,  4453,  4454,  4455,  4456,  4457,  4458,
    4459,  4460,  4461,  4462,    -1,    -1,    -1,    -1,    -1,    -1,
    5442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4487,    -1,
      -1,  4490,    -1,  4492,    -1,    -1,    -1,  4496,    -1,    -1,
    4499,  4500,    -1,    -1,  4503,  4504,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4551,    -1,    -1,    -1,    -1,    -1,    -1,  4558,
    4559,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4578,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4787,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4870,  4871,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4912,    -1,    -1,    -1,    -1,  4917,  4918,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4932,    -1,  4934,    -1,    -1,    -1,  4938,
    4939,  4940,    -1,    -1,  4943,    -1,    -1,  4946,  4947,    -1,
      -1,    -1,  4951,    -1,    -1,    -1,  4955,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5018,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5083,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5221,  5222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5237,  5238,
    5239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5247,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5275,  5276,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5290,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5457,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5471,    -1,    -1,  5474,    -1,    -1,    -1,  5478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5647,    -1,
    5649,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5679,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5736,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5765,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5824,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5856,  5857,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5868,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,  5903,  5904,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,  5931,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,   500,
      -1,    -1,    -1,    -1,    -1,    -1,   507,   508,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,    -1,   151,   152,   153,    -1,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,   172,    -1,   174,
      -1,   176,   177,    -1,   179,   180,   181,   182,   183,    -1,
     185,   186,    -1,   188,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,    -1,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,    -1,   423,   424,
      -1,    -1,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,    -1,   441,   442,   443,   444,
     445,   446,   447,   448,   449,    -1,   451,   452,   453,   454,
     455,   456,   457,    -1,   459,   460,   461,   462,   463,   464,
      -1,    -1,    -1,   468,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,    -1,   493,    -1,
      -1,    -1,    -1,   498,   499,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   507,   508,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,    -1,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,   172,    -1,   174,    -1,   176,   177,    -1,
     179,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,    -1,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,    -1,    -1,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,    -1,   423,   424,    -1,    -1,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,    -1,   441,   442,   443,   444,   445,   446,   447,   448,
     449,    -1,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,   460,   461,   462,   463,   464,    -1,    -1,    -1,   468,
      -1,    -1,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,    -1,    -1,    -1,    -1,    -1,    -1,   498,
     499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,   148,   149,    -1,   151,   152,
     153,    -1,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,   172,
      -1,   174,    -1,   176,   177,    -1,   179,   180,   181,   182,
     183,    -1,   185,   186,    -1,   188,   189,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,    -1,   220,    -1,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,   238,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
      -1,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
      -1,    -1,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,    -1,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,    -1,
     423,   424,    -1,    -1,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,    -1,   441,   442,
     443,   444,   445,   446,   447,   448,   449,    -1,   451,   452,
     453,   454,   455,   456,   457,    -1,   459,   460,   461,   462,
     463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,    -1,
      -1,    -1,    -1,    -1,    -1,   498,   499,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   507,   508,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    74,    75,    76,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,    -1,   151,   152,   153,    -1,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,   172,    -1,   174,    -1,   176,
     177,    -1,   179,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,    -1,   234,   235,   236,
     237,   238,    -1,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
      -1,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,    -1,   423,   424,    -1,    -1,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,    -1,   441,   442,   443,   444,   445,   446,
     447,   448,   449,    -1,   451,   452,   453,   454,   455,   456,
     457,    -1,   459,   460,   461,   462,   463,   464,    -1,    -1,
      -1,   468,    -1,    -1,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,     3,    -1,    -1,
      -1,   498,   499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     507,   508,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   508,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    -1,    -1,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    74,
      75,    -1,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,    -1,    -1,
      -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,   114,
      -1,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,   134,
      -1,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,   147,   148,   149,    -1,   151,   152,   153,    -1,
     155,   156,   157,   158,   159,    -1,   161,   162,   163,   164,
      -1,    -1,   167,    -1,   169,   170,   171,   172,    -1,   174,
      -1,   176,   177,    -1,   179,   180,   181,   182,   183,    -1,
     185,    -1,    -1,    -1,   189,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,   218,    -1,   220,    -1,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,    -1,   234,
      -1,   236,   237,   238,    -1,   240,   241,   242,    -1,    -1,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,    -1,   268,    -1,    -1,   271,   272,   273,   274,
      -1,    -1,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,
     295,   296,   297,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,    -1,   308,   309,   310,   311,    -1,   313,   314,
      -1,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,    -1,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,
     415,   416,   417,   418,   419,   420,   421,    -1,   423,   424,
      -1,    -1,   427,   428,    -1,   430,    -1,    -1,   433,   434,
     435,   436,   437,   438,   439,    -1,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,    -1,   451,   452,   453,   454,
     455,    -1,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,
     475,   476,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   488,   489,   490,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,   508,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    -1,    -1,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    -1,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,    -1,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,    -1,
     161,   162,   163,   164,    -1,    -1,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,    -1,    -1,    -1,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,    -1,   236,   237,   238,    -1,   240,
     241,   242,    -1,    -1,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,    -1,    -1,
     271,   272,   273,   274,    -1,    -1,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,    -1,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,    -1,    -1,    -1,   409,    -1,
     411,   412,    -1,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,    -1,   430,
      -1,    -1,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,    -1,
     451,   452,   453,   454,   455,    -1,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,   488,   489,   490,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,   508,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,   493,    -1,    -1,
      -1,    -1,   498,   499,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,   498,   499,    -1,    -1,    -1,    -1,    -1,   505,
     506,   507,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,   500,
      -1,    -1,    -1,    -1,    -1,    -1,   507,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,   498,   499,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,   498,   499,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,   498,   499,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,   498,   499,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,   498,   499,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   498,   499,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   498,   499,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,    -1,
      -1,     3,     4,     5,     6,     7,   507,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,   449,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,     3,     4,     5,     6,     7,    -1,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,   507,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,   449,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,     3,     4,     5,     6,     7,    -1,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,   507,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,   449,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,   507,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
      -1,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,   445,   446,   447,   448,   449,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,     3,    -1,    -1,    -1,    -1,   498,   499,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   507,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,    -1,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,   449,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,   493,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   507,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    -1,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,    -1,
     271,   272,   273,   274,    -1,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    -1,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,    -1,
     271,   272,   273,   274,    -1,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    -1,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,    -1,
     271,   272,   273,   274,    -1,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    -1,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,    -1,
     271,   272,   273,   274,    -1,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,     3,     4,     5,    -1,    -1,    -1,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    -1,    -1,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,    -1,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,    -1,    -1,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,    -1,
     271,   272,   273,   274,    -1,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,    -1,
     411,   412,    -1,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,     3,    -1,    -1,    -1,    -1,   498,   499,   500,
      -1,    -1,    -1,    -1,    -1,    -1,   507,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    -1,    -1,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,    -1,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,    -1,    -1,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,   269,    -1,
     271,   272,   273,   274,    -1,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,    -1,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,   493,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,   273,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,   414,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,   493,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    -1,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    -1,    -1,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    -1,    -1,
      -1,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,    -1,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,    -1,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,
      -1,   240,   241,   242,    -1,    -1,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,    -1,   268,
     269,    -1,   271,   272,    -1,   274,    -1,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,    -1,    -1,   295,   296,    -1,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,    -1,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
     409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,
     419,   420,   421,    -1,   423,   424,    -1,    -1,   427,   428,
     429,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,
      -1,    -1,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    -1,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    -1,    -1,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    -1,    -1,
      -1,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,    -1,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,    -1,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,
      -1,   240,   241,   242,    -1,    -1,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,    -1,   268,
     269,    -1,   271,   272,    -1,   274,    -1,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,    -1,    -1,   295,   296,    -1,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,    -1,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
     409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,
     419,   420,   421,    -1,   423,   424,    -1,    -1,   427,   428,
     429,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,
      -1,    -1,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    -1,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    -1,    -1,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    -1,    -1,
      -1,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,    -1,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,    -1,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,
      -1,   240,   241,   242,    -1,    -1,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,    -1,   268,
     269,    -1,   271,   272,    -1,   274,    -1,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,    -1,    -1,   295,   296,    -1,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,    -1,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
     409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,
     419,   420,   421,    -1,   423,   424,    -1,    -1,   427,   428,
     429,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,
      -1,    -1,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    -1,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    -1,    -1,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    -1,    -1,
      -1,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,    -1,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,    -1,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,
      -1,   240,   241,   242,    -1,    -1,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,    -1,   268,
     269,    -1,   271,   272,    -1,   274,    -1,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,    -1,    -1,   295,   296,    -1,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,    -1,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
     409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,
     419,   420,   421,    -1,   423,   424,    -1,    -1,   427,   428,
     429,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,
      -1,    -1,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    -1,    -1,    -1,    -1,   507,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
      -1,   187,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
      -1,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   488,   489,   490,    -1,    -1,    -1,   494,   495,
     496,    -1,   498,   499,   500,   501,   502,   503,     3,     4,
       5,    -1,    -1,     8,     9,    -1,    -1,    -1,    -1,    -1,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,    -1,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
      -1,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,    -1,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   488,   489,   490,    -1,     3,    -1,   494,
     495,   496,     8,   498,   499,   500,   501,   502,   503,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,     3,    -1,   494,   495,
     496,     8,   498,   499,   500,   501,   502,   503,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    -1,    -1,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    -1,    -1,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    74,    75,    76,
      -1,    -1,    -1,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
     147,   148,   149,    -1,   151,   152,   153,    -1,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
     167,    -1,   169,   170,   171,   172,    -1,   174,    -1,   176,
      -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,   186,
      -1,   188,   189,   190,    -1,   192,   193,   194,   195,   196,
      -1,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,    -1,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,   231,    -1,    -1,   234,   235,    -1,
     237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
      -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,   276,
     277,   278,   279,   280,   281,   282,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,   296,
      -1,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
      -1,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,    -1,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,
     417,   418,   419,   420,   421,    -1,   423,   424,    -1,    -1,
     427,   428,   429,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,    -1,    -1,   442,   443,   444,   445,   446,
     447,   448,    -1,    -1,   451,   452,   453,   454,   455,   456,
     457,    -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,
      -1,   468,    -1,    -1,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,     3,    -1,   494,   495,   496,
       8,   498,   499,   500,   501,   502,   503,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,     3,    -1,   494,   495,   496,     8,
     498,   499,   500,   501,   502,   503,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    -1,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    -1,    -1,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    -1,    -1,
      -1,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,   134,    -1,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,   147,   148,
     149,    -1,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,   167,    -1,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
      -1,   180,   181,   182,   183,    -1,   185,   186,    -1,   188,
     189,   190,    -1,   192,   193,   194,   195,   196,    -1,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,   208,
      -1,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
      -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,
     229,   230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,
      -1,   240,   241,   242,    -1,    -1,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,   263,   264,   265,   266,    -1,   268,
     269,    -1,   271,   272,    -1,   274,    -1,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,    -1,    -1,   295,   296,    -1,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,    -1,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
     409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,
     419,   420,   421,    -1,   423,   424,    -1,    -1,   427,   428,
     429,   430,   431,    -1,   433,   434,   435,   436,   437,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,    -1,   451,   452,   453,   454,   455,   456,   457,    -1,
     459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,
      -1,    -1,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,     3,    -1,   494,   495,   496,     8,   498,
     499,   500,   501,   502,   503,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,     3,    -1,   494,   495,   496,     8,   498,   499,
     500,   501,   502,   503,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    -1,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    -1,    -1,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,    -1,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    -1,   167,    -1,   169,   170,
     171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,
     181,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,    -1,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,    -1,   220,
      -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,   230,
     231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,
     241,   242,    -1,    -1,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,   263,   264,   265,   266,    -1,   268,   269,    -1,
     271,   272,    -1,   274,    -1,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,   409,    -1,
     411,   412,    -1,    -1,   415,    -1,   417,   418,   419,   420,
     421,    -1,   423,   424,    -1,    -1,   427,   428,   429,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,    -1,
     451,   452,   453,   454,   455,   456,   457,    -1,   459,    -1,
     461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,     3,    -1,   494,   495,   496,     8,   498,   499,   500,
     501,   502,   503,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,   494,   495,   496,    -1,   498,   499,   500,   501,
     502,   503,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   500,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   500,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   500,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
      -1,   161,   162,   163,   164,    -1,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,    -1,    -1,    -1,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,    -1,   234,    -1,   236,   237,   238,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,    -1,   268,    -1,
      -1,   271,   272,   273,   274,    -1,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,    -1,
     430,    -1,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,    -1,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   488,   489,
     490,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
     500,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,    -1,   161,   162,   163,   164,    -1,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
      -1,    -1,    -1,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,    -1,
     236,   237,   238,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,    -1,    -1,   271,   272,   273,   274,    -1,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,    -1,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,    -1,   430,    -1,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
      -1,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,     3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,
      -1,    -1,   488,   489,   490,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,   500,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
       4,     5,    -1,    -1,    -1,     9,   498,   499,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,   273,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,   416,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,   460,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,     4,     5,
      -1,    -1,    -1,     9,   498,   499,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,     5,    -1,    -1,
      -1,     9,   498,   499,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,     9,
     498,   499,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,   178,    -1,
     180,   181,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,     9,   498,   499,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,   178,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
       4,     5,    -1,    -1,    -1,     9,   498,   499,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    64,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,   273,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,   449,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,     4,     5,     6,     7,    -1,     9,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,   273,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,   416,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,   460,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,   109,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,   109,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,   273,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,   449,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,   109,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,   273,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,   416,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,   460,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,   109,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,   109,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,   273,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,   109,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,   273,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,   416,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,   460,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,   273,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,   273,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,   273,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,   416,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,   460,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,   273,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    -1,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,   175,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,   238,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,   175,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,   175,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
     414,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,   414,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,   414,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    35,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,    -1,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,    -1,   180,   181,   182,   183,    -1,   185,   186,    -1,
     188,   189,   190,    -1,   192,   193,   194,   195,   196,    -1,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,    -1,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,    -1,   237,
      -1,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,   263,   264,   265,   266,    -1,
     268,   269,    -1,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,    -1,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,    -1,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,   429,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,    -1,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,    -1,
     180,   181,   182,   183,    -1,   185,   186,    -1,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,    -1,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,    -1,    -1,   225,    -1,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,    -1,   274,    -1,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,    -1,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,   429,
     430,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
      -1,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,    -1,   180,   181,
     182,   183,    -1,   185,   186,    -1,   188,   189,   190,    -1,
     192,   193,   194,   195,   196,    -1,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,    -1,   237,    -1,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,    -1,   268,   269,    -1,   271,
     272,    -1,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,    -1,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,   429,   430,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,    -1,   459,    -1,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,   186,    -1,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,   266,    -1,   268,   269,    -1,   271,   272,    -1,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,    -1,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,    -1,   180,   181,   182,   183,    -1,   185,
     186,    -1,   188,   189,   190,    -1,   192,   193,   194,   195,
     196,    -1,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,    -1,   212,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,    -1,    -1,   225,
      -1,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
      -1,   237,    -1,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
     296,    -1,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
      -1,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,   429,   430,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,    -1,   459,    -1,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,    -1,   161,   162,   163,   164,    -1,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,    -1,    -1,
      -1,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,    -1,   234,    -1,   236,   237,
     238,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,    -1,
     268,    -1,    -1,   271,   272,   273,   274,    -1,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,    -1,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,    -1,   430,    -1,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,    -1,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     488,   489,   490,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,    -1,   161,   162,   163,
     164,    -1,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,    -1,    -1,    -1,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,    -1,
     234,    -1,   236,   237,   238,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    -1,   268,    -1,    -1,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,    -1,   297,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,    -1,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,    -1,    -1,    -1,   409,    -1,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,    -1,   430,    -1,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,    -1,   457,    -1,   459,   460,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   488,   489,   490,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
      -1,   161,   162,   163,   164,    -1,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,    -1,    -1,    -1,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,    -1,   234,    -1,   236,   237,   238,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,   272,   273,   274,    -1,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,    -1,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,    -1,
     430,    -1,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,    -1,   457,    -1,   459,
     460,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   488,   489,
     490,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,    -1,   161,   162,   163,   164,    -1,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
      -1,    -1,    -1,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,    -1,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,    -1,
     236,   237,   238,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,   269,    -1,   271,   272,   273,   274,    -1,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
      -1,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,    -1,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,    -1,   430,    -1,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
      -1,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   488,   489,   490,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,    -1,   161,
     162,   163,   164,    -1,    -1,   167,    -1,   169,   170,   171,
     172,   173,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,    -1,    -1,    -1,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,    -1,   236,   237,   238,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,    -1,    -1,   271,
     272,   273,   274,    -1,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,    -1,   297,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,    -1,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,    -1,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,    -1,   430,    -1,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,    -1,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   488,   489,   490,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,    -1,   161,   162,   163,   164,    -1,    -1,   167,
      -1,   169,   170,   171,   172,    -1,   174,    -1,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,    -1,    -1,
      -1,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,    -1,   213,   214,   215,   216,   217,
     218,    -1,   220,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,    -1,   234,    -1,   236,   237,
     238,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,    -1,
     268,    -1,    -1,   271,   272,   273,   274,    -1,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,    -1,   297,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,    -1,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,    -1,   423,   424,    -1,    -1,   427,
     428,    -1,   430,    -1,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,    -1,   457,
      -1,   459,   460,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     488,   489,   490,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,    -1,   161,   162,   163,
     164,    -1,    -1,   167,    -1,   169,   170,   171,   172,    -1,
     174,    -1,   176,   177,    -1,   179,   180,   181,   182,   183,
      -1,   185,    -1,    -1,    -1,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,    -1,   220,    -1,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,    -1,
     234,    -1,   236,   237,   238,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    -1,   268,    -1,    -1,   271,   272,   273,
     274,    -1,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,    -1,   297,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,    -1,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,    -1,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,   416,   417,   418,   419,   420,   421,    -1,   423,
     424,    -1,    -1,   427,   428,    -1,   430,    -1,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,    -1,   457,    -1,   459,   460,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   488,   489,   490,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
      -1,   161,   162,   163,   164,    -1,    -1,   167,    -1,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,    -1,   179,
     180,   181,   182,   183,    -1,   185,    -1,    -1,    -1,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,    -1,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,    -1,
     220,    -1,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,    -1,   234,    -1,   236,   237,   238,    -1,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,    -1,   268,    -1,
      -1,   271,   272,   273,   274,    -1,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,    -1,    -1,   295,    -1,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,    -1,   313,   314,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,    -1,    -1,   409,
      -1,   411,   412,    -1,    -1,   415,   416,   417,   418,   419,
     420,   421,    -1,   423,   424,    -1,    -1,   427,   428,    -1,
     430,    -1,    -1,   433,   434,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
      -1,   451,   452,   453,   454,   455,    -1,   457,    -1,   459,
     460,   461,   462,   463,   464,    -1,    -1,    -1,   468,    -1,
      -1,   471,   472,   473,   474,   475,   476,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   488,   489,
     490,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    -1,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,    -1,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,    -1,   161,   162,   163,   164,    -1,
      -1,   167,    -1,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,    -1,   179,   180,   181,   182,   183,    -1,   185,
      -1,    -1,    -1,   189,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,   208,    -1,   210,   211,    -1,   213,   214,   215,
     216,   217,   218,    -1,   220,    -1,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,    -1,
     236,   237,   238,    -1,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,    -1,   268,    -1,    -1,   271,   272,   273,   274,    -1,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,    -1,    -1,   295,
      -1,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,    -1,   313,   314,    -1,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,    -1,    -1,   409,    -1,   411,   412,    -1,    -1,   415,
     416,   417,   418,   419,   420,   421,    -1,   423,   424,    -1,
      -1,   427,   428,    -1,   430,    -1,    -1,   433,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,    -1,   451,   452,   453,   454,   455,
      -1,   457,    -1,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,   468,    -1,    -1,   471,   472,   473,   474,   475,
     476,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   488,   489,   490,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    -1,    -1,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,    -1,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,   134,    -1,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,    -1,   161,
     162,   163,   164,    -1,    -1,   167,    -1,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,    -1,   179,   180,   181,
     182,   183,    -1,   185,    -1,    -1,    -1,   189,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,   208,    -1,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,    -1,   220,    -1,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,    -1,   236,   237,   238,    -1,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,    -1,    -1,   271,
     272,   273,   274,    -1,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,    -1,    -1,   295,    -1,   297,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
      -1,   313,   314,    -1,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,    -1,    -1,    -1,   409,    -1,   411,
     412,    -1,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,   423,   424,    -1,    -1,   427,   428,    -1,   430,    -1,
      -1,   433,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,    -1,   451,
     452,   453,   454,   455,    -1,   457,    -1,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,   468,    -1,    -1,   471,
     472,   473,   474,   475,   476,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   488,   489,   490,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      58,    59,    60,    61,    62,    -1,    -1,    65,    66,    -1,
      -1,    69,    -1,    71,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,    -1,   116,    -1,
      -1,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,    -1,   161,   162,   163,   164,    -1,    -1,   167,
      -1,   169,   170,    -1,   172,    -1,   174,    -1,   176,   177,
      -1,   179,   180,   181,   182,   183,    -1,   185,    -1,    -1,
      -1,   189,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,    -1,   213,   214,   215,   216,    -1,
      -1,    -1,    -1,    -1,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,    -1,   234,    -1,   236,   237,
     238,    -1,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,    -1,   262,    -1,   264,   265,   266,    -1,
     268,    -1,    -1,   271,   272,   273,   274,    -1,    -1,   277,
      -1,    -1,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,    -1,    -1,   295,    -1,   297,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,    -1,    -1,
      -1,   409,    -1,   411,   412,    -1,    -1,   415,   416,   417,
     418,   419,   420,   421,    -1,    -1,    -1,    -1,    -1,   427,
     428,    -1,   430,    -1,    -1,   433,   434,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,    -1,   451,   452,   453,   454,   455,    -1,    -1,
      -1,   459,   460,   461,   462,   463,   464,    -1,    -1,    -1,
     468,    -1,    -1,   471,   472,   473,   474,   475,   476,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     488,   489,   490,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      -1,    45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    59,    60,    61,    62,    -1,
      -1,    65,    66,    -1,    -1,    69,    -1,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,    -1,   116,    -1,    -1,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,   148,   149,    -1,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,    -1,   161,   162,   163,
     164,    -1,    -1,   167,    -1,   169,   170,    -1,   172,    -1,
     174,    -1,   176,    -1,    -1,    -1,   180,   181,   182,   183,
      -1,   185,    -1,    -1,    -1,   189,   190,    -1,   192,   193,
     194,   195,   196,    -1,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,   216,    -1,    -1,    -1,    -1,    -1,   222,    -1,
      -1,   225,    -1,   227,   228,   229,   230,   231,    -1,    -1,
     234,    -1,    -1,   237,    -1,    -1,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,    -1,    -1,    -1,
     264,   265,   266,    -1,   268,    -1,    -1,   271,   272,    -1,
     274,    -1,    -1,   277,    -1,    -1,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,    -1,    -1,   298,    -1,    -1,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,    -1,   313,
     314,    -1,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,    -1,   383,
     384,   385,    -1,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,    -1,    -1,    -1,   409,    -1,   411,   412,    -1,
      -1,   415,    -1,   417,   418,   419,   420,   421,    -1,    -1,
      -1,    -1,    -1,   427,   428,    -1,   430,    -1,    -1,   433,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,    -1,   451,   452,   453,
     454,   455,    -1,    -1,    -1,   459,    -1,   461,   462,   463,
     464,    -1,    -1,    -1,   468,    -1,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   488,   489,   490
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    18,    28,    30,    31,    43,    48,    49,    70,    71,
      73,    74,    75,    81,    83,    84,    96,    98,   116,   119,
     134,   140,   144,   150,   159,   161,   168,   184,   201,   240,
     241,   246,   258,   267,   268,   272,   311,   320,   335,   342,
     343,   345,   350,   355,   358,   359,   364,   365,   371,   372,
     380,   385,   396,   414,   433,   443,   446,   451,   456,   470,
     493,   507,   514,   515,   516,   517,   523,   524,   526,   527,
     528,   529,   531,   535,   547,   552,   553,   556,   557,   558,
     584,   587,   588,   605,   656,   657,   660,   663,   664,   665,
     673,   679,   681,   683,   684,   687,   690,   691,   695,   704,
     708,   709,   710,   711,   714,   716,   717,   718,   719,   727,
     728,   747,   751,   753,   754,   755,   765,   767,   774,   775,
     778,   779,   780,   781,   782,   790,   792,   796,   801,   805,
     806,   814,   815,   818,   823,   834,   861,   864,   865,   866,
     871,   874,   876,   878,   880,   881,   886,   887,   890,   891,
     892,   896,   897,   902,   903,   906,   907,   908,   915,   917,
     918,   919,   924,   926,   927,   933,   934,   935,   936,   937,
     938,   939,   941,   942,   944,   945,   947,   950,   951,   959,
     960,   969,   970,   971,   972,   974,   979,   980,   981,   982,
     983,   984,   987,   988,   989,   990,   992,   993,   999,  1001,
    1005,  1008,  1010,  1011,  1020,  1022,  1027,  1030,  1035,  1039,
    1040,  1041,  1042,  1043,  1044,  1048,  1083,   427,   473,   920,
      25,    75,    78,    94,   113,   120,   142,   153,   162,   175,
     180,   187,   189,   205,   230,   251,   268,   289,   290,   314,
     325,   328,   357,   363,   366,   373,   376,   389,   398,   405,
     412,   414,   417,   421,   430,   435,   449,   462,   680,   920,
     299,    26,    89,   280,   383,   397,   442,   449,     3,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    37,    38,    40,    41,    42,    45,    46,    47,    48,
      49,    50,    51,    53,    54,    55,    56,    58,    59,    60,
      61,    62,    65,    66,    67,    68,    69,    71,    72,    73,
      74,    75,    76,    80,    81,    82,    83,    84,    85,    87,
      88,    89,    91,    92,    93,    94,    95,    96,    97,   100,
     101,   102,   110,   111,   112,   113,   114,   116,   117,   118,
     119,   121,   123,   124,   125,   126,   127,   128,   130,   131,
     132,   133,   134,   136,   137,   138,   139,   141,   142,   143,
     144,   145,   147,   148,   149,   151,   152,   153,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   167,
     169,   170,   171,   172,   174,   176,   180,   181,   182,   183,
     185,   186,   188,   189,   190,   192,   193,   194,   195,   196,
     198,   199,   200,   201,   203,   204,   205,   206,   207,   208,
     210,   212,   213,   214,   215,   216,   217,   218,   220,   222,
     225,   227,   228,   229,   230,   231,   234,   235,   237,   240,
     241,   242,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   263,
     264,   265,   266,   268,   269,   271,   272,   274,   276,   277,
     278,   279,   280,   281,   282,   284,   285,   286,   289,   290,
     291,   292,   295,   296,   298,   300,   301,   302,   303,   304,
     305,   306,   308,   309,   310,   311,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   354,   355,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   373,   374,   375,   376,   377,   380,   381,   382,   383,
     384,   385,   387,   388,   389,   390,   391,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   409,   411,   412,   415,   417,   418,   419,   420,   421,
     423,   424,   427,   428,   429,   430,   431,   433,   434,   435,
     436,   437,   438,   439,   442,   443,   444,   445,   446,   447,
     448,   451,   452,   453,   454,   455,   456,   457,   459,   461,
     462,   463,   464,   468,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1036,  1210,  1224,  1228,  1229,   460,
     953,   287,   321,   920,    52,   507,   596,    20,    25,    37,
      46,    64,    78,    90,   113,   120,   142,   153,   162,   175,
     183,   187,   189,   227,   242,   268,   289,   290,   293,   314,
     328,   357,   366,   376,   383,   398,   405,   417,   418,   420,
     421,   430,   435,   441,   445,   449,   606,   662,   770,   824,
     835,    26,   320,  1210,  1036,    26,   313,   374,   418,   420,
       5,   229,   872,   873,  1219,    20,    25,    37,    64,    78,
      94,   113,   142,   153,   162,   175,   180,   187,   189,   205,
     251,   268,   289,   290,   302,   314,   328,   357,   363,   366,
     373,   376,   383,   398,   405,   414,   417,   421,   428,   430,
     435,   449,   462,   680,   783,   784,   785,   920,    98,   132,
    1210,    98,   159,   460,   507,   657,   660,   663,   951,   994,
    1008,  1011,  1020,  1030,  1035,  1039,     9,    19,    26,    45,
     170,   176,   178,   202,   231,   265,   323,   344,   498,   499,
     802,   803,  1036,  1218,  1220,    26,    98,   340,   372,   807,
     808,   809,  1224,   175,  1224,  1215,  1219,   414,  1051,   162,
     187,   802,   246,   444,  1224,    75,    98,   427,  1210,   302,
     251,   113,   205,   366,   412,   414,   507,   882,   883,   365,
    1224,    26,   377,   423,   427,   539,   548,   549,  1224,    23,
     184,   807,   808,   321,   920,  1208,  1224,  1224,   228,    26,
     135,  1053,  1054,    65,    91,   242,   260,   357,   366,   377,
     423,   427,   476,   536,   537,   538,   539,    26,   377,   423,
     427,   539,   427,   288,  1094,  1208,  1051,   500,  1224,    75,
     179,   507,   954,   507,   338,  1045,  1046,  1210,  1045,  1040,
    1041,  1044,     0,   510,   507,   953,    22,    26,    28,    43,
      81,    98,   113,   125,   133,   144,   147,   162,   180,   184,
     187,   205,   215,   246,   251,   268,   307,   346,   357,   366,
     372,   373,   380,   412,   414,   417,   430,   433,   435,   448,
     449,   462,   963,   964,   965,   154,   219,   294,   440,  1055,
    1056,  1040,  1042,  1043,   125,   215,   448,   511,     3,    44,
      52,    78,    86,    99,   106,   177,   179,   197,   211,   223,
     224,   226,   236,   238,   262,   273,   297,   299,   356,   386,
     416,   460,   851,  1216,  1224,  1225,  1228,  1230,   189,   268,
     787,  1224,   787,  1211,  1224,   324,   787,   430,  1210,   112,
     414,   839,  1216,  1224,  1230,     3,   109,   378,  1221,  1222,
    1226,  1228,  1229,  1230,   268,    26,   196,  1208,   280,   462,
     187,   975,  1224,   405,     8,    15,    16,    17,    72,   167,
     494,   495,   496,   498,   499,   500,   501,   502,   503,   868,
     870,  1172,  1173,  1224,   196,  1210,  1210,    26,  1221,  1222,
    1210,  1210,   196,  1208,  1210,  1210,   787,  1210,   350,   380,
      26,   196,  1094,  1210,   369,  1210,   787,    26,   249,  1221,
    1222,   196,  1208,   229,   122,   225,   270,   333,   921,   922,
     923,  1209,  1210,    43,   425,    43,   187,    43,    43,    43,
    1208,  1214,  1224,    20,    25,    64,    78,    79,    90,    94,
     113,   142,   153,   162,   175,   180,   205,   230,   251,   290,
     314,   328,   357,   363,   366,   373,   376,   389,   398,   405,
     414,   417,   421,   428,   430,   435,   462,   680,   793,   794,
    1219,  1007,  1011,  1020,  1030,  1039,  1208,   253,  1216,  1210,
     973,  1219,   507,   196,   787,   430,  1211,   268,   787,   430,
     196,   383,  1210,   112,   414,   418,   420,  1221,  1222,   268,
     456,   418,   420,   187,   975,   405,    72,   167,   868,   348,
    1210,  1210,  1221,   196,   532,  1224,   196,  1210,   187,   196,
     787,  1210,  1210,   369,  1210,   787,   249,  1221,   338,   373,
     414,   462,   251,    94,   205,   180,   363,   428,   434,   674,
      26,  1210,  1037,   546,  1219,  1226,   873,   253,   196,   851,
     852,  1210,   196,   877,   196,   320,  1211,     3,    51,    53,
      54,    55,    56,    67,    68,   117,   118,   143,   171,   196,
     217,   218,   220,   261,   263,   278,   279,   334,   382,   390,
     423,   424,   457,   789,  1118,  1120,  1122,  1124,  1126,  1128,
    1129,  1130,  1132,  1133,  1134,  1136,  1137,  1225,  1228,   430,
     112,   414,   196,   838,   839,   196,  1222,  1223,   268,    86,
     462,   187,   975,   405,    72,   167,   196,   869,   870,    58,
     196,  1223,   202,   196,  1210,   196,  1210,   369,   877,   196,
     789,   196,   249,  1223,   229,   196,   786,   787,   196,  1209,
     196,  1210,   162,   287,   507,  1009,   606,   994,   456,   951,
     995,   996,   997,  1226,   953,  1220,   803,   804,    26,   804,
    1220,   804,    26,   804,  1220,   804,   804,   804,  1220,  1218,
    1218,  1036,   804,   324,   507,   507,   626,   626,   626,   287,
     425,   511,   626,   366,  1094,  1097,   187,   976,  1224,   470,
     470,   511,   916,   162,  1219,   507,  1006,    58,   462,   460,
     884,   885,  1208,  1210,  1224,    44,   490,   225,   509,   291,
     291,   287,   178,  1219,   425,   507,   505,   509,  1199,  1201,
     173,   797,   287,     4,     6,     7,     8,    10,    34,    51,
      53,    54,    55,    56,    63,    64,    67,    68,    76,    78,
     103,   104,   105,   106,   107,   108,   109,   115,   117,   118,
     120,   160,   165,   166,   171,   186,   188,   217,   218,   220,
     235,   243,   244,   261,   263,   270,   275,   276,   278,   279,
     290,   300,   315,   334,   361,   378,   379,   390,   406,   410,
     413,   423,   424,   429,   431,   432,   441,   449,   457,   478,
     479,   480,   481,   483,   484,   485,   486,   491,   498,   499,
     500,   507,  1040,  1121,  1124,  1127,  1128,  1129,  1131,  1132,
    1133,  1136,  1137,  1141,  1143,  1144,  1145,  1147,  1168,  1169,
    1170,  1174,  1193,  1198,  1205,  1206,  1216,  1217,  1218,  1219,
    1224,  1204,  1205,  1219,    26,   554,  1207,  1208,   377,   536,
     120,   545,  1219,   546,  1219,    44,    69,   536,   490,   391,
     922,   291,   178,   425,   496,    44,   490,   225,   923,   507,
    1208,   307,   500,  1095,  1096,  1097,     3,   177,   179,   460,
     948,   949,   951,   177,   955,  1141,  1177,  1045,   511,   507,
     958,   508,   508,   516,    95,   460,   956,   957,   409,   952,
    1208,   308,   113,   162,   180,   205,   251,   268,   357,   366,
     373,   412,   414,   417,   430,   435,   449,   462,   414,   113,
     162,   180,   205,   251,   268,   357,   366,   373,   383,   414,
     417,   430,   435,   449,   462,   414,   430,   113,   162,   180,
     205,   251,   268,   357,   366,   373,   383,   414,   417,   430,
     435,   449,   462,   430,   180,   373,   414,   435,   414,   414,
     462,   373,   414,   357,    43,   184,   414,   414,    58,   287,
     466,   961,   511,    26,   135,  1052,  1052,    58,  1052,   168,
     173,   239,   283,  1059,  1061,  1062,  1077,  1079,  1080,  1081,
    1055,  1056,   178,   221,  1094,  1098,   507,   303,   346,   380,
     507,   849,  1201,   268,   975,   303,   342,   346,   380,   509,
     788,   303,   346,   380,     3,    89,   148,   245,   303,   346,
     380,   417,   419,   470,   547,   550,   928,   929,   930,   931,
     819,    22,   144,   303,   346,   380,   453,   565,  1210,    22,
     144,   380,   448,   530,   474,   196,  1094,    60,    97,   128,
     164,   199,   234,   270,   303,   304,   329,   346,   354,   362,
     371,   380,   394,   403,   464,   547,   551,   854,   862,   507,
     836,  1201,   346,   530,   975,   202,   160,    22,    28,    41,
      75,   125,   128,   133,   137,   138,   139,   144,   147,   155,
     174,   207,   266,   270,   281,   292,   303,   336,   346,   349,
     350,   380,   425,   453,   559,   563,   564,   651,   653,   698,
       4,   498,   499,   671,  1220,    26,   196,  1208,   976,   202,
     570,  1210,   787,   787,   507,   867,   303,   380,   509,   160,
     287,    22,   144,   303,   346,   380,   202,   525,   346,   470,
     493,   518,   525,   287,   303,   346,   160,    35,    59,   111,
     204,   252,   255,   266,   302,   346,   351,   373,   380,   396,
     559,   668,   669,   303,   346,   461,   698,   706,   346,   303,
     346,   380,    89,   133,   147,   303,   342,   346,   380,   549,
     537,   539,   202,   160,    41,   130,   346,   380,   559,   561,
     303,   346,   350,   380,    87,   131,   305,   419,   287,    22,
      28,   144,   303,   346,   380,   585,   586,   525,   173,   346,
     518,   525,   160,   346,   380,   559,  1210,   237,   122,   288,
     475,   511,   921,   425,   511,    26,    95,   268,   287,   976,
      58,   450,   946,   287,   253,   851,   507,  1210,  1118,   430,
     112,   414,   839,   280,   462,    72,   167,   870,  1210,  1210,
     369,   173,  1210,  1118,   229,   787,  1210,   173,   508,   626,
    1210,   507,   760,   849,    70,  1118,   270,   178,   507,   756,
    1210,   518,   187,    35,   940,  1210,   270,   187,   518,   474,
     196,  1208,   518,   975,     5,   750,   976,   470,   472,   644,
    1210,   787,   787,   756,   445,   606,   287,   173,   898,   899,
     518,   270,    44,   533,   270,   435,   705,   425,  1218,   270,
     958,    89,   303,   682,    87,   131,   305,   419,    24,    47,
     216,   729,    35,   756,   173,   196,   518,   462,   196,  1208,
     196,   658,  1208,  1208,   462,   787,    86,   825,  1216,  1210,
     173,   680,    52,   110,   214,   266,   368,   160,    61,   352,
     511,   566,   566,   160,   507,   160,   196,  1211,   459,  1135,
    1135,  1135,   507,  1123,  1123,   317,   507,  1125,   160,    67,
      68,  1135,  1123,  1123,  1120,   472,   493,   507,  1138,   507,
    1138,   511,   566,    34,  1119,   507,   114,   194,   254,   257,
     370,   488,   507,  1139,  1140,   788,  1123,   474,   160,   511,
     566,   160,   511,   975,   196,   786,   976,   570,   196,  1210,
     196,   787,   196,   787,   160,   511,   566,  1223,   160,   187,
     160,   566,   160,    87,   131,   305,   419,   173,   160,   566,
     160,   173,   196,   196,   546,   160,   511,   566,   160,   566,
     160,   287,   196,  1210,   507,   977,  1177,   414,   508,   511,
     166,   287,   432,   543,   546,   671,   998,   994,   804,  1036,
     804,  1036,   804,  1036,   804,  1036,   804,  1036,  1036,  1036,
     804,  1036,   507,   627,   628,  1224,   627,    26,   113,   142,
     175,   180,   229,   230,   366,   373,   414,   417,   435,   810,
    1207,  1223,   809,  1210,   202,   511,  1023,   976,   112,   507,
     507,  1219,   196,  1210,  1118,  1180,    35,  1223,   825,   508,
     511,   237,  1224,   173,   173,   810,  1223,   173,   365,  1224,
    1218,  1141,  1200,     3,    26,    30,    31,    32,    33,    34,
      35,    36,    39,    43,    57,    63,    64,    70,    77,    79,
      90,    98,   103,   104,   105,   107,   108,   109,   115,   120,
     122,   129,   135,   140,   146,   150,   154,   166,   168,   173,
     175,   178,   184,   187,   191,   202,   209,   219,   221,   232,
     233,   239,   243,   244,   267,   270,   275,   283,   287,   288,
     293,   294,   307,   312,   322,   340,   353,   372,   378,   379,
     392,   407,   408,   410,   413,   414,   422,   425,   426,   432,
     440,   441,   449,   450,   458,   465,   466,   467,   469,   470,
     500,  1213,  1227,  1228,  1229,  1230,  1231,  1199,   546,   287,
     507,  1202,   505,  1040,  1181,  1141,  1197,   507,   507,   173,
     507,   507,  1040,   507,   507,   507,   507,   507,   507,  1141,
     507,   507,   507,   507,   507,   507,   507,   507,  1040,   507,
     507,   507,   507,   507,   507,   507,   507,  1141,  1141,  1141,
    1040,  1141,  1177,  1201,  1219,   507,  1219,     3,     8,    11,
      15,    16,    17,    32,    35,    40,    50,    77,   197,   202,
     223,   224,   238,   273,   290,   293,   386,   491,   494,   495,
     496,   498,   499,   500,   501,   502,   503,  1172,  1174,  1176,
     471,  1156,   299,  1141,   221,   511,  1049,   507,  1219,  1201,
    1049,   123,   198,   555,   511,    69,   120,   546,    35,     3,
     120,   242,   544,   671,  1137,  1219,  1219,    92,   141,  1153,
     102,   120,   540,   541,   543,   671,   120,   540,   237,  1208,
    1095,   173,    93,   351,   791,   508,   511,   953,   508,   511,
    1046,  1209,    35,   508,   511,    26,   178,   425,   958,   462,
     462,   187,   187,   462,   187,   202,   966,  1224,   120,   180,
     251,   373,   414,   435,   462,   967,   968,  1224,   270,   962,
     965,  1042,  1042,  1057,  1058,  1141,  1042,   170,   265,  1068,
     227,   266,   333,   384,   448,    26,  1063,  1141,  1064,  1066,
    1141,  1143,  1077,  1078,  1062,  1061,  1059,  1060,   173,  1080,
     281,  1082,  1059,  1077,  1098,  1012,  1208,    35,  1224,   380,
    1177,   425,   425,   366,   202,   212,   294,   296,   382,   458,
     500,   842,   843,   844,   846,   848,   850,  1118,  1225,   975,
     570,   425,   461,   425,   366,  1213,   509,   425,   425,   366,
     239,   425,   425,   417,   536,   303,   928,   930,   496,   932,
     173,   184,   202,   355,   820,   821,    70,    90,   156,   175,
     322,   441,   623,   624,    90,   120,   270,   425,    90,   425,
     120,   270,   366,    90,   133,   147,   303,   346,   752,   366,
     688,    20,    25,    64,    78,    94,   142,   153,   175,   180,
     251,   290,   366,   373,   376,   414,   421,   428,   435,   462,
     680,  1210,   160,   346,   380,   559,   287,   671,   287,   371,
     234,   329,   425,  1224,   425,   275,   671,   124,   222,   366,
     377,   427,   538,   352,   380,   854,   863,   508,   837,   842,
     425,   449,   644,   417,  1208,    79,   156,   196,   268,   308,
     613,   623,  1224,    79,    90,   888,   307,   287,   268,   287,
     361,   363,   430,    58,    58,   331,     3,    26,   227,   649,
      90,   888,    29,   349,   361,   363,   430,   205,   361,  1208,
     174,   207,   281,   787,   507,   425,   163,   425,   195,   507,
     571,   248,   307,   417,   445,   470,   472,   571,   187,   268,
      90,   511,     4,     4,   303,   202,   160,   128,   346,   380,
     559,   380,   560,   562,  1224,   644,    89,   133,   147,   342,
     380,   450,   450,   269,  1118,   425,   366,   507,   868,  1210,
    1208,   414,   414,   425,   425,   414,   756,   113,   380,   550,
     425,   520,   550,  1208,   425,   425,  1208,  1120,   671,    58,
     670,   671,   671,   111,   252,   255,    58,   425,   518,   259,
     366,   518,   266,   669,   425,   425,   275,  1219,   698,   425,
     425,   425,   366,  1219,   425,   328,   425,   328,   756,   417,
    1094,   307,   307,    90,   425,   888,   366,   425,   425,   571,
     571,   787,   787,   787,   787,  1208,    42,   455,    42,    42,
     425,    42,   425,   455,   366,   511,   550,   449,   715,  1222,
     425,   520,   550,  1208,   425,   366,   303,   346,   333,   347,
     375,   542,   921,  1209,  1210,   174,  1004,   977,   977,   967,
     968,   178,   966,  1214,  1224,  1208,   223,  1118,   287,   223,
     474,   223,   671,   787,   787,   223,   287,   287,    87,   131,
     305,   419,  1118,   287,   223,   223,   223,    70,   425,   470,
     597,   435,     3,   761,   762,   756,   507,    35,   160,   787,
     757,   758,  1227,    24,   928,   976,  1118,   287,   160,   425,
    1218,   685,  1210,   270,   307,   507,   519,   644,   173,   511,
     470,   285,   571,   285,    89,   120,   770,   450,   338,   462,
    1208,    26,   414,    58,   900,   901,   519,   160,  1222,    98,
     184,   534,   605,   664,   728,   805,   823,   924,   160,  1219,
     706,   707,   187,   202,   160,   287,  1219,  1222,   245,   787,
     787,   787,   787,   281,   125,   215,   433,   448,   730,   731,
     151,   332,   507,   715,   270,   519,  1208,   270,   666,   668,
     270,    35,   281,   307,   507,   626,   626,   196,   661,  1208,
     173,   196,   826,  1214,   507,   840,    35,  1118,   229,   470,
     472,  1038,   368,   852,   851,  1118,  1211,   160,   507,  1177,
    1218,   789,  1135,  1135,    34,  1119,   423,   423,  1218,  1218,
    1118,   505,   505,  1218,   425,   425,   425,   507,   425,  1218,
    1123,   838,   839,  1223,  1222,   160,   566,   644,   160,   566,
     160,   450,   160,   450,   869,   870,   566,  1223,   976,  1210,
    1210,  1118,   789,  1223,   715,   160,   160,   566,   786,   787,
    1209,  1210,   787,   270,   518,   975,   978,  1000,  1219,   508,
     196,  1208,   994,   996,  1036,  1036,  1036,  1036,  1036,  1036,
     627,   508,   511,   508,   181,   374,   415,  1209,   786,   112,
     376,   838,  1209,   280,  1209,  1207,  1207,  1209,   786,   425,
     470,   816,   154,   239,   712,   713,    20,   158,   361,   384,
    1024,  1094,   274,  1025,   112,   178,  1028,  1029,  1218,  1219,
    1028,   270,   518,   508,   511,  1007,   425,  1208,   882,   883,
     885,   808,   807,   808,   178,   185,   817,    70,  1224,   508,
     506,   512,    25,    79,   113,   142,   153,   175,   180,   230,
     251,   328,   357,   366,   373,   389,   405,   414,   417,   435,
     462,   680,   798,   799,  1177,  1199,   506,  1177,  1181,  1182,
     465,  1194,  1195,  1141,  1177,   507,  1218,  1218,     3,   114,
     194,   254,   257,   370,   488,  1183,  1184,  1219,  1177,  1177,
    1177,  1218,  1218,  1141,   868,  1141,  1185,   361,   498,   499,
     507,  1142,  1143,  1174,  1187,   508,  1177,  1141,  1177,  1188,
    1141,    57,   178,   233,   426,  1141,  1177,  1191,  1177,   259,
    1143,  1141,  1151,  1152,  1153,   259,  1141,  1153,   508,   511,
    1218,  1139,  1118,  1141,  1141,  1141,  1141,  1227,   423,    39,
     408,  1203,   787,  1141,   507,  1040,  1192,   135,   141,   166,
     270,   275,   281,   432,   442,  1141,   507,  1141,   425,    50,
     197,   202,   238,   386,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1141,  1141,    26,    33,   392,  1171,   187,   169,
    1157,   361,   507,  1168,   183,   242,   414,   418,   420,   445,
    1050,  1208,  1206,   178,  1084,    26,   135,   458,   500,   508,
     844,  1141,  1178,  1179,  1225,  1084,  1208,   427,   507,  1219,
     511,   508,   120,   507,   195,   195,   566,   952,  1208,   949,
     950,   952,  1208,  1141,   508,   251,   270,  1047,   952,  1208,
     957,   975,   978,   409,   952,   187,   511,   961,   462,   968,
     961,   509,   407,   511,    36,   129,   450,   832,   507,  1065,
    1220,   384,   227,   288,   511,   361,   362,  1067,  1207,   274,
     388,  1026,  1078,  1060,   450,  1021,   120,   301,   507,  1013,
    1039,    35,  1224,   507,  1031,  1032,  1033,  1224,   508,  1222,
    1210,  1210,   296,    58,  1225,   508,   844,   846,   843,   846,
    1225,   294,   508,   511,   788,   644,   644,  1222,  1210,  1210,
    1213,  1222,  1210,  1210,  1222,  1211,  1210,   120,   543,  1220,
     357,   449,   807,   366,   184,   807,   507,  1210,   450,   827,
     227,   227,   450,   507,   655,   196,  1210,   275,  1222,  1210,
    1210,  1141,   275,  1210,  1210,    29,   349,   425,   425,  1210,
     425,   689,   253,   851,   507,   787,   787,  1118,   430,   112,
     414,   839,   462,    72,   167,   870,  1210,   787,  1210,   787,
     369,   173,  1118,   787,   229,   190,   266,   303,   346,   454,
     692,   693,   694,  1094,   425,   888,   366,   275,   162,   124,
     222,  1222,  1210,   287,  1210,   508,   511,  1221,  1223,  1210,
     346,   559,   196,   613,   270,   977,  1218,  1118,  1210,  1224,
    1208,  1210,   977,   162,   237,  1210,    26,   449,  1210,     3,
     648,   507,   136,   650,   196,  1210,   196,  1224,   363,   430,
     363,   430,   237,  1210,    26,   449,  1210,  1208,   237,   361,
    1208,    22,   144,   380,   699,   700,   701,   702,  1227,  1222,
    1210,   120,   179,   271,   450,   569,   573,   574,  1227,    48,
    1210,   285,    75,   285,   976,   977,  1210,   564,   425,   417,
    1208,   287,   425,   888,   366,   425,   511,  1219,   328,   328,
     756,  1212,  1224,  1212,   511,   508,   511,  1222,  1210,   893,
     894,  1227,   287,   346,   425,   723,  1097,  1097,  1222,  1210,
    1097,  1211,  1221,     3,    89,   149,   207,   310,   439,   449,
     452,   521,   346,  1222,  1210,   346,   380,   559,   668,   671,
     787,  1210,   671,   787,  1210,   671,  1222,  1210,  1210,  1222,
    1210,  1210,  1222,   470,   858,  1210,   904,   905,  1227,  1210,
     346,   380,   559,   561,  1208,  1208,  1210,  1210,  1210,  1210,
    1222,  1210,    22,    28,   144,   303,   346,   380,   303,   346,
     380,   756,   346,   380,   346,   380,   128,   346,  1110,  1224,
     196,   766,  1224,   196,  1224,  1222,  1210,  1210,  1219,  1210,
      22,   586,   376,  1221,   346,   380,   559,  1210,  1210,   425,
     425,    85,   438,   333,   173,  1002,  1002,  1002,   968,   975,
     275,   795,  1219,    35,   142,   787,   795,   795,   223,   450,
     450,   795,   787,   787,   229,   787,   795,   795,   795,   288,
     327,   590,   285,   383,   591,   205,   496,   508,   511,  1141,
    1118,   787,   508,   511,   496,   730,   470,   615,  1227,  1210,
     187,   202,    61,   178,   366,   461,   686,   693,   694,   160,
     281,   238,   607,   609,   611,   613,   620,   623,    23,   202,
     357,   411,   521,   522,   414,     5,   977,  1219,   173,  1212,
     462,  1208,    35,   724,   415,  1097,   383,   858,   532,  1224,
     533,   293,   606,  1210,   175,   976,  1218,   787,  1177,   328,
    1219,   756,   756,   756,   756,   281,   287,   293,   507,   756,
    1108,  1109,  1110,   376,   160,   507,   160,   160,   159,  1039,
     787,   281,   607,  1224,   644,   470,   572,   270,    35,   626,
    1219,   270,   287,   508,   841,   842,   847,    35,   229,   354,
     428,   469,   853,   854,   855,   287,   229,   546,   193,   193,
     173,   566,    35,  1211,  1177,   508,   508,   566,   505,   490,
     490,   508,   508,  1218,   506,  1218,   508,   194,   254,  1140,
     254,  1140,  1140,  1218,   257,   508,   566,   786,  1210,   787,
    1212,   787,  1212,   566,   566,   229,   566,   376,   173,   546,
     566,   566,   287,   566,   160,   685,   508,   511,   270,   508,
     628,   202,   202,   202,   474,  1209,   671,   672,   187,   811,
     812,  1222,    23,   817,   425,   507,   178,   158,   384,   158,
     384,   361,   448,   256,   178,   284,   975,   985,   508,   511,
     508,   160,   685,  1118,  1222,   470,   659,  1208,  1210,   178,
     287,   811,    58,   566,   288,  1141,  1200,   851,  1118,   430,
     414,   839,   280,   462,  1118,   229,   787,  1210,   508,   506,
     506,   511,  1141,   146,  1195,  1196,    35,   508,  1141,   508,
     508,   508,   178,   508,   508,   508,   508,   508,   511,   508,
     312,  1186,   508,   507,  1142,  1142,  1177,    11,    15,    16,
      17,   202,   223,   290,   494,   495,   496,   498,   499,   500,
     501,   502,   503,  1174,  1142,   508,   508,   173,   178,  1189,
    1190,   508,    35,  1191,  1177,  1191,  1191,   178,   508,   508,
    1227,   309,  1155,    35,   508,   511,  1141,  1227,   511,  1141,
    1202,  1141,   508,   490,  1142,  1142,   152,  1177,   178,   135,
     141,   166,   275,   281,   432,   442,   507,   152,   868,  1141,
     408,  1203,  1141,  1192,  1141,   425,   507,  1040,   507,   507,
     298,  1161,   507,  1177,   418,   420,   418,   420,  1208,  1051,
    1051,  1051,   232,   362,   487,   507,  1040,  1085,  1086,  1087,
    1094,  1101,  1111,  1144,  1146,  1147,  1216,  1224,   467,  1106,
    1178,  1178,  1179,   508,    13,    14,   511,  1055,  1056,  1106,
     922,  1218,  1139,   541,  1095,  1141,   958,   383,   952,   251,
     507,   958,  1224,   961,  1224,  1058,   290,  1172,  1175,   492,
     833,  1141,  1067,   448,  1064,   247,  1085,   467,  1107,   456,
     412,   449,  1014,  1015,  1016,  1224,   287,  1017,  1224,  1033,
    1034,   511,  1084,   496,  1202,   850,   788,   846,   846,    58,
     848,   502,  1223,  1223,   287,  1209,   291,   287,  1141,   624,
    1212,   507,   507,   507,   655,   205,   627,   745,   160,   566,
     425,  1222,  1210,   546,  1210,  1118,  1210,   474,   787,   787,
     787,   787,    87,   131,   305,   419,  1118,  1210,   675,  1210,
     190,   454,   425,   425,   675,   692,   698,   346,   380,   559,
    1210,  1210,  1210,   213,  1210,   275,   842,   302,   380,   425,
     270,   160,   292,   696,   745,    22,   144,   350,   351,   380,
     565,   575,   576,   698,   889,  1210,   371,   507,  1209,   507,
     160,   566,   160,   566,  1210,  1210,  1210,  1210,   371,   470,
     371,   237,   701,   702,   701,   508,   511,   703,  1219,   205,
     508,   511,   496,   509,   507,   976,  1222,  1210,   346,   380,
     559,   162,  1210,  1210,  1210,   120,   562,   858,   904,   303,
     346,   380,    22,   144,   303,   346,   380,  1118,   269,  1118,
     508,   511,   496,  1208,   425,  1223,   450,   720,   239,   310,
     275,  1219,   310,  1223,   447,   425,   425,   366,   756,   511,
     858,   302,   380,    90,   425,   888,   366,   120,   173,   577,
     425,   425,   249,   249,   249,   425,   425,   366,   425,   425,
     366,   425,   366,   425,   366,   287,   425,   566,  1118,   270,
    1219,   380,   889,   160,   566,   425,   425,  1210,   425,   366,
    1222,  1210,   113,  1211,   425,  1003,  1003,  1003,   425,  1118,
     787,   223,   795,  1212,  1212,   223,   223,  1210,   223,   399,
     400,   592,  1219,   507,   178,   425,   589,   190,   269,   290,
     498,   499,   671,   759,   846,  1175,  1219,  1231,     3,   762,
     508,   508,   178,   756,   758,   759,   287,   977,    70,    77,
      90,   120,   122,   182,   209,   270,   275,   322,   340,   441,
     616,   617,   619,   159,   465,   518,   976,  1218,   546,  1210,
     546,   696,  1208,  1208,  1208,   508,   511,  1223,   187,   357,
    1223,  1218,   991,  1224,   328,   435,  1208,   626,     3,   173,
     725,   507,    44,   533,   348,   414,   705,   112,   958,   178,
     904,   572,   627,  1208,   731,   763,   764,  1219,   508,   511,
    1210,   173,   627,  1208,   658,  1208,  1210,   659,   507,   608,
    1208,   508,   287,   645,   571,    35,   160,  1039,   572,   425,
     160,  1094,   508,   511,   120,   496,   856,  1219,   546,   414,
     845,   846,   173,   857,   855,   858,   125,   215,   372,   448,
     913,  1210,   190,  1039,  1118,   508,  1218,  1138,  1138,   506,
     506,   508,   566,   566,   450,   566,   450,   566,  1210,  1210,
     715,   566,   787,  1210,   975,   160,   366,   366,   366,  1209,
     511,  1222,   470,   511,   813,   291,  1097,   376,   158,   158,
     985,   507,   425,  1029,  1210,   112,   266,  1223,   810,   566,
    1222,   506,   223,   223,   223,   671,   223,   223,   223,  1181,
     422,  1141,   150,  1118,   508,  1141,  1141,  1141,  1189,   508,
    1177,   511,  1118,  1142,  1142,  1142,  1142,   135,   141,   270,
     281,  1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,
    1142,  1141,  1141,  1190,  1189,  1118,   508,   508,   508,  1177,
     508,   511,    58,  1143,   508,  1227,  1152,   319,   404,  1154,
     508,   511,   461,  1148,    35,   508,  1219,  1141,    32,    32,
    1141,   508,  1141,   178,   507,  1180,  1141,   508,   152,  1142,
    1142,   152,   152,  1141,  1141,  1056,   467,   507,  1162,  1224,
     508,  1177,   511,  1051,  1051,  1051,  1051,  1208,  1208,  1208,
    1040,  1101,  1111,   178,   507,  1040,  1086,  1087,    35,  1088,
    1089,  1224,   511,    99,   179,   211,   226,   236,   262,   356,
    1091,  1089,    35,  1088,  1090,  1224,  1089,   493,  1105,   507,
    1201,  1141,   187,  1069,   511,  1055,  1055,  1055,  1141,  1141,
     458,  1179,   508,  1069,   508,   508,   952,   507,  1007,   952,
     509,   507,   833,   170,   231,   508,   288,   102,  1141,   353,
    1019,   455,   508,   511,  1202,    88,  1019,   508,   511,  1032,
    1107,  1141,   508,   502,   850,   435,   181,   367,   374,   415,
     436,   822,   173,   822,   508,   507,   630,   631,   829,  1146,
    1224,   627,   627,   745,  1214,   508,   122,   209,   266,   270,
     746,  1210,  1210,    35,  1210,   450,   450,   787,   787,   787,
     787,   229,   788,  1222,  1210,   425,   888,   366,   425,   213,
      58,   417,  1210,   160,   613,   507,   615,   182,   195,   270,
     571,   518,   112,   182,   270,   398,   402,   571,   669,   380,
     576,   435,  1209,   508,  1209,  1210,  1224,  1208,   371,   700,
    1210,   574,   759,  1227,  1216,  1217,   302,   380,   425,   888,
     366,  1210,   425,   858,   425,   425,   366,   180,   290,   402,
     768,   769,   180,   290,   776,   777,   425,   425,   366,   508,
     508,   508,   894,   269,   671,   846,   895,  1175,  1219,  1231,
     346,  1210,   507,   470,   721,  1220,  1219,  1219,  1219,  1210,
    1210,  1210,   905,    58,   417,  1210,  1210,  1210,  1210,   456,
    1210,  1210,   173,   173,   348,   173,   196,  1222,  1210,  1210,
    1222,  1210,  1210,  1210,  1210,  1210,  1210,   162,  1210,    77,
     567,   160,    24,    47,   435,  1224,  1210,  1219,   698,  1210,
    1210,  1211,   449,  1221,   975,   508,   223,   795,   223,   223,
     795,   795,   223,   795,   518,   986,  1218,   590,   675,   745,
     470,   472,   787,  1208,   507,   787,  1210,  1142,    29,    58,
     618,   123,   198,   122,   275,   227,  1208,   858,   326,   748,
     749,  1224,   685,   307,   507,   608,   621,   208,   637,   611,
    1223,  1223,   425,   509,   904,  1118,   507,   572,    26,   125,
     215,   372,   448,   726,   425,   722,   986,  1222,   196,  1208,
     707,   474,   287,  1085,   858,   341,   732,   508,   511,  1110,
     696,   715,   508,   666,    35,   281,   307,   507,  1009,   610,
     612,   614,   623,  1224,   307,   638,   639,   608,   637,    83,
     417,   646,  1039,   661,   659,   646,  1219,  1214,   827,   847,
    1141,  1141,   511,   507,   853,   435,   511,   425,   507,   675,
     508,   506,  1212,  1212,   566,   376,   566,   518,  1209,  1209,
    1209,   671,   184,   812,   508,  1210,   425,  1218,   985,   518,
     112,   817,   178,   275,   800,  1219,   800,   800,   223,   800,
     800,   800,  1141,   508,   508,  1190,   508,  1141,   178,   135,
     141,   281,   507,   508,   477,  1150,  1177,   339,    58,   468,
     468,   508,  1141,   266,  1141,   511,  1149,  1120,  1141,  1141,
    1141,  1180,   508,  1141,    32,    32,  1141,  1141,   152,   508,
     508,  1141,  1163,  1224,   508,  1141,  1208,  1208,  1208,  1208,
    1089,  1090,  1089,   507,   482,  1143,   508,  1224,   507,  1086,
     226,   297,  1092,  1086,  1092,   226,  1091,  1092,   226,   416,
    1099,   507,  1224,   507,   295,  1178,    58,   191,  1076,   508,
     508,   508,  1179,  1219,  1076,  1219,  1218,   508,  1224,   868,
     281,  1205,  1039,   301,  1039,  1016,   287,   507,  1018,   496,
    1033,  1019,   435,   508,   425,   807,   178,   745,  1141,   508,
     511,   470,    77,   830,   830,   508,   508,   858,   123,   198,
     207,   122,   452,   566,  1118,  1212,  1212,  1210,  1210,  1210,
    1210,  1210,  1223,  1210,   613,   697,   701,   618,   196,   275,
     671,   618,   275,  1220,  1224,  1118,   508,   508,   566,   566,
     496,   507,   508,    58,   417,  1210,  1210,  1210,  1210,  1222,
    1210,  1210,  1218,  1218,  1118,   511,  1218,  1218,   511,  1222,
    1210,  1210,   425,  1141,    70,  1223,  1210,   425,   425,   178,
     202,   470,  1209,  1209,   787,  1209,   160,  1210,   787,  1219,
    1219,  1118,   566,   566,  1221,   223,   795,   795,   795,   795,
     507,   593,   594,   508,   511,   592,   180,   212,   180,   178,
     744,  1141,   270,   617,   120,    35,   858,   626,   450,   654,
    1216,    32,   159,   202,   281,   607,   577,   157,   203,   507,
     376,   187,  1224,   858,   450,   627,    35,  1223,   720,   508,
     533,   270,   507,   175,  1210,  1177,   264,   286,   733,   734,
     735,   173,   738,  1219,   376,   572,  1039,   787,   281,   607,
     659,   508,   511,   470,   615,    58,   644,   577,   638,   125,
     144,   319,  1210,   647,   651,   470,   925,    35,   178,   287,
     507,  1219,   844,   859,   860,  1225,   858,  1118,   173,  1208,
     178,   425,   879,   210,   676,   566,   566,   566,  1210,   685,
     291,   221,   985,   508,    40,   470,   685,   566,   811,   800,
     508,  1142,   178,   507,  1180,   507,   508,   511,   508,  1143,
     339,   508,   455,   395,   508,   508,   508,  1141,  1141,  1141,
     508,   307,  1164,   508,  1102,  1103,  1146,   507,  1155,  1088,
     507,  1209,  1086,   287,   450,  1093,  1086,   226,  1086,  1216,
    1109,   507,  1109,  1224,  1055,   101,   188,   360,   507,  1070,
    1071,  1072,  1073,  1074,  1075,  1141,  1141,   469,  1158,  1055,
    1158,   508,   509,   508,  1036,  1014,    90,   828,   829,   140,
    1141,   811,   287,   811,   508,   858,   631,   290,   868,   787,
     787,   831,   831,   340,   858,   654,   508,   425,   380,  1025,
     508,   511,    35,   160,   567,   759,  1178,  1223,  1210,   425,
     507,   839,   868,   870,   769,   507,   507,   777,  1210,   508,
     507,   380,  1025,  1210,  1210,   507,   507,   507,   470,   493,
     943,   348,   943,   943,   173,   567,   795,   600,   601,  1227,
      52,   100,   126,   148,   152,   174,   177,   192,   275,   285,
     330,   362,   595,  1218,   450,   598,   599,   839,    35,   875,
     875,  1208,   745,   508,   195,   654,   250,   629,   205,   507,
     749,   326,   507,  1208,   508,   376,    26,    82,    91,   121,
     195,   206,   402,   622,   622,  1207,  1210,   976,  1212,   508,
    1039,   721,   160,   112,   696,   178,   734,   361,   414,   736,
     145,   739,   465,   741,  1210,    35,   659,   608,  1208,   508,
     612,   292,     3,   641,  1228,   645,   638,   644,   362,   362,
     652,   653,    62,    70,   242,  1039,   787,  1094,   828,   846,
     508,   511,   435,  1106,   393,   393,   508,   675,   266,   454,
     677,   678,  1210,   470,  1218,   507,   566,  1142,  1180,   508,
    1151,  1177,    58,   266,   489,    58,  1055,   508,   511,    35,
    1104,   120,  1116,  1117,  1142,    80,  1209,   508,  1141,   507,
    1086,  1093,   507,   508,  1109,   508,   508,   507,   381,   507,
     508,   511,  1159,  1160,  1224,   508,  1224,   455,  1210,   508,
     511,   271,   448,   813,   822,   566,   830,   654,   507,   832,
     832,  1208,   654,   745,  1210,   417,   701,   195,   450,   568,
    1055,   380,  1025,  1210,  1180,   173,   772,   772,  1180,  1180,
    1141,   417,   166,   252,   255,   275,   432,   580,   582,   583,
     671,  1219,   580,   581,   578,   579,  1226,   786,   787,   786,
     787,  1209,   566,   508,   511,   500,   507,   543,   602,   671,
     940,  1219,   940,   270,   275,   330,   940,   940,   518,   127,
     875,    38,   200,   173,   266,   625,   507,   667,   179,   306,
     387,   287,   633,   634,   635,   417,   508,  1216,   750,   608,
     637,  1210,   508,   696,   976,   167,   771,   572,   925,  1208,
     474,  1085,   940,   361,   397,   740,   507,   159,   696,  1039,
     638,   608,   637,   615,   507,   646,   644,   645,    70,   291,
      70,   659,   827,   508,   853,   859,  1118,   140,   470,   470,
     454,   675,   696,   507,   986,   508,   508,   508,   339,   455,
    1177,   332,   362,  1165,  1105,  1102,   507,  1142,   508,   511,
      35,  1112,  1113,  1224,   508,  1209,  1177,   508,  1177,   507,
    1177,  1071,   511,    35,  1039,  1106,   829,   380,   178,   831,
     467,   632,   868,   833,   833,   626,   745,  1210,   667,  1141,
     508,   417,   508,   294,   369,   337,   773,   773,   508,   508,
     508,  1210,   508,   511,   508,   511,   508,   511,  1218,   943,
     601,   543,   603,   604,  1219,  1219,   275,   627,   500,   627,
    1219,  1219,   593,  1219,   145,   207,   668,   125,   448,   287,
     635,   287,   634,  1210,   507,   508,   577,   376,   696,   787,
      35,    35,   507,  1210,   737,  1224,  1141,   326,   925,   644,
     577,   638,   507,   642,   643,  1146,  1224,   647,   645,   646,
     291,   291,   507,   572,   858,    27,   216,   914,   180,   180,
     986,   508,    50,   102,   437,  1141,  1166,  1167,  1166,   508,
    1109,   511,  1117,  1227,   508,   511,   173,  1118,   508,   508,
     508,  1070,   508,  1160,  1162,  1031,   811,   832,   507,   745,
     508,   629,  1025,  1210,   839,    58,  1025,   425,   583,   580,
     578,   787,   508,   511,   627,   361,   508,    61,   266,   352,
     380,   636,   636,   508,   376,  1210,   768,  1039,   696,   508,
    1216,   645,   638,   644,  1141,   508,   511,   830,   830,   652,
     646,   647,   828,   646,   271,   507,   909,   911,   915,  1011,
    1020,  1030,  1039,   839,   839,   508,  1167,   361,   172,   316,
     172,   316,   508,  1143,  1113,   295,     3,   120,   270,   275,
    1114,  1115,   347,  1100,   508,  1106,   566,   833,  1141,   633,
    1025,   787,   507,   604,   741,    21,   120,   275,  1210,   696,
     925,   507,   646,   644,   645,   508,    48,   640,   643,   831,
     831,   652,   508,  1106,   910,   911,   912,  1040,  1041,   511,
     511,    32,  1155,  1142,  1142,   275,  1115,   507,   508,   745,
     582,   159,   696,     4,   742,   743,  1218,  1219,  1227,   647,
     645,   646,   830,   507,   572,   508,   510,   425,   178,  1167,
      80,  1141,   508,   326,   508,   511,   652,   646,   647,   831,
    1217,   646,   912,   393,   393,  1112,   508,  1216,   743,   652,
     508,  1106,   470,   470,   508,   507,   401,   180,   180,   742,
     507,   839,   839,   508,  1217,   508,   308,   507,  1218,   508
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   513,   514,   515,   515,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   517,
     518,   518,   518,   519,   519,   520,   520,   521,   521,   521,
     521,   521,   521,   521,   521,   521,   522,   522,   522,   522,
     522,   522,   523,   524,   524,   525,   525,   526,   526,   526,
     526,   527,   527,   527,   527,   527,   527,   528,   529,   530,
     530,   531,   531,   531,   531,   532,   532,   533,   533,   534,
     534,   534,   534,   534,   534,   535,   535,   535,   536,   536,
     536,   537,   537,   537,   537,   538,   538,   538,   538,   538,
     538,   538,   538,   538,   538,   538,   539,   539,   540,   540,
     541,   541,   542,   542,   542,   542,   543,   543,   543,   543,
     544,   544,   544,   544,   544,   544,   544,   545,   545,   545,
     546,   546,   547,   548,   548,   548,   548,   549,   549,   550,
     550,   551,   551,   552,   552,   552,   552,   552,   553,   554,
     554,   555,   555,   556,   557,   557,   557,   557,   557,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   559,   559,
     560,   560,   561,   561,   562,   563,   564,   564,   564,   564,
     564,   564,   564,   564,   564,   564,   564,   564,   564,   564,
     564,   564,   564,   564,   564,   564,   564,   564,   564,   564,
     564,   564,   564,   564,   564,   564,   564,   564,   564,   564,
     564,   564,   564,   564,   564,   564,   564,   564,   564,   564,
     564,   564,   564,   564,   564,   564,   564,   564,   564,   564,
     564,   564,   564,   564,   564,   564,   564,   564,   564,   564,
     565,   565,   566,   566,   566,   567,   567,   568,   568,   569,
     569,   569,   569,   570,   570,   571,   572,   572,   573,   573,
     574,   574,   574,   574,   575,   575,   576,   576,   576,   576,
     577,   577,   577,   577,   578,   579,   579,   580,   580,   580,
     580,   580,   581,   581,   582,   582,   583,   583,   583,   584,
     585,   585,   586,   586,   586,   586,   587,   587,   588,   588,
     589,   589,   590,   590,   591,   591,   592,   592,   592,   593,
     593,   594,   594,   595,   595,   595,   595,   595,   595,   595,
     595,   595,   595,   595,   595,   595,   595,   595,   596,   596,
     597,   597,   598,   598,   599,   599,   600,   600,   601,   602,
     602,   602,   602,   602,   603,   603,   604,   605,   605,   605,
     605,   605,   605,   606,   606,   606,   606,   606,   606,   606,
     606,   607,   607,   608,   608,   609,   609,   610,   610,   611,
     611,   611,   612,   612,   613,   614,   614,   615,   615,   616,
     616,   616,   616,   617,   617,   617,   617,   617,   617,   617,
     617,   618,   618,   619,   619,   619,   619,   620,   621,   621,
     621,   622,   622,   622,   622,   622,   622,   622,   623,   623,
     624,   624,   624,   624,   624,   624,   624,   625,   625,   626,
     626,   627,   627,   628,   629,   629,   629,   629,   630,   630,
     631,   631,   632,   632,   633,   633,   633,   633,   633,   634,
     635,   636,   636,   636,   636,   636,   637,   637,   638,   638,
     639,   640,   640,   641,   641,   642,   642,   643,   643,   643,
     644,   644,   644,   644,   645,   645,   645,   645,   646,   646,
     647,   647,   648,   649,   649,   649,   650,   650,   651,   651,
     651,   651,   651,   652,   652,   653,   653,   653,   654,   654,
     654,   655,   656,   656,   657,   657,   658,   659,   659,   659,
     660,   660,   661,   662,   662,   663,   664,   664,   665,   665,
     666,   666,   667,   667,   668,   668,   669,   669,   669,   669,
     669,   669,   669,   669,   669,   669,   669,   669,   669,   669,
     670,   670,   671,   671,   671,   671,   672,   672,   673,   673,
     674,   674,   675,   675,   676,   676,   677,   677,   678,   678,
     679,   679,   680,   680,   681,   682,   682,   683,   683,   684,
     684,   684,   684,   684,   684,   685,   685,   686,   686,   686,
     686,   687,   688,   688,   689,   690,   690,   690,   690,   690,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   691,   692,   692,   692,   692,   693,   693,   694,   694,
     695,   695,   696,   696,   697,   697,   698,   699,   699,   700,
     700,   700,   700,   701,   702,   703,   704,   704,   705,   705,
     706,   706,   707,   707,   708,   708,   708,   709,   709,   709,
     709,   710,   710,   711,   712,   712,   713,   713,   714,   714,
     715,   715,   716,   716,   717,   718,   719,   720,   720,   721,
     721,   722,   722,   723,   723,   724,   724,   725,   725,   726,
     726,   726,   726,   726,   727,   728,   728,   729,   729,   729,
     730,   730,   731,   731,   731,   731,   731,   732,   732,   733,
     733,   734,   735,   735,   736,   736,   737,   738,   738,   739,
     739,   740,   740,   741,   741,   742,   742,   742,   743,   743,
     743,   743,   744,   744,   745,   745,   746,   746,   746,   746,
     746,   746,   747,   747,   748,   748,   749,   750,   750,   751,
     752,   752,   752,   752,   753,   754,   755,   755,   755,   755,
     755,   755,   755,   755,   755,   755,   755,   755,   755,   755,
     755,   755,   756,   757,   757,   758,   758,   759,   759,   759,
     759,   759,   759,   760,   761,   761,   762,   763,   763,   764,
     764,   765,   765,   765,   765,   766,   766,   767,   768,   768,
     769,   769,   769,   769,   769,   770,   770,   771,   771,   772,
     772,   772,   773,   773,   774,   775,   775,   776,   776,   777,
     777,   778,   778,   779,   779,   780,   781,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   783,
     783,   783,   783,   783,   783,   783,   783,   783,   783,   783,
     783,   783,   784,   784,   784,   784,   784,   784,   784,   785,
     785,   785,   786,   786,   787,   787,   788,   788,   789,   789,
     790,   791,   791,   791,   792,   792,   792,   792,   792,   792,
     792,   792,   792,   792,   792,   792,   792,   792,   792,   792,
     792,   793,   793,   793,   793,   793,   793,   793,   793,   793,
     793,   793,   793,   793,   793,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   795,   795,
     796,   796,   796,   796,   796,   796,   796,   797,   797,   798,
     798,   798,   798,   798,   798,   799,   799,   799,   799,   799,
     799,   799,   799,   799,   800,   800,   801,   801,   802,   802,
     802,   802,   802,   802,   802,   802,   802,   802,   802,   802,
     802,   802,   802,   802,   803,   803,   804,   804,   805,   806,
     806,   807,   807,   807,   807,   807,   808,   808,   809,   809,
     809,   809,   810,   810,   810,   810,   810,   810,   810,   810,
     810,   810,   810,   810,   810,   810,   810,   810,   811,   811,
     812,   812,   813,   813,   814,   815,   815,   816,   816,   817,
     817,   818,   819,   819,   820,   820,   820,   821,   821,   821,
     822,   822,   822,   822,   822,   823,   823,   824,   824,   825,
     825,   826,   826,   827,   827,   828,   828,   829,   829,   829,
     830,   830,   831,   831,   832,   832,   832,   833,   833,   833,
     834,   834,   834,   835,   835,   836,   836,   837,   837,   838,
     838,   839,   839,   839,   839,   840,   840,   841,   841,   842,
     842,   842,   842,   842,   843,   843,   843,   843,   843,   844,
     845,   846,   846,   846,   847,   847,   847,   848,   849,   849,
     849,   849,   850,   850,   851,   852,   852,   853,   853,   854,
     854,   854,   854,   854,   854,   854,   854,   854,   854,   854,
     854,   854,   854,   854,   854,   854,   854,   855,   855,   855,
     855,   855,   856,   856,   857,   857,   858,   858,   859,   860,
     860,   861,   862,   862,   863,   863,   864,   864,   865,   865,
     866,   866,   867,   867,   867,   867,   868,   868,   869,   869,
     870,   871,   872,   872,   873,   873,   874,   874,   874,   875,
     875,   875,   876,   877,   877,   878,   879,   879,   879,   879,
     880,   881,   881,   881,   881,   882,   882,   883,   883,   883,
     884,   884,   885,   886,   886,   887,   887,   887,   887,   887,
     887,   887,   887,   887,   887,   887,   887,   887,   887,   887,
     887,   887,   887,   887,   887,   887,   887,   887,   887,   887,
     887,   887,   887,   887,   887,   887,   887,   887,   887,   887,
     887,   887,   887,   887,   887,   887,   887,   887,   887,   887,
     887,   887,   887,   887,   887,   887,   887,   888,   888,   889,
     889,   890,   890,   890,   890,   891,   891,   891,   891,   891,
     891,   891,   891,   891,   891,   891,   891,   891,   891,   891,
     891,   891,   891,   891,   891,   891,   891,   891,   891,   891,
     892,   893,   893,   894,   894,   895,   895,   895,   895,   895,
     896,   896,   896,   896,   896,   896,   896,   896,   896,   896,
     896,   896,   896,   896,   896,   896,   896,   896,   896,   896,
     896,   896,   897,   898,   898,   899,   899,   900,   900,   901,
     902,   902,   902,   902,   903,   903,   904,   904,   905,   906,
     906,   906,   906,   906,   906,   906,   906,   906,   906,   906,
     906,   907,   907,   907,   907,   908,   909,   909,   909,   910,
     910,   911,   911,   911,   911,   911,   912,   912,   913,   913,
     913,   913,   914,   914,   914,   915,   916,   916,   917,   918,
     918,   919,   919,   919,   919,   919,   919,   919,   919,   919,
     919,   919,   919,   919,   919,   919,   919,   919,   919,   919,
     920,   920,   920,   921,   921,   921,   921,   921,   922,   922,
     922,   923,   923,   924,   924,   924,   924,   925,   925,   925,
     925,   926,   927,   928,   928,   929,   929,   930,   930,   930,
     931,   931,   931,   931,   931,   931,   931,   932,   932,   933,
     933,   933,   934,   935,   935,   935,   935,   936,   937,   937,
     938,   939,   939,   939,   939,   939,   939,   939,   940,   940,
     941,   942,   942,   942,   942,   942,   942,   943,   943,   944,
     945,   945,   945,   946,   946,   947,   947,   947,   947,   947,
     947,   948,   948,   949,   949,   949,   949,   949,   950,   950,
     950,   950,   951,   951,   952,   952,   952,   952,   953,   953,
     954,   954,   955,   955,   956,   956,   957,   957,   958,   958,
     959,   959,   959,   959,   960,   960,   961,   961,   962,   962,
     963,   963,   964,   964,   965,   965,   965,   965,   965,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   966,
     966,   967,   967,   967,   967,   967,   967,   968,   968,   968,
     968,   968,   969,   969,   969,   969,   969,   969,   969,   969,
     970,   971,   971,   972,   973,   973,   974,   974,   975,   976,
     977,   978,   978,   979,   979,   979,   979,   980,   980,   981,
     981,   982,   983,   984,   984,   984,   984,   985,   985,   986,
     986,   987,   987,   987,   987,   988,   989,   989,   990,   990,
     991,   991,   992,   992,   993,   993,   993,   993,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   995,   995,   996,
     997,   997,   998,   998,   998,   999,  1000,  1001,  1001,  1001,
    1002,  1002,  1002,  1003,  1003,  1003,  1004,  1004,  1005,  1006,
    1006,  1007,  1007,  1007,  1007,  1008,  1008,  1009,  1009,  1010,
    1010,  1010,  1010,  1011,  1012,  1012,  1013,  1013,  1013,  1013,
    1013,  1014,  1014,  1015,  1015,  1016,  1017,  1017,  1017,  1018,
    1018,  1018,  1019,  1019,  1020,  1021,  1021,  1022,  1023,  1023,
    1024,  1024,  1024,  1024,  1024,  1024,  1024,  1024,  1025,  1025,
    1026,  1026,  1026,  1027,  1027,  1028,  1028,  1029,  1029,  1030,
    1031,  1031,  1032,  1032,  1033,  1034,  1034,  1035,  1036,  1037,
    1037,  1037,  1037,  1037,  1038,  1038,  1038,  1039,  1039,  1040,
    1040,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1041,  1042,
    1042,  1043,  1043,  1043,  1043,  1043,  1043,  1043,  1044,  1044,
    1044,  1045,  1045,  1046,  1047,  1047,  1047,  1048,  1048,  1049,
    1049,  1050,  1050,  1050,  1050,  1050,  1050,  1050,  1050,  1050,
    1051,  1051,  1052,  1052,  1052,  1053,  1053,  1054,  1054,  1055,
    1055,  1056,  1057,  1057,  1058,  1058,  1059,  1059,  1059,  1059,
    1060,  1060,  1061,  1061,  1061,  1062,  1062,  1063,  1063,  1064,
    1065,  1065,  1065,  1066,  1067,  1067,  1068,  1068,  1069,  1069,
    1070,  1070,  1071,  1071,  1071,  1071,  1071,  1072,  1073,  1074,
    1075,  1076,  1076,  1077,  1077,  1078,  1078,  1079,  1079,  1080,
    1081,  1081,  1081,  1081,  1082,  1082,  1083,  1083,  1084,  1084,
    1085,  1085,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,
    1086,  1086,  1087,  1087,  1087,  1087,  1087,  1087,  1088,  1088,
    1088,  1088,  1089,  1089,  1090,  1090,  1090,  1090,  1090,  1091,
    1091,  1091,  1091,  1092,  1092,  1093,  1093,  1094,  1094,  1094,
    1094,  1095,  1095,  1096,  1096,  1097,  1097,  1098,  1098,  1098,
    1099,  1100,  1100,  1101,  1101,  1102,  1103,  1103,  1104,  1104,
    1105,  1105,  1106,  1106,  1107,  1107,  1107,  1108,  1108,  1109,
    1109,  1110,  1111,  1111,  1112,  1112,  1113,  1113,  1113,  1114,
    1114,  1115,  1115,  1115,  1115,  1116,  1116,  1117,  1117,  1118,
    1118,  1118,  1118,  1118,  1118,  1119,  1119,  1119,  1120,  1120,
    1120,  1120,  1120,  1120,  1120,  1121,  1121,  1121,  1121,  1122,
    1122,  1123,  1123,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1125,  1125,  1126,
    1126,  1127,  1127,  1128,  1129,  1130,  1130,  1131,  1131,  1132,
    1133,  1134,  1134,  1134,  1134,  1134,  1134,  1135,  1135,  1136,
    1136,  1136,  1136,  1137,  1138,  1138,  1138,  1139,  1139,  1139,
    1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,
    1139,  1140,  1140,  1141,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1141,  1141,  1141,  1141,  1141,  1142,  1142,  1142,
    1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,
    1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,
    1142,  1142,  1143,  1143,  1143,  1143,  1143,  1143,  1143,  1143,
    1143,  1143,  1143,  1143,  1143,  1143,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1145,  1145,  1146,  1146,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1148,  1148,  1149,  1149,  1149,  1149,  1150,
    1151,  1151,  1152,  1152,  1153,  1153,  1154,  1154,  1154,  1155,
    1155,  1155,  1155,  1156,  1156,  1157,  1157,  1158,  1158,  1159,
    1159,  1160,  1161,  1161,  1161,  1162,  1163,  1163,  1164,  1164,
    1165,  1165,  1165,  1166,  1166,  1167,  1167,  1167,  1167,  1167,
    1168,  1168,  1168,  1169,  1169,  1170,  1171,  1171,  1171,  1172,
    1172,  1173,  1173,  1173,  1173,  1173,  1173,  1173,  1173,  1173,
    1173,  1173,  1173,  1174,  1174,  1175,  1175,  1176,  1176,  1176,
    1176,  1176,  1176,  1177,  1177,  1178,  1178,  1179,  1179,  1179,
    1180,  1180,  1181,  1181,  1181,  1182,  1182,  1183,  1183,  1184,
    1184,  1184,  1184,  1184,  1184,  1184,  1184,  1185,  1185,  1186,
    1187,  1187,  1188,  1188,  1188,  1188,  1188,  1188,  1189,  1190,
    1191,  1191,  1191,  1192,  1192,  1193,  1194,  1194,  1195,  1196,
    1196,  1197,  1197,  1198,  1198,  1199,  1199,  1199,  1199,  1200,
    1200,  1201,  1201,  1202,  1202,  1203,  1203,  1204,  1204,  1205,
    1205,  1206,  1206,  1206,  1206,  1207,  1207,  1208,  1208,  1209,
    1209,  1210,  1211,  1212,  1213,  1214,  1215,  1216,  1216,  1217,
    1217,  1217,  1217,  1217,  1217,  1217,  1217,  1217,  1217,  1217,
    1217,  1217,  1218,  1219,  1220,  1220,  1220,  1221,  1222,  1222,
    1222,  1223,  1223,  1224,  1224,  1224,  1225,  1225,  1225,  1226,
    1226,  1226,  1226,  1227,  1227,  1227,  1227,  1227,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1230,  1230,  1230,  1230,  1230,  1230,  1230,  1230,
    1230,  1230,  1230,  1230,  1230,  1230,  1230,  1230,  1230,  1230,
    1230,  1230,  1230,  1230,  1230,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     5,
       1,     1,     0,     2,     0,     2,     0,     2,     2,     3,
       3,     1,     3,     3,     2,     1,     1,     2,     2,     2,
       3,     3,     5,     5,     5,     0,     3,     5,     5,     5,
       5,     3,     5,     3,     5,     3,     5,     5,     6,     1,
       1,     6,     4,     9,     7,     1,     0,     2,     0,     1,
       1,     1,     1,     1,     1,     2,     3,     3,     2,     5,
       1,     3,     3,     3,     3,     1,     3,     3,     2,     2,
       2,     2,     3,     3,     3,     3,     1,     3,     1,     3,
       1,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     3,     5,     1,     1,     1,     1,     1,     0,
       1,     1,     2,     1,     2,     3,     2,     1,     1,     2,
       1,     2,     1,     2,     3,     4,     3,     2,     4,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     4,
       6,     4,     6,    10,    13,     4,     6,     4,    10,    13,
       4,     6,     4,     6,     5,     7,    11,    14,     1,     3,
       1,     3,     4,     3,     3,     3,     2,     5,     3,     6,
       4,     6,     6,     6,     5,     5,     6,     9,     4,     5,
       7,     6,     4,     8,     4,     2,     3,     5,     6,     4,
       3,     6,     4,     3,     3,     3,     3,     2,     2,     3,
       4,     4,     3,     3,     3,     3,     3,     3,     4,     4,
       3,     2,     3,     2,     2,     3,     3,     2,     2,     3,
       4,     4,     4,     5,     1,     1,     1,     3,     3,     2,
       3,     2,     1,     1,     0,     2,     0,     2,     0,     1,
       1,     1,     3,     2,     0,     3,     2,     0,     1,     3,
       3,     1,     5,     3,     1,     2,     1,     3,     2,     3,
       6,     6,    10,     1,     2,     1,     3,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     1,     4,
       1,     3,     4,     6,     4,     8,     2,     2,    12,     9,
       1,     1,     1,     0,     4,     0,     1,     1,     1,     1,
       3,     2,     0,     1,     1,     1,     3,     3,     1,     1,
       1,     3,     3,     3,     3,     4,     3,     2,     1,     0,
       2,     0,     3,     0,     1,     0,     1,     3,     2,     1,
       1,     1,     3,     0,     1,     3,     1,    14,    17,    13,
      16,    13,    16,     1,     1,     2,     2,     2,     2,     1,
       0,     1,     0,     3,     0,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     4,     2,     4,     2,     0,     3,
       1,     1,     2,     2,     1,     3,     4,     5,     2,     5,
       5,     1,     2,     1,     2,     2,     2,     3,     3,     3,
       0,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       5,     7,     3,     8,     4,     9,    11,     2,     0,     3,
       0,     1,     3,     1,     2,     2,     2,     0,     1,     3,
       3,     6,     4,     0,     1,     1,     2,     2,     0,     3,
       3,     2,     1,     1,     2,     2,     4,     0,     1,     0,
       7,    12,     0,     1,     1,     1,     3,     3,     3,     5,
       2,     2,     2,     0,     3,     4,     4,     0,     2,     0,
       1,     0,     1,     1,     1,     1,     4,     0,     6,     3,
       5,     2,     3,     1,     0,     3,     3,     4,     4,     2,
       0,     3,     8,    11,     7,    10,     7,     2,     3,     0,
       8,    11,     4,     1,     0,     6,     5,     8,     4,     6,
       1,     0,     3,     0,     1,     2,     2,     2,     1,     2,
       3,     2,     2,     2,     2,     3,     3,     3,     1,     3,
       1,     0,     1,     2,     2,     1,     1,     3,     6,    10,
       1,     0,     1,     2,     2,     0,     2,     2,     1,     0,
       5,     7,     1,     0,     7,     2,     0,     3,     5,     5,
       8,     6,     9,     6,     9,     2,     0,     2,     2,     2,
       1,     5,     2,     0,     2,     7,     6,    10,     6,     6,
       6,     6,     7,     6,     9,     9,     6,     7,     6,     8,
       8,     8,     8,     6,     6,     7,     7,     8,     6,     9,
       6,     7,     2,     2,     2,     2,     1,     2,     1,     0,
       7,     6,     4,     0,     1,     3,     4,     1,     3,     1,
       2,     2,     2,     2,     1,     1,    10,    13,     2,     0,
       2,     2,     1,     0,     5,     4,     4,    11,    14,    12,
      15,     5,     7,    11,     2,     1,     4,     0,     8,    11,
       1,     1,     7,     9,     8,    10,     8,     4,     0,     5,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     1,
       1,     1,     1,     1,     8,    16,    20,     1,     1,     2,
       1,     3,     1,     1,     1,     3,     1,     2,     0,     1,
       2,     4,     1,     1,     1,     1,     1,     3,     0,     1,
       0,     1,     1,     4,     0,     1,     3,     0,     1,     1,
       1,     1,     2,     0,     0,     2,     2,     1,     2,     2,
       2,     2,    11,    13,     1,     3,     5,     1,     3,     5,
       1,     2,     2,     1,     8,     4,     5,     4,     4,     4,
       3,     7,     8,     6,     6,     6,     6,     6,     4,     7,
       5,     8,     3,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     3,     1,     0,     1,
       3,     7,     9,     9,     8,     3,     0,    13,     1,     3,
       5,     5,     3,     6,     2,     1,     0,     2,     0,     2,
       4,     0,     1,     0,     6,     8,     8,     1,     3,     5,
       5,     7,     9,     7,     9,     5,     6,     6,     4,     6,
       4,     6,     8,     4,     6,     4,     6,     5,     7,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     3,     3,
       3,     3,     2,     2,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     2,     2,     3,     1,     3,
       5,     2,     2,     0,     6,     6,     6,     6,     6,     6,
       6,     8,     9,     8,     8,     9,     8,     9,     9,     7,
      10,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       2,     3,     3,     3,     3,     2,     1,     2,     1,     3,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       8,     8,     8,     8,     8,     8,     9,     2,     0,     1,
       2,     1,     1,     1,     2,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     1,     2,
       3,     3,     3,     3,     4,     4,     3,     3,     3,     4,
       4,     3,     4,     4,     1,     1,     1,     0,     7,     7,
      10,     1,     1,     2,     4,     5,     1,     3,     2,     2,
       2,     2,     1,     2,     2,     4,     3,     2,     2,     2,
       2,     3,     2,     2,     2,     5,     5,     5,     1,     3,
       1,     2,     3,     0,     6,     6,     9,     3,     0,     3,
       0,     5,     2,     0,     3,     3,     3,     7,     7,    10,
       1,     1,     1,     1,     1,    14,    17,     1,     0,     1,
       0,     1,     0,     2,     0,     1,     3,     5,     5,     7,
       2,     0,     1,     0,     1,     1,     0,     2,     2,     0,
       9,    12,     7,     2,     0,     3,     2,     1,     3,     1,
       3,     2,     1,     1,     2,     3,     2,     1,     3,     3,
       3,     2,     2,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     4,     5,     1,     3,     3,     1,     3,     3,
       5,     6,     1,     3,     2,     1,     3,     1,     2,     4,
       5,     1,     1,     1,     1,     3,     3,     2,     2,     1,
       2,     1,     2,     2,     2,     1,     2,     2,     2,     2,
       1,     1,     1,     3,     3,     5,     2,     0,     2,     1,
       3,     5,     1,     2,     1,     0,     4,     6,     4,     6,
       4,     6,     3,     5,     5,     5,     1,     3,     1,     3,
       2,     2,     1,     2,     1,     2,    11,    10,    10,     2,
       2,     0,     9,     2,     0,    10,    11,    11,     5,     5,
       8,     3,     3,     6,     6,     1,     1,     1,     1,     1,
       1,     3,     1,     5,     5,     6,     6,     6,     6,     6,
       8,     8,     6,     6,     7,     9,     9,     8,    10,     6,
       6,     6,     6,     6,     6,     8,     6,     8,     6,     8,
       7,     9,     6,     8,     7,     9,     8,    10,     9,    11,
       8,    10,     9,    11,     8,     8,     7,     6,     6,     6,
       6,     8,     8,     8,     8,     6,     9,     1,     0,     2,
       0,     7,     9,     8,     7,     6,     6,     6,     6,     6,
       6,     6,     9,     9,     6,     8,     6,     8,     8,     8,
       8,     6,     8,     6,     8,     7,     9,     7,     9,     6,
       7,     1,     3,     3,     3,     1,     1,     1,     1,     1,
       6,     6,     6,     6,     6,     6,     7,     7,     6,     9,
       9,     6,     6,     6,     6,     8,     8,     8,     6,     7,
       6,     6,     6,     1,     0,     3,     3,     1,     0,     5,
       5,     6,     6,     6,     8,     9,     1,     3,     1,     5,
       6,     5,     6,     6,     7,     7,     8,     4,     5,     4,
       5,     4,     5,     6,     7,    13,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     0,     3,     2,     0,     2,     2,
       2,     2,     3,     1,     3,     1,     2,     2,     1,     2,
       2,     3,     2,     5,     4,     3,     3,     3,     6,     6,
       1,     1,     0,     3,     2,     2,     1,     2,     1,     3,
       2,     1,     0,     9,    11,    12,    14,     3,     4,     4,
       0,     2,     5,     1,     0,     1,     2,     3,     3,     3,
       1,     2,     1,     1,     1,     1,     1,     1,     0,     5,
       4,     6,     4,     3,     5,     4,     6,     5,     4,     4,
       6,     4,     6,     6,     5,     7,     9,     6,     1,     0,
       6,    11,    11,    11,    13,     9,    11,     1,     1,    10,
       4,     2,     5,     2,     0,     5,     6,     5,     5,     7,
       9,     1,     3,     1,     1,     1,     1,     1,     3,     5,
       5,     7,     1,     1,     2,     3,     3,     0,     1,     0,
       1,     0,     1,     0,     1,     3,     1,     1,     3,     0,
       3,     5,     6,     5,     1,     1,     3,     0,     1,     0,
       1,     1,     1,     3,     2,     1,     2,     2,     2,     1,
       2,     2,     2,     1,     2,     2,     2,     1,     3,     3,
       3,     4,     1,     2,     2,     2,     2,     3,     3,     3,
       1,     2,     2,     2,     1,     2,     1,     2,     2,     2,
       2,     1,     2,     2,     2,     1,     2,     2,     1,     2,
       2,     2,     1,     2,     2,     2,     1,     2,     2,     2,
       2,     2,     1,     2,     2,     2,     1,     2,     2,     2,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     2,     1,     1,     1,     3,     5,
       7,     1,     3,     3,     3,     5,     3,     6,     5,     3,
       5,     2,     2,     3,     1,     0,     4,     5,     1,     1,
       3,     3,     1,     6,     5,     5,     6,     5,     4,     6,
       7,     5,     4,     8,    12,    10,    13,     1,     4,     1,
       3,     6,     7,     6,     7,     5,     2,     8,    10,    11,
       1,     3,     5,     3,     2,     4,     3,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     2,
       1,     1,     1,     1,     0,     5,     1,     7,     7,     7,
       3,     2,     0,     3,     2,     0,     1,     0,     5,     3,
       0,     1,     1,     1,     1,     3,     9,     3,     0,     2,
       3,     2,     3,     7,     1,     3,     1,     4,     4,     7,
       2,     1,     1,     1,     3,     2,     8,     5,     0,     4,
       3,     0,     2,     0,     7,     2,     0,     5,     3,     0,
       2,     2,     2,     3,     1,     3,     1,     2,     1,     0,
       1,     2,     0,     6,     6,     1,     3,     1,     1,     8,
       1,     3,     3,     5,     2,     1,     3,     7,     1,     0,
       3,     2,     2,     2,     0,     2,     2,     1,     1,     3,
       3,     1,     2,     4,     4,     2,     3,     5,     5,     1,
       1,     9,     9,     1,     2,     4,     4,     4,     2,     2,
       3,     1,     3,     7,     1,     2,     0,     1,     0,     2,
       0,     3,     3,     4,     4,     4,     4,     3,     2,     1,
       1,     0,     1,     1,     0,     1,     5,     1,     0,     1,
       0,     3,     1,     3,     4,     3,     2,     2,     1,     1,
       1,     0,     2,     4,     5,     2,     3,     1,     1,     1,
       1,     3,     0,     1,     1,     1,     1,     1,     3,     0,
       1,     3,     1,     1,     1,     1,     1,     2,     4,     4,
       5,     2,     0,     1,     3,     1,     0,     1,     2,     3,
       2,     4,     2,     3,     2,     0,     4,     5,     2,     0,
       1,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       1,     4,     3,     4,     5,     4,     5,     4,     5,     2,
       4,     1,     1,     0,     1,     4,     5,     4,     0,     2,
       2,     2,     1,     1,     0,     4,     2,     2,     2,     3,
       5,     1,     0,     5,     3,     1,     3,     1,     2,     3,
       6,     4,     0,     2,     6,     2,     1,     3,     4,     0,
       2,     0,     2,     0,     2,     4,     0,     1,     0,     1,
       3,     3,     7,    12,     1,     3,     2,     3,     3,     1,
       2,     2,     2,     2,     1,     1,     3,     3,     2,     2,
       3,     5,     6,     2,     3,     3,     4,     0,     1,     1,
       1,     1,     1,     2,     4,     1,     1,     1,     1,     2,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     2,     2,     2,     2,     1,     3,     0,     1,
       1,     1,     1,     5,     2,     1,     1,     1,     1,     4,
       1,     2,     2,     1,     3,     3,     2,     1,     0,     5,
       2,     5,     2,     1,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     4,     1,     3,     3,     5,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     3,     3,     2,     2,     3,     5,
       4,     6,     3,     5,     4,     6,     4,     6,     5,     7,
       3,     2,     4,     2,     3,     3,     4,     3,     4,     3,
       4,     5,     6,     6,     7,     6,     7,     6,     7,     3,
       4,     4,     6,     2,     3,     4,     1,     1,     3,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     5,     6,     6,     7,
       3,     4,     1,     1,     2,     4,     1,     1,     1,     2,
       2,     2,     2,     1,     1,     4,     3,     5,     6,     8,
       6,     6,     4,     4,     1,     1,     1,     5,     1,     1,
       4,     1,     4,     1,     4,     1,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     6,     4,     4,
       4,     4,     6,     5,     5,     5,     4,     6,     4,     4,
       4,     4,     5,     7,     7,     9,     5,     4,     6,     5,
       7,     7,     7,     2,     3,     3,     3,     4,     0,     4,
       1,     3,     3,     1,     1,     1,     2,     2,     0,     2,
       4,     4,     6,     5,     0,     5,     0,     2,     0,     1,
       3,     3,     2,     2,     0,     6,     1,     0,     3,     0,
       2,     2,     0,     1,     4,     2,     2,     2,     2,     2,
       4,     3,     5,     4,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     1,     4,     1,     4,     1,
       2,     1,     2,     1,     3,     1,     3,     1,     3,     3,
       1,     3,     3,     3,     2,     1,     3,     3,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     2,
       3,     0,     3,     3,     2,     2,     1,     0,     2,     2,
       3,     2,     1,     1,     3,     5,     1,     2,     4,     2,
       0,     1,     0,     1,     2,     2,     2,     3,     5,     1,
       0,     1,     2,     0,     2,     1,     0,     1,     0,     1,
       3,     3,     2,     1,     1,     1,     3,     1,     2,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     6,     2,     3,     5,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 841 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 28183 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 857 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 28199 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 869 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 28210 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1026 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28216 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1037 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28228 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1047 "gram.y" /* yacc.c:1646  */
    {}
#line 28234 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1048 "gram.y" /* yacc.c:1646  */
    {}
#line 28240 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1049 "gram.y" /* yacc.c:1646  */
    {}
#line 28246 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1058 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28252 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1059 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28258 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1063 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28264 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1064 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28270 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1069 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 28279 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1074 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 28287 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1078 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 28301 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1088 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 28313 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1096 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 28321 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1100 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 28329 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1104 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 28337 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1109 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 28345 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1113 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 28394 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1160 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 28400 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1163 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 28408 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1167 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 28416 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1171 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 28424 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1175 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 28432 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1179 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 28440 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1193 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28452 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1211 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_ROLE;
#endif
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 28467 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1222 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_USER;
#endif
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 28482 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1235 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28488 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1236 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28494 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1241 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_ROLE;
#endif
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28509 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1252 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_ROLE;
#endif
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28524 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1263 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_USER;
#endif
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28539 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1274 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_USER;
#endif
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28554 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1298 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_ROLE;
#endif
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28568 "gram.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1308 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_ROLE;
#endif
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28582 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1318 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_USER;
#endif
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28596 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1328 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_USER;
#endif
					n->roles = (yyvsp[0].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 28610 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1338 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_GROUP;
#endif
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28624 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1348 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_GROUP;
#endif
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28638 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1368 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28650 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1386 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_GROUP;
#endif
					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 28666 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1399 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 28672 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1400 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 28678 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1412 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 28692 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1422 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 28706 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1432 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 28725 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1447 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 28744 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1464 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28750 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1465 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28756 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1470 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 28766 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1476 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28772 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1504 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28782 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1510 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 28792 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1516 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28802 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1525 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28814 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1533 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28826 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1545 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28838 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1553 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28850 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1561 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28861 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1568 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28872 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1576 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 28878 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1578 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28889 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1586 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 28904 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1597 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 28916 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1605 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28928 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1613 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 28943 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1624 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28955 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1632 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28967 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1640 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 28978 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1647 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28990 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1656 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29002 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1665 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29008 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1667 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 29014 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1670 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29020 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1671 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29026 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1675 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 29032 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1677 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 29038 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1680 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 29044 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1681 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 29050 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1682 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 29056 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1683 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 29062 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1687 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 29068 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1688 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 29074 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1689 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 29080 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1695 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29086 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1708 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 29094 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1712 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 29102 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1716 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 29121 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1731 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 29132 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1737 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 29138 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1738 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29144 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1739 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29150 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1743 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29156 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1744 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29162 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1745 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29168 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1749 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29174 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1750 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29180 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1754 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 29186 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1758 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29192 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1760 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 29203 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1767 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 29214 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1774 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 29225 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1784 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 29236 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1791 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 29246 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1800 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29252 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1801 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 29258 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1806 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29264 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1807 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 29270 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1813 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29280 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1819 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 29290 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1825 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 29300 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1831 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 29310 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1837 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 29320 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1847 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29331 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1856 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29337 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1857 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29343 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1861 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 29349 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1862 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29355 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1871 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 29364 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1886 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 29374 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1892 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 29384 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1898 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 29394 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1904 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 29404 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1910 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 29414 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1929 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29427 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1938 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29440 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1947 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29453 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1956 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29466 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1965 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29481 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1976 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29496 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1987 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29509 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1996 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29522 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2005 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29535 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2014 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29550 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2025 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29565 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2036 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29578 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2045 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29591 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2054 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29604 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2063 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29617 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2072 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29630 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2081 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29643 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2090 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29658 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2101 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29673 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2114 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29679 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2115 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29685 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2119 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29691 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2120 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29697 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2127 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29713 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2140 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29729 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2156 "gram.y" /* yacc.c:1646  */
    {
					AlterGroupCmd *n = makeNode(AlterGroupCmd);
					n->subtype = AG_SetDefault;
					(yyval.node) = (Node *)n;
				}
#line 29739 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2166 "gram.y" /* yacc.c:1646  */
    {
                   AlterTableCmd *n = makeNode(AlterTableCmd);
                   PartitionCmd *cmd = makeNode(PartitionCmd);

                   n->subtype = AT_AttachPartition;
                   cmd->name = (yyvsp[0].range);
                   cmd->bound = NULL;
                   n->def = (Node *) cmd;

                   (yyval.node) = (Node *) n;
               }
#line 29755 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2182 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29767 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2191 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29779 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2200 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29791 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2209 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29803 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2218 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29815 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2227 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 29826 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2235 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 29837 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2243 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 29849 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2252 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29861 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2261 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29873 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2270 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 29885 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2279 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *)n;
				}
#line 29905 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2296 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29917 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2305 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29929 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2314 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29941 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2323 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 29954 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2333 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 29967 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2346 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 29985 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2361 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29997 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2370 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 30008 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2379 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					AddDropPartitions * parts = makeNode(AddDropPartitions);
					n->subtype = AT_AddPartitions;
					parts->nparts = (yyvsp[0].ival);
					n->def = (Node*)parts;
					(yyval.node) = (Node *)n;
				}
#line 30021 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2388 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ExchangeIndexName *exchange = makeNode(ExchangeIndexName);
					n->subtype = AT_ExchangeIndexName;
					exchange->oldIndexRelation = (yyvsp[-2].range);
					exchange->newIndexRelation = (yyvsp[0].range);
					n->def = (Node *)exchange;
					(yyval.node) = (Node *)n;
				}
#line 30035 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2398 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ModifyPartStartValue *value = makeNode(ModifyPartStartValue);
					n->subtype = AT_ModifyStartValue;
					value->startvalue = (yyvsp[-1].node);
					n->def = (Node *)value;
					(yyval.node) = (Node *)n;
				}
#line 30048 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2408 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30066 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2423 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30077 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2431 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 30090 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2441 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 30103 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2451 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
#line 30113 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2458 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 30123 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2465 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30134 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2473 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 30145 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2481 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *)n;
				}
#line 30155 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2488 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *)n;
				}
#line 30165 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2495 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30176 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2503 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30187 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2511 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30198 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2519 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 30208 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2526 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 30218 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2533 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30229 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2541 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 30239 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2548 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 30249 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2555 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30260 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2563 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30271 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2571 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30282 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2579 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30293 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2587 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 30304 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2595 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 30315 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2603 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 30328 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2613 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 30338 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2620 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 30349 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2628 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30360 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2636 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30371 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2644 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30382 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2652 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 30393 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2660 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 30403 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2667 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 30413 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2674 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 30423 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2681 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 30433 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2687 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30444 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2696 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DistributeBy;
					n->def = (Node *)(yyvsp[0].distby);
					(yyval.node) = (Node *)n;
				}
#line 30455 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2704 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SubCluster;
					n->def = (Node *)(yyvsp[0].subclus);
					(yyval.node) = (Node *)n;
				}
#line 30466 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2712 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddNodeList;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30477 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2720 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DeleteNodeList;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30488 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2729 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_RebuildExtent;
					(yyval.node) = (Node *)n;
				}
#line 30498 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2738 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30504 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2739 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30510 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2743 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 30516 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2744 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 30522 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2745 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 30528 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2750 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 30540 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2757 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30546 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2761 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30552 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2762 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30558 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2767 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30569 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2774 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30580 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2781 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30591 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2788 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30602 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2797 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30608 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2798 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30614 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2801 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30620 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2804 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30626 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2805 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30632 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2809 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30638 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2810 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 30644 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2816 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 30652 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2820 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 30660 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2824 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 30669 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2829 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 30677 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2836 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30683 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2838 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30689 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2843 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 30697 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2847 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 30705 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2851 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 30720 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2862 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 30728 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2870 "gram.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 30783 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2923 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 30798 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2936 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 30814 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2950 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 30827 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2962 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 30835 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2969 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 30843 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2973 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 30851 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2979 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 30857 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2980 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 30863 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2981 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst(pstrdup("true"), (yylsp[0])); }
#line 30869 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2982 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst(pstrdup("false"), (yylsp[0])); }
#line 30875 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2983 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst((yylsp[0])); }
#line 30881 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2987 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30887 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2989 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30893 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2993 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30899 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2995 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30905 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3000 "gram.y" /* yacc.c:1646  */
    {
					PartitionRangeDatum *n = makeNode(PartitionRangeDatum);

					n->kind = PARTITION_RANGE_DATUM_MINVALUE;
					n->value = NULL;
					n->location = (yylsp[0]);

					(yyval.node) = (Node *) n;
				}
#line 30919 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3010 "gram.y" /* yacc.c:1646  */
    {
					PartitionRangeDatum *n = makeNode(PartitionRangeDatum);

					n->kind = PARTITION_RANGE_DATUM_MAXVALUE;
					n->value = NULL;
					n->location = (yylsp[0]);

					(yyval.node) = (Node *) n;
				}
#line 30933 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3020 "gram.y" /* yacc.c:1646  */
    {
					PartitionRangeDatum *n = makeNode(PartitionRangeDatum);

					n->kind = PARTITION_RANGE_DATUM_VALUE;
					n->value = (yyvsp[0].node);
					n->location = (yylsp[0]);

					(yyval.node) = (Node *) n;
				}
#line 30947 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3040 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 30961 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3052 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30967 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3053 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30973 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3059 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 30985 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3068 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 30998 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3078 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 31011 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3088 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 31030 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3114 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31040 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3120 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 31050 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3154 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-9].range);
					n->query = NULL;
					n->attlist = (yyvsp[-8].list);
/* _SHARDING_ */
					n->shards = (yyvsp[-6].list);
/* _SHARDING_ END */					
					n->is_from = (yyvsp[-5].boolean);
					n->is_program = (yyvsp[-4].boolean);
					n->filename = (yyvsp[-3].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-10].defelt))
						n->options = lappend(n->options, (yyvsp[-10].defelt));
					if ((yyvsp[-7].defelt))
						n->options = lappend(n->options, (yyvsp[-7].defelt));
					if ((yyvsp[-2].defelt))
						n->options = lappend(n->options, (yyvsp[-2].defelt));
					if ((yyvsp[0].list))
						n->options = list_concat(n->options, (yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 31085 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3185 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
/* _SHARDING_ */
					n->shards = NULL;
/* _SHARDING_ END */
					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *)n;
				}
#line 31110 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3208 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31116 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3209 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31122 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3213 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31128 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3214 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31134 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3218 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31140 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3219 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 31146 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3229 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31152 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3230 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31158 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3231 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31164 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3234 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31170 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3235 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31176 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3240 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31182 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3241 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31188 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3246 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 31196 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3250 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 31204 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3254 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 31212 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3258 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31220 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3262 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31228 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3266 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"), (yylsp[0]));
				}
#line 31236 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3270 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("internal"), (yylsp[0]));
				}
#line 31244 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3274 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 31252 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3278 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31260 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3282 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31268 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3286 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 31276 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3290 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star), (yylsp[-2]));
				}
#line 31284 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3294 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list), (yylsp[-3]));
				}
#line 31292 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3298 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 31300 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3302 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31308 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3311 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 31316 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3314 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 31322 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3319 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE), (yylsp[-1]));
				}
#line 31330 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3322 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 31336 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3327 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31344 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3330 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 31350 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3334 "gram.y" /* yacc.c:1646  */
    {}
#line 31356 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3335 "gram.y" /* yacc.c:1646  */
    {}
#line 31362 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3341 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 31370 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3345 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 31378 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3352 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 31386 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3358 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 31392 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3359 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 31398 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3360 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 31404 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3361 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 31410 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3362 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31416 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3367 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31424 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3371 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31432 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3378 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 31438 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3401 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-8].list);
					n->inhRelations = (yyvsp[-6].list);
					n->partspec = (yyvsp[-5].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-4].list);
					n->oncommit = (yyvsp[-3].oncommit);
					n->tablespacename = (yyvsp[-2].str);
					n->if_not_exists = false;
/* PGXC_BEGIN */
					if ((yyvsp[-12].ival) == RELPERSISTENCE_LOCAL_TEMP)
					{
						(yyvsp[-10].range)->relpersistence = RELPERSISTENCE_TEMP;
						n->islocal = true;
					}
					n->relkind = RELKIND_RELATION;
					n->distributeby = (yyvsp[-1].distby);
					n->subcluster = (yyvsp[0].subclus);
/* PGXC_END */
					(yyval.node) = (Node *)n;
				}
#line 31468 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3432 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-8].list);
					n->inhRelations = (yyvsp[-6].list);
					n->partspec = (yyvsp[-5].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-4].list);
					n->oncommit = (yyvsp[-3].oncommit);
					n->tablespacename = (yyvsp[-2].str);
					n->if_not_exists = true;
/* PGXC_BEGIN */
					if ((yyvsp[-15].ival) == RELPERSISTENCE_LOCAL_TEMP)
					{
						(yyvsp[-10].range)->relpersistence = RELPERSISTENCE_TEMP;
						n->islocal = true;
					}
					n->relkind = RELKIND_RELATION;
					n->distributeby = (yyvsp[-1].distby);
					n->subcluster = (yyvsp[0].subclus);
					if (n->inhRelations != NULL && n->distributeby != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE cannot contains both an INHERITS and a DISTRIBUTE BY clause"),
								 parser_errposition(exprLocation((Node *) n->distributeby))));
/* PGXC_END */
					(yyval.node) = (Node *)n;
				}
#line 31503 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3468 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-5].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-7].list));
					n->ofTypename->location = (yylsp[-7]);
					n->constraints = NIL;
					n->options = (yyvsp[-4].list);
					n->oncommit = (yyvsp[-3].oncommit);
					n->tablespacename = (yyvsp[-2].str);
					n->if_not_exists = false;
/* PGXC_BEGIN */
					if ((yyvsp[-11].ival) == RELPERSISTENCE_LOCAL_TEMP)
					{
						(yyvsp[-9].range)->relpersistence = RELPERSISTENCE_TEMP;
						n->islocal = true;
					}
					n->relkind = RELKIND_RELATION;
					n->distributeby = (yyvsp[-1].distby);
					n->subcluster = (yyvsp[0].subclus);
					if (n->inhRelations != NULL && n->distributeby != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE cannot contains both an INHERITS and a DISTRIBUTE BY clause"),
								 parser_errposition(exprLocation((Node *) n->distributeby))));
/* PGXC_END */
					(yyval.node) = (Node *)n;
				}
#line 31539 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3505 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-5].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-7].list));
					n->ofTypename->location = (yylsp[-7]);
					n->constraints = NIL;
					n->options = (yyvsp[-4].list);
					n->oncommit = (yyvsp[-3].oncommit);
					n->tablespacename = (yyvsp[-2].str);
					n->if_not_exists = true;
/* PGXC_BEGIN */
					if ((yyvsp[-14].ival) == RELPERSISTENCE_LOCAL_TEMP)
					{
						(yyvsp[-9].range)->relpersistence = RELPERSISTENCE_TEMP;
						n->islocal = true;
					}
					n->relkind = RELKIND_RELATION;
					n->distributeby = (yyvsp[-1].distby);
					n->subcluster = (yyvsp[0].subclus);
					if (n->inhRelations != NULL && n->distributeby != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE cannot contains both an INHERITS and a DISTRIBUTE BY clause"),
								 parser_errposition(exprLocation((Node *) n->distributeby))));
/* PGXC_END */
					(yyval.node) = (Node *)n;
				}
#line 31575 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3539 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = list_make1((yyvsp[-6].range));
					n->partbound = (yyvsp[-4].partboundspec);
					n->partspec = (yyvsp[-3].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 31596 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3558 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = list_make1((yyvsp[-6].range));
					n->partbound = (yyvsp[-4].partboundspec);
					n->partspec = (yyvsp[-3].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 31617 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3587 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 31623 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3588 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 31629 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3589 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_LOCAL_TEMP; }
#line 31635 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3590 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_LOCAL_TEMP; }
#line 31641 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3592 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 31652 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3599 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 31663 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3605 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 31669 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3606 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 31675 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3610 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31681 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3611 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31687 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3615 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31693 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3616 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31699 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3621 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31707 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3625 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31715 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3632 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31723 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3636 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31731 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3642 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31737 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3643 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31743 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3644 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31749 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3648 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31755 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3649 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31761 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3653 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = (yyvsp[-2].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->is_from_parent = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 31785 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3675 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->is_from_parent = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31808 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3694 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->is_from_parent = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 31831 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3715 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 31837 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3716 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31843 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3721 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 31854 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3727 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31860 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3728 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31866 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3730 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31883 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3761 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31894 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3768 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31905 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3775 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31920 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3786 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31935 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3797 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 31951 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3809 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 31964 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3818 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 31977 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3827 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 31996 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3844 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 32002 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3845 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 32008 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3865 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 32019 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3872 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 32030 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3879 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 32041 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3886 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 32052 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3897 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 32063 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3906 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 32069 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3907 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 32075 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3908 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32081 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3912 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 32087 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3913 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 32093 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3914 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 32099 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3915 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 32105 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3916 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 32111 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3917 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 32117 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3918 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 32123 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3928 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 32134 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3934 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32140 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3939 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 32157 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3953 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-6]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 32175 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3967 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 32193 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3982 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 32211 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3996 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 32229 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 4012 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-8]);
					n->access_method	= (yyvsp[-7].str);
					n->exclusions		= (yyvsp[-5].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 32249 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 4029 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 32271 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 4048 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 32277 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4049 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 32283 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4053 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32289 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4054 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32295 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4058 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32301 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4059 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32307 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4063 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 32315 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4069 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 32323 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4073 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 32335 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4081 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 32343 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4085 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 32351 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4091 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 32357 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4093 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 32363 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4097 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 32371 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4102 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 32379 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4108 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32385 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4109 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32391 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4120 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 32397 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4122 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 32403 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4124 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 32409 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4126 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 32415 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4128 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 32421 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4131 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 32427 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4134 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 32433 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4138 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 32439 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4139 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 32445 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4140 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 32451 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4141 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 32457 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4142 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 32463 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32469 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4146 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32475 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4150 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 32481 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4151 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 32487 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4155 "gram.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = (yyvsp[-4].str);
					n->partParams = (yyvsp[-2].list);
					n->location = (yylsp[-6]);

					n->interval = (yyvsp[0].partby);

					(yyval.partspec) = n;
				}
#line 32503 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4169 "gram.y" /* yacc.c:1646  */
    {
					PartitionBy *n = makeNode(PartitionBy);

					n->strategy = PARTITION_STRATEGY_INTERVAL;
					n->intervaltype = 0;
					n->colname = NULL;
					n->partdatatype = InvalidOid;
					n->startvalue = (yyvsp[-9].node);
					n->step = (yyvsp[-5].node);
					n->interval = 0;
					n->nPartitions = (yyvsp[-1].ival);

					(yyval.partby) = n;
				}
#line 32522 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4183 "gram.y" /* yacc.c:1646  */
    { (yyval.partby) = NULL; }
#line 32528 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4186 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32534 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4187 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 32540 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4190 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 32546 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4191 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 32552 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4195 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 32567 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4206 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 32582 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4217 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 32597 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4230 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32603 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeDefElem("oids", (Node *) makeInteger(true), (yylsp[-1]))); }
#line 32609 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeDefElem("oids", (Node *) makeInteger(false), (yylsp[-1]))); }
#line 32615 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4233 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32621 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4236 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 32627 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4237 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 32633 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4238 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 32639 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4239 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 32645 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4242 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32651 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4243 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32657 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4247 "gram.y" /* yacc.c:1646  */
    { (yyval.distby) = (yyvsp[0].distby); }
#line 32663 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4248 "gram.y" /* yacc.c:1646  */
    { (yyval.distby) = NULL; }
#line 32669 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4256 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32675 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4259 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("all"); }
#line 32681 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4260 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = strdup("key"); }
#line 32687 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4262 "gram.y" /* yacc.c:1646  */
    { 
					if (strcmp((yyvsp[0].str), "even") != 0)
                        ereport(ERROR,
                                (errcode(ERRCODE_SYNTAX_ERROR),
                                 errmsg("unrecognized distribution style \"%s\"", (yyvsp[0].str))));
					(yyval.str) = (yyvsp[0].str);
				}
#line 32699 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4271 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32705 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4272 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 32711 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4276 "gram.y" /* yacc.c:1646  */
    {
					DistributeBy *n = makeNode(DistributeBy);
					if (strcmp((yyvsp[-3].str), "modulo") == 0)
						n->disttype = DISTTYPE_MODULO;
					else if (strcmp((yyvsp[-3].str), "hash") == 0)
						n->disttype = DISTTYPE_HASH;
/*_PGPAL BEGIN*/
					else if (strcmp((yyvsp[-3].str), "shard") == 0)
						n->disttype = DISTTYPE_SHARD;
/*_PGPAL END*/                           
					else
                        ereport(ERROR,
                                (errcode(ERRCODE_SYNTAX_ERROR),
                                 errmsg("unrecognized distribution option \"%s\"", (yyvsp[-3].str))));
					n->colname = (yyvsp[-1].list);
					(yyval.distby) = n;
				}
#line 32733 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4294 "gram.y" /* yacc.c:1646  */
    {
					DistributeBy *n = makeNode(DistributeBy);
					if (strcmp((yyvsp[0].str), "replication") == 0)
                        n->disttype = DISTTYPE_REPLICATION;
					else if (strcmp((yyvsp[0].str), "roundrobin") == 0)
						n->disttype = DISTTYPE_ROUNDROBIN;
                    else
                        ereport(ERROR,
                                (errcode(ERRCODE_SYNTAX_ERROR),
                                 errmsg("unrecognized distribution option \"%s\"", (yyvsp[0].str))));
					n->colname = NULL;
					(yyval.distby) = n;
				}
#line 32751 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4308 "gram.y" /* yacc.c:1646  */
    {
					DistributeBy *n = makeNode(DistributeBy);
					n->disttype = DISTTYPE_HASH;
					n->colname = (yyvsp[-1].list);
					(yyval.distby) = n;
				}
#line 32762 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4315 "gram.y" /* yacc.c:1646  */
    {
					DistributeBy *n = makeNode(DistributeBy);
					n->disttype = DISTTYPE_ROUNDROBIN;
					n->colname = NULL;
					(yyval.distby) = n;
				}
#line 32773 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4322 "gram.y" /* yacc.c:1646  */
    {
					DistributeBy *n = makeNode(DistributeBy);
					if (strcmp((yyvsp[-1].str), "even") == 0)
						n->disttype = DISTTYPE_ROUNDROBIN;
					else if (strcmp((yyvsp[-1].str), "key") == 0)
						n->disttype = DISTTYPE_HASH;
					else if (strcmp((yyvsp[-1].str), "all") == 0)
						n->disttype = DISTTYPE_REPLICATION;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized distribution style \"%s\"", (yyvsp[-1].str))));
					if ((n->disttype == DISTTYPE_ROUNDROBIN ||
						 n->disttype == DISTTYPE_REPLICATION) &&
						((yyvsp[0].list) != NULL))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("distribution key cannot be specified for distribution style \"%s\"", (yyvsp[-1].str))));

					if ((n->disttype == DISTTYPE_HASH) && ((yyvsp[0].list) == NULL))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("distribution key must be specified for distribution style \"%s\"", (yyvsp[-1].str))));

					n->colname = (yyvsp[0].list);
					(yyval.distby) = n;
				}
#line 32805 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4351 "gram.y" /* yacc.c:1646  */
    { (yyval.subclus) = (yyvsp[0].subclus); }
#line 32811 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4352 "gram.y" /* yacc.c:1646  */
    { (yyval.subclus) = NULL; }
#line 32817 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4357 "gram.y" /* yacc.c:1646  */
    {
					PGXCSubCluster *n = makeNode(PGXCSubCluster);
					n->clustertype = SUBCLUSTER_NODE;
					n->members = (yyvsp[0].list);
					(yyval.subclus) = n;
				}
#line 32828 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4364 "gram.y" /* yacc.c:1646  */
    {
					PGXCSubCluster *n = makeNode(PGXCSubCluster);
					n->clustertype = SUBCLUSTER_GROUP;
					n->members = list_make1(makeString((yyvsp[0].str)));
					(yyval.subclus) = n;
				}
#line 32839 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4371 "gram.y" /* yacc.c:1646  */
    {
					PGXCSubCluster *n = makeNode(PGXCSubCluster);
					n->clustertype = SUBCLUSTER_GROUP;
					n->members = list_make1(makeString((yyvsp[-1].str)));
					n->members = lappend(n->members, makeString((yyvsp[0].str)));
					(yyval.subclus) = n;
				}
#line 32851 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4381 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32857 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4383 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32863 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4385 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32869 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4388 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32875 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4408 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 32889 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4419 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 32903 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4442 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					if ((yyvsp[-5].ival) == RELPERSISTENCE_LOCAL_TEMP)
					{
						(yyvsp[-3].into)->rel->relpersistence = RELPERSISTENCE_TEMP;
						ctas->islocal = true;
					}

					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32926 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4461 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32943 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4480 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-6].range);
					(yyval.into)->colNames = (yyvsp[-5].list);
					(yyval.into)->options = (yyvsp[-4].list);
					(yyval.into)->onCommit = (yyvsp[-3].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[-2].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
/* PGXC_BEGIN */
					(yyval.into)->distributeby = (yyvsp[-1].distby);
					(yyval.into)->subcluster = (yyvsp[0].subclus);
/* PGXC_END */
				}
#line 32962 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4497 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 32968 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4498 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32974 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4499 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 32980 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4512 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32997 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4525 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33014 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4541 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-3].range);
					(yyval.into)->colNames = (yyvsp[-2].list);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 33029 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4553 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 33035 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4554 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 33041 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4567 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 33053 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4587 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
/* PGXC_BEGIN */
					n->is_serial = false;
/* PGXC_END */
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 33070 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4600 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
/* PGXC_BEGIN */
					n->is_serial = false;
/* PGXC_END */
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 33087 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4616 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
/* PGXC_BEGIN */
					n->is_serial = false;
/* PGXC_END */
					(yyval.node) = (Node *)n;
				}
#line 33102 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4627 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33114 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4637 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33120 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4638 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33126 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4641 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33132 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4642 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33138 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4645 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33144 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4646 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33150 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4650 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].typnam), (yylsp[-1]));
				}
#line 33158 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4654 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 33166 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4658 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 33174 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4662 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE), (yylsp[-1]));
				}
#line 33182 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4666 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 33190 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4670 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 33198 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4674 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 33206 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4678 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 33214 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4682 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 33222 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4686 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 33230 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4690 "gram.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 33239 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4695 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 33247 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4699 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 33255 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4703 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 33263 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4708 "gram.y" /* yacc.c:1646  */
    {}
#line 33269 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4709 "gram.y" /* yacc.c:1646  */
    {}
#line 33275 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4713 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 33281 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4714 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 33287 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4716 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 33296 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4720 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 33302 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4723 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 33308 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4724 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 33314 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4737 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-4].boolean);
				n->plname = (yyvsp[0].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
#line 33330 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4750 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 33345 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4763 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 33351 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4764 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 33357 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4772 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33363 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4773 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 33369 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4777 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33375 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4778 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33381 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4782 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33387 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4783 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33393 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4787 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33399 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4788 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33405 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4793 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(makeString((yyvsp[-1].str)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33419 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4803 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(makeString((yyvsp[-1].str)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33433 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4815 "gram.y" /* yacc.c:1646  */
    {}
#line 33439 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4816 "gram.y" /* yacc.c:1646  */
    {}
#line 33445 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4827 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33458 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4837 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 33464 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4838 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 33470 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4852 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33481 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4859 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33492 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4876 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->action = CREATEEXT_CREATE;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33505 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4885 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->action = CREATEEXT_CREATE;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33518 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4894 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->action = CREATEEXT_PREPARE;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33531 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4903 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->action = CREATEEXT_PREPARE;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33544 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4912 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->action = CREATEEXT_EXECUTE;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33557 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4921 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->action = CREATEEXT_EXECUTE;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33570 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4933 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33576 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4935 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33582 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4940 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33590 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4944 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33598 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 4948 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33606 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 4952 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 33614 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 4964 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33625 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 4974 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33631 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 4976 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33637 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 4981 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33645 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 4994 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_ACCESS_METHOD;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33658 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5003 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 33671 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5012 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 33684 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5021 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33697 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5030 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33710 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5039 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 33723 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5048 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 33736 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5057 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33749 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5066 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 33762 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5075 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 33775 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5084 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 33788 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5093 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33801 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5102 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33814 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5111 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33827 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5120 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33840 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5129 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33853 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5138 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33866 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5147 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33879 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5156 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33892 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5165 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33905 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5174 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_MATVIEW;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33918 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5183 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33931 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5192 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33944 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5201 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 33957 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5210 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 33970 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5219 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 33983 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5237 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33995 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5247 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 34001 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5248 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 34007 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5249 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 34013 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5250 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 34019 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5254 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34025 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5255 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34031 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5259 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34037 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5260 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34043 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5271 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34055 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5279 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 34067 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5290 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34073 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5291 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34079 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5296 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34087 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5300 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34095 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5307 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34101 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5312 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34109 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5316 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34117 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5323 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 34125 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5327 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 34134 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5332 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 34143 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5337 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 34151 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5344 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 34159 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5350 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34165 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5355 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34171 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5367 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34186 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5379 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34201 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5392 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34207 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5393 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34213 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5398 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34219 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5399 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34225 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5403 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34231 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5404 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34237 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5415 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34250 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5424 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34262 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5432 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34273 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5451 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34295 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5471 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34317 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5491 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34340 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5512 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34363 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5541 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 34376 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5550 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 34389 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5572 "gram.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);
				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 34404 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5585 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 34410 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5586 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 34416 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5591 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 34427 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5598 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 34438 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5614 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34451 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5623 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34464 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5634 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 34470 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5635 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 34476 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5648 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34488 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5656 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34500 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5673 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34512 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5699 "gram.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);
					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 34528 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5715 "gram.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);
					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 34542 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5727 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 34548 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5728 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34554 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5732 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 34560 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5733 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34566 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5737 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34572 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5738 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 34578 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5742 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34584 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5743 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 34590 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5748 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
									 parser_errposition((yylsp[0]))));

				}
#line 34608 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5761 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34614 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5765 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34620 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5766 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 34626 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5770 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 34632 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5771 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 34638 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5772 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 34644 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5773 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 34650 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5774 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 34656 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5785 "gram.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);
					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = AMTYPE_INDEX;
					(yyval.node) = (Node *) n;
				}
#line 34668 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5805 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 34691 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5827 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 34715 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5849 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 34721 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5850 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 34727 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5851 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 34733 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5856 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34739 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5858 "gram.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 34762 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5880 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 34768 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5882 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 34774 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5884 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 34780 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5886 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 34786 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5888 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 34792 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5892 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34798 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5893 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34804 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5897 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34810 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5898 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 34816 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5903 "gram.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);
					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *)n;
				}
#line 34828 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5913 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34834 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5914 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34840 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5918 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34846 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5927 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34852 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5931 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34858 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5936 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 34866 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5940 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
#line 34878 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5950 "gram.y" /* yacc.c:1646  */
    {}
#line 34884 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5951 "gram.y" /* yacc.c:1646  */
    {}
#line 34890 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5955 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34896 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5956 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34902 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5960 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 34908 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5961 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34914 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5965 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 34920 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5966 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 34926 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5967 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34932 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5972 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 34940 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5975 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 34946 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5976 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 34952 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5977 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 34958 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5981 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 34964 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5982 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 34970 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5987 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 34976 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5989 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 35004 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 6015 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 35010 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 6016 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 35016 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 6017 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 35022 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6018 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 35028 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6019 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 35034 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6020 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 35040 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6035 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 35053 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6046 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 35066 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6058 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35072 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6060 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35078 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6065 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 35084 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6070 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35090 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6072 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35096 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6077 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 35107 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6086 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 35113 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6087 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 35119 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6088 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 35125 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6089 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 35131 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6103 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-5].str);
					n->args = list_make1((yyvsp[-2].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
#line 35151 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6122 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
#line 35166 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6144 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35180 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6154 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35195 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6165 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35209 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6175 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35223 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6185 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 35238 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6196 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 35251 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6205 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 35262 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6212 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35273 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6219 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35286 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6228 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35299 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6237 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35312 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6246 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35325 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6255 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35338 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6264 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 35352 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6274 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 35365 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6283 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 35379 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6294 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35385 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6297 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35391 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6298 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35397 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6302 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35405 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 35413 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6312 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 35419 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6313 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 35425 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6314 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 35431 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6315 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 35437 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6316 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 35443 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6317 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 35449 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6320 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35455 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6323 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35461 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6324 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35467 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6333 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node), (yylsp[-2]));
				}
#line 35475 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6339 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35481 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6340 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35487 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6344 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35493 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6346 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35499 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6357 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35514 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6368 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35529 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6379 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35544 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6390 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 35559 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6402 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35565 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6403 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35571 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6421 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35586 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6434 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35592 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6435 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35598 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6440 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);
					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35614 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6453 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35627 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6462 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 35639 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6470 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 35652 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6479 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 35663 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6487 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 35669 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6488 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 35675 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6491 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35681 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6492 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35687 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6495 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35693 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6496 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35699 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6497 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35705 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6501 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = TRUE;
				}
#line 35723 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6514 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 35729 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6520 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35740 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6530 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35753 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6539 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35766 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6550 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35772 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35778 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6556 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35790 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6564 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35802 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6576 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35816 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6586 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35830 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6599 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35844 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6609 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35858 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6631 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35869 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6641 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 35880 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6659 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35894 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6669 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35908 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6679 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35922 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6689 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35936 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6699 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35950 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6709 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35964 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6719 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35978 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6729 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35992 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6739 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36006 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6749 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36020 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6759 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 36034 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6769 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 36048 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6782 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 36054 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6783 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 36060 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6784 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 36066 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6785 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 36072 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6786 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 36078 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6787 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 36084 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6788 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 36090 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6789 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 36096 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6790 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 36102 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6791 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 36108 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6792 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 36114 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6793 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 36120 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6794 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 36126 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6799 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 36132 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6800 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 36138 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6801 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 36144 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6802 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 36150 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6803 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 36156 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6804 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 36162 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6805 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 36168 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6810 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 36174 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6811 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 36180 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6812 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 36186 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6816 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 36192 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6817 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 36198 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6820 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36204 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6821 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 36210 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6825 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36216 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6827 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36222 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6831 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 36228 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6832 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 36234 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6843 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 36246 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6853 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36252 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6854 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36258 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6855 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36264 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6890 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36276 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6898 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36288 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6906 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36300 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6914 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36312 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6922 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36324 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6930 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36336 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6938 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36348 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6946 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36360 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6954 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36377 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6967 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_POLICY;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36389 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6975 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36401 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6983 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36413 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6991 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36425 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6999 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36437 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 7007 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36449 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 7015 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36461 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 7023 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36473 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 7034 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 36479 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 7035 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 36485 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 7036 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 36491 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 7037 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 36497 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 7038 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 36503 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 7039 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 36509 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 7040 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 36515 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 7041 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 36521 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 7042 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 36527 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 7043 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 36533 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 7044 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 36539 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 7045 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 36545 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 7046 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 36551 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 7047 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 36557 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 7052 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 36563 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 7053 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 36569 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 7054 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 36575 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 7055 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 36581 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7056 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 36587 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7057 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 36593 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7058 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 36599 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7059 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 36605 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7060 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 36611 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7061 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 36617 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7062 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_REPLICATION_SLOT; }
#line 36623 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7063 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 36629 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7064 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 36635 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7068 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36641 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7069 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36647 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7085 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36660 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7095 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36673 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7105 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36686 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7115 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36699 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7125 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36712 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7135 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36725 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7145 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36738 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7155 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36744 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7156 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36750 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7161 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 36756 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7162 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 36762 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7163 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 36768 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7164 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 36774 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7165 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 36780 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7166 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 36786 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7171 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 36792 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7172 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 36798 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7173 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 36804 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7174 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 36810 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7175 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 36816 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7176 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 36822 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7177 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_REPLICATION_SLOT; }
#line 36828 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7178 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 36834 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7179 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 36840 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7182 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36846 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7183 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36852 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7194 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 36862 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7200 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 36872 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7208 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36884 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7216 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36896 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7224 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36908 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7232 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36920 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7240 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36932 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7248 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 36944 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7256 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 36956 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7264 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 36968 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7272 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 36980 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7280 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 36992 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7288 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 37004 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7296 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 37016 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7304 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 37028 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7312 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 37040 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7320 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 37052 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7328 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 37064 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7337 "gram.y" /* yacc.c:1646  */
    {}
#line 37070 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7338 "gram.y" /* yacc.c:1646  */
    {}
#line 37076 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7341 "gram.y" /* yacc.c:1646  */
    {}
#line 37082 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7342 "gram.y" /* yacc.c:1646  */
    {}
#line 37088 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7354 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 37104 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7370 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 37121 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7384 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 37138 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7409 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37144 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7411 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37150 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7413 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37156 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7415 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 37167 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7422 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 37178 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7430 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 37184 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7431 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 37190 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7435 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37201 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7442 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37212 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7449 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37223 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7456 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37234 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7470 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37246 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7478 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37258 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7486 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37270 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7494 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37282 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7502 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37294 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7510 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37306 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7518 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37318 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7526 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37330 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7534 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37342 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7542 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37354 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7550 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37366 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7558 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37378 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7566 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37390 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7574 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37402 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7582 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37414 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7590 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37426 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7601 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 37432 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7602 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 37438 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7606 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37444 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7607 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37450 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7612 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 37456 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 7613 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37462 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7624 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node*)n;
				}
#line 37476 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7637 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 37490 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7647 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 37504 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7658 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 37510 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7659 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37516 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7662 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37522 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7663 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 37528 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7674 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 37539 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7683 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37545 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7684 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37551 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7689 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 37559 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7693 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 37567 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7697 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 37575 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7709 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 37591 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7722 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 37608 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7736 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 37625 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7751 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_RELATION; }
#line 37631 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 7752 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
#line 37637 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7753 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
#line 37643 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7754 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_TYPE; }
#line 37649 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7755 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_NAMESPACE; }
#line 37655 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7770 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-12].boolean);
					n->concurrent = (yyvsp[-10].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->relationId = InvalidOid;
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *)n;
				}
#line 37685 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7798 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-15].boolean);
					n->concurrent = (yyvsp[-13].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->relationId = InvalidOid;
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *)n;
				}
#line 37715 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7826 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 37721 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7827 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37727 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7831 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 37733 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7832 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37739 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7836 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37745 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7837 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37751 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7841 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37757 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7842 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 37763 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7845 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 37769 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7846 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 37775 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 7855 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-4].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 37790 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7866 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-4].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 37805 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7877 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-5].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 37820 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7889 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37826 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7890 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37832 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7893 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37838 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7894 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37844 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7897 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 37850 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7898 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 37856 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7899 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 37862 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7902 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 37868 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7903 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 37874 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7904 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 37880 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 7922 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37895 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 7934 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37911 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 7947 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37926 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 7960 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 37932 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 7961 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 37938 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 7964 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37944 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 7965 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37950 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 7969 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 37956 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 7970 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 37962 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 7974 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 37968 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 7976 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 37974 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 7981 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 37985 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 7993 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 37996 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8000 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38007 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8007 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38019 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8021 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 38025 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 8022 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38031 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8026 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38037 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8028 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38043 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8043 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38056 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8052 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38069 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8061 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38082 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8070 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38095 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8079 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38108 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8090 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 38114 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8091 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 38120 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8092 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 38126 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8093 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 38132 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8094 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 38138 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8105 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 38150 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8119 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 38156 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8121 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 38166 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8127 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 38177 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8137 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 38185 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8141 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 38194 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8146 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 38203 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8154 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 38217 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8195 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 38225 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8199 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 38233 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8203 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 38241 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8207 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 38250 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8214 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38256 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8215 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38262 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8220 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 38273 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8229 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 38279 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 38285 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38291 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8237 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38297 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8245 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE), (yylsp[-3]));
				}
#line 38305 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8249 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE), (yylsp[-4]));
				}
#line 38313 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8253 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 38321 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8257 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"), (yylsp[0]));
				}
#line 38329 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8261 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"), (yylsp[0]));
				}
#line 38337 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8265 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"), (yylsp[0]));
				}
#line 38345 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8269 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE), (yylsp[-2]));
				}
#line 38353 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8273 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE), (yylsp[-2]));
				}
#line 38361 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8277 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE), (yylsp[-1]));
				}
#line 38369 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8281 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE), (yylsp[-1]));
				}
#line 38377 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8285 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 38385 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8289 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE), (yylsp[-1]));
				}
#line 38393 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8293 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("pushdown", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 38401 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8297 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("pushdown", (Node *)makeInteger(FALSE), (yylsp[-1]));
				}
#line 38409 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8301 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 38417 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8305 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 38425 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8309 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 38434 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8314 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 38442 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8321 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 38450 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8325 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 38458 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8329 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 38466 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8333 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 38474 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8337 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 38482 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8342 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38488 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8344 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 38496 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8350 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 38502 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8351 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 38508 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8355 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 38514 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8356 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38520 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8360 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38533 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8372 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 38541 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8376 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 38549 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8391 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38560 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8401 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38566 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8402 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38572 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 8424 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38586 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 8434 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38600 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 8447 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38614 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 8457 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38628 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8470 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38642 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8480 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38656 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8493 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 38668 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8501 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 38674 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8503 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 38680 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8505 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 38686 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8510 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38692 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8512 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 38698 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8516 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 38704 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8518 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 38710 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8523 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 38721 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8541 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38731 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8549 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38737 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8550 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38743 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8555 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 38751 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8559 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 38759 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8572 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 38773 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8583 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 38787 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8594 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 38801 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8605 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 38807 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8606 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 38813 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8607 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 38819 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8612 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38833 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8623 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 38839 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8624 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 38845 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8635 "gram.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);
					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 38859 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8647 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 38867 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8651 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 38875 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8655 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 38883 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8659 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 38891 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 8666 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38904 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 8686 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 38917 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 8695 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 38930 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 8704 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = (yyvsp[-3].ival);
					(yyval.node) = (Node *)n;
				}
#line 38943 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 8713 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = (yyvsp[-3].ival);
					(yyval.node) = (Node *)n;
				}
#line 38956 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 8723 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 38962 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 8724 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 38968 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 8727 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 38974 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 8728 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 38980 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 8729 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 38986 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 8732 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 38992 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 8733 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 38998 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 8736 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEXOPT_VERBOSE; }
#line 39004 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 8747 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 39017 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 8756 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 39030 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 8773 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39043 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 8782 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39056 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 8791 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39069 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 8800 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39082 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 8809 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39095 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 8818 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39108 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 8827 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39121 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 8836 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39134 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 8845 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_GROUP;
#endif
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39150 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 8857 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39163 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 8866 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39176 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 8875 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39189 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 8884 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39203 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 8894 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39217 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 8904 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39230 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 8913 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39243 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 8922 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39256 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 8931 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_REPLICATION_SLOT;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39269 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 8940 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39282 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 8949 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39296 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 8959 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39310 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 8969 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39324 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 8979 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39338 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 8989 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39352 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 8999 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39366 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9009 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39380 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9019 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39394 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9029 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39408 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9039 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39422 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9049 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39436 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9059 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39450 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9069 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39465 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9080 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39480 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9091 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39495 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9102 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39510 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 9113 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39524 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 9123 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39538 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 9133 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39553 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 9144 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39568 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 9155 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39582 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 9165 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39596 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 9175 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39608 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 9183 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_ROLE;
#endif
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39624 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 9195 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
#ifdef __AUDIT__
					n->stmt_type = ROLESTMT_USER;
#endif
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39640 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 9207 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39653 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 9216 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39666 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 9225 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39679 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 9234 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39692 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 9243 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39705 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 9252 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39718 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 9261 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39731 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9270 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39747 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9283 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COLUMN; }
#line 39753 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9284 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 39759 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 9287 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 39765 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 9288 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 39771 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9299 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-4].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 39783 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9307 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-4].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-6].str)));
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 39796 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9316 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-4].range);
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 39808 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9324 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-4].range);
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 39820 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9341 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39833 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9350 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39846 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9359 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39859 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9368 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39872 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9377 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39885 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9386 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39898 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9395 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39911 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9404 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39924 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9413 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39937 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9422 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39950 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9431 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39963 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9440 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39976 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9449 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39989 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9458 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40002 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9467 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40015 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9476 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40028 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9485 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40041 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9494 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 40054 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9503 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40067 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9512 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 40080 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9521 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40093 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9530 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 40106 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 9539 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40119 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 9548 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 40132 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9557 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40145 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9575 "gram.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);
					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 40156 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 9583 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40162 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 9584 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 40168 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 9588 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 40174 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 9590 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 40180 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 9595 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 40186 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 9596 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 40192 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 9597 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 40198 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 9598 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 40204 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 9599 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 40210 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 9609 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40222 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9617 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40234 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9625 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40246 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9633 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40258 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9641 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40270 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9649 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40282 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9657 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40294 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9665 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].value);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40306 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9673 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40318 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9681 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40330 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9689 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40342 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 9697 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40354 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 9705 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40366 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9713 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40378 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9721 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40390 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9729 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40402 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9737 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40414 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9745 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40426 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 9753 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40438 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 9761 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40450 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 9769 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40462 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 9777 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 40474 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 9795 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					if ((yyvsp[-2].node) != NULL)
					{
						/* FOR TABLE */
						if (IsA((yyvsp[-2].node), List))
							n->tables = (List *)(yyvsp[-2].node);
						/* FOR ALL TABLES */
						else
							n->for_all_tables = TRUE;
					}

					n->shards = (List *)(yyvsp[-1].node);

					(yyval.node) = (Node *)n;
				}
#line 40497 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 9816 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40503 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 9817 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40509 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 9822 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].list);
				}
#line 40517 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 9826 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeInteger(TRUE);
				}
#line 40525 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 9832 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40531 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 9833 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40537 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 9837 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[-1].list);
				}
#line 40545 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 9858 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40556 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 9865 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_ADD;
					(yyval.node) = (Node *)n;
				}
#line 40568 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 9873 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_SET;
					(yyval.node) = (Node *)n;
				}
#line 40580 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 9881 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_DROP;
					(yyval.node) = (Node *)n;
				}
#line 40592 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 9898 "gram.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					n->isopentenbase = false;
					n->sub_parallel_number = 0;
					n->sub_parallel_index = 0;
					(yyval.node) = (Node *)n;
				}
#line 40609 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 9912 "gram.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					n->isopentenbase = true;
					n->sub_parallel_number = 0;
					n->sub_parallel_index = 0;
					(yyval.node) = (Node *)n;
				}
#line 40626 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 9929 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].value));
				}
#line 40634 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 9933 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value));
				}
#line 40642 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 9939 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 40648 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 9949 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isopentenbase = false;
					(yyval.node) = (Node *)n;
				}
#line 40662 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 9960 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isopentenbase = true;
					(yyval.node) = (Node *)n;
				}
#line 40676 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 9971 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					n->isopentenbase = false;
					(yyval.node) = (Node *)n;
				}
#line 40690 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 9982 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					n->isopentenbase = true;
					(yyval.node) = (Node *)n;
				}
#line 40704 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 9993 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->isopentenbase = false;
					(yyval.node) = (Node *)n;
				}
#line 40718 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10004 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->isopentenbase = true;
					(yyval.node) = (Node *)n;
				}
#line 40732 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10015 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					n->isopentenbase = false;
					(yyval.node) = (Node *)n;
				}
#line 40747 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10027 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					n->isopentenbase = true;
					(yyval.node) = (Node *)n;
				}
#line 40762 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10039 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(TRUE), (yylsp[-3])));
					n->isopentenbase = false;
					(yyval.node) = (Node *)n;
				}
#line 40777 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10051 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(TRUE), (yylsp[-4])));
					n->isopentenbase = true;
					(yyval.node) = (Node *)n;
				}
#line 40792 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 10063 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(FALSE), (yylsp[-3])));
					n->isopentenbase = false;
					(yyval.node) = (Node *)n;
				}
#line 40807 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 10075 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(FALSE), (yylsp[-4])));
					n->isopentenbase = true;
					(yyval.node) = (Node *)n;
				}
#line 40822 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 10095 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->isopentenbase = false;
					(yyval.node) = (Node *) n;
				}
#line 40835 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 10105 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->isopentenbase = true;
					(yyval.node) = (Node *) n;
				}
#line 40848 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 10115 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->isopentenbase = false;
					(yyval.node) = (Node *) n;
				}
#line 40861 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 10125 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->isopentenbase = true;
					(yyval.node) = (Node *) n;
				}
#line 40874 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 10145 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40890 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 10159 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40896 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 10160 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40902 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 10161 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40908 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 10167 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 40918 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 10173 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 40928 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 10189 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 40934 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 10190 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40940 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 10193 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 40946 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 10194 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 40952 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 10195 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 40958 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 10196 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 40964 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 10200 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 40970 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 10201 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 40976 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 10202 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 40982 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 10215 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40993 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 10224 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40999 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 10225 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 41005 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 10229 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 41015 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 10238 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 41025 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 10244 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 41035 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 10263 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 41046 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 10270 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41057 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 10277 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN_SUBTXN;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 41068 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 10284 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41079 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 10291 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_SUBTXN;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 41090 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 10298 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 41101 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 10305 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 41112 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 10312 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_SUBTXN;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 41123 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 10319 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 41134 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 10326 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str)), (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 41146 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 10334 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str)), (yylsp[-2])));
					(yyval.node) = (Node *)n;
				}
#line 41158 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 10342 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str)), (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 41170 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 10350 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str)), (yylsp[-4])));
					(yyval.node) = (Node *)n;
				}
#line 41182 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 10358 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str)), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 41194 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 10366 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 41205 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 10373 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 41216 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 10380 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 41227 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 10387 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED_CHECK;
					n->gid = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 41238 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 10394 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED_CHECK;
					n->gid = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 41249 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 10402 "gram.y" /* yacc.c:1646  */
    {}
#line 41255 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 10403 "gram.y" /* yacc.c:1646  */
    {}
#line 41261 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 10404 "gram.y" /* yacc.c:1646  */
    {}
#line 41267 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 10409 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 41274 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 10412 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[-1])), (yylsp[-1])); }
#line 41281 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 10415 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[-1])), (yylsp[-1])); }
#line 41288 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 10418 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[0])), (yylsp[0])); }
#line 41295 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 10421 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[-1])), (yylsp[-1])); }
#line 41302 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 10428 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41308 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 10430 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 41314 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 10432 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41320 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 10438 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41326 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 10452 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 41342 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 10465 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 41358 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 10478 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 41379 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 10496 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 41400 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 10515 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 41406 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 10516 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 41412 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 10517 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 41418 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 10518 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 41424 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 10529 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 41434 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 10545 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41445 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 10554 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41451 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 10555 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41457 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10559 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41463 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10560 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41469 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10565 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 41477 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10569 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 41485 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10573 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 41493 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10590 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41499 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10591 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 41505 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10592 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41511 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10593 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41517 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10594 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41523 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10595 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41529 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10596 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41535 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10603 "gram.y" /* yacc.c:1646  */
    {}
#line 41541 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10604 "gram.y" /* yacc.c:1646  */
    {}
#line 41547 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10616 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 41558 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10623 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 41569 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10630 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *)makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *)n;
				 }
#line 41581 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10641 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 41592 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10658 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = FALSE;
					n->prepare = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 41604 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10666 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					n->prepare = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 41616 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 10674 "gram.y" /* yacc.c:1646  */
    {
        				DropdbStmt *n = makeNode(DropdbStmt);
        				n->dbname = (yyvsp[0].str);
        				n->missing_ok = FALSE;
        				n->prepare = TRUE;
        				(yyval.node) = (Node *)n;
        			}
#line 41628 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 10682 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					n->prepare = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 41640 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 10699 "gram.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);
					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 41650 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 10716 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 41660 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 10722 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 41670 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 10738 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 41683 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 10751 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 41695 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 10760 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 41706 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 10768 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 41717 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10776 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 41729 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10785 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 41743 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10796 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 41757 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 10807 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 41769 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 10816 "gram.y" /* yacc.c:1646  */
    {}
#line 41775 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 10817 "gram.y" /* yacc.c:1646  */
    {}
#line 41781 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 10829 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41792 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10839 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 41807 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10850 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 41822 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10861 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 41837 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10872 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 41852 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10883 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 41865 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10892 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 41878 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10903 "gram.y" /* yacc.c:1646  */
    {}
#line 41884 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 10904 "gram.y" /* yacc.c:1646  */
    {}
#line 41890 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 10920 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 41904 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 10942 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->verbose = (yyvsp[-2].boolean);
					(yyval.node) = (Node*)n;
				}
#line 41916 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 10950 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 41928 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 10959 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->verbose = (yyvsp[-3].boolean);
					(yyval.node) = (Node*)n;
				}
#line 41940 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 10969 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41946 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 10970 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 41952 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 10983 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					n->sync_option = (yyvsp[0].analyze_sync_opt);
					(yyval.node) = (Node *)n;
				}
#line 41971 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 10998 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-4].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[-1].range);
					n->va_cols = NIL;
					n->sync_option = (yyvsp[0].analyze_sync_opt);
					(yyval.node) = (Node *)n;
				}
#line 41990 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 11013 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[0].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					(yyval.node) = (Node *)n;
				}
#line 42006 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 11025 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-2].ival);
					n->relation = NULL;
					n->va_cols = NIL;
					n->sync_option = (yyvsp[0].analyze_sync_opt);
					(yyval.node) = (Node *) n;
				}
#line 42019 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 11034 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-4].ival);
					n->relation = (yyvsp[-2].range);
					n->va_cols = (yyvsp[-1].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					n->sync_option = (yyvsp[0].analyze_sync_opt);
					(yyval.node) = (Node *) n;
				}
#line 42034 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 11046 "gram.y" /* yacc.c:1646  */
    {
					VacuumShardStmt *n = makeNode(VacuumShardStmt);
					n->relation = (yyvsp[-4].range);
					n->options = TRUNSHARDOPT_FREESTORAGE;
					n->shards = list_make1(makeIntConst((yyvsp[-1].ival), -1));
					n->pause = 0;
					(yyval.node) = (Node *) n;
				}
#line 42047 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 11058 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 42053 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 11059 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 42059 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 11063 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_ANALYZE; }
#line 42065 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 11064 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_VERBOSE; }
#line 42071 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 11065 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FREEZE; }
#line 42077 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 11066 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FULL; }
#line 42083 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 11068 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "disable_page_skipping") == 0)
						(yyval.ival) = VACOPT_DISABLE_PAGE_SKIPPING;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized VACUUM option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 42097 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 11081 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					n->sync_option = (yyvsp[0].analyze_sync_opt);
					(yyval.node) = (Node *)n;
				}
#line 42112 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 11092 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[-2].range);
					n->va_cols = (yyvsp[-1].list);
					n->sync_option = (yyvsp[0].analyze_sync_opt);
					(yyval.node) = (Node *)n;
				}
#line 42127 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 11103 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE | (yyvsp[-2].ival);
					n->relation = NULL;
					n->va_cols = NIL;
					n->sync_option = (yyvsp[0].analyze_sync_opt);
					(yyval.node) = (Node *)n;
				}
#line 42140 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 11112 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE | (yyvsp[-4].ival);
					n->relation = (yyvsp[-2].range);
					n->va_cols = (yyvsp[-1].list);
					n->sync_option = (yyvsp[0].analyze_sync_opt);
					(yyval.node) = (Node *)n;
				}
#line 42153 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 11123 "gram.y" /* yacc.c:1646  */
    {}
#line 42159 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 11124 "gram.y" /* yacc.c:1646  */
    {}
#line 42165 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 11129 "gram.y" /* yacc.c:1646  */
    {
					StatSyncOpt *n = makeNode(StatSyncOpt);
					n->is_sync_from = false;
					n->nodes = NIL;
					(yyval.analyze_sync_opt) = n;
			    }
#line 42176 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 11136 "gram.y" /* yacc.c:1646  */
    {
					StatSyncOpt *n = makeNode(StatSyncOpt);
					n->is_sync_from = false;
					n->nodes = (yyvsp[0].list);
					(yyval.analyze_sync_opt) = n;
			    }
#line 42187 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 11143 "gram.y" /* yacc.c:1646  */
    {
					StatSyncOpt *n = makeNode(StatSyncOpt);
					n->is_sync_from = true;
					n->nodes = list_make1(makeString((yyvsp[0].str)));
					(yyval.analyze_sync_opt) = n;
				}
#line 42198 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 11150 "gram.y" /* yacc.c:1646  */
    {
					StatSyncOpt *n = makeNode(StatSyncOpt);
					n->is_sync_from = false;
					n->nodes = NIL;
					(yyval.analyze_sync_opt) = n;
				}
#line 42209 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 11159 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 42215 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 11160 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 42221 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 11163 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 42227 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 11164 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 42233 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 11167 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 42239 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 11168 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 42245 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 11173 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 42251 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 11174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 42257 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 11178 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_VERBOSE; }
#line 42263 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 11179 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_COORDINATOR; }
#line 42269 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 11183 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42275 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 11184 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42281 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 11191 "gram.y" /* yacc.c:1646  */
    {
					AuditStmt * n = makeNode(AuditStmt);

					n->audit_ison = (yyvsp[-2].boolean);
					n->audit_type = AuditType_Statement;
					n->audit_mode = (yyvsp[0].ival);
					n->action_list = (yyvsp[-1].list);
					n->user_list = NIL;
					n->object_name = NIL;
					n->object_type = 0;

					(yyval.node) = (Node *)n;
				}
#line 42299 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 11205 "gram.y" /* yacc.c:1646  */
    {
					AuditStmt * n = makeNode(AuditStmt);

					n->audit_ison = (yyvsp[-4].boolean);
					n->audit_type = AuditType_User;
					n->audit_mode = (yyvsp[0].ival);
					n->action_list = (yyvsp[-3].list);
					n->user_list = (yyvsp[-1].list);
					n->object_name = NIL;
					n->object_type = 0;

					(yyval.node) = (Node *)n;
				}
#line 42317 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 11219 "gram.y" /* yacc.c:1646  */
    {
					AuditStmt * n = makeNode(AuditStmt);

					n->audit_ison = (yyvsp[-5].boolean);
					n->audit_type = AuditType_Object;
					n->audit_mode = (yyvsp[0].ival);
					n->action_list = (yyvsp[-4].list);
					n->user_list = NIL;
					n->object_name = (yyvsp[-1].list);
					n->object_type = (yyvsp[-2].ival);

					if (n->object_name == NIL)
					{
						/* 
						 * Audit xxx ON TABLE DEFAULT
						 */
						ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("invalid audit statement")));
					}

					(yyval.node) = (Node *)n;
				}
#line 42345 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 11243 "gram.y" /* yacc.c:1646  */
    {
					AuditStmt * n = makeNode(AuditStmt);

					n->audit_ison = (yyvsp[-4].boolean);
					n->audit_type = AuditType_Object;
					n->audit_mode = (yyvsp[0].ival);
					n->action_list = (yyvsp[-3].list);
					n->user_list = NIL;
					n->object_name = (yyvsp[-1].list);
					n->object_type = OBJECT_TABLE;

					(yyval.node) = (Node *)n;
				}
#line 42363 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 11259 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42369 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 11260 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42375 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 11264 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 42381 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 11265 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditMode_All; }
#line 42387 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 11269 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditMode_Fail; }
#line 42393 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 11270 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditMode_Success; }
#line 42399 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 11274 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42405 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 11275 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1_int(AuditSql_All); }
#line 42411 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 11279 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1_int((yyvsp[0].ival)); }
#line 42417 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 11280 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_append_unique_int((yyvsp[-2].list), (yyvsp[0].ival)); }
#line 42423 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 11288 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_AlterSystem; }
#line 42429 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 11290 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Database; }
#line 42435 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 11291 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Database_Alter; }
#line 42441 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 11292 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Database_Create; }
#line 42447 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 11293 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Database_Drop; }
#line 42453 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 11295 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Extension; }
#line 42459 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 11296 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Extension_Alter; }
#line 42465 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 11297 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Extension_Create; }
#line 42471 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 11298 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Extension_Drop; }
#line 42477 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 11300 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Function; }
#line 42483 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 11301 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Function_Alter; }
#line 42489 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 11302 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Function_Create; }
#line 42495 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 11303 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Function_Drop; }
#line 42501 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 11305 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Group; }
#line 42507 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 11306 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Group_CreateNodeGroup; }
#line 42513 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 11307 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Group_CreateShardingGroup; }
#line 42519 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 11308 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Group_DropNodeGroup; }
#line 42525 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 11309 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Group_DropShardingInGroup; }
#line 42531 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 11311 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Index; }
#line 42537 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 11312 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Index_Alter; }
#line 42543 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 11313 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Index_Create; }
#line 42549 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 11314 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Index_Drop; }
#line 42555 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 11316 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_MaterializedView; }
#line 42561 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 11317 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_MaterializedView_Alter; }
#line 42567 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 11318 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_MaterializedView_Create; }
#line 42573 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 11319 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_MaterializedView_Drop; }
#line 42579 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 11321 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Node; }
#line 42585 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 11322 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Node_Alter; }
#line 42591 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 11323 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Node_Create; }
#line 42597 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 11324 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Node_Drop; }
#line 42603 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 11326 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Partition; }
#line 42609 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 11327 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Partition_AddPartitions; }
#line 42615 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 11329 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Role; }
#line 42621 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 11330 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Role_Alter; }
#line 42627 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 11331 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Role_Create; }
#line 42633 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 11332 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Role_Drop; }
#line 42639 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 11333 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Role_Set; }
#line 42645 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 11335 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Schema; }
#line 42651 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 11336 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Schema_Alter; }
#line 42657 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 11337 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Schema_Create; }
#line 42663 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 11338 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Schema_Drop; }
#line 42669 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 11340 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Sequence; }
#line 42675 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 11341 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Sequence_Create; }
#line 42681 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 11342 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Sequence_Drop; }
#line 42687 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 11344 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Table; }
#line 42693 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 11345 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Table_Create; }
#line 42699 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 11346 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Table_Drop; }
#line 42705 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 11347 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Table_Truncate; }
#line 42711 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 11349 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Tablespace; }
#line 42717 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11350 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Tablespace_Alter; }
#line 42723 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11351 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Tablespace_Create; }
#line 42729 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11352 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Tablespace_Drop; }
#line 42735 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11354 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Trigger; }
#line 42741 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11355 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Trigger_Alter; }
#line 42747 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11356 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Trigger_Create; }
#line 42753 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11357 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Trigger_Drop; }
#line 42759 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11358 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Trigger_Disable; }
#line 42765 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11359 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Trigger_Enable; }
#line 42771 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11361 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Type; }
#line 42777 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11362 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Type_Alter; }
#line 42783 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11363 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Type_Create; }
#line 42789 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11364 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Type_Drop; }
#line 42795 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11366 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_User; }
#line 42801 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11367 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_User_Alter; }
#line 42807 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11368 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_User_Create; }
#line 42813 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11369 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_User_Drop; }
#line 42819 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11371 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_View; }
#line 42825 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11372 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_View_Alter; }
#line 42831 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11373 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_View_Create; }
#line 42837 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11374 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_View_Drop; }
#line 42843 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11383 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_AlterSequence; }
#line 42849 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11384 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_AlterTable; }
#line 42855 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11385 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_CommentTable; }
#line 42861 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11386 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_DeleteTable; }
#line 42867 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11387 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_GrantFunction; }
#line 42873 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11388 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_GrantSequence; }
#line 42879 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11389 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_GrantTable; }
#line 42885 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11390 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_GrantType; }
#line 42891 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11391 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_InsertTable; }
#line 42897 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11392 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_LockTable; }
#line 42903 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11393 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_SelectSequence; }
#line 42909 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11394 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_SelectTable; }
#line 42915 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11395 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_SystemAudit; }
#line 42921 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11396 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_SystemGrant; }
#line 42927 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11397 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_UpdateTable; }
#line 42933 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11406 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Alter; }
#line 42939 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11407 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Audit; }
#line 42945 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11408 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Comment; }
#line 42951 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11409 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Delete; }
#line 42957 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11410 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Grant; }
#line 42963 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11413 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Insert; }
#line 42969 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11414 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Lock; }
#line 42975 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11415 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Rename; }
#line 42981 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11416 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Select; }
#line 42987 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11417 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AuditSql_Update; }
#line 42993 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11424 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 42999 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11425 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 43005 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11429 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 43011 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11430 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 43017 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11431 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_VIEW; }
#line 43023 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 11432 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_MATVIEW; }
#line 43029 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 11435 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 43035 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 11436 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 43041 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 11441 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeString((yyvsp[0].str)));
				}
#line 43049 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 11445 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 43057 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 11449 "gram.y" /* yacc.c:1646  */
    { 
					(yyval.list) = list_make3(makeString((yyvsp[-4].str)), makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 43065 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 11453 "gram.y" /* yacc.c:1646  */
    { 
					(yyval.list) = list_make4(makeString((yyvsp[-6].str)), makeString((yyvsp[-4].str)), makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 43073 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 11457 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = NIL;
				}
#line 43081 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 11464 "gram.y" /* yacc.c:1646  */
    {
					CleanAuditStmt *n = makeNode(CleanAuditStmt);

					n->clean_type = CleanAuditType_All;
					n->user_list = NIL;
					n->object_name = NIL;
					n->object_type = 0;

					(yyval.node) = (Node *)n;
				}
#line 43096 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 11475 "gram.y" /* yacc.c:1646  */
    {
					CleanAuditStmt *n = makeNode(CleanAuditStmt);

					n->clean_type = CleanAuditType_Statement;
					n->user_list = NIL;
					n->object_name = NIL;
					n->object_type = 0;

					(yyval.node) = (Node *)n;
				}
#line 43111 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 11486 "gram.y" /* yacc.c:1646  */
    {
					CleanAuditStmt *n = makeNode(CleanAuditStmt);

					n->clean_type = CleanAuditType_User;
					n->user_list = NIL;
					n->object_name = NIL;
					n->object_type = 0;

					(yyval.node) = (Node *)n;
				}
#line 43126 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 11497 "gram.y" /* yacc.c:1646  */
    {
					CleanAuditStmt *n = makeNode(CleanAuditStmt);

					n->clean_type = CleanAuditType_ByUser;
					n->user_list = (yyvsp[0].list);
					n->object_name = NIL;
					n->object_type = 0;

					(yyval.node) = (Node *)n;
				}
#line 43141 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 11508 "gram.y" /* yacc.c:1646  */
    {
					CleanAuditStmt *n = makeNode(CleanAuditStmt);

					n->clean_type = CleanAuditType_Object;
					n->user_list = NIL;
					n->object_name = NIL;
					n->object_type = 0;

					(yyval.node) = (Node *)n;
				}
#line 43156 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 11519 "gram.y" /* yacc.c:1646  */
    {
					CleanAuditStmt *n = makeNode(CleanAuditStmt);

					n->clean_type = CleanAuditType_OnObject;
					n->user_list = NIL;
					n->object_name = (yyvsp[0].list);
					n->object_type = (yyvsp[-1].ival);

					if (n->object_name == NIL)
					{
						/* 
						 * Clean Audit ON TABLE DEFAULT
						 */
						ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("invalid clean audit statement")));
					}

					(yyval.node) = (Node *)n;
				}
#line 43181 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 11540 "gram.y" /* yacc.c:1646  */
    {
					CleanAuditStmt *n = makeNode(CleanAuditStmt);

					n->clean_type = CleanAuditType_OnObject;
					n->user_list = NIL;
					n->object_name = (yyvsp[0].list);
					n->object_type = OBJECT_TABLE;

					if (n->object_name == NIL)
					{
						n->clean_type = CleanAuditType_OnDefault;
					}

					(yyval.node) = (Node *)n;
				}
#line 43201 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 11556 "gram.y" /* yacc.c:1646  */
    {
					CleanAuditStmt *n = makeNode(CleanAuditStmt);

					n->clean_type = CleanAuditType_Unknown;
					n->user_list = NIL;
					n->object_name = NIL;
					n->object_type = 0;

					(yyval.node) = (Node *)n;
				}
#line 43216 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 11574 "gram.y" /* yacc.c:1646  */
    {
					SampleStmt *n = makeNode(SampleStmt);
					
					n->relation = (yyvsp[-3].range);
					n->rownum = (yyvsp[-1].ival);
					
					(yyval.node) = (Node *)n;
				}
#line 43229 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 11588 "gram.y" /* yacc.c:1646  */
    {
					PauseClusterStmt *n = makeNode(PauseClusterStmt);
					n->pause = true;
					(yyval.node) = (Node *)n;
				}
#line 43239 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 11594 "gram.y" /* yacc.c:1646  */
    {
					PauseClusterStmt *n = makeNode(PauseClusterStmt);
					n->pause = false;
					(yyval.node) = (Node *)n;
				}
#line 43249 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 11602 "gram.y" /* yacc.c:1646  */
    {
					BarrierStmt *n = makeNode(BarrierStmt);
					n->id = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 43259 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 11611 "gram.y" /* yacc.c:1646  */
    {
					(yyval.str) = pstrdup((yyvsp[0].str));
				}
#line 43267 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 11615 "gram.y" /* yacc.c:1646  */
    {
					(yyval.str) = NULL;
				}
#line 43275 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 11642 "gram.y" /* yacc.c:1646  */
    {
					CreateNodeStmt *n = makeNode(CreateNodeStmt);
					n->node_type = PGXC_NODE_NONE; /*default value*/
					n->node_name = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 43287 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 11650 "gram.y" /* yacc.c:1646  */
    {
					CreateNodeStmt *n = makeNode(CreateNodeStmt);
					n->node_type = PGXC_NODE_GTM;
					n->node_name = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 43299 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 11660 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43305 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 11663 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43311 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 11666 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43317 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 11670 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 43323 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 11671 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 43329 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 11692 "gram.y" /* yacc.c:1646  */
    {
					AlterNodeStmt *n = makeNode(AlterNodeStmt);
					n->node_type = PGXC_NODE_NONE; /*default value*/
					n->cluster = true;
					n->node_name = (yyvsp[-2].str);
                    n->cluster_name = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 43343 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 11702 "gram.y" /* yacc.c:1646  */
    {
					AlterNodeStmt *n = makeNode(AlterNodeStmt);
					n->node_type = PGXC_NODE_NONE; /*default value*/
					n->cluster = false;
					n->node_name = (yyvsp[-2].str);
                    n->cluster_name = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 43357 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 11712 "gram.y" /* yacc.c:1646  */
    {
					AlterNodeStmt *n = makeNode(AlterNodeStmt);
					n->node_type = PGXC_NODE_GTM;
					n->cluster = false;
					n->node_name = (yyvsp[-1].str);
                    n->cluster_name = NULL;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 43371 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 11722 "gram.y" /* yacc.c:1646  */
    {
					AlterNodeStmt *n = makeNode(AlterNodeStmt);
					n->node_type = PGXC_NODE_GTM;
					n->cluster = true;
					n->node_name = (yyvsp[-1].str);
                    n->cluster_name = NULL;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 43385 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 11741 "gram.y" /* yacc.c:1646  */
    {
					DropNodeStmt *n = makeNode(DropNodeStmt);
					n->node_name = (yyvsp[-2].str);
                    n->cluster_name = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 43397 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 11749 "gram.y" /* yacc.c:1646  */
    {
					DropNodeStmt *n = makeNode(DropNodeStmt);
					n->node_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 43407 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 11765 "gram.y" /* yacc.c:1646  */
    {
				CreateGroupStmt *n = makeNode(CreateGroupStmt);
				n->group_name = (yyvsp[-2].str);
				n->nodes = (yyvsp[0].list);
				n->default_group = 0;
				(yyval.node) = (Node *)n;
			}
#line 43419 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 11773 "gram.y" /* yacc.c:1646  */
    {
				CreateGroupStmt *n = makeNode(CreateGroupStmt);
				n->group_name = (yyvsp[-2].str);
				n->nodes = (yyvsp[0].list);
				n->default_group = 1;
				(yyval.node) = (Node *)n;
			}
#line 43431 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 11789 "gram.y" /* yacc.c:1646  */
    {
					AlterGroupStmt *n = makeNode(AlterGroupStmt);
					n->group_name = (yyvsp[-1].str);
					n->cmds = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 43442 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 11807 "gram.y" /* yacc.c:1646  */
    {
					DropGroupStmt *n = makeNode(DropGroupStmt);
					n->group_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 43452 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 11824 "gram.y" /* yacc.c:1646  */
    {
				MoveDataStmt *stmt = makeNode(MoveDataStmt);
				stmt->strategy = MOVE_DATA_STRATEGY_NODE;
				stmt->isextension = false;
				stmt->from_node = (yyvsp[-2].a_const);
				stmt->to_node = (yyvsp[0].a_const);
				stmt->shards = NIL;

				stmt->num_shard = 0;
				stmt->arr_shard = NULL;
				stmt->fromid = 0;
				stmt->toid = 0;
				stmt->split_point = -1;
				stmt->group		  = makeString((yyvsp[-5].str));
				(yyval.node) = (Node *)stmt;
			}
#line 43473 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 11841 "gram.y" /* yacc.c:1646  */
    {
				MoveDataStmt *stmt = makeNode(MoveDataStmt);
				stmt->strategy = MOVE_DATA_STRATEGY_SHARD;
				stmt->isextension = false;
				stmt->from_node = (yyvsp[-6].a_const);
				stmt->to_node = (yyvsp[-4].a_const);
				stmt->shards = (yyvsp[-1].list);

				stmt->num_shard = 0;
				stmt->arr_shard = NULL;
				stmt->fromid = 0;
				stmt->toid = 0;
				stmt->split_point = -1;
				stmt->group		  = makeString((yyvsp[-9].str));
				(yyval.node) = (Node *)stmt;
			}
#line 43494 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 11858 "gram.y" /* yacc.c:1646  */
    {
				MoveDataStmt *stmt = makeNode(MoveDataStmt);
				stmt->strategy = MOVE_DATA_STRATEGY_AT;
				stmt->isextension = false;
				stmt->from_node = (yyvsp[-4].a_const);
				stmt->to_node = (yyvsp[-2].a_const);
				stmt->split_point = (yyvsp[0].ival);
				
				stmt->shards = NIL;
				stmt->num_shard = 0;
				stmt->arr_shard = NULL;
				stmt->fromid = 0;
				stmt->toid = 0;
				stmt->group		  = makeString((yyvsp[-7].str));
				(yyval.node) = (Node *)stmt;
			}
#line 43515 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 11875 "gram.y" /* yacc.c:1646  */
    {
				MoveDataStmt *stmt = makeNode(MoveDataStmt);
				stmt->strategy = MOVE_DATA_STRATEGY_SHARD;
				stmt->isextension = true;
				stmt->from_node = (yyvsp[-6].a_const);
				stmt->to_node = (yyvsp[-4].a_const);
				stmt->shards = (yyvsp[-1].list);

				stmt->num_shard = 0;
				stmt->arr_shard = NULL;
				stmt->fromid = 0;
				stmt->toid = 0;
				stmt->split_point = -1;
				stmt->group		  = makeString((yyvsp[-9].str));
				(yyval.node) = (Node *)stmt;
			}
#line 43536 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 11894 "gram.y" /* yacc.c:1646  */
    { (yyval.a_const) = (A_Const *)makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 43542 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 11895 "gram.y" /* yacc.c:1646  */
    { (yyval.a_const) = (A_Const *)makeIntConst((yyvsp[-1].ival), (yylsp[-1])); }
#line 43548 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 11900 "gram.y" /* yacc.c:1646  */
    { 
					(yyval.list) = list_make1(makeIntConst((yyvsp[0].ival), (yylsp[0]))); 
				}
#line 43556 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 11904 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list),makeIntConst((yyvsp[0].ival), (yylsp[0])));
				}
#line 43564 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 11918 "gram.y" /* yacc.c:1646  */
    {
				CreateShardStmt *stmt = makeNode(CreateShardStmt);
				stmt->isExtended  = false;
				stmt->isnull = false;				
				stmt->idx_of_node = (yyvsp[-2].ival);
				stmt->num_of_node = (yyvsp[0].ival);
				stmt->members     = NULL;
				(yyval.node) = (Node *)stmt;
			}
#line 43578 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 11928 "gram.y" /* yacc.c:1646  */
    {
				CreateShardStmt *stmt = makeNode(CreateShardStmt);
				stmt->isExtended  = true;
				stmt->isnull = false;
				stmt->idx_of_node = (yyvsp[-2].ival);				
				stmt->num_of_node = (yyvsp[0].ival);
				stmt->members     = NULL;
				(yyval.node) = (Node *)stmt;
			}
#line 43592 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 11938 "gram.y" /* yacc.c:1646  */
    {
				CreateShardStmt *stmt = makeNode(CreateShardStmt);
				stmt->isnull = true;
				stmt->isExtended  = false;
				stmt->num_of_node = -1;
				stmt->idx_of_node = -1;
				stmt->members     = list_make1(makeString((yyvsp[0].str)));
				(yyval.node) = (Node *)stmt;
			}
#line 43606 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 11948 "gram.y" /* yacc.c:1646  */
    {
				CreateShardStmt *stmt = makeNode(CreateShardStmt);
				stmt->isnull = true;
				stmt->isExtended  = true;
				stmt->num_of_node = -1;
				stmt->idx_of_node = -1;
				stmt->members     = list_make1(makeString((yyvsp[0].str)));
				(yyval.node) = (Node *)stmt;
			}
#line 43620 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 11967 "gram.y" /* yacc.c:1646  */
    {
				DropShardStmt *stmt = makeNode(DropShardStmt);				
				stmt->group_name     = (yyvsp[0].str);
				(yyval.node) = (Node *)stmt;
			}
#line 43630 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 11981 "gram.y" /* yacc.c:1646  */
    {
				CleanShardingStmt *stmt = makeNode(CleanShardingStmt);
				stmt->group_name = NULL;
				(yyval.node) = (Node *)stmt;
			}
#line 43640 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 11987 "gram.y" /* yacc.c:1646  */
    {
				CleanShardingStmt *stmt = makeNode(CleanShardingStmt);
				stmt->group_name = (yyvsp[-4].str);
				stmt->dn_from = (yyvsp[-2].str);
				stmt->dn_to = (yyvsp[0].str);
				(yyval.node) = (Node *)stmt;
			}
#line 43652 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 12004 "gram.y" /* yacc.c:1646  */
    {
				CreateKeyValuesStmt *stmt = makeNode(CreateKeyValuesStmt);
				stmt->valuesLists  = (yyvsp[-6].list);
				stmt->relinfo	   = (yyvsp[-3].list);				
				stmt->group 	   = (yyvsp[0].str);	
				stmt->coldgroup    = NULL;
				if (list_length(stmt->valuesLists) > 256)
				{
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("value list too long")));
				}
				(yyval.node) = (Node *)stmt;
			}
#line 43671 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 12019 "gram.y" /* yacc.c:1646  */
    {
				CreateKeyValuesStmt *stmt = makeNode(CreateKeyValuesStmt);
				stmt->valuesLists  = (yyvsp[-7].list);
				stmt->relinfo	   = (yyvsp[-4].list);				
				stmt->group 	   = (yyvsp[-1].str);	
				stmt->coldgroup    = (yyvsp[0].str);	
				if (list_length(stmt->valuesLists) > 256)
				{
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("value list too long")));
				}
				(yyval.node) = (Node *)stmt;
			}
#line 43690 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 12037 "gram.y" /* yacc.c:1646  */
    { 
					(yyval.list) = list_make1((yyvsp[0].str)); 
				}
#line 43698 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 12041 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].str));
				}
#line 43706 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 12056 "gram.y" /* yacc.c:1646  */
    {
					CheckOverLapStmt *n = makeNode(CheckOverLapStmt);
					n->first  = (yyvsp[-2].list);
					n->second = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 43717 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 12063 "gram.y" /* yacc.c:1646  */
    {
					CheckOverLapStmt *n = makeNode(CheckOverLapStmt);
					n->first  = (yyvsp[0].list);
					n->second = NULL;
					(yyval.node) = (Node *)n;
				}
#line 43728 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 12082 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 43739 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 12089 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 43753 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 12099 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 43764 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 12106 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 43775 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 12128 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 43783 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 12132 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 43791 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 12139 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 43799 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 12145 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43805 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 12146 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 43811 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 12150 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 43817 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 12151 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 43823 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 12152 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43829 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 12163 "gram.y" /* yacc.c:1646  */
    {
					ExecDirectStmt *n = makeNode(ExecDirectStmt);
					n->node_names = (yyvsp[-1].list);
					n->query = (yyvsp[0].str);
					(yyval.node) = (Node *)n;

					if (!superuser() && !mls_user())
						ereport(ERROR,
						       (errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
						        errmsg("must be superuser to use EXECUTE DIRECT")));
				}
#line 43845 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 12191 "gram.y" /* yacc.c:1646  */
    {
					CleanConnStmt *n = makeNode(CleanConnStmt);
					n->is_coord = true;
					n->nodes = (yyvsp[-2].list);
					n->is_force = false;
					n->dbname = (yyvsp[-1].str);
					n->username = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 43859 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 12201 "gram.y" /* yacc.c:1646  */
    {
					CleanConnStmt *n = makeNode(CleanConnStmt);
					n->is_coord = false;
					n->nodes = (yyvsp[-2].list);
					n->is_force = false;
					n->dbname = (yyvsp[-1].str);
					n->username = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 43873 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 12211 "gram.y" /* yacc.c:1646  */
    {
					CleanConnStmt *n = makeNode(CleanConnStmt);
					n->is_coord = true;
					n->nodes = NIL;
					n->is_force = (yyvsp[-2].boolean);
					n->dbname = (yyvsp[-1].str);
					n->username = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 43887 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 12222 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43893 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 12223 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43899 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 12224 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 43905 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 12227 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43911 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 12228 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43917 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 12229 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 43923 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 12232 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 43929 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 12233 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 43935 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 12246 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 43947 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 12255 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43953 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 12256 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43959 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12274 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43970 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12282 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
#ifdef PGXC
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE TABLE AS EXECUTE not yet supported")));
#endif
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 43994 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12303 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 44000 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12304 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44006 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12315 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 44016 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12321 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 44026 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12327 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 44036 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12333 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 44046 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12350 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 44058 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12367 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 44066 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12371 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 44075 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12379 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 44085 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12385 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 44096 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12392 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 44106 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12398 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 44117 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12405 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 44127 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12413 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 44133 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12414 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 44139 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12419 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 44145 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12421 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 44151 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12426 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 44163 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12437 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 44176 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12447 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 44189 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12456 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 44197 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12463 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 44209 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12472 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 44221 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12480 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 44229 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12486 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44235 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12487 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44241 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12500 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 44255 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12512 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44261 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12513 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44267 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12525 "gram.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 44280 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12535 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 44286 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12536 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 44292 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12539 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 44298 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12540 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 44304 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12541 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 44310 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12542 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 44316 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12543 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 44322 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 12544 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 44328 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 12545 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 44334 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12546 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 44340 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12549 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 44346 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12550 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 44352 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12554 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 44358 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12555 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 44364 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12556 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 44370 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 12566 "gram.y" /* yacc.c:1646  */
    {
					LockNodeStmt *n = makeNode(LockNodeStmt);
					n->lock = true;
					n->params = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44381 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 12573 "gram.y" /* yacc.c:1646  */
    {
					LockNodeStmt *n = makeNode(LockNodeStmt);
					n->lock = false;
					n->params = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44392 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 12581 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44398 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 12583 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 44404 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 12586 "gram.y" /* yacc.c:1646  */
    {(yyval.node) = (Node *)makeInteger((yyvsp[0].ival)); }
#line 44410 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 12588 "gram.y" /* yacc.c:1646  */
    {(yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 44416 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 12603 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 44431 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 12616 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44437 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 12617 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 44443 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 12622 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 44452 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 12627 "gram.y" /* yacc.c:1646  */
    {
					int ncolumns = list_length((yyvsp[-3].list));
					int i = 1;
					ListCell *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 44477 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 12651 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 44489 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 12661 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 44495 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 12662 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 44501 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 12673 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 44514 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 12683 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 44520 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 12686 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44526 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 12687 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 44532 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 12688 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 44538 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 12689 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 44544 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 12690 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 44550 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 12693 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44556 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 12694 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 44562 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 12695 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44568 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 12748 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 44574 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 12749 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 44580 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 12764 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44586 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 12766 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 44597 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 12773 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44609 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 12781 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44621 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 12789 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 44633 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 12797 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 44645 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 12805 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44657 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 12813 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44669 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 12823 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44675 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 12824 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44681 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 12854 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 44697 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 12868 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 44714 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 12880 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44720 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 12882 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 44743 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 12901 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44751 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 12905 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44759 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 12909 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44767 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 12926 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 44778 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 12933 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 44789 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 12940 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 44800 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 12949 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44806 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 12950 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 44812 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 12954 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-6].str);
				n->aliascolnames = (yyvsp[-5].list);
				n->ctematerialized = (yyvsp[-3].ival);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 44826 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 12966 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 44832 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 12967 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 44838 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 12968 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 44844 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 12972 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 44850 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 12973 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 44856 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 12978 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 44871 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 12989 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 44877 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 12998 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44886 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 13003 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44895 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 13008 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44904 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 13013 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44913 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 13018 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44925 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 13026 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44937 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 13034 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 44946 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 13039 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 44955 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 13044 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 44964 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 13050 "gram.y" /* yacc.c:1646  */
    {}
#line 44970 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 13051 "gram.y" /* yacc.c:1646  */
    {}
#line 44976 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 13055 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 44982 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 13056 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 44988 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 13057 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 44994 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 13064 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 45000 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 13065 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45006 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 13069 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL;}
#line 45012 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 13070 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45018 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 13074 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list);}
#line 45024 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 13075 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45030 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 13079 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45036 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 13083 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 45042 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 13084 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 45048 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 13088 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 45061 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 13097 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 45074 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 13109 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-1].node)); }
#line 45080 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 13110 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node)); }
#line 45086 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 13111 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[0].node)); }
#line 45092 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 13112 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), NULL); }
#line 45098 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 13116 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45104 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 13117 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL,NULL); }
#line 45110 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 13122 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45116 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 13124 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 45129 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 13134 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 45135 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 13139 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45141 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 13142 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 45147 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 13146 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45153 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 13148 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 45162 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 13155 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45168 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 13165 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0])); }
#line 45174 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 13166 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 45180 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 13167 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(1, -1); }
#line 45186 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 13175 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45192 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 13179 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45198 "gram.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 13180 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45204 "gram.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 13183 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45210 "gram.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 13184 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45216 "gram.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 13209 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45222 "gram.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 13210 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45228 "gram.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 13214 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45234 "gram.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 13215 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 45240 "gram.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 13219 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45246 "gram.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 13220 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45252 "gram.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 13221 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45258 "gram.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 13222 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45264 "gram.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 13223 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45270 "gram.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 13228 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 45278 "gram.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 13241 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45286 "gram.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 13248 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45294 "gram.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 13255 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 45302 "gram.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 13261 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45308 "gram.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 13262 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45314 "gram.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 13266 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45320 "gram.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 13267 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45326 "gram.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 13271 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45332 "gram.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 13272 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45338 "gram.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 13276 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45344 "gram.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 13277 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 45350 "gram.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 13282 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 45362 "gram.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 13292 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 45368 "gram.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 13293 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 45374 "gram.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 13294 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 45380 "gram.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 13295 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 45386 "gram.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 13299 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45392 "gram.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 13300 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45398 "gram.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 13311 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 45408 "gram.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 13317 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 45418 "gram.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 13334 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45424 "gram.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 13335 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45430 "gram.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 13339 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45436 "gram.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 13340 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45442 "gram.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 13347 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 45451 "gram.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 13352 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);
					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 45463 "gram.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 13360 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 45474 "gram.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 13367 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 45486 "gram.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 13375 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45496 "gram.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 13381 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45507 "gram.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 13388 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
#ifdef _PG_ORCL_
					if (0 && (yyvsp[0].alias) == NULL)
#else
					if ((yyvsp[0].alias) == NULL)
#endif
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
#ifdef _PG_ORCL_
					if (n->alias == NULL)
					{
						n->alias = makeAnonymousAlias((yylsp[-1]));
					}
#endif
					(yyval.node) = (Node *) n;
				}
#line 45556 "gram.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 13433 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
#ifdef _PG_ORCL_
					if (0 && (yyvsp[0].alias) == NULL)
#else
					if ((yyvsp[0].alias) == NULL)
#endif
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
#ifdef _PG_ORCL_
					if (n->alias == NULL)
					{
						n->alias = makeAnonymousAlias((yylsp[-1]));
					}
#endif
					(yyval.node) = (Node *) n;
				}
#line 45595 "gram.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 13468 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 45603 "gram.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 13472 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 45612 "gram.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 13498 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 45620 "gram.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 13502 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 45636 "gram.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 13514 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 45653 "gram.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 13527 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 45671 "gram.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 13541 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 45686 "gram.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 13552 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 45702 "gram.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 13567 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 45712 "gram.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 13573 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 45721 "gram.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 13578 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 45731 "gram.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 13584 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 45740 "gram.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 13590 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 45746 "gram.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 13591 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 45752 "gram.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 13600 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 45760 "gram.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 13604 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 45768 "gram.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 13608 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 45778 "gram.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 13614 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 45788 "gram.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 13620 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 45796 "gram.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 13625 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 45802 "gram.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 13626 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 45808 "gram.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 13627 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 45814 "gram.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 13628 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 45820 "gram.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 13632 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45826 "gram.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 13633 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45832 "gram.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 13645 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 45838 "gram.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 13646 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45844 "gram.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 13652 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;

					(yyval.range)->partitionvalue = (yyvsp[0].partfor);
					if((yyval.range)->partitionvalue)
						(yyval.range)->intervalparent = true;
					else
						(yyval.range)->intervalparent = false;
				}
#line 45861 "gram.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 13665 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;

					(yyval.range)->intervalparent = false;
					(yyval.range)->partitionvalue = NULL;
				}
#line 45875 "gram.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 13675 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;

					(yyval.range)->partitionvalue = (yyvsp[0].partfor);
					if((yyval.range)->partitionvalue)
						(yyval.range)->intervalparent = true;
					else
						(yyval.range)->intervalparent = false;
				}
#line 45892 "gram.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 13688 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-2].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
					
					(yyval.range)->partitionvalue = (yyvsp[0].partfor);
					if((yyval.range)->partitionvalue)
						(yyval.range)->intervalparent = true;
					else
						(yyval.range)->intervalparent = false;
				}
#line 45909 "gram.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 13704 "gram.y" /* yacc.c:1646  */
    { (yyval.partfor) = (yyvsp[0].partfor); }
#line 45915 "gram.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 13705 "gram.y" /* yacc.c:1646  */
    { (yyval.partfor) = NULL; }
#line 45921 "gram.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 13709 "gram.y" /* yacc.c:1646  */
    {
				PartitionForExpr * expr = makeNode(PartitionForExpr);
				expr->isdefault = false;
				expr->router_src = (yyvsp[-1].node);

				(yyval.partfor) = (PartitionForExpr*)expr;		
			}
#line 45933 "gram.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 13717 "gram.y" /* yacc.c:1646  */
    {
				PartitionForExpr * expr = makeNode(PartitionForExpr);
				expr->isdefault = true;
				expr->router_src = NULL;

				(yyval.partfor) = (PartitionForExpr*)expr;
			}
#line 45945 "gram.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 13728 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 45951 "gram.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 13729 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 45957 "gram.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 13743 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45965 "gram.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 13747 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 45976 "gram.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 13754 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 45987 "gram.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 13767 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);
					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 46001 "gram.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 13779 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 46007 "gram.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 13780 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46013 "gram.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 13796 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 46027 "gram.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 13806 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 46041 "gram.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 13818 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 46047 "gram.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 13822 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 46053 "gram.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 13823 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 46059 "gram.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 13826 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46065 "gram.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 13827 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46071 "gram.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 13830 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 46077 "gram.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 13831 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46083 "gram.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 13836 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46089 "gram.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 13837 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46095 "gram.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 13842 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46101 "gram.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 13844 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 46113 "gram.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 13851 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46119 "gram.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 13856 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46125 "gram.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 13857 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46131 "gram.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 13862 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 46139 "gram.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 13866 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 46147 "gram.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 13872 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->is_from_parent = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 46170 "gram.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 13897 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 46184 "gram.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 13908 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *)n;
				}
#line 46198 "gram.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 13919 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46204 "gram.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 13920 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46210 "gram.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 13925 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 46228 "gram.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 13939 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);
					ListCell		   *option;
					bool				nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = intVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 46289 "gram.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 13996 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 46304 "gram.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 14010 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 46310 "gram.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 14012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 46316 "gram.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 14017 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 46322 "gram.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 14019 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 46328 "gram.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 14021 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(true), (yylsp[-1])); }
#line 46334 "gram.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 14023 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(false), (yylsp[0])); }
#line 46340 "gram.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 14028 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 46346 "gram.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 14030 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 46352 "gram.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 14035 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 46364 "gram.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 14043 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 46376 "gram.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 14063 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 46385 "gram.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 14068 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = TRUE;
				}
#line 46395 "gram.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 14075 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 46404 "gram.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 14080 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = TRUE;
				}
#line 46414 "gram.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 14086 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 46423 "gram.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 14091 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
#line 46433 "gram.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 14100 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 46439 "gram.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 14102 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 46445 "gram.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 14104 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 46451 "gram.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 14108 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46457 "gram.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 14109 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46463 "gram.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 14110 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46469 "gram.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 14111 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46475 "gram.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 14112 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46481 "gram.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 14114 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 46490 "gram.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 14119 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 46500 "gram.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 14138 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46506 "gram.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 14139 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46512 "gram.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 14140 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46518 "gram.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 14141 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46524 "gram.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 14153 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46534 "gram.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 14159 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 46544 "gram.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 14166 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46550 "gram.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 14167 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46556 "gram.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 14174 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46565 "gram.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 14179 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46574 "gram.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 14184 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46583 "gram.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 14189 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46592 "gram.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 14194 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46601 "gram.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 14200 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46610 "gram.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 14206 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46619 "gram.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 14211 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46628 "gram.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 14217 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46637 "gram.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 14223 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46647 "gram.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 14229 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46657 "gram.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 14235 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46667 "gram.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 14242 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46677 "gram.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 14249 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46686 "gram.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 14256 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 46711 "gram.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 14277 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 46719 "gram.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 14287 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46727 "gram.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 14291 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46735 "gram.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 14299 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46743 "gram.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 14303 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 46752 "gram.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 14311 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46765 "gram.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 14323 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46783 "gram.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 14344 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46791 "gram.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 14348 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46799 "gram.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 14354 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46807 "gram.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 14358 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 46822 "gram.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 14371 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 46832 "gram.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 14379 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46844 "gram.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 14389 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46850 "gram.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 14391 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46856 "gram.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 14393 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 46862 "gram.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 14395 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46868 "gram.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 14397 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46874 "gram.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 14399 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46880 "gram.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 14403 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 46886 "gram.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 14404 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 46892 "gram.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 14412 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46905 "gram.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 14421 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46917 "gram.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 14429 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46930 "gram.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 14438 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46942 "gram.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 14449 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46951 "gram.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 14456 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 46957 "gram.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 14457 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 46963 "gram.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 14458 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 46969 "gram.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 14463 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 46975 "gram.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 14465 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 46981 "gram.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 14467 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 46987 "gram.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 14469 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 46993 "gram.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 14471 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 46999 "gram.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 14473 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47005 "gram.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 14475 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 47014 "gram.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 14480 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 47023 "gram.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 14485 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 47033 "gram.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 14491 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 47045 "gram.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 14499 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 47054 "gram.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 14504 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 47065 "gram.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 14511 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 47075 "gram.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 14517 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47081 "gram.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 14522 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 47089 "gram.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 14526 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 47098 "gram.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 14561 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47104 "gram.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 14563 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 47110 "gram.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 14565 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47122 "gram.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 14573 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   (yylsp[-3]));
				}
#line 47132 "gram.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 14588 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47138 "gram.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 14590 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 47144 "gram.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 14592 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47150 "gram.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 14594 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47156 "gram.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 14596 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47162 "gram.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 14598 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47168 "gram.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 14600 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47174 "gram.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 14602 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47180 "gram.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 14604 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47186 "gram.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 14606 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47192 "gram.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 14608 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47198 "gram.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 14610 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47204 "gram.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 14612 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47210 "gram.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 14614 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47216 "gram.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 14617 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47222 "gram.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 14619 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47228 "gram.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 14621 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 47234 "gram.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 14624 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47240 "gram.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 14626 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47246 "gram.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 14628 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 47252 "gram.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 14630 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 47258 "gram.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 14633 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 47267 "gram.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 14638 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 47279 "gram.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 14646 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 47288 "gram.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 14651 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47300 "gram.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 14659 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 47309 "gram.c" /* yacc.c:1646  */
    break;

  case 2203:
#line 14664 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 47321 "gram.c" /* yacc.c:1646  */
    break;

  case 2204:
#line 14672 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 47330 "gram.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 14677 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47342 "gram.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 14686 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 47354 "gram.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 14694 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47366 "gram.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 14702 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 47378 "gram.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 14710 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 47390 "gram.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 14728 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 47402 "gram.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 14736 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 47414 "gram.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 14744 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 47426 "gram.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 14752 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 47438 "gram.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 14760 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   (yylsp[-1]));
				}
#line 47458 "gram.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 14776 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 47470 "gram.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 14784 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 47482 "gram.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 14792 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 47494 "gram.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 14800 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 47506 "gram.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 14808 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 47518 "gram.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 14816 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 47530 "gram.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 14824 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 47538 "gram.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 14828 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 47546 "gram.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 14832 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 47554 "gram.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 14836 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 47562 "gram.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 14840 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 47574 "gram.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 14848 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 47586 "gram.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 14856 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 47598 "gram.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 14864 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 47610 "gram.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 14872 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 47634 "gram.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 14892 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 47660 "gram.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 14914 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 47675 "gram.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 14925 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 47686 "gram.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 14932 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 47706 "gram.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 14948 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 47715 "gram.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 14953 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47725 "gram.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 14959 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);
					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 47743 "gram.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 14984 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47749 "gram.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 14986 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 47755 "gram.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 14988 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47761 "gram.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 14990 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 47767 "gram.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 14992 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47773 "gram.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 14994 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47779 "gram.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 14996 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47785 "gram.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 14998 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47791 "gram.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 15000 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47797 "gram.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 15002 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47803 "gram.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 15004 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47809 "gram.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 15006 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47815 "gram.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 15008 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47821 "gram.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 15010 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47827 "gram.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 15012 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47833 "gram.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 15014 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47839 "gram.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 15016 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47845 "gram.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 15018 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47851 "gram.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 15020 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 47857 "gram.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 15022 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 47865 "gram.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 15026 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 47873 "gram.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 15030 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 47881 "gram.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 15034 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 47889 "gram.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 15038 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 47898 "gram.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 15043 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47908 "gram.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 15058 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47914 "gram.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 15059 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47920 "gram.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 15061 "gram.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 47939 "gram.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 15076 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else if (operator_precedence_warning)
					{
						/*
						 * If precedence warnings are enabled, insert
						 * AEXPR_PAREN nodes wrapping all explicitly
						 * parenthesized subexpressions; this prevents bogus
						 * warnings from being issued when the ordering has
						 * been forced by parentheses.  Take care that an
						 * AEXPR_PAREN node has the same exprLocation as its
						 * child, so as not to cause surprising changes in
						 * error cursor positioning.
						 *
						 * In principle we should not be relying on a GUC to
						 * decide whether to insert AEXPR_PAREN nodes.
						 * However, since they have no effect except to
						 * suppress warnings, it's probably safe enough; and
						 * we'd just as soon not waste cycles on dummy parse
						 * nodes if we don't have to.
						 */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_PAREN, NIL, (yyvsp[-2].node), NULL,
												 exprLocation((yyvsp[-2].node)));
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 47977 "gram.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 15110 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47983 "gram.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 15112 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47989 "gram.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 15114 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 48004 "gram.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 15125 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 48032 "gram.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 15149 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 48047 "gram.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 15160 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 48062 "gram.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 15171 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 48073 "gram.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 15178 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 48087 "gram.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 15188 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 48101 "gram.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 15198 "gram.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);
				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *)g;
			  }
#line 48112 "gram.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 15207 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL, (yylsp[-2]));
				}
#line 48120 "gram.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 15211 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list), (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 48130 "gram.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 15217 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)), (yylsp[-5]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 48141 "gram.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 15224 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)), (yylsp[-7]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 48152 "gram.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 15231 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
#line 48166 "gram.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 15241 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 48177 "gram.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 15248 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL, (yylsp[-3]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 48197 "gram.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 15276 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 48236 "gram.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 15311 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48242 "gram.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 15321 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48248 "gram.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 15322 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48254 "gram.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 15330 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   (yylsp[-4]));
				}
#line 48264 "gram.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 15336 "gram.y" /* yacc.c:1646  */
    {
/* ORACLE_BEGIN */
					if (enable_oracle_compatible)
					{
						(yyval.node) = (Node *) makeFuncCall(OracleFuncName("orcl_current_date"), NIL, (yylsp[0]));
					}
					else
					{
						(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
					}
/* ORACLE_END */
				}
#line 48281 "gram.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 15349 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 48289 "gram.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 15353 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48297 "gram.c" /* yacc.c:1646  */
    break;

  case 2291:
#line 15357 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 48305 "gram.c" /* yacc.c:1646  */
    break;

  case 2292:
#line 15361 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48313 "gram.c" /* yacc.c:1646  */
    break;

  case 2293:
#line 15365 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 48321 "gram.c" /* yacc.c:1646  */
    break;

  case 2294:
#line 15369 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48329 "gram.c" /* yacc.c:1646  */
    break;

  case 2295:
#line 15373 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 48337 "gram.c" /* yacc.c:1646  */
    break;

  case 2296:
#line 15377 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48345 "gram.c" /* yacc.c:1646  */
    break;

  case 2297:
#line 15382 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(OracleFuncName("orcl_sysdate"), NIL, (yylsp[0]));
				}
#line 48353 "gram.c" /* yacc.c:1646  */
    break;

  case 2298:
#line 15386 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(OracleFuncName("orcl_systimestamp"), NIL, (yylsp[0]));
				}
#line 48361 "gram.c" /* yacc.c:1646  */
    break;

  case 2299:
#line 15391 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 48369 "gram.c" /* yacc.c:1646  */
    break;

  case 2300:
#line 15395 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 48377 "gram.c" /* yacc.c:1646  */
    break;

  case 2301:
#line 15399 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 48385 "gram.c" /* yacc.c:1646  */
    break;

  case 2302:
#line 15404 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(OracleFuncName("sessiontimezone"), NIL, (yylsp[0]));
				}
#line 48393 "gram.c" /* yacc.c:1646  */
    break;

  case 2303:
#line 15408 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(OracleFuncName("dbtimezone"), NIL, (yylsp[0]));
				}
#line 48401 "gram.c" /* yacc.c:1646  */
    break;

  case 2304:
#line 15413 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 48409 "gram.c" /* yacc.c:1646  */
    break;

  case 2305:
#line 15417 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 48417 "gram.c" /* yacc.c:1646  */
    break;

  case 2306:
#line 15421 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 48425 "gram.c" /* yacc.c:1646  */
    break;

  case 2307:
#line 15425 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 48431 "gram.c" /* yacc.c:1646  */
    break;

  case 2308:
#line 15427 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 48439 "gram.c" /* yacc.c:1646  */
    break;

  case 2309:
#line 15431 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 48452 "gram.c" /* yacc.c:1646  */
    break;

  case 2310:
#line 15440 "gram.y" /* yacc.c:1646  */
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 48461 "gram.c" /* yacc.c:1646  */
    break;

  case 2311:
#line 15445 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 48472 "gram.c" /* yacc.c:1646  */
    break;

  case 2312:
#line 15452 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str),
												list_make1((yyvsp[-3].node)),
												(yylsp[-5]));
				}
#line 48491 "gram.c" /* yacc.c:1646  */
    break;

  case 2313:
#line 15467 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 48502 "gram.c" /* yacc.c:1646  */
    break;

  case 2314:
#line 15474 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 48510 "gram.c" /* yacc.c:1646  */
    break;

  case 2315:
#line 15478 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 48518 "gram.c" /* yacc.c:1646  */
    break;

  case 2316:
#line 15482 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 48526 "gram.c" /* yacc.c:1646  */
    break;

  case 2317:
#line 15486 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 48534 "gram.c" /* yacc.c:1646  */
    break;

  case 2318:
#line 15490 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 48545 "gram.c" /* yacc.c:1646  */
    break;

  case 2319:
#line 15497 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 48557 "gram.c" /* yacc.c:1646  */
    break;

  case 2320:
#line 15505 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 48569 "gram.c" /* yacc.c:1646  */
    break;

  case 2321:
#line 15513 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 48577 "gram.c" /* yacc.c:1646  */
    break;

  case 2322:
#line 15517 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 48585 "gram.c" /* yacc.c:1646  */
    break;

  case 2323:
#line 15521 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 48593 "gram.c" /* yacc.c:1646  */
    break;

  case 2324:
#line 15525 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 48601 "gram.c" /* yacc.c:1646  */
    break;

  case 2325:
#line 15529 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 48609 "gram.c" /* yacc.c:1646  */
    break;

  case 2326:
#line 15533 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-4]));
				}
#line 48619 "gram.c" /* yacc.c:1646  */
    break;

  case 2327:
#line 15539 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 48627 "gram.c" /* yacc.c:1646  */
    break;

  case 2328:
#line 15543 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 48640 "gram.c" /* yacc.c:1646  */
    break;

  case 2329:
#line 15552 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 48648 "gram.c" /* yacc.c:1646  */
    break;

  case 2330:
#line 15556 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 48656 "gram.c" /* yacc.c:1646  */
    break;

  case 2331:
#line 15560 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 48665 "gram.c" /* yacc.c:1646  */
    break;

  case 2332:
#line 15565 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 48678 "gram.c" /* yacc.c:1646  */
    break;

  case 2333:
#line 15579 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48684 "gram.c" /* yacc.c:1646  */
    break;

  case 2334:
#line 15581 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 48690 "gram.c" /* yacc.c:1646  */
    break;

  case 2335:
#line 15585 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 48696 "gram.c" /* yacc.c:1646  */
    break;

  case 2336:
#line 15587 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 48702 "gram.c" /* yacc.c:1646  */
    break;

  case 2337:
#line 15589 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 48708 "gram.c" /* yacc.c:1646  */
    break;

  case 2338:
#line 15591 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 48714 "gram.c" /* yacc.c:1646  */
    break;

  case 2339:
#line 15594 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48720 "gram.c" /* yacc.c:1646  */
    break;

  case 2340:
#line 15597 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 48726 "gram.c" /* yacc.c:1646  */
    break;

  case 2341:
#line 15598 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 48732 "gram.c" /* yacc.c:1646  */
    break;

  case 2342:
#line 15602 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 48744 "gram.c" /* yacc.c:1646  */
    break;

  case 2343:
#line 15610 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 48756 "gram.c" /* yacc.c:1646  */
    break;

  case 2344:
#line 15619 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 48762 "gram.c" /* yacc.c:1646  */
    break;

  case 2345:
#line 15620 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 48768 "gram.c" /* yacc.c:1646  */
    break;

  case 2346:
#line 15623 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 48774 "gram.c" /* yacc.c:1646  */
    break;

  case 2347:
#line 15624 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 48780 "gram.c" /* yacc.c:1646  */
    break;

  case 2348:
#line 15625 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 48786 "gram.c" /* yacc.c:1646  */
    break;

  case 2349:
#line 15631 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 48794 "gram.c" /* yacc.c:1646  */
    break;

  case 2350:
#line 15635 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 48802 "gram.c" /* yacc.c:1646  */
    break;

  case 2351:
#line 15639 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 48810 "gram.c" /* yacc.c:1646  */
    break;

  case 2352:
#line 15643 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 48818 "gram.c" /* yacc.c:1646  */
    break;

  case 2353:
#line 15653 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48824 "gram.c" /* yacc.c:1646  */
    break;

  case 2354:
#line 15654 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48830 "gram.c" /* yacc.c:1646  */
    break;

  case 2355:
#line 15658 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 48836 "gram.c" /* yacc.c:1646  */
    break;

  case 2356:
#line 15659 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48842 "gram.c" /* yacc.c:1646  */
    break;

  case 2357:
#line 15667 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48848 "gram.c" /* yacc.c:1646  */
    break;

  case 2358:
#line 15668 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48854 "gram.c" /* yacc.c:1646  */
    break;

  case 2359:
#line 15672 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 48860 "gram.c" /* yacc.c:1646  */
    break;

  case 2360:
#line 15674 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 48866 "gram.c" /* yacc.c:1646  */
    break;

  case 2361:
#line 15679 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 48876 "gram.c" /* yacc.c:1646  */
    break;

  case 2362:
#line 15687 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 48882 "gram.c" /* yacc.c:1646  */
    break;

  case 2363:
#line 15689 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 48899 "gram.c" /* yacc.c:1646  */
    break;

  case 2364:
#line 15702 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 48905 "gram.c" /* yacc.c:1646  */
    break;

  case 2365:
#line 15707 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 48923 "gram.c" /* yacc.c:1646  */
    break;

  case 2366:
#line 15732 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48929 "gram.c" /* yacc.c:1646  */
    break;

  case 2367:
#line 15733 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 48935 "gram.c" /* yacc.c:1646  */
    break;

  case 2368:
#line 15736 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48941 "gram.c" /* yacc.c:1646  */
    break;

  case 2369:
#line 15737 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48947 "gram.c" /* yacc.c:1646  */
    break;

  case 2370:
#line 15749 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					(yyval.windef) = n;
				}
#line 48969 "gram.c" /* yacc.c:1646  */
    break;

  case 2371:
#line 15767 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
#line 48979 "gram.c" /* yacc.c:1646  */
    break;

  case 2372:
#line 15773 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48991 "gram.c" /* yacc.c:1646  */
    break;

  case 2373:
#line 15783 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 49012 "gram.c" /* yacc.c:1646  */
    break;

  case 2374:
#line 15800 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 49053 "gram.c" /* yacc.c:1646  */
    break;

  case 2375:
#line 15845 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49065 "gram.c" /* yacc.c:1646  */
    break;

  case 2376:
#line 15853 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49077 "gram.c" /* yacc.c:1646  */
    break;

  case 2377:
#line 15861 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49089 "gram.c" /* yacc.c:1646  */
    break;

  case 2378:
#line 15869 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49101 "gram.c" /* yacc.c:1646  */
    break;

  case 2379:
#line 15877 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49113 "gram.c" /* yacc.c:1646  */
    break;

  case 2380:
#line 15897 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49119 "gram.c" /* yacc.c:1646  */
    break;

  case 2381:
#line 15898 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49125 "gram.c" /* yacc.c:1646  */
    break;

  case 2382:
#line 15899 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 49131 "gram.c" /* yacc.c:1646  */
    break;

  case 2383:
#line 15902 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49137 "gram.c" /* yacc.c:1646  */
    break;

  case 2384:
#line 15903 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49143 "gram.c" /* yacc.c:1646  */
    break;

  case 2385:
#line 15906 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 49149 "gram.c" /* yacc.c:1646  */
    break;

  case 2386:
#line 15909 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 49155 "gram.c" /* yacc.c:1646  */
    break;

  case 2387:
#line 15910 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 49161 "gram.c" /* yacc.c:1646  */
    break;

  case 2388:
#line 15911 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 49167 "gram.c" /* yacc.c:1646  */
    break;

  case 2389:
#line 15914 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49173 "gram.c" /* yacc.c:1646  */
    break;

  case 2390:
#line 15915 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49179 "gram.c" /* yacc.c:1646  */
    break;

  case 2391:
#line 15918 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 49185 "gram.c" /* yacc.c:1646  */
    break;

  case 2392:
#line 15919 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 49191 "gram.c" /* yacc.c:1646  */
    break;

  case 2393:
#line 15920 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 49197 "gram.c" /* yacc.c:1646  */
    break;

  case 2394:
#line 15921 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 49203 "gram.c" /* yacc.c:1646  */
    break;

  case 2395:
#line 15922 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 49209 "gram.c" /* yacc.c:1646  */
    break;

  case 2396:
#line 15923 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 49215 "gram.c" /* yacc.c:1646  */
    break;

  case 2397:
#line 15924 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 49221 "gram.c" /* yacc.c:1646  */
    break;

  case 2398:
#line 15925 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 49227 "gram.c" /* yacc.c:1646  */
    break;

  case 2399:
#line 15926 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 49233 "gram.c" /* yacc.c:1646  */
    break;

  case 2400:
#line 15927 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 49239 "gram.c" /* yacc.c:1646  */
    break;

  case 2401:
#line 15928 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 49245 "gram.c" /* yacc.c:1646  */
    break;

  case 2402:
#line 15929 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 49251 "gram.c" /* yacc.c:1646  */
    break;

  case 2403:
#line 15933 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49257 "gram.c" /* yacc.c:1646  */
    break;

  case 2404:
#line 15935 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49263 "gram.c" /* yacc.c:1646  */
    break;

  case 2405:
#line 15940 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49269 "gram.c" /* yacc.c:1646  */
    break;

  case 2406:
#line 15942 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49275 "gram.c" /* yacc.c:1646  */
    break;

  case 2407:
#line 15947 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49281 "gram.c" /* yacc.c:1646  */
    break;

  case 2408:
#line 15949 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49287 "gram.c" /* yacc.c:1646  */
    break;

  case 2409:
#line 15951 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 49293 "gram.c" /* yacc.c:1646  */
    break;

  case 2410:
#line 15953 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 49299 "gram.c" /* yacc.c:1646  */
    break;

  case 2411:
#line 15955 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 49305 "gram.c" /* yacc.c:1646  */
    break;

  case 2412:
#line 15957 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 49311 "gram.c" /* yacc.c:1646  */
    break;

  case 2413:
#line 15969 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 49319 "gram.c" /* yacc.c:1646  */
    break;

  case 2414:
#line 15973 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 49327 "gram.c" /* yacc.c:1646  */
    break;

  case 2415:
#line 15980 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 49335 "gram.c" /* yacc.c:1646  */
    break;

  case 2416:
#line 15984 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 49343 "gram.c" /* yacc.c:1646  */
    break;

  case 2417:
#line 15990 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 49351 "gram.c" /* yacc.c:1646  */
    break;

  case 2418:
#line 15994 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 49364 "gram.c" /* yacc.c:1646  */
    break;

  case 2419:
#line 16003 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 49377 "gram.c" /* yacc.c:1646  */
    break;

  case 2420:
#line 16013 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 49383 "gram.c" /* yacc.c:1646  */
    break;

  case 2421:
#line 16014 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 49389 "gram.c" /* yacc.c:1646  */
    break;

  case 2422:
#line 16018 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 49397 "gram.c" /* yacc.c:1646  */
    break;

  case 2423:
#line 16022 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 49405 "gram.c" /* yacc.c:1646  */
    break;

  case 2424:
#line 16026 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 49413 "gram.c" /* yacc.c:1646  */
    break;

  case 2425:
#line 16031 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49419 "gram.c" /* yacc.c:1646  */
    break;

  case 2426:
#line 16032 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 49425 "gram.c" /* yacc.c:1646  */
    break;

  case 2427:
#line 16038 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 49433 "gram.c" /* yacc.c:1646  */
    break;

  case 2428:
#line 16041 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49439 "gram.c" /* yacc.c:1646  */
    break;

  case 2429:
#line 16048 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49445 "gram.c" /* yacc.c:1646  */
    break;

  case 2430:
#line 16049 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 49451 "gram.c" /* yacc.c:1646  */
    break;

  case 2431:
#line 16050 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 49457 "gram.c" /* yacc.c:1646  */
    break;

  case 2432:
#line 16051 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 49463 "gram.c" /* yacc.c:1646  */
    break;

  case 2433:
#line 16052 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 49469 "gram.c" /* yacc.c:1646  */
    break;

  case 2434:
#line 16053 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 49475 "gram.c" /* yacc.c:1646  */
    break;

  case 2435:
#line 16054 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 49481 "gram.c" /* yacc.c:1646  */
    break;

  case 2436:
#line 16055 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49487 "gram.c" /* yacc.c:1646  */
    break;

  case 2437:
#line 16066 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 49495 "gram.c" /* yacc.c:1646  */
    break;

  case 2438:
#line 16070 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 49503 "gram.c" /* yacc.c:1646  */
    break;

  case 2439:
#line 16077 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49509 "gram.c" /* yacc.c:1646  */
    break;

  case 2440:
#line 16083 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 49515 "gram.c" /* yacc.c:1646  */
    break;

  case 2441:
#line 16084 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49521 "gram.c" /* yacc.c:1646  */
    break;

  case 2442:
#line 16101 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 49529 "gram.c" /* yacc.c:1646  */
    break;

  case 2443:
#line 16105 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 49538 "gram.c" /* yacc.c:1646  */
    break;

  case 2444:
#line 16110 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 49546 "gram.c" /* yacc.c:1646  */
    break;

  case 2445:
#line 16114 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 49565 "gram.c" /* yacc.c:1646  */
    break;

  case 2446:
#line 16129 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
				}
#line 49573 "gram.c" /* yacc.c:1646  */
    break;

  case 2447:
#line 16133 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49579 "gram.c" /* yacc.c:1646  */
    break;

  case 2448:
#line 16137 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49585 "gram.c" /* yacc.c:1646  */
    break;

  case 2449:
#line 16140 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49591 "gram.c" /* yacc.c:1646  */
    break;

  case 2450:
#line 16143 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 49597 "gram.c" /* yacc.c:1646  */
    break;

  case 2451:
#line 16144 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49603 "gram.c" /* yacc.c:1646  */
    break;

  case 2452:
#line 16145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49609 "gram.c" /* yacc.c:1646  */
    break;

  case 2453:
#line 16149 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 49620 "gram.c" /* yacc.c:1646  */
    break;

  case 2454:
#line 16155 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 49626 "gram.c" /* yacc.c:1646  */
    break;

  case 2455:
#line 16166 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 49640 "gram.c" /* yacc.c:1646  */
    break;

  case 2456:
#line 16179 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49646 "gram.c" /* yacc.c:1646  */
    break;

  case 2457:
#line 16180 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 49652 "gram.c" /* yacc.c:1646  */
    break;

  case 2458:
#line 16185 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 49664 "gram.c" /* yacc.c:1646  */
    break;

  case 2459:
#line 16195 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49670 "gram.c" /* yacc.c:1646  */
    break;

  case 2460:
#line 16196 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 49676 "gram.c" /* yacc.c:1646  */
    break;

  case 2461:
#line 16199 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49682 "gram.c" /* yacc.c:1646  */
    break;

  case 2462:
#line 16200 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 49688 "gram.c" /* yacc.c:1646  */
    break;

  case 2463:
#line 16204 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 49696 "gram.c" /* yacc.c:1646  */
    break;

  case 2464:
#line 16208 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 49704 "gram.c" /* yacc.c:1646  */
    break;

  case 2465:
#line 16215 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 49712 "gram.c" /* yacc.c:1646  */
    break;

  case 2466:
#line 16219 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 49720 "gram.c" /* yacc.c:1646  */
    break;

  case 2467:
#line 16223 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 49732 "gram.c" /* yacc.c:1646  */
    break;

  case 2468:
#line 16231 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 49744 "gram.c" /* yacc.c:1646  */
    break;

  case 2469:
#line 16241 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49750 "gram.c" /* yacc.c:1646  */
    break;

  case 2470:
#line 16242 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 49756 "gram.c" /* yacc.c:1646  */
    break;

  case 2471:
#line 16246 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49762 "gram.c" /* yacc.c:1646  */
    break;

  case 2472:
#line 16247 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 49768 "gram.c" /* yacc.c:1646  */
    break;

  case 2473:
#line 16251 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49774 "gram.c" /* yacc.c:1646  */
    break;

  case 2474:
#line 16252 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 49780 "gram.c" /* yacc.c:1646  */
    break;

  case 2477:
#line 16266 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49786 "gram.c" /* yacc.c:1646  */
    break;

  case 2478:
#line 16267 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49792 "gram.c" /* yacc.c:1646  */
    break;

  case 2479:
#line 16271 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 49798 "gram.c" /* yacc.c:1646  */
    break;

  case 2480:
#line 16272 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 49804 "gram.c" /* yacc.c:1646  */
    break;

  case 2481:
#line 16276 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 49816 "gram.c" /* yacc.c:1646  */
    break;

  case 2482:
#line 16292 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 49828 "gram.c" /* yacc.c:1646  */
    break;

  case 2483:
#line 16300 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 49840 "gram.c" /* yacc.c:1646  */
    break;

  case 2484:
#line 16308 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 49856 "gram.c" /* yacc.c:1646  */
    break;

  case 2485:
#line 16329 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 49862 "gram.c" /* yacc.c:1646  */
    break;

  case 2486:
#line 16330 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 49868 "gram.c" /* yacc.c:1646  */
    break;

  case 2487:
#line 16342 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 49876 "gram.c" /* yacc.c:1646  */
    break;

  case 2488:
#line 16346 "gram.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 49905 "gram.c" /* yacc.c:1646  */
    break;

  case 2489:
#line 16373 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49911 "gram.c" /* yacc.c:1646  */
    break;

  case 2490:
#line 16375 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 49917 "gram.c" /* yacc.c:1646  */
    break;

  case 2491:
#line 16379 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49923 "gram.c" /* yacc.c:1646  */
    break;

  case 2492:
#line 16382 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49929 "gram.c" /* yacc.c:1646  */
    break;

  case 2493:
#line 16385 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49935 "gram.c" /* yacc.c:1646  */
    break;

  case 2494:
#line 16387 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49941 "gram.c" /* yacc.c:1646  */
    break;

  case 2495:
#line 16389 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49947 "gram.c" /* yacc.c:1646  */
    break;

  case 2496:
#line 16391 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49953 "gram.c" /* yacc.c:1646  */
    break;

  case 2497:
#line 16402 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49959 "gram.c" /* yacc.c:1646  */
    break;

  case 2498:
#line 16404 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 49968 "gram.c" /* yacc.c:1646  */
    break;

  case 2499:
#line 16415 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 49976 "gram.c" /* yacc.c:1646  */
    break;

  case 2500:
#line 16419 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 49984 "gram.c" /* yacc.c:1646  */
    break;

  case 2501:
#line 16423 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 49992 "gram.c" /* yacc.c:1646  */
    break;

  case 2502:
#line 16427 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50000 "gram.c" /* yacc.c:1646  */
    break;

  case 2503:
#line 16431 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50013 "gram.c" /* yacc.c:1646  */
    break;

  case 2504:
#line 16440 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50024 "gram.c" /* yacc.c:1646  */
    break;

  case 2505:
#line 16447 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50060 "gram.c" /* yacc.c:1646  */
    break;

  case 2506:
#line 16479 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 50068 "gram.c" /* yacc.c:1646  */
    break;

  case 2507:
#line 16483 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 50078 "gram.c" /* yacc.c:1646  */
    break;

  case 2508:
#line 16489 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50089 "gram.c" /* yacc.c:1646  */
    break;

  case 2509:
#line 16496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[0]));
				}
#line 50097 "gram.c" /* yacc.c:1646  */
    break;

  case 2510:
#line 16500 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[0]));
				}
#line 50105 "gram.c" /* yacc.c:1646  */
    break;

  case 2511:
#line 16504 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 50113 "gram.c" /* yacc.c:1646  */
    break;

  case 2512:
#line 16509 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 50119 "gram.c" /* yacc.c:1646  */
    break;

  case 2513:
#line 16510 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50125 "gram.c" /* yacc.c:1646  */
    break;

  case 2514:
#line 16512 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 50131 "gram.c" /* yacc.c:1646  */
    break;

  case 2515:
#line 16513 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 50137 "gram.c" /* yacc.c:1646  */
    break;

  case 2516:
#line 16514 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 50143 "gram.c" /* yacc.c:1646  */
    break;

  case 2517:
#line 16519 "gram.y" /* yacc.c:1646  */
    {
					RoleSpec *spc = (RoleSpec *) (yyvsp[0].rolespec);
					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
					}
				}
#line 50175 "gram.c" /* yacc.c:1646  */
    break;

  case 2518:
#line 16549 "gram.y" /* yacc.c:1646  */
    {
						/*
						 * "public" and "none" are not keywords, but they must
						 * be treated specially here.
						 */
						RoleSpec *n;
						if (strcmp((yyvsp[0].str), "public") == 0)
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
							n->roletype = ROLESPEC_PUBLIC;
						}
						else if (strcmp((yyvsp[0].str), "none") == 0)
						{
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"none"),
									 parser_errposition((yylsp[0]))));
						}
						else
						{
							n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
							n->rolename = pstrdup((yyvsp[0].str));
						}
						(yyval.rolespec) = n;
					}
#line 50206 "gram.c" /* yacc.c:1646  */
    break;

  case 2519:
#line 16576 "gram.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
					}
#line 50214 "gram.c" /* yacc.c:1646  */
    break;

  case 2520:
#line 16580 "gram.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
					}
#line 50222 "gram.c" /* yacc.c:1646  */
    break;

  case 2521:
#line 16586 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 50228 "gram.c" /* yacc.c:1646  */
    break;

  case 2522:
#line 16588 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 50234 "gram.c" /* yacc.c:1646  */
    break;

  case 2523:
#line 16604 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50240 "gram.c" /* yacc.c:1646  */
    break;

  case 2524:
#line 16605 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50246 "gram.c" /* yacc.c:1646  */
    break;

  case 2525:
#line 16606 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50252 "gram.c" /* yacc.c:1646  */
    break;

  case 2526:
#line 16611 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50258 "gram.c" /* yacc.c:1646  */
    break;

  case 2527:
#line 16612 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50264 "gram.c" /* yacc.c:1646  */
    break;

  case 2528:
#line 16613 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50270 "gram.c" /* yacc.c:1646  */
    break;

  case 2529:
#line 16618 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50276 "gram.c" /* yacc.c:1646  */
    break;

  case 2530:
#line 16619 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50282 "gram.c" /* yacc.c:1646  */
    break;

  case 2531:
#line 16620 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50288 "gram.c" /* yacc.c:1646  */
    break;

  case 2532:
#line 16621 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50294 "gram.c" /* yacc.c:1646  */
    break;

  case 2533:
#line 16627 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50300 "gram.c" /* yacc.c:1646  */
    break;

  case 2534:
#line 16628 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50306 "gram.c" /* yacc.c:1646  */
    break;

  case 2535:
#line 16629 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50312 "gram.c" /* yacc.c:1646  */
    break;

  case 2536:
#line 16630 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50318 "gram.c" /* yacc.c:1646  */
    break;

  case 2537:
#line 16631 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50324 "gram.c" /* yacc.c:1646  */
    break;


#line 50328 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 17209 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

#ifdef _PG_ORCL_
/* OracleFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
OracleFuncName(char *name)
{
	return list_make2(makeString("pg_oracle"), makeString(name));
}
#endif

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
